/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/extpath","fs","vs/base/common/process","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/product/common/product","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],x=function(V){for(var e=[],p=0,L=V.length;p<L;p++)e[p]=Z[V[p]];return e};define(Z[102],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=p}),define(Z[47],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(b){return(n,f,w)=>{let i=null,P=null;if(typeof w.value=="function"?(i="value",P=w.value):typeof w.get=="function"&&(i="get",P=w.get),!P)throw new Error("not supported");w[i]=b(P,f)}}e.createDecorator=p;function L(b,n,f){let w=null,i=null;if(typeof f.value=="function"?(w="value",i=f.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(w="get",i=f.get),!i)throw new Error("not supported");const P=`$memoize$${n}`;f[w]=function(...E){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,E)}),this[P]}}e.memoize=L;function k(b,n,f){return p((w,i)=>{const P=`$debounce$${i}`,E=`$debounce$result$${i}`;return function(...v){this[E]||(this[E]=f?f():void 0),clearTimeout(this[P]),n&&(this[E]=n(this[E],...v),v=[this[E]]),this[P]=setTimeout(()=>{w.apply(this,v),this[E]=f?f():void 0},b)}})}e.debounce=k;function M(b,n,f){return p((w,i)=>{const P=`$throttle$timer$${i}`,E=`$throttle$result$${i}`,v=`$throttle$lastRun$${i}`,d=`$throttle$pending$${i}`;return function(...g){if(this[E]||(this[E]=f?f():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),n&&(this[E]=n(this[E],...g)),this[d])return;const I=this[v]+b;I<=Date.now()?(this[v]=Date.now(),w.apply(this,[this[E]]),this[E]=f?f():void 0):(this[d]=!0,this[P]=setTimeout(()=>{this[d]=!1,this[v]=Date.now(),w.apply(this,[this[E]]),this[E]=f?f():void 0},I-Date.now()))}})}e.throttle=M}),define(Z[17],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(a=>{a(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function L(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=L;function k(c){f(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function M(c){f(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=M;function b(c){if(c instanceof Error){let{name:t,message:a}=c;const r=c.stacktrace||c.stack;return{$isError:!0,name:t,message:a,stack:r}}return c}e.transformErrorForSerialization=b;const n="Canceled";function f(c){return c instanceof Error&&c.name===n&&c.message===n}e.isPromiseCanceledError=f;class w extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=w;function i(){const c=new Error(n);return c.name=c.message,c}e.canceled=i;function P(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=P;function E(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=E;function v(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function d(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function g(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=g;class I extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=I;class y extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=y;class u extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=u;function h(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=h;function o(c,t=Object.create(null)){const a=new Error(c);return t.actions&&(a.actions=t.actions),a}e.createErrorWithActions=o}),define(Z[30],x([0,1,17]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(T,A=0){return T[T.length-(1+A)]}e.tail=L;function k(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=k;function M(T,A,W=(z,X)=>z===X){if(T===A)return!0;if(!T||!A||T.length!==A.length)return!1;for(let z=0,X=T.length;z<X;z++)if(!W(T[z],A[z]))return!1;return!0}e.equals=M;function b(T,A,W){let z=0,X=T.length-1;for(;z<=X;){const U=(z+X)/2|0,N=W(T[U],A);if(N<0)z=U+1;else if(N>0)X=U-1;else return U}return-(z+1)}e.binarySearch=b;function n(T,A){let W=0,z=T.length;if(z===0)return 0;for(;W<z;){const X=Math.floor((W+z)/2);A(T[X])?z=X:W=X+1}return W}e.findFirstInSorted=n;function f(T,A,W){if(T=T|0,T>=A.length)throw new TypeError("invalid index");let z=A[Math.floor(A.length*Math.random())],X=[],U=[],N=[];for(let Q of A){const J=W(Q,z);J<0?X.push(Q):J>0?U.push(Q):N.push(Q)}return T<X.length?f(T,X,W):T<X.length+N.length?N[0]:f(T-(X.length+N.length),U,W)}e.quickSelect=f;function w(T,A){const W=[];let z;for(const X of T.slice(0).sort(A))!z||A(z[0],X)!==0?(z=[X],W.push(z)):z.push(X);return W}e.groupBy=w;function i(T,A,W){const z=[];function X(Q,J,re){if(J===0&&re.length===0)return;const le=z[z.length-1];le&&le.start+le.deleteCount===Q?(le.deleteCount+=J,le.toInsert.push(...re)):z.push({start:Q,deleteCount:J,toInsert:re})}let U=0,N=0;for(;;){if(U===T.length){X(U,0,A.slice(N));break}if(N===A.length){X(U,T.length-U,[]);break}const Q=T[U],J=A[N],re=W(Q,J);re===0?(U+=1,N+=1):re<0?(X(U,1,[]),U+=1):re>0&&(X(U,0,[J]),N+=1)}return z}e.sortedDiff=i;function P(T,A,W){const z=i(T,A,W),X=[],U=[];for(const N of z)X.push(...T.slice(N.start,N.start+N.deleteCount)),U.push(...N.toInsert);return{removed:X,added:U}}e.delta=P;function E(T,A,W){if(W===0)return[];const z=T.slice(0,W).sort(A);return d(T,A,z,W,T.length),z}e.top=E;function v(T,A,W,z,X){return W===0?Promise.resolve([]):new Promise((U,N)=>{(async()=>{const Q=T.length,J=T.slice(0,W).sort(A);for(let re=W,le=Math.min(W+z,Q);re<Q;re=le,le=Math.min(le+z,Q)){if(re>W&&await new Promise(ie=>setTimeout(ie)),X&&X.isCancellationRequested)throw(0,p.canceled)();d(T,A,J,re,le)}return J})().then(U,N)})}e.topAsync=v;function d(T,A,W,z,X){for(const U=W.length;z<X;z++){const N=T[z];if(A(N,W[U-1])<0){W.pop();const Q=n(W,J=>A(N,J)<0);W.splice(Q,0,N)}}}function g(T){return T.filter(A=>!!A)}e.coalesce=g;function I(T){let A=0;for(let W=0;W<T.length;W++)T[W]&&(T[A]=T[W],A+=1);T.length=A}e.coalesceInPlace=I;function y(T,A,W){T.splice(W,0,T.splice(A,1)[0])}e.move=y;function u(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=u;function h(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=h;function o(T,A){if(!A)return T.filter((z,X)=>T.indexOf(z)===X);const W=Object.create(null);return T.filter(z=>{const X=A(z);return W[X]?!1:(W[X]=!0,!0)})}e.distinct=o;function c(T){const A=new Set;return T.filter(W=>A.has(W)?!1:(A.add(W),!0))}e.distinctES6=c;function t(T){const A=Object.create(null);return W=>{const z=T(W);return A[z]?!1:(A[z]=!0,!0)}}e.uniqueFilter=t;function a(T,A){for(let W=T.length-1;W>=0;W--){const z=T[W];if(A(z))return W}return-1}e.lastIndex=a;function r(T,A){return T.length>0?T[0]:A}e.firstOrDefault=r;function s(T,A,W=(z,X)=>z===X){let z=0;for(let X=0,U=Math.min(T.length,A.length);X<U&&W(T[X],A[X]);X++)z++;return z}e.commonPrefixLength=s;function l(T){return[].concat(...T)}e.flatten=l;function m(T,A){let W=typeof A=="number"?T:0;typeof A=="number"?W=T:(W=0,A=T);const z=[];if(W<=A)for(let X=W;X<A;X++)z.push(X);else for(let X=W;X>A;X--)z.push(X);return z}e.range=m;function S(T,A,W){return T.reduce((z,X)=>(z[A(X)]=W?W(X):X,z),Object.create(null))}e.index=S;function D(T,A){return T.push(A),()=>R(T,A)}e.insert=D;function R(T,A){const W=T.indexOf(A);if(W>-1)return T.splice(W,1),A}e.remove=R;function F(T,A,W){const z=T.slice(0,A),X=T.slice(A);return z.concat(W,X)}e.arrayInsert=F;function C(T,A){let W;if(typeof A=="number"){let z=A;W=()=>{const X=Math.sin(z++)*179426549;return X-Math.floor(X)}}else W=Math.random;for(let z=T.length-1;z>0;z-=1){const X=Math.floor(W()*(z+1)),U=T[z];T[z]=T[X],T[X]=U}}e.shuffle=C;function G(T,A){const W=T.indexOf(A);W>-1&&(T.splice(W,1),T.unshift(A))}e.pushToStart=G;function ne(T,A){const W=T.indexOf(A);W>-1&&(T.splice(W,1),T.push(A))}e.pushToEnd=ne;function ae(T,A){return Array.isArray(T)?T.map(A):A(T)}e.mapArrayOrNot=ae;function K(T){return Array.isArray(T)?T:[T]}e.asArray=K;function ee(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=ee;function _(T,A){for(const W of T){const z=A(W);if(z!==void 0)return z}}e.mapFind=_;function j(T,A,W){const z=B(T,A),X=T.length,U=W.length;T.length=X+U;for(let N=X-1;N>=z;N--)T[N+U]=T[N];for(let N=0;N<U;N++)T[N+z]=W[N]}e.insertInto=j;function $(T,A,W,z){const X=B(T,A),U=T.splice(X,W);return j(T,X,z),U}e.splice=$;function B(T,A){return A<0?Math.max(A+T.length,0):Math.min(A,T.length)}function H(T,A){let W=Number.MAX_SAFE_INTEGER,z=0;return T.forEach((X,U)=>{const N=A(X);N<W&&(W=N,z=U)}),z}e.minIndex=H;function O(T,A){let W=Number.MIN_SAFE_INTEGER,z=0;return T.forEach((X,U)=>{const N=A(X);N>W&&(W=N,z=U)}),z}e.maxIndex=O;class q{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let W=this.firstIdx;for(;W<this.items.length&&A(this.items[W]);)W++;const z=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,z}takeFromEndWhile(A){let W=this.lastIdx;for(;W>=0&&A(this.items[W]);)W--;const z=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,z}}e.ArrayQueue=q}),define(Z[43],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(L){const k=this;let M=!1,b;return function(){return M||(M=!0,b=L.apply(k,arguments)),b}}e.once=p}),define(Z[64],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(L){function k(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}L.is=k;const M=Object.freeze([]);function b(){return M}L.empty=b;function*n(c){yield c}L.single=n;function f(c){return c||M}L.from=f;function w(c){return!c||c[Symbol.iterator]().next().done===!0}L.isEmpty=w;function i(c){return c[Symbol.iterator]().next().value}L.first=i;function P(c,t){for(const a of c)if(t(a))return!0;return!1}L.some=P;function E(c,t){for(const a of c)if(t(a))return a}L.find=E;function*v(c,t){for(const a of c)t(a)&&(yield a)}L.filter=v;function*d(c,t){let a=0;for(const r of c)yield t(r,a++)}L.map=d;function*g(...c){for(const t of c)for(const a of t)yield a}L.concat=g;function*I(c){for(const t of c)for(const a of t)yield a}L.concatNested=I;function y(c,t,a){let r=a;for(const s of c)r=t(r,s);return r}L.reduce=y;function*u(c,t,a=c.length){for(t<0&&(t+=c.length),a<0?a+=c.length:a>c.length&&(a=c.length);t<a;t++)yield c[t]}L.slice=u;function h(c,t=Number.POSITIVE_INFINITY){const a=[];if(t===0)return[a,c];const r=c[Symbol.iterator]();for(let s=0;s<t;s++){const l=r.next();if(l.done)return[a,L.empty()];a.push(l.value)}return[a,{[Symbol.iterator](){return r}}]}L.consume=h;function o(c,t,a=(r,s)=>r===s){const r=c[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const l=r.next(),m=s.next();if(l.done!==m.done)return!1;if(l.done)return!0;if(!a(l.value,m.value))return!1}}L.equals=o})(p=e.Iterable||(e.Iterable={}))}),define(Z[40],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function b(t,a=!1){let r=0,s=t.length,l="",m=0,S=16,D=0;function R(ee){let _=0,j=0;for(;_<ee;){const $=t.charCodeAt(r);if($>=48&&$<=57)j=j*16+$-48;else if($>=65&&$<=70)j=j*16+$-65+10;else if($>=97&&$<=102)j=j*16+$-97+10;else break;r++,_++}return _<ee&&(j=-1),j}function F(ee){r=ee,l="",m=0,S=16,D=0}function C(){const ee=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&w(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&w(t.charCodeAt(r)))for(r++;r<t.length&&w(t.charCodeAt(r));)r++;else return D=3,t.substring(ee,r);let _=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&w(t.charCodeAt(r))){for(r++;r<t.length&&w(t.charCodeAt(r));)r++;_=r}else D=3;return t.substring(ee,_)}function G(){let ee="",_=r;for(;;){if(r>=s){ee+=t.substring(_,r),D=2;break}const j=t.charCodeAt(r);if(j===34){ee+=t.substring(_,r),r++;break}if(j===92){if(ee+=t.substring(_,r),r++,r>=s){D=2;break}switch(t.charCodeAt(r++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:const B=R(4);B>=0?ee+=String.fromCharCode(B):D=4;break;default:D=5}_=r;continue}if(j>=0&&j<=31)if(f(j)){ee+=t.substring(_,r),D=2;break}else D=6;r++}return ee}function ne(){if(l="",D=0,m=r,r>=s)return m=s,S=17;let ee=t.charCodeAt(r);if(n(ee)){do r++,l+=String.fromCharCode(ee),ee=t.charCodeAt(r);while(n(ee));return S=15}if(f(ee))return r++,l+=String.fromCharCode(ee),ee===13&&t.charCodeAt(r)===10&&(r++,l+=`
`),S=14;switch(ee){case 123:return r++,S=1;case 125:return r++,S=2;case 91:return r++,S=3;case 93:return r++,S=4;case 58:return r++,S=6;case 44:return r++,S=5;case 34:return r++,l=G(),S=10;case 47:const _=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<s&&!f(t.charCodeAt(r));)r++;return l=t.substring(_,r),S=12}if(t.charCodeAt(r+1)===42){r+=2;const j=s-1;let $=!1;for(;r<j;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,$=!0;break}r++}return $||(r++,D=1),l=t.substring(_,r),S=13}return l+=String.fromCharCode(ee),r++,S=16;case 45:if(l+=String.fromCharCode(ee),r++,r===s||!w(t.charCodeAt(r)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=C(),S=11;default:for(;r<s&&ae(ee);)r++,ee=t.charCodeAt(r);if(m!==r){switch(l=t.substring(m,r),l){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return l+=String.fromCharCode(ee),r++,S=16}}function ae(ee){if(n(ee)||f(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let ee;do ee=ne();while(ee>=12&&ee<=15);return ee}return{setPosition:F,getPosition:()=>r,scan:a?K:ne,getToken:()=>S,getTokenValue:()=>l,getTokenOffset:()=>m,getTokenLength:()=>r-m,getTokenError:()=>D}}e.createScanner=b;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function P(t,a){const r=[],s=new Object;let l;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function D(R,F,C,G){m.value=R,m.offset=F,m.length=C,m.type=G,m.colonOffset=void 0,l=m}try{h(t,{onObjectBegin:(R,F)=>{if(a<=R)throw s;l=void 0,S=a>R,r.push("")},onObjectProperty:(R,F,C)=>{if(a<F||(D(R,F,C,"property"),r[r.length-1]=R,a<=F+C))throw s},onObjectEnd:(R,F)=>{if(a<=R)throw s;l=void 0,r.pop()},onArrayBegin:(R,F)=>{if(a<=R)throw s;l=void 0,r.push(0)},onArrayEnd:(R,F)=>{if(a<=R)throw s;l=void 0,r.pop()},onLiteralValue:(R,F,C)=>{if(a<F||(D(R,F,C,c(R)),a<=F+C))throw s},onSeparator:(R,F,C)=>{if(a<=F)throw s;if(R===":"&&l&&l.type==="property")l.colonOffset=F,S=!1,l=void 0;else if(R===","){const G=r[r.length-1];typeof G=="number"?r[r.length-1]=G+1:(S=!0,r[r.length-1]=""),l=void 0}}})}catch(R){if(R!==s)throw R}return{path:r,previousNode:l,isAtPropertyKey:S,matches:R=>{let F=0;for(let C=0;F<R.length&&C<r.length;C++)if(R[F]===r[C]||R[F]==="*")F++;else if(R[F]!=="**")return!1;return F===R.length}}}e.getLocation=P;function E(t,a=[],r=M.DEFAULT){let s=null,l=[];const m=[];function S(R){Array.isArray(l)?l.push(R):s!==null&&(l[s]=R)}return h(t,{onObjectBegin:()=>{const R={};S(R),m.push(l),l=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{l=m.pop()},onArrayBegin:()=>{const R=[];S(R),m.push(l),l=R,s=null},onArrayEnd:()=>{l=m.pop()},onLiteralValue:S,onError:(R,F,C)=>{a.push({error:R,offset:F,length:C})}},r),l[0]}e.parse=E;function v(t,a=[],r=M.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(R){s.type==="property"&&(s.length=R-s.offset,s=s.parent)}function m(R){return s.children.push(R),R}h(t,{onObjectBegin:R=>{s=m({type:"object",offset:R,length:-1,parent:s,children:[]})},onObjectProperty:(R,F,C)=>{s=m({type:"property",offset:F,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:R,offset:F,length:C,parent:s})},onObjectEnd:(R,F)=>{s.length=R+F-s.offset,s=s.parent,l(R+F)},onArrayBegin:(R,F)=>{s=m({type:"array",offset:R,length:-1,parent:s,children:[]})},onArrayEnd:(R,F)=>{s.length=R+F-s.offset,s=s.parent,l(R+F)},onLiteralValue:(R,F,C)=>{m({type:c(R),offset:F,length:C,parent:s,value:R}),l(F+C)},onSeparator:(R,F,C)=>{s.type==="property"&&(R===":"?s.colonOffset=F:R===","&&l(F))},onError:(R,F,C)=>{a.push({error:R,offset:F,length:C})}},r);const D=s.children[0];return D&&delete D.parent,D}e.parseTree=v;function d(t,a){if(!t)return;let r=t;for(let s of a)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const m of r.children)if(Array.isArray(m.children)&&m.children[0].value===s){r=m.children[1],l=!0;break}if(!l)return}else{const l=s;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=d;function g(t){if(!t.parent||!t.parent.children)return[];const a=g(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;a.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&a.push(r)}return a}e.getNodePath=g;function I(t){switch(t.type){case"array":return t.children.map(I);case"object":const a=Object.create(null);for(let r of t.children){const s=r.children[1];s&&(a[r.children[0].value]=I(s))}return a;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=I;function y(t,a,r=!1){return a>=t.offset&&a<t.offset+t.length||r&&a===t.offset+t.length}e.contains=y;function u(t,a,r=!1){if(y(t,a,r)){const s=t.children;if(Array.isArray(s))for(let l=0;l<s.length&&s[l].offset<=a;l++){const m=u(s[l],a,r);if(m)return m}return t}}e.findNodeAtOffset=u;function h(t,a,r=M.DEFAULT){const s=b(t,!1);function l(W){return W?()=>W(s.getTokenOffset(),s.getTokenLength()):()=>!0}function m(W){return W?z=>W(z,s.getTokenOffset(),s.getTokenLength()):()=>!0}const S=l(a.onObjectBegin),D=m(a.onObjectProperty),R=l(a.onObjectEnd),F=l(a.onArrayBegin),C=l(a.onArrayEnd),G=m(a.onLiteralValue),ne=m(a.onSeparator),ae=l(a.onComment),K=m(a.onError),ee=r&&r.disallowComments,_=r&&r.allowTrailingComma;function j(){for(;;){const W=s.scan();switch(s.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:ee||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(W){case 12:case 13:ee?$(10):ae();break;case 16:$(1);break;case 15:case 14:break;default:return W}}}function $(W,z=[],X=[]){if(K(W),z.length+X.length>0){let U=s.getToken();for(;U!==17;){if(z.indexOf(U)!==-1){j();break}else if(X.indexOf(U)!==-1)break;U=j()}}}function B(W){const z=s.getTokenValue();return W?G(z):D(z),j(),!0}function H(){switch(s.getToken()){case 11:let W=0;try{W=JSON.parse(s.getTokenValue()),typeof W!="number"&&($(2),W=0)}catch(z){$(2)}G(W);break;case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return j(),!0}function O(){return s.getToken()!==10?($(3,[],[2,5]),!1):(B(!1),s.getToken()===6?(ne(":"),j(),A()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function q(){S(),j();let W=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(W||$(4,[],[]),ne(","),j(),s.getToken()===2&&_)break}else W&&$(6,[],[]);O()||$(4,[],[2,5]),W=!0}return R(),s.getToken()!==2?$(7,[2],[]):j(),!0}function T(){F(),j();let W=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(W||$(4,[],[]),ne(","),j(),s.getToken()===4&&_)break}else W&&$(6,[],[]);A()||$(4,[],[4,5]),W=!0}return C(),s.getToken()!==4?$(8,[4],[]):j(),!0}function A(){switch(s.getToken()){case 3:return T();case 1:return q();case 10:return B(!0);default:return H()}}return j(),s.getToken()===17?r.allowEmptyContent?!0:($(4,[],[]),!1):A()?(s.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=h;function o(t,a){let r=b(t),s=[],l,m=0,S;do switch(S=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:m!==S&&s.push(t.substring(m,S)),a!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,a)),m=r.getPosition();break}while(l!==17);return s.join("")}e.stripComments=o;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Z[103],x([0,1,40]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(f,w,i){let P,E,v,d,g;if(w){for(d=w.offset,g=d+w.length,v=d;v>0&&!n(f,v-1);)v--;let m=g;for(;m<f.length&&!n(f,m);)m++;E=f.substring(v,m),P=M(E,i)}else E=f,P=0,v=0,d=0,g=f.length;const I=b(i,f);let y=!1,u=0,h;i.insertSpaces?h=k(" ",i.tabSize||4):h="	";const o=(0,p.createScanner)(E,!1);let c=!1;function t(){return I+k(h,P+u)}function a(){let m=o.scan();for(y=!1;m===15||m===14;)y=y||m===14,m=o.scan();return c=m===16||o.getTokenError()!==0,m}const r=[];function s(m,S,D){!c&&S<g&&D>d&&f.substring(S,D)!==m&&r.push({offset:S,length:D-S,content:m})}let l=a();if(l!==17){const m=o.getTokenOffset()+v,S=k(h,P);s(S,v,m)}for(;l!==17;){let m=o.getTokenOffset()+o.getTokenLength()+v,S=a(),D="";for(;!y&&(S===12||S===13);){const F=o.getTokenOffset()+v;s(" ",m,F),m=o.getTokenOffset()+o.getTokenLength()+v,D=S===12?t():"",S=a()}if(S===2)l!==1&&(u--,D=t());else if(S===4)l!==3&&(u--,D=t());else{switch(l){case 3:case 1:u++,D=t();break;case 5:case 12:D=t();break;case 13:y?D=t():D=" ";break;case 6:D=" ";break;case 10:if(S===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?D=" ":S!==5&&S!==17&&(c=!0);break;case 16:c=!0;break}y&&(S===12||S===13)&&(D=t())}const R=o.getTokenOffset()+v;s(D,m,R),l=S}return r}e.format=L;function k(f,w){let i="";for(let P=0;P<w;P++)i+=f;return i}function M(f,w){let i=0,P=0;const E=w.tabSize||4;for(;i<f.length;){const v=f.charAt(i);if(v===" ")P++;else if(v==="	")P+=E;else break;i++}return Math.floor(P/E)}function b(f,w){for(let i=0;i<w.length;i++){const P=w.charAt(i);if(P==="\r")return i+1<w.length&&w.charAt(i+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=b;function n(f,w){return`\r
`.indexOf(f.charAt(w))!==-1}e.isEOL=n}),define(Z[77],x([0,1,40,103]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(w,i,P){return M(w,i,void 0,P)}e.removeProperty=k;function M(w,i,P,E,v){const d=i.slice(),g=[],I=(0,p.parseTree)(w,g);let y,u;for(;d.length>0&&(u=d.pop(),y=(0,p.findNodeAtLocation)(I,d),y===void 0&&P!==void 0);)typeof u=="string"?P={[u]:P}:P=[P];if(y)if(y.type==="object"&&typeof u=="string"&&Array.isArray(y.children)){const h=(0,p.findNodeAtLocation)(y,[u]);if(h!==void 0)if(P===void 0){if(!h.parent)throw new Error("Malformed AST");const o=y.children.indexOf(h.parent);let c,t=h.parent.offset+h.parent.length;if(o>0){const a=y.children[o-1];c=a.offset+a.length}else c=y.offset+1,y.children.length>1&&(t=y.children[1].offset);return b(w,{offset:c,length:t-c,content:""},E)}else return b(w,{offset:h.offset,length:h.length,content:JSON.stringify(P)},E);else{if(P===void 0)return[];const o=`${JSON.stringify(u)}: ${JSON.stringify(P)}`,c=v?v(y.children.map(a=>a.children[0].value)):y.children.length;let t;if(c>0){const a=y.children[c-1];t={offset:a.offset+a.length,length:0,content:","+o}}else y.children.length===0?t={offset:y.offset+1,length:0,content:o}:t={offset:y.offset+1,length:0,content:o+","};return b(w,t,E)}}else if(y.type==="array"&&typeof u=="number"&&Array.isArray(y.children))if(P!==void 0){const h=`${JSON.stringify(P)}`;let o;if(y.children.length===0||u===0)o={offset:y.offset+1,length:0,content:y.children.length===0?h:h+","};else{const c=u===-1||u>y.children.length?y.children.length:u,t=y.children[c-1];o={offset:t.offset+t.length,length:0,content:","+h}}return b(w,o,E)}else{const h=u,o=y.children[h];let c;if(y.children.length===1)c={offset:y.offset+1,length:y.length-2,content:""};else if(y.children.length-1===h){const t=y.children[h-1],a=t.offset+t.length,r=y.offset+y.length;c={offset:a,length:r-2-a,content:""}}else c={offset:o.offset,length:y.children[h+1].offset-o.offset,content:""};return b(w,c,E)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${y.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return b(w,{offset:I?I.offset:0,length:I?I.length:0,content:JSON.stringify(P)},E)}}e.setProperty=M;function b(w,i,P){let E=n(w,i),v=i.offset,d=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;v>0&&!(0,L.isEOL)(E,v-1);)v--;for(;d<E.length&&!(0,L.isEOL)(E,d);)d++}const g=(0,L.format)(E,{offset:v,length:d-v},P);for(let y=g.length-1;y>=0;y--){const u=g[y];E=n(E,u),v=Math.min(v,u.offset),d=Math.max(d,u.offset+u.length),d+=u.content.length-u.length}const I=w.length-(E.length-d)-v;return[{offset:v,length:I,content:E.substring(v,d)}]}e.withFormatting=b;function n(w,i){return w.substring(0,i.offset)+i.content+w.substring(i.offset+i.length)}e.applyEdit=n;function f(w,i){let P=i.slice(0).sort((v,d)=>{const g=v.offset-d.offset;return g===0?v.length-d.length:g}),E=w.length;for(let v=P.length-1;v>=0;v--){let d=P[v];if(d.offset+d.length<=E)w=n(w,d);else throw new Error("Overlapping edit");E=d.offset}return w}e.applyEdits=f}),define(Z[57],x([0,1,17]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(u){u[u.DependsOnKbLayout=-1]="DependsOnKbLayout",u[u.Unknown=0]="Unknown",u[u.Backspace=1]="Backspace",u[u.Tab=2]="Tab",u[u.Enter=3]="Enter",u[u.Shift=4]="Shift",u[u.Ctrl=5]="Ctrl",u[u.Alt=6]="Alt",u[u.PauseBreak=7]="PauseBreak",u[u.CapsLock=8]="CapsLock",u[u.Escape=9]="Escape",u[u.Space=10]="Space",u[u.PageUp=11]="PageUp",u[u.PageDown=12]="PageDown",u[u.End=13]="End",u[u.Home=14]="Home",u[u.LeftArrow=15]="LeftArrow",u[u.UpArrow=16]="UpArrow",u[u.RightArrow=17]="RightArrow",u[u.DownArrow=18]="DownArrow",u[u.Insert=19]="Insert",u[u.Delete=20]="Delete",u[u.KEY_0=21]="KEY_0",u[u.KEY_1=22]="KEY_1",u[u.KEY_2=23]="KEY_2",u[u.KEY_3=24]="KEY_3",u[u.KEY_4=25]="KEY_4",u[u.KEY_5=26]="KEY_5",u[u.KEY_6=27]="KEY_6",u[u.KEY_7=28]="KEY_7",u[u.KEY_8=29]="KEY_8",u[u.KEY_9=30]="KEY_9",u[u.KEY_A=31]="KEY_A",u[u.KEY_B=32]="KEY_B",u[u.KEY_C=33]="KEY_C",u[u.KEY_D=34]="KEY_D",u[u.KEY_E=35]="KEY_E",u[u.KEY_F=36]="KEY_F",u[u.KEY_G=37]="KEY_G",u[u.KEY_H=38]="KEY_H",u[u.KEY_I=39]="KEY_I",u[u.KEY_J=40]="KEY_J",u[u.KEY_K=41]="KEY_K",u[u.KEY_L=42]="KEY_L",u[u.KEY_M=43]="KEY_M",u[u.KEY_N=44]="KEY_N",u[u.KEY_O=45]="KEY_O",u[u.KEY_P=46]="KEY_P",u[u.KEY_Q=47]="KEY_Q",u[u.KEY_R=48]="KEY_R",u[u.KEY_S=49]="KEY_S",u[u.KEY_T=50]="KEY_T",u[u.KEY_U=51]="KEY_U",u[u.KEY_V=52]="KEY_V",u[u.KEY_W=53]="KEY_W",u[u.KEY_X=54]="KEY_X",u[u.KEY_Y=55]="KEY_Y",u[u.KEY_Z=56]="KEY_Z",u[u.Meta=57]="Meta",u[u.ContextMenu=58]="ContextMenu",u[u.F1=59]="F1",u[u.F2=60]="F2",u[u.F3=61]="F3",u[u.F4=62]="F4",u[u.F5=63]="F5",u[u.F6=64]="F6",u[u.F7=65]="F7",u[u.F8=66]="F8",u[u.F9=67]="F9",u[u.F10=68]="F10",u[u.F11=69]="F11",u[u.F12=70]="F12",u[u.F13=71]="F13",u[u.F14=72]="F14",u[u.F15=73]="F15",u[u.F16=74]="F16",u[u.F17=75]="F17",u[u.F18=76]="F18",u[u.F19=77]="F19",u[u.NumLock=78]="NumLock",u[u.ScrollLock=79]="ScrollLock",u[u.US_SEMICOLON=80]="US_SEMICOLON",u[u.US_EQUAL=81]="US_EQUAL",u[u.US_COMMA=82]="US_COMMA",u[u.US_MINUS=83]="US_MINUS",u[u.US_DOT=84]="US_DOT",u[u.US_SLASH=85]="US_SLASH",u[u.US_BACKTICK=86]="US_BACKTICK",u[u.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",u[u.US_BACKSLASH=88]="US_BACKSLASH",u[u.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",u[u.US_QUOTE=90]="US_QUOTE",u[u.OEM_8=91]="OEM_8",u[u.OEM_102=92]="OEM_102",u[u.NUMPAD_0=93]="NUMPAD_0",u[u.NUMPAD_1=94]="NUMPAD_1",u[u.NUMPAD_2=95]="NUMPAD_2",u[u.NUMPAD_3=96]="NUMPAD_3",u[u.NUMPAD_4=97]="NUMPAD_4",u[u.NUMPAD_5=98]="NUMPAD_5",u[u.NUMPAD_6=99]="NUMPAD_6",u[u.NUMPAD_7=100]="NUMPAD_7",u[u.NUMPAD_8=101]="NUMPAD_8",u[u.NUMPAD_9=102]="NUMPAD_9",u[u.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",u[u.NUMPAD_ADD=104]="NUMPAD_ADD",u[u.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",u[u.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",u[u.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",u[u.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",u[u.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",u[u.ABNT_C1=110]="ABNT_C1",u[u.ABNT_C2=111]="ABNT_C2",u[u.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class k{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,o){this._keyCodeToStr[h]=o,this._strToKeyCode[o.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const M=new k,b=new k,n=new k;(function(){function u(h,o,c=o,t=c){M.define(h,o),b.define(h,c),n.define(h,t)}u(0,"unknown"),u(1,"Backspace"),u(2,"Tab"),u(3,"Enter"),u(4,"Shift"),u(5,"Ctrl"),u(6,"Alt"),u(7,"PauseBreak"),u(8,"CapsLock"),u(9,"Escape"),u(10,"Space"),u(11,"PageUp"),u(12,"PageDown"),u(13,"End"),u(14,"Home"),u(15,"LeftArrow","Left"),u(16,"UpArrow","Up"),u(17,"RightArrow","Right"),u(18,"DownArrow","Down"),u(19,"Insert"),u(20,"Delete"),u(21,"0"),u(22,"1"),u(23,"2"),u(24,"3"),u(25,"4"),u(26,"5"),u(27,"6"),u(28,"7"),u(29,"8"),u(30,"9"),u(31,"A"),u(32,"B"),u(33,"C"),u(34,"D"),u(35,"E"),u(36,"F"),u(37,"G"),u(38,"H"),u(39,"I"),u(40,"J"),u(41,"K"),u(42,"L"),u(43,"M"),u(44,"N"),u(45,"O"),u(46,"P"),u(47,"Q"),u(48,"R"),u(49,"S"),u(50,"T"),u(51,"U"),u(52,"V"),u(53,"W"),u(54,"X"),u(55,"Y"),u(56,"Z"),u(57,"Meta"),u(58,"ContextMenu"),u(59,"F1"),u(60,"F2"),u(61,"F3"),u(62,"F4"),u(63,"F5"),u(64,"F6"),u(65,"F7"),u(66,"F8"),u(67,"F9"),u(68,"F10"),u(69,"F11"),u(70,"F12"),u(71,"F13"),u(72,"F14"),u(73,"F15"),u(74,"F16"),u(75,"F17"),u(76,"F18"),u(77,"F19"),u(78,"NumLock"),u(79,"ScrollLock"),u(80,";",";","OEM_1"),u(81,"=","=","OEM_PLUS"),u(82,",",",","OEM_COMMA"),u(83,"-","-","OEM_MINUS"),u(84,".",".","OEM_PERIOD"),u(85,"/","/","OEM_2"),u(86,"`","`","OEM_3"),u(110,"ABNT_C1"),u(111,"ABNT_C2"),u(87,"[","[","OEM_4"),u(88,"\\","\\","OEM_5"),u(89,"]","]","OEM_6"),u(90,"'","'","OEM_7"),u(91,"OEM_8"),u(92,"OEM_102"),u(93,"NumPad0"),u(94,"NumPad1"),u(95,"NumPad2"),u(96,"NumPad3"),u(97,"NumPad4"),u(98,"NumPad5"),u(99,"NumPad6"),u(100,"NumPad7"),u(101,"NumPad8"),u(102,"NumPad9"),u(103,"NumPad_Multiply"),u(104,"NumPad_Add"),u(105,"NumPad_Separator"),u(106,"NumPad_Subtract"),u(107,"NumPad_Decimal"),u(108,"NumPad_Divide")})();var f;(function(u){function h(r){return M.keyCodeToStr(r)}u.toString=h;function o(r){return M.strToKeyCode(r)}u.fromString=o;function c(r){return b.keyCodeToStr(r)}u.toUserSettingsUS=c;function t(r){return n.keyCodeToStr(r)}u.toUserSettingsGeneral=t;function a(r){return b.strToKeyCode(r)||n.strToKeyCode(r)}u.fromUserSettings=a})(f=e.KeyCodeUtils||(e.KeyCodeUtils={}));var w;(function(u){u[u.CtrlCmd=2048]="CtrlCmd",u[u.Shift=1024]="Shift",u[u.Alt=512]="Alt",u[u.WinCtrl=256]="WinCtrl",u[u.KeyCode=255]="KeyCode"})(w||(w={}));var i;(function(u){u[u.CtrlCmd=2048]="CtrlCmd",u[u.Shift=1024]="Shift",u[u.Alt=512]="Alt",u[u.WinCtrl=256]="WinCtrl"})(i=e.KeyMod||(e.KeyMod={}));function P(u,h){const o=(h&65535)<<16>>>0;return(u|o)>>>0}e.KeyChord=P;function E(u,h){if(u===0)return null;const o=(u&65535)>>>0,c=(u&4294901760)>>>16;return c!==0?new g([v(o,h),v(c,h)]):new g([v(o,h)])}e.createKeybinding=E;function v(u,h){const o=!!(u&2048),c=!!(u&256),t=h===2?c:o,a=!!(u&1024),r=!!(u&512),s=h===2?o:c,l=u&255;return new d(t,a,r,s,l)}e.createSimpleKeybinding=v;class d{constructor(h,o,c,t,a){this.ctrlKey=h,this.shiftKey=o,this.altKey=c,this.metaKey=t,this.keyCode=a}equals(h){return this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.keyCode===h.keyCode}getHashCode(){const h=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",c=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${h}${o}${c}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class g{constructor(h){if(h.length===0)throw(0,p.illegalArgument)("parts");this.parts=h}getHashCode(){let h="";for(let o=0,c=this.parts.length;o<c;o++)o!==0&&(h+=";"),h+=this.parts[o].getHashCode();return h}equals(h){if(h===null||this.parts.length!==h.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(h.parts[o]))return!1;return!0}}e.ChordKeybinding=g;class I{constructor(h,o,c,t,a,r){this.ctrlKey=h,this.shiftKey=o,this.altKey=c,this.metaKey=t,this.keyLabel=a,this.keyAriaLabel=r}}e.ResolvedKeybindingPart=I;class y{}e.ResolvedKeybinding=y}),define(Z[2],x([0,1,43,64]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let M=null;function b(r){M=r}if(e.setDisposableTracker=b,k){const r="__is_disposable_tracked__";b(new class{trackDisposable(s){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[r]||console.log(l)},3e3)}setParent(s,l){if(s&&s!==u.None)try{s[r]=!0}catch{}}markAsDisposed(s){if(s&&s!==u.None)try{s[r]=!0}catch{}}markAsSingleton(s){}})}function n(r){return M?.trackDisposable(r),r}function f(r){M?.markAsDisposed(r)}function w(r,s){M?.setParent(r,s)}function i(r,s){if(!!M)for(const l of r)M.setParent(l,s)}function P(r){return M?.markAsSingleton(r),r}e.markAsSingleton=P;class E extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=E;function v(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=v;function d(r){if(L.Iterable.is(r)){let s=[];for(const l of r)if(l)try{l.dispose()}catch(m){s.push(m)}if(s.length===1)throw s[0];if(s.length>1)throw new E(s);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=d;function g(...r){const s=I(()=>d(r));return i(r,s),s}e.combinedDisposable=g;function I(r){const s=n({dispose:(0,p.once)(()=>{f(s),r()})});return s}e.toDisposable=I;class y{constructor(){this._toDispose=new Set,this._isDisposed=!1,n(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return w(s,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new y,n(this),w(this._store,this)}dispose(){f(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,n(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&w(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&w(s,null),s}}e.MutableDisposable=h;class o{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class c{constructor(){this.references=new Map}acquire(s,...l){let m=this.references.get(s);m||(m={counter:0,object:this.createReferencedObject(s,...l)},this.references.set(s,m));const{object:S}=m,D=(0,p.once)(()=>{--m.counter==0&&(this.destroyReferencedObject(s,m.object),this.references.delete(s))});return m.counter++,{object:S,dispose:D}}}e.ReferenceCollection=c;class t{constructor(s){this.referenceCollection=s}async acquire(s,...l){const m=this.referenceCollection.acquire(s,...l);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(S){throw m.dispose(),S}}}e.AsyncReferenceCollection=t;class a{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=a}),define(Z[104],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(M){this.element=M,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class L{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let M=this._first;for(;M!==p.Undefined;){const b=M.next;M.prev=p.Undefined,M.next=p.Undefined,M=b}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,b){const n=new p(M);if(this._first===p.Undefined)this._first=n,this._last=n;else if(b){const w=this._last;this._last=n,n.prev=w,w.next=n}else{const w=this._first;this._first=n,n.next=w,w.prev=n}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(n))}}shift(){if(this._first!==p.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==p.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==p.Undefined&&M.next!==p.Undefined){const b=M.prev;b.next=M.next,M.next.prev=b}else M.prev===p.Undefined&&M.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):M.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):M.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==p.Undefined;)yield M.element,M=M.next}}e.LinkedList=L}),function(){function V(k){const M=[];typeof k=="number"&&M.push("code/timeOrigin",k);function b(f){M.push(f,Date.now())}function n(){const f=[];for(let w=0;w<M.length;w+=2)f.push({name:M[w],startTime:M[w+1]});return f}return{mark:b,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const b of performance.getEntriesByType("mark"))M.push({name:b.name,startTime:Math.round(k+b.startTime)});return M}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function p(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=p(L))}(),define(Z[3],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let L=!1,k=!1,M=!1,b=!1,n=!1,f=!1,w=!1,i,P=p,E,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const g=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=g&&d?.sandboxed,typeof navigator=="object"&&!g)v=navigator.userAgent,L=v.indexOf("Windows")>=0,k=v.indexOf("Macintosh")>=0,w=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=v.indexOf("Linux")>=0,f=!0,i=navigator.language,P=i;else if(typeof d=="object"){L=d.platform==="win32",k=d.platform==="darwin",M=d.platform==="linux",b=M&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,i=p,P=p;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const s=JSON.parse(r),l=s.availableLanguages["*"];i=s.locale,P=l||p,E=s._translationsConfigFile}catch(s){}n=!0}else console.error("Unable to resolve platform.");var I;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function y(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let u=0;k?u=1:L?u=3:M&&(u=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=M,e.isLinuxSnap=b,e.isNative=n,e.isWeb=f,e.isIOS=w,e.platform=u,e.userAgent=v,e.language=P;var h;(function(r){function s(){return e.language}r.value=s;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=l;function m(){return e.language==="en"}r.isDefault=m})(h=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=E,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let D=0,R=l.length;D<R;D++){const F=l[D];if(F.id===S.data.vscodeSetImmediateId){l.splice(D,1),F.callback();return}}});let m=0;return S=>{const D=++m;l.push({id:D,callback:S}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const s=Promise.resolve();return l=>s.then(l)}();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||w?2:L?1:3;let c=!0,t=!1;function a(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,c=new Uint16Array(r.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=a}),define(Z[33],x([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const k=p.globals.vscode.process;L={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()},nextTick(M){return(0,p.setImmediate)(M)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},nextTick(k){return(0,p.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(Z[8],x([0,1,33]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,M=90,b=122,n=46,f=47,w=92,i=58,P=63;class E extends Error{constructor(o,c,t){let a;typeof c=="string"&&c.indexOf("not ")===0?(a="must not be",c=c.replace(/^not /,"")):a="must be";const r=o.indexOf(".")!==-1?"property":"argument";let s=`The "${o}" ${r} ${a} of type ${c}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function v(h,o){if(typeof h!="string")throw new E(o,"string",h)}function d(h){return h===f||h===w}function g(h){return h===f}function I(h){return h>=L&&h<=M||h>=k&&h<=b}function y(h,o,c,t){let a="",r=0,s=-1,l=0,m=0;for(let S=0;S<=h.length;++S){if(S<h.length)m=h.charCodeAt(S);else{if(t(m))break;m=f}if(t(m)){if(!(s===S-1||l===1))if(l===2){if(a.length<2||r!==2||a.charCodeAt(a.length-1)!==n||a.charCodeAt(a.length-2)!==n){if(a.length>2){const D=a.lastIndexOf(c);D===-1?(a="",r=0):(a=a.slice(0,D),r=a.length-1-a.lastIndexOf(c)),s=S,l=0;continue}else if(a.length!==0){a="",r=0,s=S,l=0;continue}}o&&(a+=a.length>0?`${c}..`:"..",r=2)}else a.length>0?a+=`${c}${h.slice(s+1,S)}`:a=h.slice(s+1,S),r=S-s-1;s=S,l=0}else m===n&&l!==-1?++l:l=-1}return a}function u(h,o){if(o===null||typeof o!="object")throw new E("pathObject","Object",o);const c=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return c?c===o.root?`${c}${t}`:`${c}${h}${t}`:t}e.win32={resolve(...h){let o="",c="",t=!1;for(let a=h.length-1;a>=-1;a--){let r;if(a>=0){if(r=h[a],v(r,"path"),r.length===0)continue}else o.length===0?r=p.cwd():(r=p.env[`=${o}`]||p.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===w)&&(r=`${o}\\`));const s=r.length;let l=0,m="",S=!1;const D=r.charCodeAt(0);if(s===1)d(D)&&(l=1,S=!0);else if(d(D))if(S=!0,d(r.charCodeAt(1))){let R=2,F=R;for(;R<s&&!d(r.charCodeAt(R));)R++;if(R<s&&R!==F){const C=r.slice(F,R);for(F=R;R<s&&d(r.charCodeAt(R));)R++;if(R<s&&R!==F){for(F=R;R<s&&!d(r.charCodeAt(R));)R++;(R===s||R!==F)&&(m=`\\\\${C}\\${r.slice(F,R)}`,l=R)}}}else l=1;else I(D)&&r.charCodeAt(1)===i&&(m=r.slice(0,2),l=2,s>2&&d(r.charCodeAt(2))&&(S=!0,l=3));if(m.length>0)if(o.length>0){if(m.toLowerCase()!==o.toLowerCase())continue}else o=m;if(t){if(o.length>0)break}else if(c=`${r.slice(l)}\\${c}`,t=S,S&&o.length>0)break}return c=y(c,!t,"\\",d),t?`${o}\\${c}`:`${o}${c}`||"."},normalize(h){v(h,"path");const o=h.length;if(o===0)return".";let c=0,t,a=!1;const r=h.charCodeAt(0);if(o===1)return g(r)?"\\":h;if(d(r))if(a=!0,d(h.charCodeAt(1))){let l=2,m=l;for(;l<o&&!d(h.charCodeAt(l));)l++;if(l<o&&l!==m){const S=h.slice(m,l);for(m=l;l<o&&d(h.charCodeAt(l));)l++;if(l<o&&l!==m){for(m=l;l<o&&!d(h.charCodeAt(l));)l++;if(l===o)return`\\\\${S}\\${h.slice(m)}\\`;l!==m&&(t=`\\\\${S}\\${h.slice(m,l)}`,c=l)}}}else c=1;else I(r)&&h.charCodeAt(1)===i&&(t=h.slice(0,2),c=2,o>2&&d(h.charCodeAt(2))&&(a=!0,c=3));let s=c<o?y(h.slice(c),!a,"\\",d):"";return s.length===0&&!a&&(s="."),s.length>0&&d(h.charCodeAt(o-1))&&(s+="\\"),t===void 0?a?`\\${s}`:s:a?`${t}\\${s}`:`${t}${s}`},isAbsolute(h){v(h,"path");const o=h.length;if(o===0)return!1;const c=h.charCodeAt(0);return d(c)||o>2&&I(c)&&h.charCodeAt(1)===i&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let o,c;for(let r=0;r<h.length;++r){const s=h[r];v(s,"path"),s.length>0&&(o===void 0?o=c=s:o+=`\\${s}`)}if(o===void 0)return".";let t=!0,a=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++a;const r=c.length;r>1&&d(c.charCodeAt(1))&&(++a,r>2&&(d(c.charCodeAt(2))?++a:t=!1))}if(t){for(;a<o.length&&d(o.charCodeAt(a));)a++;a>=2&&(o=`\\${o.slice(a)}`)}return e.win32.normalize(o)},relative(h,o){if(v(h,"from"),v(o,"to"),h===o)return"";const c=e.win32.resolve(h),t=e.win32.resolve(o);if(c===t||(h=c.toLowerCase(),o=t.toLowerCase(),h===o))return"";let a=0;for(;a<h.length&&h.charCodeAt(a)===w;)a++;let r=h.length;for(;r-1>a&&h.charCodeAt(r-1)===w;)r--;const s=r-a;let l=0;for(;l<o.length&&o.charCodeAt(l)===w;)l++;let m=o.length;for(;m-1>l&&o.charCodeAt(m-1)===w;)m--;const S=m-l,D=s<S?s:S;let R=-1,F=0;for(;F<D;F++){const G=h.charCodeAt(a+F);if(G!==o.charCodeAt(l+F))break;G===w&&(R=F)}if(F!==D){if(R===-1)return t}else{if(S>D){if(o.charCodeAt(l+F)===w)return t.slice(l+F+1);if(F===2)return t.slice(l+F)}s>D&&(h.charCodeAt(a+F)===w?R=F:F===2&&(R=3)),R===-1&&(R=0)}let C="";for(F=a+R+1;F<=r;++F)(F===r||h.charCodeAt(F)===w)&&(C+=C.length===0?"..":"\\..");return l+=R,C.length>0?`${C}${t.slice(l,m)}`:(t.charCodeAt(l)===w&&++l,t.slice(l,m))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const o=e.win32.resolve(h);if(o.length<=2)return h;if(o.charCodeAt(0)===w){if(o.charCodeAt(1)===w){const c=o.charCodeAt(2);if(c!==P&&c!==n)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(I(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===w)return`\\\\?\\${o}`;return h},dirname(h){v(h,"path");const o=h.length;if(o===0)return".";let c=-1,t=0;const a=h.charCodeAt(0);if(o===1)return d(a)?h:".";if(d(a)){if(c=t=1,d(h.charCodeAt(1))){let l=2,m=l;for(;l<o&&!d(h.charCodeAt(l));)l++;if(l<o&&l!==m){for(m=l;l<o&&d(h.charCodeAt(l));)l++;if(l<o&&l!==m){for(m=l;l<o&&!d(h.charCodeAt(l));)l++;if(l===o)return h;l!==m&&(c=t=l+1)}}}}else I(a)&&h.charCodeAt(1)===i&&(c=o>2&&d(h.charCodeAt(2))?3:2,t=c);let r=-1,s=!0;for(let l=o-1;l>=t;--l)if(d(h.charCodeAt(l))){if(!s){r=l;break}}else s=!1;if(r===-1){if(c===-1)return".";r=c}return h.slice(0,r)},basename(h,o){o!==void 0&&v(o,"ext"),v(h,"path");let c=0,t=-1,a=!0,r;if(h.length>=2&&I(h.charCodeAt(0))&&h.charCodeAt(1)===i&&(c=2),o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let s=o.length-1,l=-1;for(r=h.length-1;r>=c;--r){const m=h.charCodeAt(r);if(d(m)){if(!a){c=r+1;break}}else l===-1&&(a=!1,l=r+1),s>=0&&(m===o.charCodeAt(s)?--s==-1&&(t=r):(s=-1,t=l))}return c===t?t=l:t===-1&&(t=h.length),h.slice(c,t)}for(r=h.length-1;r>=c;--r)if(d(h.charCodeAt(r))){if(!a){c=r+1;break}}else t===-1&&(a=!1,t=r+1);return t===-1?"":h.slice(c,t)},extname(h){v(h,"path");let o=0,c=-1,t=0,a=-1,r=!0,s=0;h.length>=2&&h.charCodeAt(1)===i&&I(h.charCodeAt(0))&&(o=t=2);for(let l=h.length-1;l>=o;--l){const m=h.charCodeAt(l);if(d(m)){if(!r){t=l+1;break}continue}a===-1&&(r=!1,a=l+1),m===n?c===-1?c=l:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||a===-1||s===0||s===1&&c===a-1&&c===t+1?"":h.slice(c,a)},format:u.bind(null,"\\"),parse(h){v(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const c=h.length;let t=0,a=h.charCodeAt(0);if(c===1)return d(a)?(o.root=o.dir=h,o):(o.base=o.name=h,o);if(d(a)){if(t=1,d(h.charCodeAt(1))){let R=2,F=R;for(;R<c&&!d(h.charCodeAt(R));)R++;if(R<c&&R!==F){for(F=R;R<c&&d(h.charCodeAt(R));)R++;if(R<c&&R!==F){for(F=R;R<c&&!d(h.charCodeAt(R));)R++;R===c?t=R:R!==F&&(t=R+1)}}}}else if(I(a)&&h.charCodeAt(1)===i){if(c<=2)return o.root=o.dir=h,o;if(t=2,d(h.charCodeAt(2))){if(c===3)return o.root=o.dir=h,o;t=3}}t>0&&(o.root=h.slice(0,t));let r=-1,s=t,l=-1,m=!0,S=h.length-1,D=0;for(;S>=t;--S){if(a=h.charCodeAt(S),d(a)){if(!m){s=S+1;break}continue}l===-1&&(m=!1,l=S+1),a===n?r===-1?r=S:D!==1&&(D=1):r!==-1&&(D=-1)}return l!==-1&&(r===-1||D===0||D===1&&r===l-1&&r===s+1?o.base=o.name=h.slice(s,l):(o.name=h.slice(s,r),o.base=h.slice(s,l),o.ext=h.slice(r,l))),s>0&&s!==t?o.dir=h.slice(0,s-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let o="",c=!1;for(let t=h.length-1;t>=-1&&!c;t--){const a=t>=0?h[t]:p.cwd();v(a,"path"),a.length!==0&&(o=`${a}/${o}`,c=a.charCodeAt(0)===f)}return o=y(o,!c,"/",g),c?`/${o}`:o.length>0?o:"."},normalize(h){if(v(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===f,c=h.charCodeAt(h.length-1)===f;return h=y(h,!o,"/",g),h.length===0?o?"/":c?"./":".":(c&&(h+="/"),o?`/${h}`:h)},isAbsolute(h){return v(h,"path"),h.length>0&&h.charCodeAt(0)===f},join(...h){if(h.length===0)return".";let o;for(let c=0;c<h.length;++c){const t=h[c];v(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(h,o){if(v(h,"from"),v(o,"to"),h===o||(h=e.posix.resolve(h),o=e.posix.resolve(o),h===o))return"";const c=1,t=h.length,a=t-c,r=1,s=o.length-r,l=a<s?a:s;let m=-1,S=0;for(;S<l;S++){const R=h.charCodeAt(c+S);if(R!==o.charCodeAt(r+S))break;R===f&&(m=S)}if(S===l)if(s>l){if(o.charCodeAt(r+S)===f)return o.slice(r+S+1);if(S===0)return o.slice(r+S)}else a>l&&(h.charCodeAt(c+S)===f?m=S:S===0&&(m=0));let D="";for(S=c+m+1;S<=t;++S)(S===t||h.charCodeAt(S)===f)&&(D+=D.length===0?"..":"/..");return`${D}${o.slice(r+m)}`},toNamespacedPath(h){return h},dirname(h){if(v(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===f;let c=-1,t=!0;for(let a=h.length-1;a>=1;--a)if(h.charCodeAt(a)===f){if(!t){c=a;break}}else t=!1;return c===-1?o?"/":".":o&&c===1?"//":h.slice(0,c)},basename(h,o){o!==void 0&&v(o,"ext"),v(h,"path");let c=0,t=-1,a=!0,r;if(o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let s=o.length-1,l=-1;for(r=h.length-1;r>=0;--r){const m=h.charCodeAt(r);if(m===f){if(!a){c=r+1;break}}else l===-1&&(a=!1,l=r+1),s>=0&&(m===o.charCodeAt(s)?--s==-1&&(t=r):(s=-1,t=l))}return c===t?t=l:t===-1&&(t=h.length),h.slice(c,t)}for(r=h.length-1;r>=0;--r)if(h.charCodeAt(r)===f){if(!a){c=r+1;break}}else t===-1&&(a=!1,t=r+1);return t===-1?"":h.slice(c,t)},extname(h){v(h,"path");let o=-1,c=0,t=-1,a=!0,r=0;for(let s=h.length-1;s>=0;--s){const l=h.charCodeAt(s);if(l===f){if(!a){c=s+1;break}continue}t===-1&&(a=!1,t=s+1),l===n?o===-1?o=s:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||t===-1||r===0||r===1&&o===t-1&&o===c+1?"":h.slice(o,t)},format:u.bind(null,"/"),parse(h){v(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const c=h.charCodeAt(0)===f;let t;c?(o.root="/",t=1):t=0;let a=-1,r=0,s=-1,l=!0,m=h.length-1,S=0;for(;m>=t;--m){const D=h.charCodeAt(m);if(D===f){if(!l){r=m+1;break}continue}s===-1&&(l=!1,s=m+1),D===n?a===-1?a=m:S!==1&&(S=1):a!==-1&&(S=-1)}if(s!==-1){const D=r===0&&c?1:r;a===-1||S===0||S===1&&a===s-1&&a===r+1?o.base=o.name=h.slice(D,s):(o.name=h.slice(D,a),o.base=h.slice(D,s),o.ext=h.slice(a,s))}return r>0?o.dir=h.slice(0,r-1):c&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[105],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var L;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(M,...b){const n=b.reduce((i,P)=>(i[P]=!0,i),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(i=>!n[i]).forEach(i=>{for(let P=0;P<f.length;P++)if(i.search(f[P])!==-1){delete M[i];break}})}e.sanitizeProcessEnvironment=k}),define(Z[78],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var p;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(p=e.ScanCode||(e.ScanCode={}));const L=[],k=Object.create(null),M=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>M[n]||0,toEnum:n=>k[n]||0,toString:n=>L[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class b{constructor(f,w,i,P,E){this.ctrlKey=f,this.shiftKey=w,this.altKey=i,this.metaKey=P,this.scanCode=E}equals(f){return this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.scanCode===f.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=b,function(){function n(f,w){L[f]=w,k[w]=f,M[w.toLowerCase()]=f}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let f=0;f<=193;f++)e.IMMUTABLE_CODE_TO_KEY_CODE[f]=-1;for(let f=0;f<=112;f++)e.IMMUTABLE_KEY_CODE_TO_CODE[f]=-1;function n(f,w){e.IMMUTABLE_CODE_TO_KEY_CODE[f]=w,w!==0&&w!==3&&w!==5&&w!==4&&w!==6&&w!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[w]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(Z[106],x([0,1,57,78]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class k{static _readModifiers(b){b=b.toLowerCase().trim();let n=!1,f=!1,w=!1,i=!1,P;do P=!1,/^ctrl(\+|\-)/.test(b)&&(n=!0,b=b.substr("ctrl-".length),P=!0),/^shift(\+|\-)/.test(b)&&(f=!0,b=b.substr("shift-".length),P=!0),/^alt(\+|\-)/.test(b)&&(w=!0,b=b.substr("alt-".length),P=!0),/^meta(\+|\-)/.test(b)&&(i=!0,b=b.substr("meta-".length),P=!0),/^win(\+|\-)/.test(b)&&(i=!0,b=b.substr("win-".length),P=!0),/^cmd(\+|\-)/.test(b)&&(i=!0,b=b.substr("cmd-".length),P=!0);while(P);let E;const v=b.indexOf(" ");return v>0?(E=b.substring(0,v),b=b.substring(v)):(E=b,b=""),{remains:b,ctrl:n,shift:f,alt:w,meta:i,key:E}}static parseSimpleKeybinding(b){const n=this._readModifiers(b),f=p.KeyCodeUtils.fromUserSettings(n.key);return[new p.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,f),n.remains]}static parseKeybinding(b,n){if(!b)return null;const f=[];let w;do[w,b]=this.parseSimpleKeybinding(b),f.push(w);while(b.length>0);return new p.ChordKeybinding(f)}static parseSimpleUserBinding(b){const n=this._readModifiers(b),f=n.key.match(/^\[([^\]]+)\]$/);if(f){const i=f[1],P=L.ScanCodeUtils.lowerCaseToEnum(i);return[new L.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,P),n.remains]}const w=p.KeyCodeUtils.fromUserSettings(n.key);return[new p.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,w),n.remains]}static parseUserBinding(b){if(!b)return[];const n=[];let f;for(;b.length>0;)[f,b]=this.parseSimpleUserBinding(b),n.push(f);return n}}e.KeybindingParser=k}),define(Z[107],x([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=p.globals.performance&&typeof p.globals.performance.now=="function";class k{constructor(b){this._highResolution=L&&b,this._startTime=this._now(),this._stopTime=-1}static create(b=!0){return new k(b)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Z[4],x([0,1,17,43,2,104,107]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(o){o.None=()=>k.Disposable.None;function c(_){return(j,$=null,B)=>{let H=!1,O;return O=_(q=>{if(!H)return O?O.dispose():H=!0,j.call($,q)},null,B),H&&O.dispose(),O}}o.once=c;function t(_,j){return S(($,B=null,H)=>_(O=>$.call(B,j(O)),null,H))}o.map=t;function a(_,j){return S(($,B=null,H)=>_(O=>{j(O),$.call(B,O)},null,H))}o.forEach=a;function r(_,j){return S(($,B=null,H)=>_(O=>j(O)&&$.call(B,O),null,H))}o.filter=r;function s(_){return _}o.signal=s;function l(..._){return(j,$=null,B)=>(0,k.combinedDisposable)(..._.map(H=>H(O=>j.call($,O),null,B)))}o.any=l;function m(_,j,$){let B=$;return t(_,H=>(B=j(B,H),B))}o.reduce=m;function S(_){let j;const $=new E({onFirstListenerAdd(){j=_($.fire,$)},onLastListenerRemove(){j.dispose()}});return $.event}function D(_,j,$=100,B=!1,H){let O,q,T,A=0;const W=new E({leakWarningThreshold:H,onFirstListenerAdd(){O=_(z=>{A++,q=j(q,z),B&&!T&&(W.fire(q),q=void 0),clearTimeout(T),T=setTimeout(()=>{const X=q;q=void 0,T=void 0,(!B||A>1)&&W.fire(X),A=0},$)})},onLastListenerRemove(){O.dispose()}});return W.event}o.debounce=D;function R(_,j=($,B)=>$===B){let $=!0,B;return r(_,H=>{const O=$||!j(H,B);return $=!1,B=H,O})}o.latch=R;function F(_,j){return[o.filter(_,j),o.filter(_,$=>!j($))]}o.split=F;function C(_,j=!1,$=[]){let B=$.slice(),H=_(T=>{B?B.push(T):q.fire(T)});const O=()=>{B&&B.forEach(T=>q.fire(T)),B=null},q=new E({onFirstListenerAdd(){H||(H=_(T=>q.fire(T)))},onFirstListenerDidAdd(){B&&(j?setTimeout(O):O())},onLastListenerRemove(){H&&H.dispose(),H=null}});return q.event}o.buffer=C;class G{constructor(j){this.event=j}map(j){return new G(t(this.event,j))}forEach(j){return new G(a(this.event,j))}filter(j){return new G(r(this.event,j))}reduce(j,$){return new G(m(this.event,j,$))}latch(){return new G(R(this.event))}debounce(j,$=100,B=!1,H){return new G(D(this.event,j,$,B,H))}on(j,$,B){return this.event(j,$,B)}once(j,$,B){return c(this.event)(j,$,B)}}function ne(_){return new G(_)}o.chain=ne;function ae(_,j,$=B=>B){const B=(...T)=>q.fire($(...T)),H=()=>_.on(j,B),O=()=>_.removeListener(j,B),q=new E({onFirstListenerAdd:H,onLastListenerRemove:O});return q.event}o.fromNodeEventEmitter=ae;function K(_,j,$=B=>B){const B=(...T)=>q.fire($(...T)),H=()=>_.addEventListener(j,B),O=()=>_.removeEventListener(j,B),q=new E({onFirstListenerAdd:H,onLastListenerRemove:O});return q.event}o.fromDOMEventEmitter=K;function ee(_){return new Promise(j=>c(_)(j))}o.toPromise=ee})(n=e.Event||(e.Event={}));class f{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${f._idPool++}`}start(c){this._stopWatch=new b.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let w=-1;function i(o){const c=w;return w=o,{dispose(){w=c}}}e.setGlobalLeakWarningThreshold=i;class P{constructor(c,t=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let t=w;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||c<t)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(a)||0;if(this._stacks.set(a,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let s,l=0;for(const[m,S]of this._stacks)(!s||l<S)&&(s=m,l=S);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${l}):`),console.warn(s)}return()=>{const s=this._stacks.get(a)||0;this._stacks.set(a,s-1)}}}class E{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=w>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(c,t,a)=>{this._listeners||(this._listeners=new M.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(t?[c,t]:c);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,t);const l=this._leakageMon?.check(this._listeners.size),m=(0,k.toDisposable)(()=>{l&&l(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof k.DisposableStore?a.add(m):Array.isArray(a)&&a.push(m),m}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,c]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,a]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,a):t[0].call(t[1],a)}catch(r){(0,p.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=E;class v extends E{async fireAsync(c,t,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,c]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[r,s]=this._asyncDeliveryQueue.shift(),l=[],m={...s,waitUntil:S=>{if(Object.isFrozen(l))throw new Error("waitUntil can NOT be called asynchronous");a&&(S=a(S,typeof r=="function"?r:r[0])),l.push(S)}};try{typeof r=="function"?r.call(void 0,m):r[0].call(r[1],m)}catch(S){(0,p.onUnexpectedError)(S);continue}Object.freeze(l),await Promise.allSettled(l).then(S=>{for(const D of S)D.status==="rejected"&&(0,p.onUnexpectedError)(D.reason)})}}}}e.AsyncEmitter=v;class d extends E{constructor(c){super(c);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=d;class g extends d{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=g;class I extends E{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=I;class y{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const t={event:c,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const a=()=>{this.hasListeners&&this.unhook(t);const r=this.events.indexOf(t);this.events.splice(r,1)};return(0,k.toDisposable)((0,L.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(t=>this.emitter.fire(t))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=y;class u{constructor(){this.buffers=[]}wrapEvent(c){return(t,a,r)=>c(s=>{const l=this.buffers[this.buffers.length-1];l?l.push(()=>t.call(a,s)):t.call(a,s)},void 0,r)}bufferEvents(c){const t=[];this.buffers.push(t);const a=c();return this.buffers.pop(),t.forEach(r=>r()),a}}e.EventBufferer=u;class h{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=k.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=h}),define(Z[23],x([0,1,4]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(n,f){const w=setTimeout(n.bind(f),0);return{dispose(){clearTimeout(w)}}});var k;(function(n){function f(w){return w===n.None||w===n.Cancelled||w instanceof M?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}n.isCancellationToken=f,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class b{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=k.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=b}),define(Z[108],x([0,1,4]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(P){const E=this._icons.get(P.id);E?P.description?E.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function M(i,P){return new n(i,P)}e.registerCodicon=M;function b(i){return i?i.replace(/\$\((.*?)\)/g,(P,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=b;class n{constructor(P,E,v){this.id=P,this.definition=E,this.description=v,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function f(i,P){const E=["codicon","codicon-"+i];return P&&E.push("codicon-modifier-"+P),E}e.getClassNamesArray=f;var w;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function E(g){if(g instanceof n)return["codicon","codicon-"+g.id];const I=P.exec(g.id);if(!I)return E(n.error);let[,y,u]=I;const h=["codicon","codicon-"+y];return u&&h.push("codicon-modifier-"+u.substr(1)),h}i.asClassNameArray=E;function v(g){return E(g).join(" ")}i.asClassName=v;function d(g){return"."+E(g).join(".")}i.asCSSSelector=d})(w=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(Z[65],x([0,1,17,2]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=k;function M(h){const o=h;return o?k(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=M;function b(h,o){return new n(h,o)}e.newWriteableStream=b;class n{constructor(o,c){this.reducer=o,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(c=>c(o))}emitError(o){this.listeners.error.length===0?(0,p.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(c=>c(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,c){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(o,c){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const a=t.indexOf(c);a>=0&&t.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(h,o){const c=[];let t;for(;(t=h.read())!==null;)c.push(t);return o(c)}e.consumeReadable=f;function w(h,o,c){const t=[];let a;for(;(a=h.read())!==null&&t.length<c;)t.push(a);return a===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof a!="undefined"){const r=a;return a=void 0,r}return h.read()}}}e.peekReadable=w;function i(h,o){return new Promise((c,t)=>{const a=[];P(h,{onData:r=>{o&&a.push(r)},onError:r=>{o?t(r):c(void 0)},onEnd:()=>{c(o?o(a):void 0)}})})}e.consumeStream=i;function P(h,o){h.on("error",c=>o.onError(c)),h.on("end",()=>o.onEnd()),h.on("data",c=>o.onData(c))}e.listenStream=P;function E(h,o){return new Promise((c,t)=>{const a=new L.DisposableStore,r=[],s=S=>{if(r.push(S),r.length>o)return a.dispose(),h.pause(),c({stream:h,buffer:r,ended:!1})},l=S=>t(S),m=()=>c({stream:h,buffer:r,ended:!0});a.add((0,L.toDisposable)(()=>h.removeListener("error",l))),h.on("error",l),a.add((0,L.toDisposable)(()=>h.removeListener("end",m))),h.on("end",m),a.add((0,L.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=E;function v(h,o){const c=b(o);return c.end(h),c}e.toStream=v;function d(){const h=b(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function g(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}e.toReadable=g;function I(h,o,c){const t=b(c);return P(h,{onData:a=>t.write(o.data(a)),onError:a=>t.error(o.error?o.error(a):a),onEnd:()=>t.end()}),t}e.transform=I;function y(h,o,c){let t=!1;return{read:()=>{const a=o.read();return t?a:(t=!0,a!==null?c([h,a]):h)}}}e.prefixedReadable=y;function u(h,o,c){let t=!1;const a=b(c);return P(o,{onData:r=>t?a.write(r):(t=!0,a.write(c([h,r]))),onError:r=>a.error(r),onEnd:()=>{t||(t=!0,a.write(h)),a.end()}}),a}e.prefixedStream=u}),define(Z[18],x([0,1,65]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let k,M;class b{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return L?new b(Buffer.allocUnsafe(s)):new b(new Uint8Array(s))}static wrap(s){return L&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new b(s)}static fromString(s,l){return!(l?.dontUseNodeBuffer||!1)&&L?new b(Buffer.from(s)):(k||(k=new TextEncoder),new b(k.encode(s)))}static concat(s,l){if(typeof l=="undefined"){l=0;for(let D=0,R=s.length;D<R;D++)l+=s[D].byteLength}const m=b.alloc(l);let S=0;for(let D=0,R=s.length;D<R;D++){const F=s[D];m.set(F,S),S+=F.byteLength}return m}toString(){return L?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(s,l){return new b(this.buffer.subarray(s,l))}set(s,l){s instanceof b?this.buffer.set(s.buffer,l):this.buffer.set(s,l)}readUInt32BE(s){return w(this.buffer,s)}writeUInt32BE(s,l){i(this.buffer,s,l)}readUInt32LE(s){return P(this.buffer,s)}writeUInt32LE(s,l){E(this.buffer,s,l)}readUInt8(s){return v(this.buffer,s)}writeUInt8(s,l){d(this.buffer,s,l)}}e.VSBuffer=b;function n(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0}e.readUInt16LE=n;function f(r,s,l){r[l+0]=s&255,s=s>>>8,r[l+1]=s&255}e.writeUInt16LE=f;function w(r,s){return r[s]*2**24+r[s+1]*2**16+r[s+2]*2**8+r[s+3]}e.readUInt32BE=w;function i(r,s,l){r[l+3]=s,s=s>>>8,r[l+2]=s,s=s>>>8,r[l+1]=s,s=s>>>8,r[l]=s}e.writeUInt32BE=i;function P(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0|r[s+2]<<16>>>0|r[s+3]<<24>>>0}e.readUInt32LE=P;function E(r,s,l){r[l+0]=s&255,s=s>>>8,r[l+1]=s&255,s=s>>>8,r[l+2]=s&255,s=s>>>8,r[l+3]=s&255}e.writeUInt32LE=E;function v(r,s){return r[s]}e.readUInt8=v;function d(r,s,l){r[l]=s}e.writeUInt8=d;function g(r){return p.consumeReadable(r,s=>b.concat(s))}e.readableToBuffer=g;function I(r){return p.toReadable(r)}e.bufferToReadable=I;function y(r){return p.consumeStream(r,s=>b.concat(s))}e.streamToBuffer=y;async function u(r){return r.ended?b.concat(r.buffer):b.concat([...r.buffer,await y(r.stream)])}e.bufferedStreamToBuffer=u;function h(r){return p.toStream(r,s=>b.concat(s))}e.bufferToStream=h;function o(r){return p.transform(r,{data:s=>typeof s=="string"?b.fromString(s):b.wrap(s)},s=>b.concat(s))}e.streamToBufferReadableStream=o;function c(r){return p.newWriteableStream(s=>b.concat(s),r)}e.newWriteableBufferStream=c;function t(r,s){return p.prefixedReadable(r,s,l=>b.concat(l))}e.prefixedBufferReadable=t;function a(r,s){return p.prefixedStream(r,s,l=>b.concat(l))}e.prefixedBufferStream=a}),define(Z[25],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=p;const L=/{(\d+)}/g;function k(Y,...se){return se.length===0?Y:Y.replace(L,function(ce,we){const ye=parseInt(we,10);return isNaN(ye)||ye<0||ye>=se.length?ce:se[ye]})}e.format=k;const M=/{([^}]+)}/g;function b(Y,se){return Y.replace(M,(ce,we)=>se[we]??ce)}e.format2=b;function n(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=n;function f(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function w(Y,se){let ce=0;const we=se.charCodeAt(0);for(let ye=Y.length-1;ye>=0;ye--)Y.charCodeAt(ye)===we&&ce++;return ce}e.count=w;function i(Y,se,ce="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${ce}`}e.truncate=i;function P(Y,se=" "){const ce=E(Y,se);return v(ce,se)}e.trim=P;function E(Y,se){if(!Y||!se)return Y;const ce=se.length;if(ce===0||Y.length===0)return Y;let we=0;for(;Y.indexOf(se,we)===we;)we=we+ce;return Y.substring(we)}e.ltrim=E;function v(Y,se){if(!Y||!se)return Y;const ce=se.length,we=Y.length;if(ce===0||we===0)return Y;let ye=we,De=-1;for(;De=Y.lastIndexOf(se,ye-1),!(De===-1||De+ce!==ye);){if(De===0)return"";ye=De}return Y.substring(0,ye)}e.rtrim=v;function d(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(Y){return Y.replace(/\*/g,"")}e.stripWildcards=g;function I(Y,se,ce={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=f(Y)),ce.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let we="";return ce.global&&(we+="g"),ce.matchCase||(we+="i"),ce.multiline&&(we+="m"),ce.unicode&&(we+="u"),new RegExp(Y,we)}e.createRegExp=I;function y(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function u(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function h(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=h;function o(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=o;function c(Y){for(let se=0,ce=Y.length;se<ce;se++){const we=Y.charCodeAt(se);if(we!==32&&we!==9)return se}return-1}e.firstNonWhitespaceIndex=c;function t(Y,se=0,ce=Y.length){for(let we=se;we<ce;we++){const ye=Y.charCodeAt(we);if(ye!==32&&ye!==9)return Y.substring(se,we)}return Y.substring(se,ce)}e.getLeadingWhitespace=t;function a(Y,se=Y.length-1){for(let ce=se;ce>=0;ce--){const we=Y.charCodeAt(ce);if(we!==32&&we!==9)return ce}return-1}e.lastNonWhitespaceIndex=a;function r(Y,se){return Y<se?-1:Y>se?1:0}e.compare=r;function s(Y,se,ce=0,we=Y.length,ye=0,De=se.length){for(;ce<we&&ye<De;ce++,ye++){let Ne=Y.charCodeAt(ce),ze=se.charCodeAt(ye);if(Ne<ze)return-1;if(Ne>ze)return 1}const Fe=we-ce,We=De-ye;return Fe<We?-1:Fe>We?1:0}e.compareSubstring=s;function l(Y,se){return m(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=l;function m(Y,se,ce=0,we=Y.length,ye=0,De=se.length){for(;ce<we&&ye<De;ce++,ye++){let Ne=Y.charCodeAt(ce),ze=se.charCodeAt(ye);if(Ne===ze)continue;const he=Ne-ze;if(!(he===32&&D(ze))&&!(he===-32&&D(Ne)))return S(Ne)&&S(ze)?he:s(Y.toLowerCase(),se.toLowerCase(),ce,we,ye,De)}const Fe=we-ce,We=De-ye;return Fe<We?-1:Fe>We?1:0}e.compareSubstringIgnoreCase=m;function S(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=S;function D(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=D;function R(Y){return S(Y)||D(Y)}function F(Y,se){return Y.length===se.length&&C(Y,se)}e.equalsIgnoreCase=F;function C(Y,se,ce=Y.length){for(let we=0;we<ce;we++){const ye=Y.charCodeAt(we),De=se.charCodeAt(we);if(ye!==De){if(R(ye)&&R(De)){const Fe=Math.abs(ye-De);if(Fe!==0&&Fe!==32)return!1}else if(String.fromCharCode(ye).toLowerCase()!==String.fromCharCode(De).toLowerCase())return!1}}return!0}function G(Y,se){const ce=se.length;return se.length>Y.length?!1:C(Y,se,ce)}e.startsWithIgnoreCase=G;function ne(Y,se){let ce,we=Math.min(Y.length,se.length);for(ce=0;ce<we;ce++)if(Y.charCodeAt(ce)!==se.charCodeAt(ce))return ce;return we}e.commonPrefixLength=ne;function ae(Y,se){let ce,we=Math.min(Y.length,se.length);const ye=Y.length-1,De=se.length-1;for(ce=0;ce<we;ce++)if(Y.charCodeAt(ye-ce)!==se.charCodeAt(De-ce))return ce;return we}e.commonSuffixLength=ae;function K(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=K;function ee(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=ee;function _(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=_;function j(Y,se,ce){const we=Y.charCodeAt(ce);if(K(we)&&ce+1<se){const ye=Y.charCodeAt(ce+1);if(ee(ye))return _(we,ye)}return we}e.getNextCodePoint=j;function $(Y,se){const ce=Y.charCodeAt(se-1);if(ee(ce)&&se>1){const we=Y.charCodeAt(se-2);if(K(we))return _(we,ce)}return ce}function B(Y,se){const ce=Be.getInstance(),we=se,ye=Y.length,De=j(Y,ye,se);se+=De>=65536?2:1;let Fe=ce.getGraphemeBreakType(De);for(;se<ye;){const We=j(Y,ye,se),Ne=ce.getGraphemeBreakType(We);if(Ce(Fe,Ne))break;se+=We>=65536?2:1,Fe=Ne}return se-we}e.nextCharLength=B;function H(Y,se){const ce=Be.getInstance(),we=se,ye=$(Y,se);se-=ye>=65536?2:1;let De=ce.getGraphemeBreakType(ye);for(;se>0;){const Fe=$(Y,se),We=ce.getGraphemeBreakType(Fe);if(Ce(We,De))break;se-=Fe>=65536?2:1,De=We}return we-se}e.prevCharLength=H;function O(Y,se){const ce=Be.getInstance(),we=Y.length,ye=se,De=j(Y,we,se),Fe=ce.getGraphemeBreakType(De);se+=De>=65536?2:1;let We=Fe;for(;se<we;){const ze=j(Y,we,se),he=ce.getGraphemeBreakType(ze);if(Ce(We,he))break;se+=ze>=65536?2:1,We=he}const Ne=se;for(se=ye,We=Fe;se>0;){const ze=$(Y,se),he=ce.getGraphemeBreakType(ze);if(Ce(he,We))break;se-=ze>=65536?2:1,We=he}return[se,Ne]}function q(Y,se){return se>0&&ee(Y.charCodeAt(se))?O(Y,se-1):O(Y,se)}e.getCharContainingOffset=q;const T=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function A(Y){return T.test(Y)}e.containsRTL=A;const W=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function z(Y){return W.test(Y)}e.containsEmoji=z;const X=/^[\t\n\r\x20-\x7E]*$/;function U(Y){return X.test(Y)}e.isBasicASCII=U,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function N(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=N;function Q(Y){for(let se=0,ce=Y.length;se<ce;se++)if(J(Y.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=Q;function J(Y){return Y=+Y,Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=J;function re(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=re;function le(Y,se){if(Y.length<se)return Y;const ce=/\b/g;let we=0;for(;ce.test(Y)&&!(Y.length-ce.lastIndex<se);)we=ce.lastIndex,ce.lastIndex+=1;return Y.substring(we).replace(/^\s/,"")}e.lcut=le;const ie=/\x1B\x5B[12]?K/g,oe=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function fe(Y){return Y&&(Y=Y.replace(ie,""),Y=Y.replace(oe,""),Y=Y.replace(ge,"")),Y}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function de(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=de;function Pe(Y){return de(Y)?Y.substr(1):Y}e.stripUTF8BOM=Pe;function pe(Y,se){if(!Y||!se||Y.length<se.length)return!1;const ce=se.length,we=Y.toLowerCase();let ye=0,De=-1;for(;ye<ce;){const Fe=we.indexOf(se[ye],De+1);if(Fe<0)return!1;De=Fe,ye++}return!0}e.fuzzyContains=pe;function me(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=me;function be(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=be;function ke(Y,se=1){if(se===0)return"";let ce=-1;do ce=Y.indexOf(`
`,ce+1),se--;while(se>0&&ce>=0);return ce===-1?Y:(Y[ce-1]==="\r"&&ce--,Y.substr(0,ce))}e.getNLines=ke;function Ae(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=Ae;function Ue(Y){return Be.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Ue;function Ce(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}e.breakBetweenGraphemeBreakType=Ce;var Ge;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=ot()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ce=this._data,we=ce.length/3;let ye=1;for(;ye<=we;)if(se<ce[3*ye])ye=2*ye;else if(se>ce[3*ye+1])ye=2*ye+1;else return ce[3*ye+2];return 0}}Be._INSTANCE=null;function ot(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ze(Y,se){if(Y===0)return 0;const ce=at(Y,se);if(ce!==void 0)return ce;const we=$(se,Y);return Y-=Ye(we),Y}e.getLeftDeleteOffset=Ze;function at(Y,se){let ce=$(se,Y);for(Y-=Ye(ce);ht(ce)||ce===65039||ce===8419;){if(Y===0)return;ce=$(se,Y),Y-=Ye(ce)}if(!!re(ce)){if(Y>=0){const we=$(se,Y);we===8205&&(Y-=Ye(we))}return Y}}function Ye(Y){return Y>=65536?2:1}function ht(Y){return 127995<=Y&&Y<=127999}var xe;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={}))}),define(Z[79],x([0,1,25]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(y){return k(y,0)}e.hash=L;function k(y,u){switch(typeof y){case"object":return y===null?M(349,u):Array.isArray(y)?f(y,u):w(y,u);case"string":return n(y,u);case"boolean":return b(y,u);case"number":return M(y,u);case"undefined":return M(937,u);default:return M(617,u)}}e.doHash=k;function M(y,u){return(u<<5)-u+y|0}function b(y,u){return M(y?433:863,u)}function n(y,u){u=M(149417,u);for(let h=0,o=y.length;h<o;h++)u=M(y.charCodeAt(h),u);return u}e.stringHash=n;function f(y,u){return u=M(104579,u),y.reduce((h,o)=>k(o,h),u)}function w(y,u){return u=M(181387,u),Object.keys(y).sort().reduce((h,o)=>(h=n(o,h),k(y[o],h)),u)}class i{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=k(u,this._value),this._value}}e.Hasher=i;var P;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function E(y,u,h=32){const o=h-u,c=~((1<<o)-1);return(y<<u|(c&y)>>>o)>>>0}function v(y,u=0,h=y.byteLength,o=0){for(let c=0;c<h;c++)y[u+c]=o}function d(y,u,h="0"){for(;y.length<u;)y=h+y;return y}function g(y,u=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((y>>>0).toString(16),u/4)}e.toHexString=g;class I{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const h=u.length;if(h===0)return;const o=this._buff;let c=this._buffLen,t=this._leftoverHighSurrogate,a,r;for(t!==0?(a=t,r=-1,t=0):(a=u.charCodeAt(0),r=0);;){let s=a;if(p.isHighSurrogate(a))if(r+1<h){const l=u.charCodeAt(r+1);p.isLowSurrogate(l)?(r++,s=p.computeCodePoint(a,l)):s=65533}else{t=a;break}else p.isLowSurrogate(a)&&(s=65533);if(c=this._push(o,c,s),r++,r<h)a=u.charCodeAt(r);else break}this._buffLen=c,this._leftoverHighSurrogate=t}_push(u,h,o){return o<128?u[h++]=o:o<2048?(u[h++]=192|(o&1984)>>>6,u[h++]=128|(o&63)>>>0):o<65536?(u[h++]=224|(o&61440)>>>12,u[h++]=128|(o&4032)>>>6,u[h++]=128|(o&63)>>>0):(u[h++]=240|(o&1835008)>>>18,u[h++]=128|(o&258048)>>>12,u[h++]=128|(o&4032)>>>6,u[h++]=128|(o&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=I._bigBlock32,h=this._buffDV;for(let S=0;S<64;S+=4)u.setUint32(S,h.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)u.setUint32(S,E(u.getUint32(S-12,!1)^u.getUint32(S-32,!1)^u.getUint32(S-56,!1)^u.getUint32(S-64,!1),1),!1);let o=this._h0,c=this._h1,t=this._h2,a=this._h3,r=this._h4,s,l,m;for(let S=0;S<80;S++)S<20?(s=c&t|~c&a,l=1518500249):S<40?(s=c^t^a,l=1859775393):S<60?(s=c&t|c&a|t&a,l=2400959708):(s=c^t^a,l=3395469782),m=E(o,5)+s+r+l+u.getUint32(S*4,!1)&4294967295,r=a,a=t,t=E(c,30),c=o,o=m;this._h0=this._h0+o&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=I,I._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[13],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(D){return Array.isArray(D)}e.isArray=p;function L(D){return typeof D=="string"}e.isString=L;function k(D){return Array.isArray(D)&&D.every(R=>L(R))}e.isStringArray=k;function M(D){return typeof D=="object"&&D!==null&&!Array.isArray(D)&&!(D instanceof RegExp)&&!(D instanceof Date)}e.isObject=M;function b(D){return typeof D=="number"&&!isNaN(D)}e.isNumber=b;function n(D){return!!D&&typeof D[Symbol.iterator]=="function"}e.isIterable=n;function f(D){return D===!0||D===!1}e.isBoolean=f;function w(D){return typeof D=="undefined"}e.isUndefined=w;function i(D){return!P(D)}e.isDefined=i;function P(D){return w(D)||D===null}e.isUndefinedOrNull=P;function E(D,R){if(!D)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}e.assertType=E;function v(D){if(P(D))throw new Error("Assertion Failed: argument is undefined or null");return D}e.assertIsDefined=v;function d(...D){const R=[];for(let F=0;F<D.length;F++){const C=D[F];if(P(C))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);R.push(C)}return R}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function I(D){if(!M(D))return!1;for(let R in D)if(g.call(D,R))return!1;return!0}e.isEmptyObject=I;function y(D){return typeof D=="function"}e.isFunction=y;function u(...D){return D.length>0&&D.every(y)}e.areFunctions=u;function h(D,R){const F=Math.min(D.length,R.length);for(let C=0;C<F;C++)o(D[C],R[C])}e.validateConstraints=h;function o(D,R){if(L(R)){if(typeof D!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(y(R)){try{if(D instanceof R)return}catch{}if(!P(D)&&D.constructor===R||R.length===1&&R.call(void 0,D)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function c(D){let R=[],F=Object.getPrototypeOf(D);for(;Object.prototype!==F;)R=R.concat(Object.getOwnPropertyNames(F)),F=Object.getPrototypeOf(F);return R}e.getAllPropertyNames=c;function t(D){const R=[];for(const F of c(D))typeof D[F]=="function"&&R.push(F);return R}e.getAllMethodNames=t;function a(D,R){const F=G=>function(){const ne=Array.prototype.slice.call(arguments,0);return R(G,ne)};let C={};for(const G of D)C[G]=F(G);return C}e.createProxyObject=a;function r(D){return D===null?void 0:D}e.withNullAsUndefined=r;function s(D){return typeof D=="undefined"?null:D}e.withUndefinedAsNull=s;function l(D){return class{constructor(){return new Proxy({},{get(R,F){if(R[F])return R[F];throw new Error(`Not Implemented: ${D}->${String(F)}`)}})}}}e.NotImplementedProxy=l;function m(D,R="Unreachable"){throw new Error(R)}e.assertNever=m;function S(D){return!!D&&typeof D.then=="function"&&typeof D.catch=="function"}e.isPromise=S}),define(Z[31],x([0,1,8,3,25,13]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function b(r){return r===47||r===92}e.isPathSeparator=b;function n(r){return r.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=n;function f(r){return r.indexOf("/")===-1&&(r=n(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=f;function w(r,s=p.posix.sep){if(!r)return"";const l=r.length,m=r.charCodeAt(0);if(b(m)){if(b(r.charCodeAt(1))&&!b(r.charCodeAt(2))){let D=3;const R=D;for(;D<l&&!b(r.charCodeAt(D));D++);if(R!==D&&!b(r.charCodeAt(D+1))){for(D+=1;D<l;D++)if(b(r.charCodeAt(D)))return r.slice(0,D+1).replace(/[\\/]/g,s)}}return s}else if(y(m)&&r.charCodeAt(1)===58)return b(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let S=r.indexOf("://");if(S!==-1){for(S+=3;S<l;S++)if(b(r.charCodeAt(S)))return r.slice(0,S+1)}return""}e.getRoot=w;function i(r){if(!L.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let l=2;const m=l;for(;l<r.length&&(s=r.charCodeAt(l),s!==92);l++);return!(m===l||(s=r.charCodeAt(l+1),isNaN(s)||s===92))}e.isUNC=i;const P=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,s=L.isWindows){const l=s?P:E;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||s&&v.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function g(r,s,l){const m=r===s;return!l||m?m:!r||!s?!1:(0,k.equalsIgnoreCase)(r,s)}e.isEqual=g;function I(r,s,l,m=p.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let D=s.length;return s.charAt(s.length-1)===m&&D--,r.charAt(D)===m}return s.charAt(s.length-1)!==m&&(s+=m),r.indexOf(s)===0}e.isEqualOrParent=I;function y(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=y;function u(r,s){return L.isWindows&&r.endsWith(":")&&(r+=p.sep),(0,p.isAbsolute)(r)||(r=(0,p.join)(s,r)),r=(0,p.normalize)(r),L.isWindows?(r=(0,k.rtrim)(r,p.sep),r.endsWith(":")&&(r+=p.sep)):(r=(0,k.rtrim)(r,p.sep),r||(r=p.sep)),r}e.sanitizeFilePath=u;function h(r){const s=(0,p.normalize)(r);return L.isWindows?r.length>3?!1:o(s)&&(r.length===2||s.charCodeAt(2)===92):s===p.posix.sep}e.isRootOrDriveLetter=h;function o(r){return L.isWindows?y(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function c(r){return o(r)?r[0]:void 0}e.getDriveLetter=c;function t(r,s,l){return s.length>r.length?-1:r===s?0:(l&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=t;function a(r){const s=r.split(":");let l,m,S;if(s.forEach(D=>{const R=Number(D);(0,M.isNumber)(R)?m===void 0?m=R:S===void 0&&(S=R):l=l?[l,D].join(":"):D}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:m!==void 0?m:void 0,column:S!==void 0?S:m!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(Z[44],x([0,1,13]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const I=Array.isArray(g)?[]:{};return Object.keys(g).forEach(y=>{g[y]&&typeof g[y]=="object"?I[y]=L(g[y]):I[y]=g[y]}),I}e.deepClone=L;function k(g){if(!g||typeof g!="object")return g;const I=[g];for(;I.length>0;){const y=I.shift();Object.freeze(y);for(const u in y)if(M.call(y,u)){const h=y[u];typeof h=="object"&&!Object.isFrozen(h)&&I.push(h)}}return g}e.deepFreeze=k;const M=Object.prototype.hasOwnProperty;function b(g,I){return n(g,I,new Set)}e.cloneAndChange=b;function n(g,I,y){if((0,p.isUndefinedOrNull)(g))return g;const u=I(g);if(typeof u!="undefined")return u;if((0,p.isArray)(g)){const h=[];for(const o of g)h.push(n(o,I,y));return h}if((0,p.isObject)(g)){if(y.has(g))throw new Error("Cannot clone recursive data-structure");y.add(g);const h={};for(let o in g)M.call(g,o)&&(h[o]=n(g[o],I,y));return y.delete(g),h}return g}function f(g,I,y=!0){return(0,p.isObject)(g)?((0,p.isObject)(I)&&Object.keys(I).forEach(u=>{u in g?y&&((0,p.isObject)(g[u])&&(0,p.isObject)(I[u])?f(g[u],I[u],y):g[u]=I[u]):g[u]=I[u]}),g):I}e.mixin=f;function w(g,I){if(g===I)return!0;if(g==null||I===null||I===void 0||typeof g!=typeof I||typeof g!="object"||Array.isArray(g)!==Array.isArray(I))return!1;let y,u;if(Array.isArray(g)){if(g.length!==I.length)return!1;for(y=0;y<g.length;y++)if(!w(g[y],I[y]))return!1}else{const h=[];for(u in g)h.push(u);h.sort();const o=[];for(u in I)o.push(u);if(o.sort(),!w(h,o))return!1;for(y=0;y<h.length;y++)if(!w(g[h[y]],I[h[y]]))return!1}return!0}e.equals=w;function i(g){const I=new Set;return JSON.stringify(g,(y,u)=>{if((0,p.isObject)(u)||Array.isArray(u)){if(I.has(u))return"[Circular]";I.add(u)}return u})}e.safeStringify=i;function P(g,I,y){const u=I(g);return typeof u=="undefined"?y:u}e.getOrDefault=P;function E(g,I){const y=Object.create(null);return!g||!I||Object.keys(I).forEach(h=>{const o=g[h],c=I[h];w(o,c)||(y[h]=c)}),y}e.distinct=E;function v(g,I){const y=I.toLowerCase(),u=Object.keys(g).find(h=>h.toLowerCase()===y);return u?g[u]:g[I]}e.getCaseInsensitive=v;function d(g,I){const y=Object.create(null);for(const u of Object.keys(g))I(u,g[u])&&(y[u]=g[u]);return y}e.filter=d}),define(Z[7],x([0,1,8,3]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,M=/^\//,b=/^\/\//;function n(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!M.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(r,s){return!r&&!s?"file":r}function w(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==P&&(s=P+s):s=P;break}return s}const i="",P="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(s,l,m,S,D,R=!1){typeof s=="object"?(this.scheme=s.scheme||i,this.authority=s.authority||i,this.path=s.path||i,this.query=s.query||i,this.fragment=s.fragment||i):(this.scheme=f(s,R),this.authority=l||i,this.path=w(this.scheme,m||i),this.query=S||i,this.fragment=D||i,n(this,R))}static isUri(s){return s instanceof v?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return h(this,!1)}with(s){if(!s)return this;let{scheme:l,authority:m,path:S,query:D,fragment:R}=s;return l===void 0?l=this.scheme:l===null&&(l=i),m===void 0?m=this.authority:m===null&&(m=i),S===void 0?S=this.path:S===null&&(S=i),D===void 0?D=this.query:D===null&&(D=i),R===void 0?R=this.fragment:R===null&&(R=i),l===this.scheme&&m===this.authority&&S===this.path&&D===this.query&&R===this.fragment?this:new g(l,m,S,D,R)}static parse(s,l=!1){const m=E.exec(s);return m?new g(m[2]||i,a(m[4]||i),a(m[5]||i),a(m[7]||i),a(m[9]||i),l):new g(i,i,i,i,i)}static file(s){let l=i;if(L.isWindows&&(s=s.replace(/\\/g,P)),s[0]===P&&s[1]===P){const m=s.indexOf(P,2);m===-1?(l=s.substring(2),s=P):(l=s.substring(2,m),s=s.substring(m)||P)}return new g("file",l,s,i,i)}static from(s){const l=new g(s.scheme,s.authority,s.path,s.query,s.fragment);return n(l,!0),l}static joinPath(s,...l){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return L.isWindows&&s.scheme==="file"?m=v.file(p.win32.join(h(s,!0),...l)).path:m=p.posix.join(s.path,...l),s.with({path:m})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof v)return s;{const l=new g(s);return l._formatted=s.external,l._fsPath=s._sep===d?s.fsPath:null,l}}else return s}}e.URI=v;const d=L.isWindows?1:void 0;class g extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=d),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const I={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(r,s){let l,m=-1;for(let S=0;S<r.length;S++){const D=r.charCodeAt(S);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||s&&D===47)m!==-1&&(l+=encodeURIComponent(r.substring(m,S)),m=-1),l!==void 0&&(l+=r.charAt(S));else{l===void 0&&(l=r.substr(0,S));const R=I[D];R!==void 0?(m!==-1&&(l+=encodeURIComponent(r.substring(m,S)),m=-1),l+=R):m===-1&&(m=S)}}return m!==-1&&(l+=encodeURIComponent(r.substring(m))),l!==void 0?l:r}function u(r){let s;for(let l=0;l<r.length;l++){const m=r.charCodeAt(l);m===35||m===63?(s===void 0&&(s=r.substr(0,l)),s+=I[m]):s!==void 0&&(s+=r[l])}return s!==void 0?s:r}function h(r,s){let l;return r.authority&&r.path.length>1&&r.scheme==="file"?l=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?l=r.path.substr(1):l=r.path[1].toLowerCase()+r.path.substr(2):l=r.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=h;function o(r,s){const l=s?u:y;let m="",{scheme:S,authority:D,path:R,query:F,fragment:C}=r;if(S&&(m+=S,m+=":"),(D||S==="file")&&(m+=P,m+=P),D){let G=D.indexOf("@");if(G!==-1){const ne=D.substr(0,G);D=D.substr(G+1),G=ne.indexOf(":"),G===-1?m+=l(ne,!1):(m+=l(ne.substr(0,G),!1),m+=":",m+=l(ne.substr(G+1),!1)),m+="@"}D=D.toLowerCase(),G=D.indexOf(":"),G===-1?m+=l(D,!1):(m+=l(D.substr(0,G),!1),m+=D.substr(G))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const G=R.charCodeAt(1);G>=65&&G<=90&&(R=`/${String.fromCharCode(G+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const G=R.charCodeAt(0);G>=65&&G<=90&&(R=`${String.fromCharCode(G+32)}:${R.substr(2)}`)}m+=l(R,!0)}return F&&(m+="?",m+=l(F,!1)),C&&(m+="#",m+=s?C:y(C,!1)),m}function c(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+c(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(r){return r.match(t)?r.replace(t,s=>c(s)):r}}),define(Z[109],x([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const i=w;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function k(w){const i=[];let P;try{const E=JSON.parse(w.arguments),v=E[E.length-1];v&&v.__$stack&&(E.pop(),P=v.__$stack),i.push(...E)}catch(E){i.push("Unable to log remote console arguments",w.arguments)}return{args:i,stack:P}}e.parse=k;function M(w){if(typeof w!="string")return M(k(w).stack);const i=w;if(i){const P=b(i),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(E&&E.length===4)return{uri:p.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=M;function b(w){if(!w)return w;const i=w.indexOf(`
`);return i===-1?w:w.substring(0,i)}function n(w,i){const{args:P,stack:E}=k(w),v=typeof P[0]=="string"&&P.length===1;let d=b(E);d&&(d=`(${d.trim()})`);let g=[];if(typeof P[0]=="string"?d&&v?g=[`%c[${i}] %c${P[0]} %c${d}`,f("blue"),f(""),f("grey")]:g=[`%c[${i}] %c${P[0]}`,f("blue"),f(""),...P.slice(1)]:g=[`%c[${i}]%`,f("blue"),...P],d&&!v&&g.push(d),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,g)}e.log=n;function f(w){return`color: ${w}`}});var bt=this&&this.__classPrivateFieldSet||function(V,e,p,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?V!==e||!k:!e.has(V))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(V,p):k?k.value=p:e.set(V,p),p},je=this&&this.__classPrivateFieldGet||function(V,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?V!==e||!L:!e.has(V))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(V):L?L.value:e.get(V)};define(Z[37],x([0,1,30,25,7]),function(V,e,p,L,k){"use strict";var M,b,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function f(a,r,s){let l=a.get(r);return l===void 0&&(l=s,a.set(r,l)),l}e.getOrSet=f;function w(a){const r=[];return a.forEach((s,l)=>{r.push(`${l} => ${s}`)}),`Map(${a.size}) {${r.join(", ")}}`}e.mapToString=w;function i(a){const r=[];return a.forEach(s=>{r.push(s)}),`Set(${a.size}) {${r.join(", ")}}`}e.setToString=i;class P{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),l=this._value.charCodeAt(this._pos);return s-l}value(){return this._value[this._pos]}}e.StringIterator=P;class E{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class v{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var d;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(d||(d={}));class g{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class I{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class y{constructor(r){this._iter=r}static forUris(r=()=>!1){return new y(new g(r))}static forPaths(){return new y(new v)}static forStrings(){return new y(new P)}static forConfigKeys(){return new y(new E)}clear(){this._root=void 0}set(r,s){const l=this._iter.reset(r);let m;for(this._root||(this._root=new I,this._root.segment=l.value()),m=this._root;;){const D=l.cmp(m.segment);if(D>0)m.left||(m.left=new I,m.left.segment=l.value()),m=m.left;else if(D<0)m.right||(m.right=new I,m.right.segment=l.value()),m=m.right;else if(l.hasNext())l.next(),m.mid||(m.mid=new I,m.mid.segment=l.value()),m=m.mid;else break}const S=m.value;return m.value=s,m.key=r,S}fill(r,s){const l=s.slice(0);(0,p.shuffle)(l);for(let m of l)this.set(m,r)}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let l=this._root;for(;l;){const m=s.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else break}return l}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const l=this._iter.reset(r),m=[];let S=this._root;for(;S;){const D=l.cmp(S.segment);if(D>0)m.push([1,S]),S=S.left;else if(D<0)m.push([-1,S]),S=S.right;else if(l.hasNext())l.next(),m.push([0,S]),S=S.mid;else{for(s?(S.left=void 0,S.mid=void 0,S.right=void 0):S.value=void 0;m.length>0&&S.isEmpty();){let[R,F]=m.pop();switch(R){case 1:F.left=void 0;break;case 0:F.mid=void 0;break;case-1:F.right=void 0;break}S=F}break}}}findSubstr(r){const s=this._iter.reset(r);let l=this._root,m;for(;l;){const S=s.cmp(l.segment);if(S>0)l=l.left;else if(S<0)l=l.right;else if(s.hasNext())s.next(),m=l.value||m,l=l.mid;else break}return l&&l.value||m}findSuperstr(r){const s=this._iter.reset(r);let l=this._root;for(;l;){const m=s.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(r){for(const[s,l]of this)r(l,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const l=s.pop();l&&(l.value&&(yield[l.key,l.value]),l.left&&s.push(l.left),l.mid&&s.push(l.mid),l.right&&s.push(l.right))}}}e.TernarySearchTree=y;class u{constructor(r,s){this[M]="ResourceMap",r instanceof u?(this.map=new Map(r.map),this.toKey=s??u.defaultToKey):(this.map=new Map,this.toKey=r??u.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[l,m]of this.map)r(m,k.URI.parse(l),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield k.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[k.URI.parse(r[0]),r[1]]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[k.URI.parse(r[0]),r[1]]}}e.ResourceMap=u,u.defaultToKey=a=>a.toString();var h;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class o{constructor(){this[b]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const l=this._map.get(r);if(!!l)return s!==0&&this.touch(l,s),l.value}set(r,s,l=0){let m=this._map.get(r);if(m)m.value=s,l!==0&&this.touch(m,l);else{switch(m={key:r,value:s,next:void 0,previous:void 0},l){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(r,m),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const l=this._state;let m=this._head;for(;m;){if(s?r.bind(s)(m.value,m.key,this):r(m.value,m.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const r=this,s=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.key,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return m}values(){const r=this,s=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.value,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return m}entries(){const r=this,s=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:[l.key,l.value],done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return m}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,l=this.size;for(;s&&l>r;)this._map.delete(s.key),s=s.next,l--;this._head=s,this._size=l,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,l=r.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const l=r.next,m=r.previous;r===this._tail?(m.next=void 0,this._tail=m):(l.previous=m,m.next=l),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const l=r.next,m=r.previous;r===this._head?(l.previous=void 0,this._head=l):(l.previous=m,m.next=l),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,l)=>{r.push([l,s])}),r}fromJSON(r){this.clear();for(const[s,l]of r)this.set(s,l)}}e.LinkedMap=o;class c extends o{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class t{constructor(r){n.set(this,void 0),bt(this,n,r,"f")}get size(){return je(this,n,"f").size}forEach(r,s){je(this,n,"f").forEach(r,s)}get(r){return je(this,n,"f").get(r)}has(r){return je(this,n,"f").has(r)}entries(){return je(this,n,"f").entries()}keys(){return je(this,n,"f").keys()}values(){return je(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return je(this,n,"f").entries()}}e.ReadonlyMapView=t}),define(Z[110],x([0,1,18,25,7]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(i){return JSON.stringify(i,f)}e.stringify=M;function b(i){let P=JSON.parse(i);return P=w(P),P}e.parse=b;var n;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function f(i,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,L.regExpFlags)(P)}:P}function w(i,P=0){if(!i||P>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return k.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof p.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let E=0;E<i.length;++E)i[E]=w(i[E],P+1);else for(const E in i)Object.hasOwnProperty.call(i,E)&&(i[E]=w(i[E],P+1))}return i}e.revive=w}),define(Z[10],x([0,1,3,7]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,w,i){this._hosts[f]=w,this._ports[f]=i}setConnectionToken(f,w){this._connectionTokens[f]=w}rewrite(f){if(this._delegate)return this._delegate(f);const w=f.authority;let i=this._hosts[w];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const P=this._ports[w],E=this._connectionTokens[w];let v=`path=${encodeURIComponent(f.path)}`;return typeof E=="string"&&(v+=`&tkn=${encodeURIComponent(E)}`),L.URI.from({scheme:p.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${i}:${P}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new M;class b{asBrowserUri(f,w){const i=this.toUri(f,w);return i.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===k.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${k.vscodeFileResource}://${b.FALLBACK_AUTHORITY}`)?i.with({scheme:k.vscodeFileResource,authority:i.authority||b.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(f,w){const i=this.toUri(f,w);return i.scheme===k.vscodeFileResource?i.with({scheme:k.file,authority:i.authority!==b.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(f,w){return L.URI.isUri(f)?f:L.URI.parse(w.toUrl(f))}}b.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new b}),define(Z[66],x([0,1,37]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new p.LRUCache(1e4);function k(w){return f(w,"NFC",L)}e.normalizeNFC=k;const M=new p.LRUCache(1e4);function b(w){return f(w,"NFD",M)}e.normalizeNFD=b;const n=/[^\u0000-\u0080]/;function f(w,i,P){if(!w)return w;const E=P.get(w);if(E)return E;let v;return n.test(w)?v=w.normalize(i):v=w,P.set(w,v),v}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(i){return b(i).replace(w,"")}}()}),define(Z[15],x([0,1,31,10,8,3,25,7]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(v){return(0,n.uriToFsPath)(v,!0)}e.originalFSPath=f;class w{constructor(d){this._ignorePathCasing=d}compare(d,g,I=!1){return d===g?0:(0,b.compare)(this.getComparisonKey(d,I),this.getComparisonKey(g,I))}isEqual(d,g,I=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,I)===this.getComparisonKey(g,I)}getComparisonKey(d,g=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,g,I=!1){if(d.scheme===g.scheme){if(d.scheme===L.Schemas.file)return p.isEqualOrParent(f(d),f(g),this._ignorePathCasing(d))&&d.query===g.query&&(I||d.fragment===g.fragment);if((0,e.isEqualAuthority)(d.authority,g.authority))return p.isEqualOrParent(d.path,g.path,this._ignorePathCasing(d),"/")&&d.query===g.query&&(I||d.fragment===g.fragment)}return!1}joinPath(d,...g){return n.URI.joinPath(d,...g)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===L.Schemas.file?g=n.URI.file(k.dirname(f(d))).path:(g=k.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===L.Schemas.file?g=n.URI.file(k.normalize(f(d))).path:g=k.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(d.scheme!==g.scheme||!(0,e.isEqualAuthority)(d.authority,g.authority))return;if(d.scheme===L.Schemas.file){const u=k.relative(f(d),f(g));return M.isWindows?p.toSlashes(u):u}let I=d.path||"/",y=g.path||"/";if(this._ignorePathCasing(d)){let u=0;for(const h=Math.min(I.length,y.length);u<h&&!(I.charCodeAt(u)!==y.charCodeAt(u)&&I.charAt(u).toLowerCase()!==y.charAt(u).toLowerCase());u++);I=y.substr(0,u)+I.substr(u)}return k.posix.relative(I,y)}resolvePath(d,g){if(d.scheme===L.Schemas.file){const I=n.URI.file(k.resolve(f(d),g));return d.with({authority:I.authority,path:I.path})}return g=p.toPosixPath(g),d.with({path:k.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||(0,b.equalsIgnoreCase)(d,g)}hasTrailingPathSeparator(d,g=k.sep){if(d.scheme===L.Schemas.file){const I=f(d);return I.length>p.getRoot(I).length&&I[I.length-1]===g}else{const I=d.path;return I.length>1&&I.charCodeAt(I.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=k.sep){return(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=k.sep){let I=!1;if(d.scheme===L.Schemas.file){const y=f(d);I=y!==void 0&&y.length===p.getRoot(y).length&&y[y.length-1]===g}else{g="/";const y=d.path;I=y.length===1&&y.charCodeAt(y.length-1)===47}return!I&&!(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(v=>v.scheme===L.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new w(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(v,d){const g=[];for(let I=0;I<v.length;I++){const y=d(v[I]);v.some((u,h)=>h===I?!1:(0,e.isEqualOrParent)(y,d(u)))||g.push(v[I])}return g}e.distinctParents=i;var P;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function d(g){const I=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(h=>{const[o,c]=h.split(":");o&&c&&I.set(o,c)});const u=g.path.substring(0,g.path.indexOf(";"));return u&&I.set(v.META_DATA_MIME,u),I}v.parseMetaData=d})(P=e.DataUri||(e.DataUri={}));function E(v,d,g){if(d){let I=v.path;return I&&I[0]!==k.posix.sep&&(I=k.posix.sep+I),v.with({scheme:g,authority:d,path:I})}return v.with({scheme:g})}e.toLocalResource=E}),define(Z[9],x([0,1,23,17,4,2,15]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function n($){return!!$&&typeof $.then=="function"}e.isThenable=n;function f($){const B=new p.CancellationTokenSource,H=$(B.token),O=new Promise((q,T)=>{const A=B.token.onCancellationRequested(()=>{A.dispose(),B.dispose(),T((0,L.canceled)())});Promise.resolve(H).then(W=>{A.dispose(),B.dispose(),q(W)},W=>{A.dispose(),B.dispose(),T(W)})});return new class{cancel(){B.cancel()}then(q,T){return O.then(q,T)}catch(q){return this.then(void 0,q)}finally(q){return O.finally(q)}}}e.createCancelablePromise=f;function w($,B,H){return Promise.race([$,new Promise(O=>B.onCancellationRequested(()=>O(H)))])}e.raceCancellation=w;async function i($){let B=-1;const H=$.map((q,T)=>q.then(A=>(B=T,A))),O=await Promise.race(H);return $.forEach((q,T)=>{T!==B&&q.cancel()}),O}e.raceCancellablePromises=i;function P($,B,H){let O;const q=setTimeout(()=>{O?.(void 0),H?.()},B);return Promise.race([$.finally(()=>clearTimeout(q)),new Promise(T=>O=T)])}e.raceTimeout=P;function E($){return new Promise((B,H)=>{const O=$();n(O)?O.then(B,H):B(O)})}e.asPromise=E;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const H=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(H,H).then(O)})}return new Promise((H,O)=>{this.queuedPromise.then(H,O)})}return this.activePromise=B(),new Promise((H,O)=>{this.activePromise.then(q=>{this.activePromise=null,H(q)},q=>{this.activePromise=null,O(q)})})}}e.Throttler=v;class d{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=d;class g{constructor(){this.promiseMap=new Map}queue(B,H){const q=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get(B)===q&&this.promiseMap.delete(B)});return this.promiseMap.set(B,q),q}}e.SequencerByKey=g;class I{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,H=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,q)=>{this.doResolve=O,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},H),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=I;class y{constructor(B){this.delayer=new I(B),this.throttler=new v}trigger(B,H){return this.delayer.trigger(()=>this.throttler.queue(B),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=y;class u{constructor(){this._isOpen=!1,this._promise=new Promise((B,H)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class h extends u{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function o($,B){return B?new Promise((H,O)=>{const q=setTimeout(()=>{T.dispose(),H()},$),T=B.onCancellationRequested(()=>{clearTimeout(q),T.dispose(),O((0,L.canceled)())})}):f(H=>o($,H))}e.timeout=o;function c($,B=0){const H=setTimeout($,B);return(0,M.toDisposable)(()=>clearTimeout(H))}e.disposableTimeout=c;function t($){const B=[];let H=0;const O=$.length;function q(){return H<O?$[H++]():null}function T(A){A!=null&&B.push(A);const W=q();return W?W.then(T):Promise.resolve(B)}return Promise.resolve(null).then(T)}e.sequence=t;function a($,B=O=>!!O,H=null){let O=0;const q=$.length,T=()=>{if(O>=q)return Promise.resolve(H);const A=$[O++];return Promise.resolve(A()).then(z=>B(z)?Promise.resolve(z):T())};return T()}e.first=a;function r($,B=O=>!!O,H=null){if($.length===0)return Promise.resolve(H);let O=$.length;const q=()=>{O=-1;for(const T of $)T.cancel?.()};return new Promise((T,A)=>{for(const W of $)W.then(z=>{--O>=0&&B(z)?(q(),T(z)):O===0&&T(H)}).catch(z=>{--O>=0&&(q(),A(z))})})}e.firstParallel=r;class s{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((H,O)=>{this.outstandingPromises.push({factory:B,c:H,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const H=B.factory();H.then(B.c,B.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class l extends s{constructor(){super(1)}}e.Queue=l;class m{constructor(){this.queues=new Map}queueFor(B,H=b.extUri){const O=H.getComparisonKey(B);let q=this.queues.get(O);return q||(q=new l,k.Event.once(q.onFinished)(()=>{q?.dispose(),this.queues.delete(O)}),this.queues.set(O,q)),q}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=m;class S{constructor(B,H){this._token=-1,typeof B=="function"&&typeof H=="number"&&this.setIfNotSet(B,H)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,H){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},H)}setIfNotSet(B,H){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},H))}}e.TimeoutTimer=S;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,H){this.cancel(),this._token=setInterval(()=>{B()},H)}}e.IntervalTimer=D;class R{constructor(B,H){this.timeoutToken=-1,this.runner=B,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class F{constructor(B,H){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=H,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=F;class C extends R{constructor(B,H){super(B,H);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=C;class G extends M.Disposable{constructor(B,H,O,q){super();this.maxWorkChunkSize=B,this.maxPendingWork=H,this.throttleDelay=O,this.handler=q,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=G,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const $=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=B=>{const H=setTimeout(()=>B($));let O=!1;return{dispose(){O||(O=!0,clearTimeout(H))}}}}else e.runWhenIdle=($,B)=>{const H=requestIdleCallback($,typeof B=="number"?{timeout:B}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(H))}}}}();class ne{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(H){this._error=H}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ne;async function ae($,B,H){let O;for(let q=0;q<H;q++)try{return await $()}catch(T){O=T,await o(B)}throw O}e.retry=ae;class K{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,H,O){return this._pending={taskId:B,cancel:()=>O?.(),promise:H},H.then(()=>this.donePending(B),()=>this.donePending(B)),H}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let H,O;const q=new Promise((T,A)=>{H=T,O=A});this._next={run:B,promise:q,promiseResolve:H,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=K;class ee{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,H)=>{this.completeCallback=B,this.errorCallback=H})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(H=>{this.completeCallback(B),this.resolved=!0,H()})}error(B){return new Promise(H=>{this.errorCallback(B),this.rejected=!0,H()})}cancel(){new Promise(B=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=_;var j;(function($){async function B(H){let O;const q=await Promise.all(H.map(T=>T.then(A=>A,A=>{O||(O=A)})));if(typeof O!="undefined")throw O;return q}$.settled=B})(j=e.Promises||(e.Promises={}))}),define(Z[111],x([0,1,9,31,37,8,25]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const f="**",w="/",i="[/\\\\]",P="[^/\\\\]",E=/\//g;function v(O){switch(O){case 0:return"";case 1:return`${P}*?`;default:return`(?:${i}|${P}+${i}|${i}${P}+)*?`}}function d(O,q){if(!O)return[];const T=[];let A=!1,W=!1,z="";for(const X of O){switch(X){case q:if(!A&&!W){T.push(z),z="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":W=!0;break;case"]":W=!1;break}z+=X}return z&&T.push(z),T}e.splitGlobAware=d;function g(O){if(!O)return"";let q="";const T=d(O,w);if(T.every(A=>A===f))q=".*";else{let A=!1;T.forEach((W,z)=>{if(W===f){A||(q+=v(2),A=!0);return}let X=!1,U="",N=!1,Q="";for(const J of W){if(J!=="}"&&X){U+=J;continue}if(N&&(J!=="]"||!Q)){let re;J==="-"?re=J:(J==="^"||J==="!")&&!Q?re="^":J===w?re="":re=b.escapeRegExpCharacters(J),Q+=re;continue}switch(J){case"{":X=!0;continue;case"[":N=!0;continue;case"}":q+=`(?:${d(U,",").map(ie=>g(ie)).join("|")})`,X=!1,U="";break;case"]":q+="["+Q+"]",N=!1,Q="";break;case"?":q+=P;continue;case"*":q+=v(1);continue;default:q+=b.escapeRegExpCharacters(J)}}z<T.length-1&&(T[z+1]!==f||z+2<T.length)&&(q+=i),A=!1})}return q}const I=/^\*\*\/\*\.[\w\.-]+$/,y=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),a=function(){return!1},r=function(){return null};function s(O,q){if(!O)return r;let T;typeof O!="string"?T=O.pattern:T=O,T=T.trim();const A=`${T}_${!!q.trimForExclusions}`;let W=t.get(A);if(W)return l(W,O);let z;if(I.test(T)){const X=T.substr(4);W=function(U,N){return typeof U=="string"&&U.endsWith(X)?T:null}}else(z=y.exec(m(T,q)))?W=S(z[1],T):(q.trimForExclusions?h:u).test(T)?W=D(T,q):(z=o.exec(m(T,q)))?W=R(z[1].substr(1),T,!0):(z=c.exec(m(T,q)))?W=R(z[1],T,!1):W=F(T);return t.set(A,W),l(W,O)}function l(O,q){return typeof q=="string"?O:function(T,A){return L.isEqualOrParent(T,q.base)?O(M.relative(q.base,T),A):null}}function m(O,q){return q.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function S(O,q){const T=`/${O}`,A=`\\${O}`,W=function(X,U){return typeof X!="string"?null:U?U===O?q:null:X===O||X.endsWith(T)||X.endsWith(A)?q:null},z=[O];return W.basenames=z,W.patterns=[q],W.allBasenames=z,W}function D(O,q){const T=H(O.slice(1,-1).split(",").map(U=>s(U,q)).filter(U=>U!==r),O),A=T.length;if(!A)return r;if(A===1)return T[0];const W=function(U,N){for(let Q=0,J=T.length;Q<J;Q++)if(T[Q](U,N))return O;return null},z=T.find(U=>!!U.allBasenames);z&&(W.allBasenames=z.allBasenames);const X=T.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return X.length&&(W.allPaths=X),W}function R(O,q,T){const A=M.sep===M.posix.sep,W=A?O:O.replace(E,M.sep),z=M.sep+W,X=M.posix.sep+O,U=T?function(N,Q){return typeof N=="string"&&(N===W||N.endsWith(z)||!A&&(N===O||N.endsWith(X)))?q:null}:function(N,Q){return typeof N=="string"&&(N===W||!A&&N===O)?q:null};return U.allPaths=[(T?"*/":"./")+O],U}function F(O){try{const q=new RegExp(`^${g(O)}$`);return function(T){return q.lastIndex=0,typeof T=="string"&&q.test(T)?O:null}}catch(q){return r}}function C(O,q,T){return!O||typeof q!="string"?!1:G(O)(q,void 0,T)}e.match=C;function G(O,q={}){if(!O)return a;if(typeof O=="string"||ee(O)){const T=s(O,q);if(T===r)return a;const A=function(W,z){return!!T(W,z)};return T.allBasenames&&(A.allBasenames=T.allBasenames),T.allPaths&&(A.allPaths=T.allPaths),A}return $(O,q)}e.parse=G;function ne(O){if(!O)return;let q;return T=>(q||(q=(O()||Promise.resolve([])).then(A=>A?K(A):{})),q.then(A=>!!A[T]))}e.hasSiblingPromiseFn=ne;function ae(O){if(!O)return;let q;return T=>{if(!q){const A=O();q=A?K(A):{}}return!!q[T]}}e.hasSiblingFn=ae;function K(O){const q={};for(const T of O)q[T]=!0;return q}function ee(O){const q=O;return q&&typeof q.base=="string"&&typeof q.pattern=="string"}e.isRelativePattern=ee;function _(O){return O.allBasenames||[]}e.getBasenameTerms=_;function j(O){return O.allPaths||[]}e.getPathTerms=j;function $(O,q){const T=H(Object.getOwnPropertyNames(O).map(U=>B(U,O[U],q)).filter(U=>U!==r)),A=T.length;if(!A)return r;if(!T.some(U=>!!U.requiresSiblings)){if(A===1)return T[0];const U=function(J,re){for(let le=0,ie=T.length;le<ie;le++){const oe=T[le](J,re);if(oe)return oe}return null},N=T.find(J=>!!J.allBasenames);N&&(U.allBasenames=N.allBasenames);const Q=T.reduce((J,re)=>re.allPaths?J.concat(re.allPaths):J,[]);return Q.length&&(U.allPaths=Q),U}const W=function(U,N,Q){let J;for(let re=0,le=T.length;re<le;re++){const ie=T[re];ie.requiresSiblings&&Q&&(N||(N=M.basename(U)),J||(J=N.substr(0,N.length-M.extname(U).length)));const oe=ie(U,N,J,Q);if(oe)return oe}return null},z=T.find(U=>!!U.allBasenames);z&&(W.allBasenames=z.allBasenames);const X=T.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return X.length&&(W.allPaths=X),W}function B(O,q,T){if(q===!1)return r;const A=s(O,T);if(A===r)return r;if(typeof q=="boolean")return A;if(q){const W=q.when;if(typeof W=="string"){const z=(X,U,N,Q)=>{if(!Q||!A(X,U))return null;const J=W.replace("$(basename)",N),re=Q(J);return(0,p.isThenable)(re)?re.then(le=>le?O:null):re?O:null};return z.requiresSiblings=!0,z}}return A}function H(O,q){const T=O.filter(U=>!!U.basenames);if(T.length<2)return O;const A=T.reduce((U,N)=>{const Q=N.basenames;return Q?U.concat(Q):U},[]);let W;if(q){W=[];for(let U=0,N=A.length;U<N;U++)W.push(q)}else W=T.reduce((U,N)=>{const Q=N.patterns;return Q?U.concat(Q):U},[]);const z=function(U,N){if(typeof U!="string")return null;if(!N){let J;for(J=U.length;J>0;J--){const re=U.charCodeAt(J-1);if(re===47||re===92)break}N=U.substr(J)}const Q=A.indexOf(N);return Q!==-1?W[Q]:null};z.basenames=A,z.patterns=W,z.allBasenames=A;const X=O.filter(U=>!U.basenames);return X.push(z),X}}),define(Z[34],x([0,1,31,10,8,3,15,25,7]),function(V,e,p,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function w(s,l,m){if(typeof s=="string"&&(s=f.URI.file(s)),m){const D=m.getWorkspaceFolder(s);if(D){const R=m.getWorkspace().folders.length>1;let F;if((0,b.isEqual)(D.uri,s)?F="":F=(0,b.relativePath)(D.uri,s),R){const C=D.name?D.name:(0,b.basename)(D.uri);F=F?C+" \u2022 "+F:C}return F}}if(s.scheme!==L.Schemas.file&&s.scheme!==L.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(s.fsPath))return(0,k.normalize)(P(s.fsPath));let S=(0,k.normalize)(s.fsPath);return!M.isWindows&&l?.userHome&&(S=v(S,l.userHome.fsPath)),S}e.getPathLabel=w;function i(s){if(!s)return;typeof s=="string"&&(s=f.URI.file(s));const l=(0,b.basename)(s)||(s.scheme===L.Schemas.file?s.fsPath:s.path);return M.isWindows&&(0,p.isRootOrDriveLetter)(l)?P(l):l}e.getBaseLabel=i;function P(s){return(0,p.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=P;let E=Object.create(null);function v(s,l){if(M.isWindows||!s||!l)return s;let m=E.original===l?E.normalized:void 0;return m||(m=`${(0,n.rtrim)(l,k.posix.sep)}${k.posix.sep}`,E={original:l,normalized:m}),(M.isLinux?s.startsWith(m):(0,n.startsWithIgnoreCase)(s,m))&&(s=`~/${s.substr(m.length)}`),s}e.tildify=v;function d(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=d;const g="\u2026",I="\\\\",y="~";function u(s,l=k.sep){const m=new Array(s.length);let S=!1;for(let D=0;D<s.length;D++){let R=s[D];if(R===""){m[D]=`.${l}`;continue}if(!R){m[D]=R;continue}S=!0;let F="";R.indexOf(I)===0?(F=R.substr(0,R.indexOf(I)+I.length),R=R.substr(R.indexOf(I)+I.length)):R.indexOf(l)===0?(F=R.substr(0,R.indexOf(l)+l.length),R=R.substr(R.indexOf(l)+l.length)):R.indexOf(y)===0&&(F=R.substr(0,R.indexOf(y)+y.length),R=R.substr(R.indexOf(y)+y.length));const C=R.split(l);for(let G=1;S&&G<=C.length;G++)for(let ne=C.length-G;S&&ne>=0;ne--){S=!1;let ae=C.slice(ne,ne+G).join(l);for(let K=0;!S&&K<s.length;K++)if(K!==D&&s[K]&&s[K].indexOf(ae)>-1){const ee=ne+G===C.length,_=ne>0&&s[K].indexOf(l)>-1?l+ae:ae,j=s[K].endsWith(_);S=!ee||j}if(!S){let K="";(C[0].endsWith(":")||F!=="")&&(ne===1&&(ne=0,G++,ae=C[0]+l+ae),ne>0&&(K=C[0]+l),K=F+K),ne>0&&(K=K+g+l),K=K+ae,ne+G<C.length&&(K=K+l+g),m[D]=K}}S&&(m[D]=R)}return m}e.shorten=u;var h;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(s,l=Object.create(null)){const m=[];let S=!1,D="";for(const R of s)if(R==="$"||S&&R==="{")D&&m.push({value:D,type:h.TEXT}),D="",S=!0;else if(R==="}"&&S){const F=l[D];if(typeof F=="string")F.length&&m.push({value:F,type:h.VARIABLE});else if(F){const C=m[m.length-1];(!C||C.type!==h.SEPARATOR)&&m.push({value:F.label,type:h.SEPARATOR})}D="",S=!1}else D+=R;return D&&!S&&m.push({value:D,type:h.TEXT}),m.filter((R,F)=>{if(R.type===h.SEPARATOR){const C=m[F-1],G=m[F+1];return[C,G].every(ne=>ne&&(ne.type===h.VARIABLE||ne.type===h.TEXT)&&ne.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=o;function c(s,l){return M.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):s.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function t(s,l){return M.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):M.isWindows?s.replace(/&&|&/g,m=>m==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function a(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=a;function r(s){const l=s.indexOf("/")!==-1?k.posix:k.win32,m=l.basename(s),S=l.dirname(s);return m.length?{name:m,parentPath:S}:{name:S,parentPath:""}}e.splitName=r}),define(Z[28],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(f){return p.test(f)}e.isUUID=L;const k=new Uint8Array(16),M=[];for(let f=0;f<256;f++)M.push(f.toString(16).padStart(2,"0"));let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(f){for(let w=0;w<f.length;w++)f[w]=Math.floor(Math.random()*256);return f};function n(){b(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let f=0,w="";return w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w}e.generateUuid=n}),define(Z[112],x([0,1,58,32,43]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(b,n){if(await new Promise((i,P)=>{const E=L.createReadStream(b),v=p.createHash("sha1");E.pipe(v);const d=(0,k.once)((g,I)=>{E.removeAllListeners(),v.removeAllListeners(),g?P(g):i(I)});E.once("error",d),E.once("end",d),v.once("error",d),v.once("data",g=>d(void 0,g.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=M}),define(Z[80],x([0,1,239]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(M="utf8"){this.stringDecoder=new p.StringDecoder(M),this.remaining=null}write(M){const b=[],n=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(n.length<1)return b;let f=0,w,i=f;for(;i<n.length;)if(w=n.charCodeAt(i),w===13||w===10){if(b.push(n.substring(f,i)),i++,i<n.length){const P=w;w=n.charCodeAt(i),(P===13&&w===10||P===10&&w===13)&&i++}f=i}else i++;return this.remaining=f<n.length?n.substr(f):null,b}end(){return this.remaining}}e.LineDecoder=L}),define(Z[113],x([0,1,26]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(n){const f=n.replace(/\-/g,":").toLowerCase();return!L.has(f)}function M(){return new Promise(async(n,f)=>{const w=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await b())}catch(i){f(i)}finally{clearTimeout(w)}})}e.getMac=M;function b(){return new Promise((n,f)=>{try{const w=(0,p.networkInterfaces)();for(let i in w){const P=w[i];if(P){for(const{mac:E}of P)if(k(E))return n(E)}}f("Unable to retrieve mac address (unexpected format)")}catch(w){f(w)}})}}),define(Z[67],x([0,1,26,17,37,28,113]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,P=0;const E=(0,p.networkInterfaces)();for(let v in E){const d=E[v];if(d)for(const{mac:g,internal:I}of d)I||(P+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(i+=1))}this._value=P>0?i/P:0}return this._value}};let n;async function f(){return n||(n=(async()=>await w()||M.generateUuid())()),n}e.getMachineId=f;async function w(){try{const i=await new Promise((E,v)=>{V(["crypto"],E,v)}),P=await(0,b.getMac)();return i.createHash("sha256").update(P,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(Z[19],x([0,1,32,26,114,9,31,66,8,3,15,7,28]),function(V,e,p,L,k,M,b,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function d(_,j=v.UNLINK){if((0,b.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");return j===v.UNLINK?I(_):g(_)}async function g(_){try{const j=(0,f.join)((0,L.tmpdir)(),(0,E.generateUuid)());try{await e.Promises.rename(_,j)}catch($){return I(_)}I(j).catch($=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function I(_){return e.Promises.rmdir(_,{recursive:!0,maxRetries:3})}function y(_){if((0,b.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(_,{recursive:!0})}e.rimrafSync=y;async function u(_,j){return c(await(j?h(_):(0,k.promisify)(p.readdir)(_)))}async function h(_){try{return await(0,k.promisify)(p.readdir)(_,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const j=[],$=await u(_);for(const B of $){let H=!1,O=!1,q=!1;try{const T=await e.Promises.lstat((0,f.join)(_,B));H=T.isFile(),O=T.isDirectory(),q=T.isSymbolicLink()}catch(T){console.warn("[node.js fs] unexpected error from lstat after readdir: ",T)}j.push({name:B,isFile:()=>H,isDirectory:()=>O,isSymbolicLink:()=>q})}return j}function o(_){return c(p.readdirSync(_))}e.readdirSync=o;function c(_){return _.map(j=>typeof j=="string"?w.isMacintosh?(0,n.normalizeNFC)(j):j:(j.name=w.isMacintosh?(0,n.normalizeNFC)(j.name):j.name,j))}async function t(_){const j=await u(_),$=[];for(const B of j)await r.existsDirectory((0,f.join)(_,B))&&$.push(B);return $}function a(_,j=1e3){return new Promise($=>{let B=!1;const H=setInterval(()=>{B||(B=!0,p.access(_,O=>{B=!1,O&&(clearInterval(H),$(void 0))}))},j)})}e.whenDeleted=a;var r;(function(_){async function j(H){let O;try{if(O=await e.Promises.lstat(H),!O.isSymbolicLink())return{stat:O}}catch(q){}try{return{stat:await e.Promises.stat(H),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(w.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(T){if(T.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw T}throw q}}_.stat=j;async function $(H){try{const{stat:O,symbolicLink:q}=await _.stat(H);return O.isFile()&&q?.dangling!==!0}catch(O){}return!1}_.existsFile=$;async function B(H){try{const{stat:O,symbolicLink:q}=await _.stat(H);return O.isDirectory()&&q?.dangling!==!0}catch(O){}return!1}_.existsDirectory=B})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new M.ResourceQueue;function l(_,j,$){return s.queueFor(P.URI.file(_),i.extUriBiasedIgnorePathCase).queue(()=>{const B=R($);return new Promise((H,O)=>S(_,j,B,q=>q?O(q):H()))})}let m=!0;function S(_,j,$,B){if(!m)return p.writeFile(_,j,{mode:$.mode,flag:$.flag},B);p.open(_,$.flag,$.mode,(H,O)=>{if(H)return B(H);p.writeFile(O,j,q=>{if(q)return p.close(O,()=>B(q));p.fdatasync(O,T=>(T&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",T),m=!1),p.close(O,A=>B(A))))})})}function D(_,j,$){const B=R($);if(!m)return p.writeFileSync(_,j,{mode:B.mode,flag:B.flag});const H=p.openSync(_,B.flag,B.mode);try{p.writeFileSync(H,j);try{p.fdatasyncSync(H)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),m=!1}}finally{p.closeSync(H)}}e.writeFileSync=D;function R(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function F(_,j){if(_===j)return;async function $(B){try{const H=await e.Promises.lstat(B);if(H.isDirectory()||H.isSymbolicLink())return;await e.Promises.utimes(B,H.atime,new Date)}catch(H){}}try{await e.Promises.rename(_,j),await $(j)}catch(B){if(_.toLowerCase()!==j.toLowerCase()&&B.code==="EXDEV"||_.endsWith("."))await C(_,j,{preserveSymlinks:!1}),await d(_,v.MOVE),await $(j);else throw B}}async function C(_,j,$){return ne(_,j,{root:{source:_,target:j},options:$,handledSourcePaths:new Set})}const G=511;async function ne(_,j,$){if($.handledSourcePaths.has(_))return;$.handledSourcePaths.add(_);const{stat:B,symbolicLink:H}=await r.stat(_);if(H){if($.options.preserveSymlinks)try{return await ee(_,j,$)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(H.dangling)return}return B.isDirectory()?ae(_,j,B.mode&G,$):K(_,j,B.mode&G)}async function ae(_,j,$,B){await e.Promises.mkdir(j,{recursive:!0,mode:$});const H=await u(_);for(const O of H)await ne((0,f.join)(_,O),(0,f.join)(j,O),B)}async function K(_,j,$){await e.Promises.copyFile(_,j),await e.Promises.chmod(j,$)}async function ee(_,j,$){let B=await e.Promises.readlink(_);(0,b.isEqualOrParent)(B,$.root.source,!w.isLinux)&&(B=(0,f.join)($.root.target,B.substr($.root.source.length+1))),await e.Promises.symlink(B,j)}e.Promises=new class{get access(){return(0,k.promisify)(p.access)}get stat(){return(0,k.promisify)(p.stat)}get lstat(){return(0,k.promisify)(p.lstat)}get utimes(){return(0,k.promisify)(p.utimes)}get read(){return(0,k.promisify)(p.read)}get readFile(){return(0,k.promisify)(p.readFile)}get write(){return(0,k.promisify)(p.write)}get appendFile(){return(0,k.promisify)(p.appendFile)}get fdatasync(){return(0,k.promisify)(p.fdatasync)}get truncate(){return(0,k.promisify)(p.truncate)}get rename(){return(0,k.promisify)(p.rename)}get copyFile(){return(0,k.promisify)(p.copyFile)}get open(){return(0,k.promisify)(p.open)}get close(){return(0,k.promisify)(p.close)}get symlink(){return(0,k.promisify)(p.symlink)}get readlink(){return(0,k.promisify)(p.readlink)}get chmod(){return(0,k.promisify)(p.chmod)}get mkdir(){return(0,k.promisify)(p.mkdir)}get unlink(){return(0,k.promisify)(p.unlink)}get rmdir(){return(0,k.promisify)(p.rmdir)}get realpath(){return(0,k.promisify)(p.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return d}get move(){return F}get copy(){return C}}}),define(Z[81],x([0,1,32,8,25,19]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function b(i){const P=(0,L.dirname)(i);if(i===P)return i;const E=((0,L.basename)(i)||i).toLowerCase();try{const d=(0,M.readdirSync)(P).filter(g=>g.toLowerCase()===E);if(d.length===1){const g=b(P);if(g)return(0,L.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(E);if(g>=0){const I=b(P);if(I)return(0,L.join)(I,d[g])}}}catch(v){}return null}e.realcaseSync=b;async function n(i){try{return await M.Promises.realpath(i)}catch(P){const E=w(i);return await M.Promises.access(E,p.constants.R_OK),E}}e.realpath=n;function f(i){try{return p.realpathSync(i)}catch(P){const E=w(i);return p.accessSync(E,p.constants.R_OK),E}}e.realpathSync=f;function w(i){return(0,k.rtrim)((0,L.normalize)(i),L.sep)}}),define(Z[115],x([0,1,59]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(n,f,w,i=1){let P=!1;return new Promise(E=>{const v=setTimeout(()=>{if(!P)return P=!0,E(0)},w);k(n,f,i,d=>{if(!P)return P=!0,clearTimeout(v),E(d)})})}e.findFreePort=L;function k(n,f,w,i){if(f===0)return i(0);const P=new p.Socket;P.once("connect",()=>(b(P),k(n+w,f-1,w,i))),P.once("data",()=>{}),P.once("error",E=>(b(P),E.code!=="ECONNREFUSED"?k(n+w,f-1,w,i):i(n))),P.connect(n,"127.0.0.1")}function M(n,f,w){let i=!1,P,E=1;const v=p.createServer({pauseOnConnect:!0});function d(g,I){i||(i=!0,v.removeAllListeners(),v.close(),P&&clearTimeout(P),I(g))}return new Promise(g=>{P=setTimeout(()=>{d(0,g)},w),v.on("listening",()=>{d(n,g)}),v.on("error",I=>{I&&(I.code==="EADDRINUSE"||I.code==="EACCES")&&E<f?(n++,E++,v.listen(n,"127.0.0.1")):d(0,g)}),v.on("close",()=>{d(0,g)}),v.listen(n,"127.0.0.1")})}e.findFreePortFaster=M;function b(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(f){console.error(f)}}}),define(Z[116],x([0,1,26,8,19]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,b=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var f;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(f||(f={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class P{constructor(c,t,a){this.exePath=c,this.displayName=t,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:o=!1}={}){return o?w===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:o=!1,findPreview:c=!1}={}){const t=E({useAlternateBitness:o});if(!t)return null;const a=L.join(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(a))return null;let r=-1,s=null;for(const S of await k.Promises.readdir(a)){let D=-1;if(c){const F=S.indexOf("-");if(F<0)continue;const C=S.substring(0,F);if(!M.test(C)||S.substring(F+1)!=="preview")continue;D=parseInt(C,10)}else{if(!M.test(S))continue;D=parseInt(S,10)}if(D<=r)continue;const R=L.join(a,S,"pwsh.exe");!await k.SymlinkSupport.existsFile(R)||(s=R,r=D)}if(!s)return null;const l=t.includes("x86")?" (x86)":"",m=c?" Preview":"";return new P(s,`PowerShell${m}${l}`,!0)}async function d({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const c=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=o?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:b,pwshMsixName:"PowerShell (Store)"};for(const r of await k.Promises.readdir(c))if(t.test(r)){const s=L.join(c,r,"pwsh.exe");return new P(s,a)}return null}function g(){const o=L.join(p.homedir(),".dotnet","tools","pwsh.exe");return new P(o,".NET Core PowerShell Global Tool")}function I(){const o=L.join(process.env.windir,w===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(o,"Windows PowerShell",!0)}async function*y(){let o=await v();o&&(yield o),o=await v({useAlternateBitness:!0}),o&&(yield o),o=await d(),o&&(yield o),o=g(),o&&(yield o),o=await v({findPreview:!0}),o&&(yield o),o=await d({findPreview:!0}),o&&(yield o),o=await v({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=I(),o&&(yield o)}async function*u(){for await(const o of y())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=u;async function h(){for await(const o of u())return o;return null}e.getFirstAvailablePowerShellInstallation=h}),define(Z[82],x([0,1,41,10]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(b){return new Promise((n,f)=>{let w;const i=new Map;function P(v,d,g,I,y){const u=i.get(d);if(v===b||u){const h={name:E(g),cmd:g,pid:v,ppid:d,load:I,mem:y};i.set(v,h),v===b&&(w=h),u&&(u.children||(u.children=[]),u.children.push(h),u.children.length>1&&(u.children=u.children.sort((o,c)=>o.pid-c.pid)))}}function E(v){const d=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,I=/--crashes-directory/,y=/\\pipe\\winpty-control/,u=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(g.exec(v))return"watcherService ";if(I.exec(v))return"electron-crash-reporter";if(y.exec(v))return"winpty-process";if(u.exec(v))return"console-window-host (Windows internal process)";let o=h.exec(v);if(o&&o.length===2)return o[1]==="renderer"?d.exec(v)?"shared-process":"window":o[1];const c=/[a-zA-Z-]+\.js/g;let t="";do o=c.exec(v),o&&(t+=o+" ");while(o);return t&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${t}`:v}if(process.platform==="win32"){const v=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,g)=>{V(["windows-process-tree"],d,g)}).then(d=>{d.getProcessList(b,g=>{d.getProcessCpuUsage(g,I=>{const y=new Map;I.forEach(u=>{const h=v(u.commandLine||"");y.set(u.pid,{name:E(h),cmd:h,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),w=y.get(b),w?(y.forEach(u=>{const h=y.get(u.ppid);h&&(h.children||(h.children=[]),h.children.push(u))}),y.forEach(u=>{u.children&&(u.children=u.children.sort((h,o)=>h.pid-o.pid))}),n(w)):f(new Error(`Root process ${b} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let v=function(){let d=[w];const g=[];for(;d.length;){const y=d.shift();y&&(g.push(y.pid),y.children&&(d=d.concat(y.children)))}let I=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",V).fsPath);I+=" "+g.join(" "),(0,p.exec)(I,{},(y,u,h)=>{if(y||h)f(y||new Error(h.toString()));else{const o=u.toString().split(`
`);for(let c=0;c<g.length;c++){const t=i.get(g[c]);t.load=parseFloat(o[c])}if(!w){f(new Error(`Root process ${b} not found`));return}n(w)}})};(0,p.exec)("which ps",{},(d,g,I)=>{if(d||I)if(process.platform!=="linux")f(d||new Error(I.toString()));else{const y=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",V).fsPath);(0,p.exec)(y,{},(u,h,o)=>{u||o?f(u||new Error(o.toString())):(M(h,P),v())})}else{const y=g.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${y} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,o,c)=>{h||c&&!c.includes("screen size is bogus")?f(h||new Error(c.toString())):(M(o,P),process.platform==="linux"?v():w?n(w):f(new Error(`Root process ${b} not found`)))})}})}})}e.listProcesses=k;function M(b,n){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=b.toString().split(`
`);for(const i of w){const P=f.exec(i.trim());P&&P.length===6&&n(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}}),define(Z[117],x([0,1,32,23,31,2,66,8,3,19]),function(V,e,p,L,k,M,b,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(d,g,I){return E({path:d,isDirectory:!1},g,I)}e.watchFile=i;function P(d,g,I){return E({path:d,isDirectory:!0},g,I)}e.watchFolder=P,e.CHANGE_BUFFER_DELAY=100;function E(d,g,I){if(f.isMacintosh&&(0,k.isEqualOrParent)(d.path,"/Volumes/"))return I(`Refusing to watch ${d.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const y=(0,n.basename)(d.path),u=new Map;let h=!1,o=[(0,M.toDisposable)(()=>{u.forEach(c=>(0,M.dispose)(c)),u.clear()})];try{const c=(0,p.watch)(d.path);o.push((0,M.toDisposable)(()=>{c.removeAllListeners(),c.close()}));const t=new Set;d.isDirectory&&w.Promises.readdir(d.path).then(a=>a.forEach(r=>t.add(r))),c.on("error",(a,r)=>{h||I(`Failed to watch ${d.path} for changes using fs.watch() (${a}, ${r})`)}),c.on("change",(a,r)=>{if(h)return;let s="";if(r&&(s=r.toString(),f.isMacintosh&&(s=(0,b.normalizeNFC)(s))),!s||a!=="change"&&a!=="rename")return;const l=d.isDirectory?(0,n.join)(d.path,s):d.path;if(d.isDirectory)if(a==="rename"){const m=u.get(l);m&&(0,M.dispose)(m);const S=setTimeout(async()=>{u.delete(l);const D=await w.Promises.exists(l);if(h)return;let R;D?t.has(s)?R="changed":(R="added",t.add(s)):(t.delete(s),R="deleted"),g(R,l)},e.CHANGE_BUFFER_DELAY);u.set(l,(0,M.toDisposable)(()=>clearTimeout(S)))}else{let m;t.has(s)?m="changed":(m="added",t.add(s)),g(m,l)}else if(a==="rename"||s!==y){const m=setTimeout(async()=>{const S=await w.Promises.exists(l);h||(S?(g("changed",l),o=[E(d,g,I)]):g("deleted",l))},e.CHANGE_BUFFER_DELAY);(0,M.dispose)(o),o=[(0,M.toDisposable)(()=>clearTimeout(m))]}else g("changed",l)})}catch(c){w.Promises.exists(d.path).then(t=>{t&&!h&&I(`Failed to watch ${d.path} for changes using fs.watch() (${c.toString()})`)})}return(0,M.toDisposable)(()=>{h=!0,o=(0,M.dispose)(o)})}async function v(d,g,I,y=512){const u=await w.Promises.open(d,"r"),h=Buffer.allocUnsafe(y),o=new L.CancellationTokenSource(I);let c,t=!1;const a=i(d,async r=>{if(r==="changed"){if(t)return;t=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:s}=await w.Promises.read(u,h,0,y,null);if(!s||o.token.isCancellationRequested)break;g(h.slice(0,s))}}catch(s){c=new Error(s),o.dispose(!0)}finally{t=!1}}},r=>{c=new Error(r),o.dispose(!0)});return new Promise((r,s)=>{o.token.onCancellationRequested(async()=>{a.dispose(),await w.Promises.close(u),c?s(c):r()})})}e.watchFileContents=v}),define(Z[118],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[119],x([0,1,14,13,118]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){p.ipcMain.on(k.CONTEXT_MENU_CHANNEL,(n,f,w,i,P)=>{const E=b(n,i,w);E.popup({window:(0,L.withNullAsUndefined)(p.BrowserWindow.fromWebContents(n.sender)),x:P?P.x:void 0,y:P?P.y:void 0,positioningItem:P?P.positioningItem:void 0,callback:()=>{E&&n.sender.send(k.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=M;function b(n,f,w){const i=new p.Menu;return w.forEach(P=>{let E;P.type==="separator"?E=new p.MenuItem({type:P.type}):Array.isArray(P.submenu)?E=new p.MenuItem({submenu:b(n,f,P.submenu),label:P.label}):E=new p.MenuItem({label:P.label,type:P.type,accelerator:P.accelerator,checked:P.checked,enabled:P.enabled,visible:P.visible,click:(v,d,g)=>n.sender.send(f,P.id,g)}),i.append(E)}),i}});var ue=this&&this.__decorate||function(V,e,p,L){var k=arguments.length,M=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,p):L,b;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(V,e,p,L);else for(var n=V.length-1;n>=0;n--)(b=V[n])&&(M=(k<3?b(M):k>3?b(e,p,M):b(e,p))||M);return k>3&&M&&Object.defineProperty(e,p,M),M};define(Z[35],x([0,1,30,9,18,23,47,17,4,2,110,25,13]),function(V,e,p,L,k,M,b,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function d(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function I(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(y||(y={}));class u{constructor(O){this.buffer=O,this.pos=0}read(O){const q=this.buffer.slice(this.pos,this.pos+O);return this.pos+=q.byteLength,q}}class h{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var o;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(o||(o={}));function c(H){const O=k.VSBuffer.alloc(4);return O.writeUInt32BE(H,0),O}function t(H){return H.read(4).readUInt32BE(0)}function a(H){const O=k.VSBuffer.alloc(1);return O.writeUInt8(H,0),O}const r={Undefined:a(o.Undefined),String:a(o.String),Buffer:a(o.Buffer),VSBuffer:a(o.VSBuffer),Array:a(o.Array),Object:a(o.Object)},s=typeof Buffer!="undefined";function l(H,O){if(typeof O=="undefined")H.write(r.Undefined);else if(typeof O=="string"){const q=k.VSBuffer.fromString(O);H.write(r.String),H.write(c(q.byteLength)),H.write(q)}else if(s&&Buffer.isBuffer(O)){const q=k.VSBuffer.wrap(O);H.write(r.Buffer),H.write(c(q.byteLength)),H.write(q)}else if(O instanceof k.VSBuffer)H.write(r.VSBuffer),H.write(c(O.byteLength)),H.write(O);else if(Array.isArray(O)){H.write(r.Array),H.write(c(O.length));for(const q of O)l(H,q)}else{const q=k.VSBuffer.fromString(JSON.stringify(O));H.write(r.Object),H.write(c(q.byteLength)),H.write(q)}}function m(H){switch(H.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return H.read(t(H)).toString();case o.Buffer:return H.read(t(H)).buffer;case o.VSBuffer:return H.read(t(H));case o.Array:{const q=t(H),T=[];for(let A=0;A<q;A++)T.push(m(H));return T}case o.Object:return JSON.parse(H.read(t(H)).toString())}}class S{constructor(O,q,T=null,A=1e3){this.protocol=O,this.ctx=q,this.logger=T,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(O,q){this.channels.set(O,q),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const q=this.send([O.type]);this.logger&&this.logger.logOutgoing(q,0,1,I(O.type));return}case 201:case 202:case 204:case 203:{const q=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(q,O.id,1,I(O.type),O.data);return}}}send(O,q=void 0){const T=new h;return l(T,O),l(T,q),this.sendBuffer(T.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(q){return 0}}onRawMessage(O){const q=new u(O),T=m(q),A=m(q),W=T[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,T[1],1,`${d(W)}: ${T[2]}.${T[3]}`,A),this.onPromise({type:W,id:T[1],channelName:T[2],name:T[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,T[1],1,`${d(W)}: ${T[2]}.${T[3]}`,A),this.onEventListen({type:W,id:T[1],channelName:T[2],name:T[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,T[1],1,`${d(W)}`),this.disposeActiveRequest({type:W,id:T[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,T[1],1,`${d(W)}`),this.disposeActiveRequest({type:W,id:T[1]})}}onPromise(O){const q=this.channels.get(O.channelName);if(!q){this.collectPendingRequest(O);return}const T=new M.CancellationTokenSource;let A;try{A=q.call(this.ctx,O.name,O.arg,T.token)}catch(X){A=Promise.reject(X)}const W=O.id;A.then(X=>{this.sendResponse({id:W,data:X,type:201}),this.activeRequests.delete(O.id)},X=>{X instanceof Error?this.sendResponse({id:W,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:W,data:X,type:203}),this.activeRequests.delete(O.id)});const z=(0,w.toDisposable)(()=>T.cancel());this.activeRequests.set(O.id,z)}onEventListen(O){const q=this.channels.get(O.channelName);if(!q){this.collectPendingRequest(O);return}const T=O.id,W=q.listen(this.ctx,O.name,O.arg)(z=>this.sendResponse({id:T,data:z,type:204}));this.activeRequests.set(O.id,W)}disposeActiveRequest(O){const q=this.activeRequests.get(O.id);q&&(q.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let q=this.pendingRequests.get(O.channelName);q||(q=[],this.pendingRequests.set(O.channelName,q));const T=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:O,timeoutTimer:T})}flushPendingRequests(O){const q=this.pendingRequests.get(O);if(q){for(const T of q)switch(clearTimeout(T.timeoutTimer),T.request.type){case 100:this.onPromise(T.request);break;case 102:this.onEventListen(T.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=S;var D;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(O,q=null){this.protocol=O,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(T=>this.onBuffer(T)),this.logger=q}getChannel(O){const q=this;return{call(T,A,W){return q.isDisposed?Promise.reject(n.canceled()):q.requestPromise(O,T,A,W)},listen(T,A){return q.isDisposed?Promise.reject(n.canceled()):q.requestEvent(O,T,A)}}}requestPromise(O,q,T,A=M.CancellationToken.None){const W=this.lastRequestId++,X={id:W,type:100,channelName:O,name:q,arg:T};if(A.isCancellationRequested)return Promise.reject(n.canceled());let U;return new Promise((Q,J)=>{if(A.isCancellationRequested)return J(n.canceled());const re=()=>{const ge=fe=>{switch(fe.type){case 201:this.handlers.delete(W),Q(fe.data);break;case 202:this.handlers.delete(W);const de=new Error(fe.data.message);de.stack=fe.data.stack,de.name=fe.data.name,J(de);break;case 203:this.handlers.delete(W),J(fe.data);break}};this.handlers.set(W,ge),this.sendRequest(X)};let le=null;this.state===y.Idle?re():(le=(0,L.createCancelablePromise)(ge=>this.whenInitialized()),le.then(()=>{le=null,re()}));const ie=()=>{le?(le.cancel(),le=null):this.sendRequest({id:W,type:101}),J(n.canceled())},oe=A.onCancellationRequested(ie);U=(0,w.combinedDisposable)((0,w.toDisposable)(ie),oe),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(O,q,T){const A=this.lastRequestId++,z={id:A,type:102,channelName:O,name:q,arg:T};let X=null;const U=new f.Emitter({onFirstListenerAdd:()=>{X=(0,L.createCancelablePromise)(Q=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add(U),this.sendRequest(z)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete(U),this.sendRequest({id:A,type:103}))}}),N=Q=>U.fire(Q.data);return this.handlers.set(A,N),U.event}sendRequest(O){switch(O.type){case 100:case 102:{const q=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(q,O.id,0,`${d(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const q=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(q,O.id,0,d(O.type));return}}}send(O,q=void 0){const T=new h;return l(T,O),l(T,q),this.sendBuffer(T.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(q){return 0}}onBuffer(O){const q=new u(O),T=m(q),A=m(q),W=T[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,I(W)),this.onResponse({type:T[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,T[1],0,I(W),A),this.onResponse({type:T[0],id:T[1],data:A})}}onResponse(O){if(O.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(O.id);q&&q(O)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}ue([b.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class F{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:q,onDidClientDisconnect:T})=>{f.Event.once(q.onMessage)(W=>{const z=new u(W),X=m(z),U=new S(q,X),N=new R(q);this.channels.forEach((J,re)=>U.registerChannel(re,J));const Q={channelServer:U,channelClient:N,ctx:X};this._connections.add(Q),this._onDidAddConnection.fire(Q),T(()=>{U.dispose(),N.dispose(),this._connections.delete(Q),this._onDidRemoveConnection.fire(Q)})})})}get connections(){const O=[];return this._connections.forEach(q=>O.push(q)),O}getChannel(O,q){const T=this;return{call(A,W,z){let X;if((0,E.isFunction)(q)){let N=(0,p.getRandomElement)(T.connections.filter(q));X=N?Promise.resolve(N):f.Event.toPromise(f.Event.filter(T.onDidAddConnection,q))}else X=q.routeCall(T,A,W);const U=X.then(N=>N.channelClient.getChannel(O));return G(U).call(A,W,z)},listen(A,W){if((0,E.isFunction)(q))return T.getMulticastEvent(O,q,A,W);const z=q.routeEvent(T,A,W).then(X=>X.channelClient.getChannel(O));return G(z).listen(A,W)}}}getMulticastEvent(O,q,T,A){const W=this;let z=new w.DisposableStore;const X=new f.Emitter({onFirstListenerAdd:()=>{z=new w.DisposableStore;const U=new f.EventMultiplexer,N=new Map,Q=re=>{const ie=re.channelClient.getChannel(O).listen(T,A),oe=U.add(ie);N.set(re,oe)},J=re=>{const le=N.get(re);!le||(le.dispose(),N.delete(re))};W.connections.filter(q).forEach(Q),f.Event.filter(W.onDidAddConnection,q)(Q,void 0,z),W.onDidRemoveConnection(J,void 0,z),U.event(X.fire,X,z),z.add(U)},onLastListenerRemove:()=>{z.dispose()}});return X.event}registerChannel(O,q){this.channels.set(O,q),this._connections.forEach(T=>{T.channelServer.registerChannel(O,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=F;class C{constructor(O,q,T=null){const A=new h;l(A,q),O.send(A.buffer),this.channelClient=new R(O,T),this.channelServer=new S(O,q,T)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,q){this.channelServer.registerChannel(O,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=C;function G(H){return{call(O,q,T){return H.then(A=>A.call(O,q,T))},listen(O,q){const T=new f.Relay;return H.then(A=>T.input=A.listen(O,q)),T.event}}}e.getDelayedChannel=G;function ne(H){let O=!1;return{call(q,T,A){return O?H.call(q,T,A):(0,L.timeout)(0).then(()=>O=!0).then(()=>H.call(q,T,A))},listen(q,T){if(O)return H.listen(q,T);const A=new f.Relay;return(0,L.timeout)(0).then(()=>O=!0).then(()=>A.input=H.listen(q,T)),A.event}}}e.getNextTickChannel=ne;class ae{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const q of O.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await f.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=ae;var K;(function(H){function O(W,z){const X=W,U=z&&z.disableMarshalling,N=new Map;for(const Q in X)T(Q)&&N.set(Q,f.Event.buffer(X[Q],!0));return new class{listen(Q,J,re){const le=N.get(J);if(le)return le;if(A(J)){const ie=X[J];if(typeof ie=="function")return ie.call(X,re)}throw new Error(`Event not found: ${J}`)}call(Q,J,re){const le=X[J];if(typeof le=="function"){if(!U&&Array.isArray(re))for(let ie=0;ie<re.length;ie++)re[ie]=(0,i.revive)(re[ie]);return le.apply(X,re)}throw new Error(`Method not found: ${J}`)}}}H.fromService=O;function q(W,z){const X=z&&z.disableMarshalling;return new Proxy({},{get(U,N){if(typeof N=="string")return z?.properties?.has(N)?z.properties.get(N):A(N)?function(Q){return W.listen(N,Q)}:T(N)?W.listen(N):async function(...Q){let J;z&&!(0,E.isUndefinedOrNull)(z.context)?J=[z.context,...Q]:J=Q;const re=await W.call(N,J);return X?re:(0,i.revive)(re)};throw new Error(`Property not found: ${String(N)}`)}})}H.toService=q;function T(W){return W[0]==="o"&&W[1]==="n"&&P.isUpperAsciiLetter(W.charCodeAt(2))}function A(W){return/^onScoped/.test(W)&&P.isUpperAsciiLetter(W.charCodeAt(8))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){let O=H.toString();if(O!=="[object Object]")return O}return H}function j(H){return Array.isArray(H)?H.map(_):_(H)}function $(H,O,q,T,A,W,z){z=j(z);const X=ee[A],U=X[T%X.length];let N=[`%c[${H}]%c[${String(O).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(T).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(W)?(N=N.concat(z),N.push(")")):N.push(z),console.log.apply(console,N)}e.logWithColors=$;class B{constructor(O,q){this._outgoingPrefix=O,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,q,T,A,W){this._totalOutgoing+=O,$(this._outgoingPrefix,this._totalOutgoing,O,q,T,A,W)}logIncoming(O,q,T,A,W){this._totalIncoming+=O,$(this._incomingPrefix,this._totalIncoming,O,q,T,A,W)}}e.IPCLogger=B}),define(Z[120],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(k,M){this.sender=k,this.onMessage=M}send(k){try{this.sender.send("vscode:message",k.buffer)}catch(M){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(Z[121],x([0,1,18,4,35]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(f){this.port=f,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",w=>p.VSBuffer.wrap(w.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class b extends k.IPCClient{constructor(f,w){const i=new M(f);super(i,w);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=b}),define(Z[83],x([0,1,18,4,2,3,33,35]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var f;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function i(){return w||(w=p.VSBuffer.alloc(0)),w}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,l){if(s===0)return i();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const R=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=s),R}if(this._chunks[0].byteLength>s){const R=this._chunks[0].slice(0,s);return l&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),R}let m=p.VSBuffer.alloc(s),S=0,D=0;for(;s>0;){const R=this._chunks[D];if(R.byteLength>s){const F=R.slice(0,s);m.set(F,S),S+=s,l&&(this._chunks[D]=R.slice(s),this._totalLength-=s),s-=s}else m.set(R,S),S+=R.byteLength,l?(this._chunks.shift(),this._totalLength-=R.byteLength):D++,s-=R.byteLength}return m}}e.ChunkStream=P;var E;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(E||(E={}));var v;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(s,l,m,S){this.type=s,this.id=l,this.ack=m,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends k.Disposable{constructor(s){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const m=this._state.messageType,S=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(m,S,D,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class I{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=p.VSBuffer.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this._writeSoon(l,s.data)}_bufferAdd(s,l){const m=this._totalLength===0;return this._data.push(s,l),this._totalLength+=s.byteLength+l.byteLength,m}_bufferTake(){const s=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,l){this._bufferAdd(s,l)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class y extends k.Disposable{constructor(s){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new I(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new d(1,0,0,s))}}e.Protocol=y;class u extends n.IPCClient{constructor(s,l,m=null){super(s,l,m);this.protocol=s}static fromSocket(s,l){return new u(new y(s),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=u;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,b.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class o{constructor(s){this.data=s,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],l=0,m=this._first;for(;m;)s[l++]=m.data,m=m.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const l=new o(s);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class t{constructor(){this.lastRuns=[];const s=Date.now();for(let l=0;l<t._HISTORY_LENGTH;l++)this.lastRuns[l]=s-1e3*l;setInterval(()=>{for(let l=t._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const s=Date.now(),l=(1+t._HISTORY_LENGTH)*1e3;let m=0;for(let S=0;S<t._HISTORY_LENGTH;S++)s-this.lastRuns[S]<=l&&m++;return 1-m/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class a{constructor(s,l=null,m=t.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=m,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.push(this._socket.onClose(S=>this._onSocketClose.fire(S))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new d(5,0,0,i());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const l=new d(4,0,0,i());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,l){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let l=0,m=s.length;l<m;l++)this._socketWriter.write(s[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new d(6,0,0,i())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const l=this._outgoingUnackMsg.toArray();for(let m=0,S=l.length;m<S;m++)this._socketWriter.write(l[m]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const m=new d(1,l,this._incomingAckId,s);this._outgoingUnackMsg.push(m),this._isReconnecting||(this._socketWriter.write(m),this._recvAckCheck())}sendControl(s){const l=new d(2,0,0,s);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),l=Date.now()-s.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new d(3,0,this._incomingAckId,i());this._socketWriter.write(s)}}e.PersistentProtocol=a}),define(Z[122],x([0,1,14,18,4,2,35,120]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(i,P){const E=k.Event.fromNodeEventEmitter(p.ipcMain,P,(d,g)=>({event:d,message:g})),v=k.Event.filter(E,({event:d})=>d.sender.id===i);return k.Event.map(v,({message:d})=>d&&L.VSBuffer.wrap(d))}class w extends b.IPCServer{constructor(){super(w.getOnDidClientConnect())}static getOnDidClientConnect(){const P=k.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:E})=>E);return k.Event.map(P,E=>{const v=E.id,d=w.Clients.get(v);d&&d.dispose();const g=new k.Emitter;w.Clients.set(v,(0,M.toDisposable)(()=>g.fire()));const I=f(v,"vscode:message"),y=k.Event.any(k.Event.signal(f(v,"vscode:disconnect")),g.event);return{protocol:new n.Protocol(E,I),onDidClientDisconnect:y}})}}e.Server=w,w.Clients=new Map}),define(Z[84],x([0,1,14,4,28,121]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class b extends M.Client{constructor(w,i){super({addEventListener:(P,E)=>w.addListener(P,E),removeEventListener:(P,E)=>w.removeListener(P,E),postMessage:P=>w.postMessage(P),start:()=>w.start(),close:()=>w.close()},i)}}e.Client=b;async function n(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,k.generateUuid)();f.webContents.send("vscode:createMessageChannel",w);const i=L.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(E,v)=>({nonce:v,port:E.ports[0]})),{port:P}=await L.Event.toPromise(L.Event.once(L.Event.filter(i,E=>E.nonce===w)));return P}e.connect=n}),define(Z[85],x([0,1,9,4,2,13]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var b;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(b=e.StorageHint||(e.StorageHint={}));function n(P){const E=P;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=n;var f;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(f||(f={}));class w extends k.Disposable{constructor(E,v=Object.create(null)){super();this.database=E,this.options=v,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){E.changed?.forEach((v,d)=>this.accept(d,v)),E.deleted?.forEach(v=>this.accept(v,void 0))}accept(E,v){if(this.state===f.Closed)return;let d=!1;(0,M.isUndefinedOrNull)(v)?d=this.cache.delete(E):this.cache.get(E)!==v&&(this.cache.set(E,v),d=!0),d&&this._onDidChangeStorage.fire(E)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,v){const d=this.cache.get(E);return(0,M.isUndefinedOrNull)(d)?v:d}getBoolean(E,v){const d=this.get(E);return(0,M.isUndefinedOrNull)(d)?v:d==="true"}getNumber(E,v){const d=this.get(E);return(0,M.isUndefinedOrNull)(d)?v:parseInt(d,10)}async set(E,v){if(this.state===f.Closed)return;if((0,M.isUndefinedOrNull)(v))return this.delete(E);const d=String(v);if(this.cache.get(E)!==d)return this.cache.set(E,d),this.pendingInserts.set(E,d),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async delete(E){if(!(this.state===f.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(E){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert&&E.insert.forEach((v,d)=>this.items.set(d,v)),E.delete&&E.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=i}),define(Z[123],x([0,1,9,4,37,8,19]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(i,P=Object.create(null)){this.path=i,this.options=P,this.name=(0,M.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const i=await this.whenConnected,P=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(v=>P.set(v.key,v.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${P.size} rows`),P}async updateItems(i){const P=await this.whenConnected;return this.doUpdateItems(P,i)}doUpdateItems(i,P){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${P.insert?(0,k.mapToString)(P.insert):"0"}), delete(${P.delete?(0,k.setToString)(P.delete):"0"})`),this.transaction(i,()=>{const E=P.insert,v=P.delete;if(E&&E.size>0){const d=[];d.push([]);let g=0;E.forEach((I,y)=>{let u=d[g];u.length>n.MAX_HOST_PARAMETERS&&(g++,u=[],d.push(u)),u.push(y,I)}),d.forEach(I=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(I.length/2).fill("(?,?)").join(",")}`,y=>y.run(I),()=>{const y=[];let u=0;return E.forEach((h,o)=>{y.push(o),u+=h.length}),`Keys: ${y.join(", ")} Length: ${u}`})})}if(v&&v.size){const d=[];d.push([]);let g=0;v.forEach(I=>{let y=d[g];y.length>n.MAX_HOST_PARAMETERS&&(g++,y=[],d.push(y)),y.push(I)}),d.forEach(I=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(I.length).fill("?").join(",")})`,y=>y.run(I),()=>{const y=[];return v.forEach(u=>{y.push(u)}),`Keys: ${y.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const P=await this.whenConnected;return this.doClose(P,i)}doClose(i,P){return new Promise((E,v)=>{i.db.close(d=>(d&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${d}`),this.path===n.IN_MEMORY_PATH?E():!i.isErroneous&&!i.isInMemory?this.backup().then(E,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),E())):typeof P=="function"?b.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const I=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:P()}).then(()=>I(),y=>(I(),Promise.reject(y)))})).then(E,v):v(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return b.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const P=await this.whenConnected,E=await this.get(P,i?"PRAGMA integrity_check":"PRAGMA quick_check"),v=i?E.integrity_check:E.quick_check;return P.isErroneous?`${v} (last error: ${P.lastError})`:P.isInMemory?`${v} (in-memory!)`:v}async connect(i,P=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${P})`);try{return await this.doConnect(i)}catch(E){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${E}`),E.code==="SQLITE_BUSY"&&P)return await(0,p.timeout)(n.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await b.Promises.unlink(i);try{await b.Promises.rename(this.toBackupPath(i),i)}catch(v){}return await this.doConnect(i)}catch(v){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${v}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(i,P){i.isErroneous=!0,i.lastError=P,this.logger.error(P)}doConnect(i){return new Promise((P,E)=>{new Promise((v,d)=>{V(["@vscode/sqlite3"],v,d)}).then(v=>{const d={db:new(this.logger.isTracing?v.verbose().Database:v.Database)(i,g=>g?d.db?d.db.close(()=>E(g)):E(g):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(d),I=>d.db.close(()=>E(I)))),isInMemory:i===n.IN_MEMORY_PATH};d.db.on("error",g=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&d.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},E)})}exec(i,P){return new Promise((E,v)=>{i.db.exec(P,d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${d}`),v(d)):E())})}get(i,P){return new Promise((E,v)=>{i.db.get(P,(d,g)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${d}`),v(d)):E(g))})}all(i,P){return new Promise((E,v)=>{i.db.all(P,(d,g)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${d}`),v(d)):E(g))})}transaction(i,P){return new Promise((E,v)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),P(),i.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${d}`),v(d)):E())})})}prepare(i,P,E,v){const d=i.db.prepare(P),g=I=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${I} (${P}). Details: ${v()}`)};d.on("error",g),E(d),d.finalize(I=>{I&&g(I),d.removeListener("error",g)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class f{constructor(i){i&&typeof i.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[124],x([12,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(Z[125],x([0,1,124]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,M=k*24,b=M*7,n=M*30,f=M*365;function w(P,E){typeof P!="number"&&(P=P.getTime());const v=Math.round((new Date().getTime()-P)/1e3);if(v<-30)return(0,p.localize)(0,null,w(new Date().getTime()+v*1e3,!1));if(v<30)return(0,p.localize)(1,null);let d;return v<L?(d=v,E?d===1?(0,p.localize)(2,null,d):(0,p.localize)(3,null,d):d===1?(0,p.localize)(4,null,d):(0,p.localize)(5,null,d)):v<k?(d=Math.floor(v/L),E?d===1?(0,p.localize)(6,null,d):(0,p.localize)(7,null,d):d===1?(0,p.localize)(8,null,d):(0,p.localize)(9,null,d)):v<M?(d=Math.floor(v/k),E?d===1?(0,p.localize)(10,null,d):(0,p.localize)(11,null,d):d===1?(0,p.localize)(12,null,d):(0,p.localize)(13,null,d)):v<b?(d=Math.floor(v/M),E?d===1?(0,p.localize)(14,null,d):(0,p.localize)(15,null,d):d===1?(0,p.localize)(16,null,d):(0,p.localize)(17,null,d)):v<n?(d=Math.floor(v/b),E?d===1?(0,p.localize)(18,null,d):(0,p.localize)(19,null,d):d===1?(0,p.localize)(20,null,d):(0,p.localize)(21,null,d)):v<f?(d=Math.floor(v/n),E?d===1?(0,p.localize)(22,null,d):(0,p.localize)(23,null,d):d===1?(0,p.localize)(24,null,d):(0,p.localize)(25,null,d)):(d=Math.floor(v/f),E?d===1?(0,p.localize)(26,null,d):(0,p.localize)(27,null,d):d===1?(0,p.localize)(28,null,d):(0,p.localize)(29,null,d))}e.fromNow=w;function i(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(Z[126],x([12,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(Z[68],x([0,1,30,13,126]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(w,i){return i&&(w.stack||w.stacktrace)?k.localize(0,null,n(w),b(w.stack)||b(w.stacktrace)):n(w)}function b(w){return Array.isArray(w)?w.join(`
`):w}function n(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?k.localize(1,null,w.message):w.message||k.localize(2,null)}function f(w=null,i=!1){if(!w)return k.localize(3,null);if(Array.isArray(w)){const P=p.coalesce(w),E=f(P[0],i);return P.length>1?k.localize(4,null,E,P.length):E}if(L.isString(w))return w;if(w.detail){const P=w.detail;if(P.error)return M(P.error,i);if(P.exception)return M(P.exception,i)}return w.stack?M(w,i):w.message?w.message:k.localize(5,null)}e.toErrorMessage=f}),define(Z[127],x([12,11]),function(V,e){return V.create("vs/base/common/keybindingLabels",e)}),define(Z[128],x([0,1,127]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(b,n,f=n){this.modifierLabels=[null],this.modifierLabels[2]=b,this.modifierLabels[1]=n,this.modifierLabels[3]=f}toLabel(b,n,f){if(n.length===0)return null;const w=[];for(let i=0,P=n.length;i<P;i++){const E=n[i],v=f(E);if(v===null)return null;w[i]=k(E,v,this.modifierLabels[b])}return w.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function k(M,b,n){if(b===null)return"";const f=[];return M.ctrlKey&&f.push(n.ctrlKey),M.shiftKey&&f.push(n.shiftKey),M.altKey&&f.push(n.altKey),M.metaKey&&f.push(n.metaKey),b!==""&&f.push(b),f.join(n.separator)}}),define(Z[129],x([12,11]),function(V,e){return V.create("vs/base/node/processes",e)}),define(Z[69],x([0,1,41,31,10,44,8,3,33,13,80,19,129]),function(V,e,p,L,k,M,b,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function v(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,c){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};c&&(t.cwd=c);const a=p.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(r=>{a.once("error",s=>{r({success:!1,error:s})}),a.once("exit",(s,l)=>{r(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?v(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(a=>{p.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,s,l)=>{a(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function g(o=f.env){return o.comspec||"cmd.exe"}e.getWindowsShell=g;class I{constructor(c,t,a,r){if(t!==void 0&&a!==void 0&&r!==void 0)this.cmd=c,this.args=t,this.shell=a,this.options=r;else{const s=c;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(f.env).forEach(l=>{s[l]=f.env[l]}),Object.keys(this.options.env).forEach(l=>{s[l]=this.options.env[l]}),this.options.env=s}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const t=c.lastIndexOf(b.sep);return t!==-1&&(c=c.substring(t+1)),I.WellKnowCommands[c]?c:"other"}start(c){return n.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(f.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(t=>{let a,r;const s=new Promise((l,m)=>{a=l,r=m});if(t){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=p.exec(l,this.options,(m,S,D)=>{this.childProcess=null;const R=m;R&&R.killed?r({killed:this.terminateRequested,stdout:S.toString(),stderr:D.toString()}):this.handleExec(a,c,m,S,D)})}else{let l=null;const m=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,a,c,r);const D={terminated:this.terminateRequested};w.isNumber(S)&&(D.cmdCode=S),a(D)};if(this.shell&&n.isWindows){const S=M.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let D=!1,R=!1;const F=[];let C=this.ensureQuotes(this.cmd);F.push(C.value),D=C.quoted,this.args&&this.args.forEach(ne=>{C=this.ensureQuotes(ne),F.push(C.value),R=R&&C.quoted});const G=["/s","/c"];D?R?G.push('"'+F.join(" ")+'"'):F.length>1?G.push('"'+F[0]+'" '+F.slice(1).join(" ")):G.push('"'+F[0]+'"'):G.push(F.join(" ")),l=p.spawn(g(),G,S)}else this.cmd&&(l=p.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(w.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",S=>{this.childProcess=null,r({terminated:this.terminateRequested,error:S})}),l.pid&&(this.childProcess.on("close",m),this.handleSpawn(l,a,c,r,!0)))}return s})}handleClose(c,t,a,r){}ensureQuotes(c){return I.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,d(c,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!n.isWindows)return c(!1);const t=p.spawn(g(),["/s","/c"]);t.on("error",a=>c(!0)),t.on("exit",a=>c(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class y extends I{constructor(c,t,a,r){super(c,t,a,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,t,a,r,s){[r,s].forEach((l,m)=>{const S=new i.LineDecoder;S.write(l).forEach(F=>{t({line:F,source:m===0?0:1})});const R=S.end();R&&t({line:R,source:m===0?0:1})}),c({terminated:this.terminateRequested,error:a})}handleSpawn(c,t,a,r,s){const l=new i.LineDecoder,m=new i.LineDecoder;c.stdout.on("data",S=>{l.write(S).forEach(R=>a({line:R,source:0}))}),c.stderr.on("data",S=>{m.write(S).forEach(R=>a({line:R,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=m}handleClose(c,t,a,r){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&a({line:s,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&a({line:l,source:1})}}e.LineProcess=y;function u(o){let c=[],t=!1;const a=function(r){if(t){c.push(r);return}(!o.send(r,l=>{if(l&&console.error(l),t=!1,c.length>0){const m=c.slice(0);c=[],m.forEach(S=>a(S))}})||n.isWindows)&&(t=!0)};return{send:a}}e.createQueuedSender=u;var h;(function(o){async function c(t,a,r){if(b.isAbsolute(t))return t;if(a===void 0&&(a=f.cwd()),b.dirname(t)!=="."||(r===void 0&&w.isString(f.env.PATH)&&(r=f.env.PATH.split(b.delimiter)),r===void 0||r.length===0))return b.join(a,t);async function l(m){if(await P.Promises.exists(m)){let S;try{S=await P.Promises.stat(m)}catch(D){D.message.startsWith("EACCES")&&(S=await P.Promises.lstat(m))}return S?!S.isDirectory():!1}return!1}for(let m of r){let S;if(b.isAbsolute(m)?S=b.join(m,t):S=b.join(a,m,t),await l(S))return S;let D=S+".com";if(await l(D)||(D=S+".exe",await l(D)))return D}return b.join(a,t)}o.findExecutable=c})(h=e.win32||(e.win32={}))}),define(Z[130],x([0,1,26,3,116,69]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function b(v,d){return v===1?L.isWindows?P():M.getWindowsShell(d):w(v,d)}e.getSystemShell=b;function n(v,d){return v===1?L.isWindows?E(d):M.getWindowsShell(d):w(v,d)}e.getSystemShellSync=n;let f=null;function w(v,d){if(L.isLinux&&v===2||L.isMacintosh&&v===3)return"/bin/bash";if(!f){let g;if(L.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,p.userInfo)().shell}catch(I){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}f=g}return f}let i=null;async function P(){return i||(i=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),i}function E(v){if(i)return i;const d=L.isWindows&&parseFloat((0,p.release)())>=10,g=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),I=`${v.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?I:M.getWindowsShell(v)}}),define(Z[86],x([0,1,41,9,18,23,109,17,4,2,44,3,69,35]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends v.ChannelServer{constructor(y){super({send:u=>{try{process.send&&process.send(u.buffer.toString("base64"))}catch(h){}},onMessage:f.Event.fromNodeEventEmitter(process,"message",u=>k.VSBuffer.wrap(Buffer.from(u,"base64")))},y);process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(y,u){this.modulePath=y,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new L.Delayer(h),this.child=null,this._client=null}getChannel(y){const u=this;return{call(h,o,c){return u.requestPromise(y,h,o,c)},listen(h,o){return u.requestEvent(y,h,o)}}}requestPromise(y,u,h,o=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(n.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(y),t=(0,L.createCancelablePromise)(s=>c.call(u,h,s)),a=o.onCancellationRequested(()=>t.cancel()),r=(0,w.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{a.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(y,u,h){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let o;const c=new f.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(y).listen(u,h)(c.fire,c),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),P.isMacintosh&&u.env&&delete u.env.DYLD_LIBRARY_PATH,this.child=(0,p.fork)(this.modulePath,y,u);const h=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,b.isRemoteConsoleLog)(l)){(0,b.log)(l,`IPC Library: ${this.options.serverName}`);return}h.fire(k.VSBuffer.wrap(Buffer.from(l,"base64")))});const c=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,t=l=>this.child&&this.child.connected&&c.send(l.buffer.toString("base64")),a=h.event,r={send:t,onMessage:a};this._client=new v.ChannelClient(r);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,m)=>{process.removeListener("exit",s),this.activeRequests.forEach(S=>(0,w.dispose)(S)),this.activeRequests.clear(),l!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+m),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:m})})}return this._client}getCachedChannel(y){let u=this.channels.get(y);return u||(u=this.client.getChannel(y),this.channels.set(y,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(Z[131],x([12,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(Z[132],x([12,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[133],x([12,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[134],x([12,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(Z[135],x([12,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(Z[136],x([12,11]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[137],x([12,11]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[138],x([12,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[139],x([12,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(Z[140],x([12,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(Z[141],x([12,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(Z[142],x([12,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[143],x([12,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[144],x([12,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[145],x([12,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[146],x([12,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(Z[147],x([12,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[148],x([12,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[149],x([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/window",e)}),define(Z[150],x([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[151],x([12,11]),function(V,e){return V.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[152],x([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[153],x([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[154],x([0,1,4,2]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(n,f,w){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(n,f,w){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class M extends L.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,f,w){this.channel.call("attach",[n,f,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,f){this.channel.call("terminate",[n,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,f,w){return this.channel.call("openExtensionDevelopmentHostWindow",[n,f||{},w])}}e.ExtensionHostDebugChannelClient=M}),define(Z[155],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(b){this.driver=b}listen(b,n){throw new Error(`No event found: ${n}`)}call(b,n,f){switch(n){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=p;class L{constructor(b){this.channel=b}click(b,n,f){return this.channel.call("click",[b,n,f])}doubleClick(b){return this.channel.call("doubleClick",b)}setValue(b,n){return this.channel.call("setValue",[b,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(b){return this.channel.call("isActiveElement",b)}getElements(b,n){return this.channel.call("getElements",[b,n])}getElementXY(b,n,f){return this.channel.call("getElementXY",[b,n,f])}typeInEditor(b,n){return this.channel.call("typeInEditor",[b,n])}getTerminalBuffer(b){return this.channel.call("getTerminalBuffer",b)}writeInTerminal(b,n){return this.channel.call("writeInTerminal",[b,n])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class k{constructor(b){this.channel=b}registerWindowDriver(b){return this.channel.call("registerWindowDriver",b)}reloadWindowDriver(b){return this.channel.call("reloadWindowDriver",b)}}e.WindowDriverRegistryChannelClient=k}),define(Z[156],x([0,1,125,47,10,8,33,15,7]),function(V,e,p,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(g,I,y){this._args=g,this.paths=I,this.productService=y}get appRoot(){return(0,M.dirname)(k.FileAccess.asFileUri("",V).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,n.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,n.joinPath)(f.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=b.env.VSCODE_PORTABLE;return g?f.URI.file((0,M.join)(g,"argv.json")):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,n.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,M.resolve)(g):(0,M.normalize)((0,M.join)(k.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,M.resolve)(g):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,M.resolve)(g);const I=b.env.VSCODE_EXTENSIONS;if(I)return I;const y=b.env.VSCODE_PORTABLE;return y?(0,M.join)(y,"extensions"):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(I=>/^[^:/?#]+?:\/\//.test(I)?f.URI.parse(I):f.URI.file((0,M.normalize)(I)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,M.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!b.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,n.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([L.memoize],w.prototype,"appRoot",null),ue([L.memoize],w.prototype,"userHome",null),ue([L.memoize],w.prototype,"userDataPath",null),ue([L.memoize],w.prototype,"appSettingsHome",null),ue([L.memoize],w.prototype,"tmpDir",null),ue([L.memoize],w.prototype,"userRoamingDataHome",null),ue([L.memoize],w.prototype,"settingsResource",null),ue([L.memoize],w.prototype,"userDataSyncHome",null),ue([L.memoize],w.prototype,"userDataSyncLogResource",null),ue([L.memoize],w.prototype,"sync",null),ue([L.memoize],w.prototype,"machineSettingsResource",null),ue([L.memoize],w.prototype,"globalStorageHome",null),ue([L.memoize],w.prototype,"workspaceStorageHome",null),ue([L.memoize],w.prototype,"keybindingsResource",null),ue([L.memoize],w.prototype,"keyboardLayoutResource",null),ue([L.memoize],w.prototype,"argvResource",null),ue([L.memoize],w.prototype,"snippetsHome",null),ue([L.memoize],w.prototype,"isExtensionDevelopment",null),ue([L.memoize],w.prototype,"untitledWorkspacesHome",null),ue([L.memoize],w.prototype,"installSourcePath",null),ue([L.memoize],w.prototype,"builtinExtensionsPath",null),ue([L.memoize],w.prototype,"extensionsPath",null),ue([L.memoize],w.prototype,"extensionDevelopmentLocationURI",null),ue([L.memoize],w.prototype,"extensionDevelopmentKind",null),ue([L.memoize],w.prototype,"extensionTestsLocationURI",null),ue([L.memoize],w.prototype,"debugExtensionHost",null),ue([L.memoize],w.prototype,"serviceMachineIdResource",null),ue([L.memoize],w.prototype,"telemetryLogResource",null),ue([L.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function i(d,g){return v(d["inspect-extensions"],d["inspect-brk-extensions"],5870,g,d.debugId)}e.parseExtensionHostPort=i;function P(d,g){return v(d["inspect-search"],d["inspect-brk-search"],5876,g)}e.parseSearchPort=P;function E(d,g){return v(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,g)}e.parsePtyHostPort=E;function v(d,g,I,y,u){const o=Number(g||d)||(y?null:I),c=o?Boolean(!!g):!1;return{port:o,break:c,debugId:u}}}),define(Z[87],x([0,1,240,3,134]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,k.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,k.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,k.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,k.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,k.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const b={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,g,I=b){const y={},u=[],h=[];for(let a in g){const r=g[a];r.alias&&(y[a]=r.alias),r.type==="string"||r.type==="string[]"?(u.push(a),r.deprecates&&u.push(r.deprecates)):r.type==="boolean"&&(h.push(a),r.deprecates&&h.push(r.deprecates))}const o=p(d,{string:u,boolean:h,alias:y}),c={},t=o;c._=o._.map(a=>String(a)).filter(a=>a.length>0),delete t._;for(let a in g){const r=g[a];r.alias&&delete t[r.alias];let s=t[a];r.deprecates&&t.hasOwnProperty(r.deprecates)&&(s||(s=t[r.deprecates]),delete t[r.deprecates]),typeof s!="undefined"&&(r.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):r.type==="string"&&Array.isArray(s)&&(s=s.pop(),I.onMultipleValues(a,s)),c[a]=s),delete t[a]}for(let a in t)I.onUnknownOption(a);return c}e.parseArgs=n;function f(d,g){let I="";return g.args&&(Array.isArray(g.args)?I=` <${g.args.join("> <")}>`:I=` <${g.args}>`),g.alias?`-${g.alias} --${d}${I}`:`--${d}${I}`}function w(d,g){let I=0,y=[];for(const c in d){const t=d[c],a=f(c,t);I=Math.max(I,a.length),y.push([a,t.description])}let u=I+2+1;if(g-u<25)return y.reduce((c,t)=>c.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let h=g-u-1,o=[];for(const c of y){let t=c[0],a=P(c[1],h),r=i(u-t.length-2);o.push("  "+t+r+a[0]);for(let s=1;s<a.length;s++)o.push(i(u)+a[s])}return o}e.formatOptions=w;function i(d){return" ".repeat(d)}function P(d,g){let I=[];for(;d.length;){let y=d.length<g?d.length:d.lastIndexOf(" ",g),u=d.slice(0,y).trim();d=d.slice(y),I.push(u)}return I}function E(d,g,I,y,u=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${d} ${I}`];o.push(""),o.push(`${(0,k.localize)(32,null)}: ${g} [${(0,k.localize)(33,null)}][${(0,k.localize)(34,null)}...]`),o.push(""),u&&(L.isWindows?o.push((0,k.localize)(35,null,g)):o.push((0,k.localize)(36,null,g)),o.push(""));const c={};for(const t in y){const a=y[t];if(a.description&&a.cat){let r=c[a.cat];r||(c[a.cat]=r={}),r[t]=a}}for(let t in c){const a=t;let r=c[a];r&&(o.push(M[a]),o.push(...w(r,h)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=E;function v(d,g){return`${d||(0,k.localize)(37,null)}
${g||(0,k.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=v}),define(Z[157],x([0,1,59,154,87]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends L.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,f,w){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1],w[2]):super.call(n,f,w)}async openExtensionDevelopmentHostWindow(n,f,w){const i=(0,k.parseArgs)(n,k.OPTIONS);i.debugRenderer=w;const P=i.extensionDevelopmentPath;if(!P)return{success:!1};let E;const v=Object.keys(f);for(let h of v){let o=f[h];o===null||(E||(E=Object.create(null)),E[h]=o)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(P,{context:5,cli:i,userEnv:E});if(!w)return{success:!0};const g=d.win;if(!g)return{success:!0};const I=g.webContents.debugger;let y=I.isAttached()?Infinity:0;const u=(0,p.createServer)(h=>{y++==0&&I.attach();let o=!1;const c=r=>{o||h.write(JSON.stringify(r)+"\0")},t=(r,s,l,m)=>c({method:s,params:l,sessionId:m});g.on("close",()=>{I.removeListener("message",t),h.end(),o=!0}),I.addListener("message",t);let a=Buffer.alloc(0);h.on("data",r=>{a=Buffer.concat([a,r]);for(let s=a.indexOf(0);s!==-1;s=a.indexOf(0)){let l;try{const m=a.slice(0,s).toString("utf8");a=a.slice(s+1),l=JSON.parse(m)}catch(m){console.error("error reading cdp line",m)}I.sendCommand(l.method,l.params,l.sessionId).then(m=>c({id:l.id,sessionId:l.sessionId,result:m})).catch(m=>c({id:l.id,sessionId:l.sessionId,error:{code:0,message:m.message}}))}}),h.on("error",r=>{console.error("error on cdp pipe:",r)}),h.on("close",()=>{o=!0,--y==0&&I.detach()})});return await new Promise(h=>u.listen(0,h)),g.on("close",()=>u.close()),{rendererDebugPort:u.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function V(e,p,L,k){function M(n){const f=b(n),w=[f];return e.isAbsolute(f)||w.unshift(k),e.resolve(...w)}function b(n){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,L);const i=n["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(P,"AppData","Roaming")}break;case"darwin":w=e.join(p.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,L)}return{getUserDataPath:M}}if(typeof define=="function")define(Z[158],x([0,159,26,10,15,33]),function(e,p,L,k,M,b){const n=M.dirname(k.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(M.joinPath(n,"package.json").fsPath);return V(p,L,f.name,b.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),L=require("os");module.exports=V(p,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[160],x([0,1,26,156,158]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends L.AbstractNativeEnvironmentService{constructor(n,f){super(n,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,k.getUserDataPath)(n)},f)}}e.NativeEnvironmentService=M}),define(Z[161],x([0,1,32,26,8]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(b){const n=(0,k.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return p.writeFileSync(n,""),b&&console.log(`Marker file for --wait created: ${n}`),n}catch(f){b&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=M}),define(Z[162],x([0,1,137]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function M(E){return E=E.trim(),E==="*"||L.test(E)}e.isValidVersionStr=M;function b(E){if(!M(E))return null;if(E=E.trim(),E==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=E.match(L);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=b;function n(E){if(!E)return null;let v=E.majorBase,d=E.majorMustEqual,g=E.minorBase,I=E.minorMustEqual,y=E.patchBase,u=E.patchMustEqual;E.hasCaret&&(v===0||(I=!1),u=!1);let h=0;if(E.preRelease){const o=k.exec(E.preRelease);if(o){const[,c,t,a]=o;h=Date.UTC(Number(c),Number(t)-1,Number(a))}}return{majorBase:v,majorMustEqual:d,minorBase:g,minorMustEqual:I,patchBase:y,patchMustEqual:u,isMinimum:E.hasGreaterEquals,notBefore:h}}e.normalizeVersion=n;function f(E,v,d){let g;typeof E=="string"?g=n(b(E)):g=E;let I;v instanceof Date?I=v.getTime():typeof v=="string"&&(I=new Date(v).getTime());let y;if(typeof d=="string"?y=n(b(d)):y=d,!g||!y)return!1;let u=g.majorBase,h=g.minorBase,o=g.patchBase,c=y.majorBase,t=y.minorBase,a=y.patchBase,r=y.notBefore,s=y.majorMustEqual,l=y.minorMustEqual,m=y.patchMustEqual;return y.isMinimum?u>c?!0:u<c?!1:h>t?!0:h<t||I&&I<r?!1:o>=a:(u===1&&c===0&&(!s||!l||!m)&&(c=1,t=0,a=0,s=!0,l=!1,m=!1),u<c?!1:u>c?!s:h<t?!1:h>t?!l:o<a?!1:o>a?!m:!(I&&I<r))}e.isValidVersion=f;function w(E,v,d,g){return d.isBuiltin||typeof d.main=="undefined"?!0:P(E,v,d.engines.vscode,g)}e.isValidExtensionVersion=w;function i(E,v,d){return E==="*"||P(v,d,E)}e.isEngineValid=i;function P(E,v,d,g=[]){let I=n(b(d));if(!I)return g.push(p.localize(0,null,d)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return g.push(p.localize(1,null,d)),!1}else if(!I.majorMustEqual)return g.push(p.localize(2,null,d)),!1;return f(E,v,I)?!0:(g.push(p.localize(3,null,E,d)),!1)}}),define(Z[163],x([0,1,2,10,35,86]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends p.Disposable{constructor(f,w,i,P){super();this.requests=f,this.onDidFilesChange=w,this.onLogMessage=i,this.verboseLogging=P,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=b.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.watch(this.requests)}setVerboseLogging(f){this.verboseLogging=f,this.isDisposed||this.service?.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}watch(f){this.requests=f,this.service?.watch(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b,b.MAX_RESTARTS=5}),define(Z[164],x([0,1,2,10,35,86]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends p.Disposable{constructor(f,w,i,P,E={}){super();this.folders=f,this.onDidFilesChange=w,this.onLogMessage=i,this.verboseLogging=P,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=b.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.watch(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}watch(f){this.folders=f,this.service&&this.service.watch(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b,b.MAX_RESTARTS=5}),define(Z[165],x([0,1,41,111,10,80]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class b{constructor(f,w,i,P,E){this.watchedFolder=f,this.eventCallback=i,this.logCallback=P,this.verboseLogging=E,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(v=>(0,L.parse)(v)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=(0,p.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",V).fsPath,f);const w=new M.LineDecoder;this.handle.stdout.on("data",i=>{const P=[];for(const E of w.write(i)){const v=E.split("|");if(v.length===2){const d=Number(v[0]),g=v[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(I=>I(g))){this.verboseLogging&&this.log(g);continue}P.push({type:b.changeTypeMap[d],path:g})}else this.log(v[1])}}P.length>0&&this.eventCallback(P)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,P)=>this.onExit(i,P))}onError(f){this.error("process error: "+f.toString())}onExit(f,w){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${w})`),this.restartCounter<=b.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=b,b.MAX_RESTARTS=5,b.changeTypeMap=[0,1,2]}),define(Z[166],x([0,1,8,25,165]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M{constructor(n,f,w,i){this.onDidFilesChange=f,this.onLogMessage=w,this.verboseLogging=i,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(p.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,p.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new k.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=M}),define(Z[70],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(k,M=[],b=!1){this.ctor=k,this.staticArguments=M,this.supportsDelayedInstantiation=b}}e.SyncDescriptor=p}),define(Z[167],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=p;class L{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let b of this._nodes.values())b.outgoing.size===0&&M.push(b);return M}insertEdge(M,b){const n=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(b);n.outgoing.set(this._hashFn(b),f),f.incoming.set(this._hashFn(M),n)}removeNode(M){const b=this._hashFn(M);this._nodes.delete(b);for(let n of this._nodes.values())n.outgoing.delete(b),n.incoming.delete(b)}lookupOrInsertNode(M){const b=this._hashFn(M);let n=this._nodes.get(b);return n||(n=new p(M),this._nodes.set(b,n)),n}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[b,n]of this._nodes)M.push(`${b}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,b]of this._nodes){const n=new Set([M]),f=this._findCycle(b,n);if(f)return f}}_findCycle(M,b){for(let[n,f]of M.outgoing){if(b.has(n))return[...b,n].join(" -> ");b.add(n);const w=this._findCycle(f,b);if(w)return w;b.delete(n)}}}e.Graph=L}),define(Z[5],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function f(w){return w[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=f})(p=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(n,f,w,i){f[p.DI_TARGET]===f?f[p.DI_DEPENDENCIES].push({id:n,index:w,optional:i}):(f[p.DI_DEPENDENCIES]=[{id:n,index:w,optional:i}],f[p.DI_TARGET]=f)}function k(n){if(p.serviceIds.has(n))return p.serviceIds.get(n);const f=function(w,i,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(f,w,P,!1)};return f.toString=()=>n,p.serviceIds.set(n,f),f}e.createDecorator=k;function M(n){return n}e.refineServiceDecorator=M;function b(n){return function(f,w,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(n,f,i,!0)}}e.optional=b}),define(Z[71],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function L(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[88],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService");class L{constructor(M){this.machineId=M}encryption(){return new Promise((M,b)=>V(["vscode-encrypt"],M,b))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch(b){return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch(b){return M}}}e.EncryptionMainService=L}),define(Z[48],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[168],x([0,1,10,136,5]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var M;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(M=e.TargetPlatform||(e.TargetPlatform={}));function b(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function n(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=n;function f(u,h){switch(u){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=f;function w(u,h){return h==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function i(u,h,o){return w(h,o)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===o?!0:P(o).includes(u)}e.isTargetPlatformCompatible=i;function P(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function E(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=E;var v;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var d;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var g;(function(u){u.Install="install",u.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var I;(function(u){u[u.None=0]="None",u[u.Install=1]="Install",u[u.Update=2]="Update"})(I=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class y extends Error{constructor(h,o){super(h);this.code=o,this.name=o}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",V).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(Z[169],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(Z[170],x([0,1,25,5]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=k;function M(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));class n{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,E){if(typeof P=="undefined"||P===null)return typeof E=="undefined"||E===null;if(typeof E=="undefined"||E===null)return!1;if(typeof P=="string"||typeof E=="string"){let v=typeof P=="string"?P:P.value,d=typeof E=="string"?E:E.value;return p.equalsIgnoreCase(v,d)}return P._lower===E._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=n;function f(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function w(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[171],x([0,1,25,170]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(d,g){return d.uuid&&g.uuid?d.uuid===g.uuid:d.id===g.id?!0:(0,p.compareIgnoreCase)(d.id,g.id)===0}e.areSameExtensions=k;class M{constructor(g,I){this.version=I,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof M?k(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=M;function b(d,g){return`${d}.${g}`}e.getExtensionId=b;function n(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function f(d,g){return n(b(d,g))}e.getGalleryExtensionId=f;function w(d,g){const I=[],y=u=>{for(const h of I)if(h.some(o=>k(g(o),g(u))))return h;return null};for(const u of d){const h=y(u);h?h.push(u):I.push([u])}return I}e.groupByExtension=w;function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function P(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function E(d){const g=new Set;for(const I of d)I.malicious&&g.add(I.id.id);return g}e.getMaliciousExtensionsSet=E;function v(d,g){const I=[],y=g.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const u=y.shift();if(u&&I.every(h=>!k(h.identifier,{id:u}))){const h=d.filter(o=>k(o.identifier,{id:u}));h.length===1&&(I.push(h[0]),y.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return I}e.getExtensionDependencies=v}),define(Z[89],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(Z[172],x([0,1,41,10,8,3,105,19,69,138,89]),function(V,e,p,L,k,M,b,n,f,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=w.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends E{openTerminal(o,c){return this.spawnTerminal(p,o,f.getWindowsShell(),c)}spawnTerminal(o,c,t,a){const r=c.windowsExec||v.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const s=k.basename(r).toLowerCase();if(s==="cmder"||s==="cmder.exe")return o.spawn(r,a?[a]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return r.indexOf(" ")>=0&&l.push('""'),l.push(r),(s==="wt"||s==="wt.exe")&&l.push("-d ."),new Promise((m,S)=>{const D=I(process),R=o.spawn(t,l,{cwd:a,env:D});R.on("error",S),R.on("exit",()=>m())})}runInTerminal(o,c,t,a,r){const s="windowsExec"in r&&r.windowsExec?r.windowsExec:v.getDefaultTerminalWindows();return new Promise((l,m)=>{const S=`"${c} - ${P}"`,D=`""${t.join('" "')}" & pause"`,R=["/c","start",S,"/wait",s,"/c",D],F=Object.assign({},I(process),a);Object.keys(F).filter(ne=>F[ne]===null).forEach(ne=>delete F[ne]);const C={cwd:c,env:F,windowsVerbatimArguments:!0};p.spawn(v.CMD,R,C).on("error",ne=>{m(y(ne))}),l(void 0)})}static getDefaultTerminalWindows(){if(!v._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return v._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=v,v.CMD="cmd.exe";class d extends E{openTerminal(o,c){return this.spawnTerminal(p,o,c)}runInTerminal(o,c,t,a,r){const s=r.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((l,m)=>{if(s===i.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const S=s===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`,V).fsPath,"-t",o||P,"-w",c];for(let G of t)R.push("-a"),R.push(G);if(a){const G=Object.assign({},I(process),a);for(let ne in G){const ae=G[ne];ae===null?(R.push("-u"),R.push(ne)):(R.push("-e"),R.push(`${ne}=${ae}`))}}let F="";const C=p.spawn(d.OSASCRIPT,R);C.on("error",G=>{m(y(G))}),C.stderr.on("data",G=>{F+=G.toString()}),C.on("exit",G=>{if(G===0)l(void 0);else if(F){const ne=F.split(`
`,1);m(new Error(ne[0]))}else m(new Error(w.localize(1,null,S,G)))})}else m(new Error(w.localize(2,null,s)))})}spawnTerminal(o,c,t){const a=c.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((r,s)=>{const l=["-a",a];t&&l.push(t);const m=I(process),S=o.spawn("/usr/bin/open",l,{cwd:t,env:m});S.on("error",s),S.on("exit",()=>r())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class g extends E{openTerminal(o,c){return this.spawnTerminal(p,o,c)}runInTerminal(o,c,t,a,r){const s=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,m)=>{let S=[];s.then(D=>{D.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const R=`${u(t)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;S.push(`''${R}''`);const F=Object.assign({},I(process),a);Object.keys(F).filter(ae=>F[ae]===null).forEach(ae=>delete F[ae]);const C={cwd:c,env:F};let G="";const ne=p.spawn(D,S,C);ne.on("error",ae=>{m(y(ae))}),ne.stderr.on("data",ae=>{G+=ae.toString()}),ne.on("exit",ae=>{if(ae===0)l(void 0);else if(G){const K=G.split(`
`,1);m(new Error(K[0]))}else m(new Error(w.localize(4,null,D,ae)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{M.isLinux?await n.Promises.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,c,t){const a=c.linuxExec?Promise.resolve(c.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,s)=>{a.then(l=>{const m=I(process),S=o.spawn(l,[],{cwd:t,env:m});S.on("error",s),S.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=w.localize(3,null);function I(h){const o={...h.env};return(0,b.sanitizeProcessEnvironment)(o),o}function y(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(w.localize(5,null,h.path)):h}function u(h){let o="";for(let c of h)c.indexOf(" ")>=0?o+='"'+c+'"':o+=c,o+=" ";return o}}),define(Z[20],x([0,1,37,8,25,13,7,140,5]),function(V,e,p,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function w(_){return _.create===!0}e.isFileOpenForWriteOptions=w;var i;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var P;(function(_){_[_.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var E;(function(_){_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=v;function d(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function I(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=I;var y;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(j,$){super(j);this.code=$}}e.FileSystemProviderError=u;function h(_,j){const $=new u(_.toString(),j);return c($,j),$}e.createFileSystemProviderError=h;function o(_){return _||h((0,n.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=o;function c(_,j){return _.name=j?`${j} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=c;function t(_){if(!_)return y.Unknown;if(_ instanceof u)return _.code;const j=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!j)return y.Unknown;switch(j[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=t;function a(_){if(_ instanceof D)return _.fileOperationResult;switch(t(_)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var r;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor(j,$,B){this.resource=j,this.operation=$,this.target=B}isOperation(j){return this.operation===j}}e.FileOperationEvent=s;var l;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class m{constructor(j,$){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const B of j)switch(B.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>$)),this.added.set(B.resource,B);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>$)),this.updated.set(B.resource,B);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>$)),this.deleted.set(B.resource,B);break}}contains(j,...$){return this.doContains(j,{includeChildren:!1},...$)}affects(j,...$){return this.doContains(j,{includeChildren:!0},...$)}doContains(j,$,...B){if(!j)return!1;const H=B.length>0;return!!((!H||B.includes(1))&&(this.added?.get(j)||$.includeChildren&&this.added?.findSuperstr(j))||(!H||B.includes(0))&&(this.updated?.get(j)||$.includeChildren&&this.updated?.findSuperstr(j))||(!H||B.includes(2))&&(this.deleted?.findSubstr(j)||$.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function S(_,j,$){return!_||!j||_===j||j.length>_.length?!1:(j.charAt(j.length-1)!==L.sep&&(j+=L.sep),$?(0,k.startsWithIgnoreCase)(_,j):_.indexOf(j)===0)}e.isParent=S;class D extends Error{constructor(j,$,B){super(j);this.fileOperationResult=$,this.options=B}}e.FileOperationError=D;class R extends D{constructor(j,$,B){super(j,2,B);this.stat=$}}e.NotModifiedSinceFileOperationError=R;var F;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var C;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(C=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function G(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=G;async function ne(_,j){if(!j.canHandleResource(b.URI.from({scheme:_.scheme})))return new Promise($=>{const B=j.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===_.scheme&&H.added&&(B.dispose(),$())})})}e.whenProviderRegistered=ne,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ae{static formatSize(j){return(0,M.isNumber)(j)||(j=0),j<ae.KB?(0,n.localize)(1,null,j.toFixed(0)):j<ae.MB?(0,n.localize)(2,null,(j/ae.KB).toFixed(2)):j<ae.GB?(0,n.localize)(3,null,(j/ae.MB).toFixed(2)):j<ae.TB?(0,n.localize)(4,null,(j/ae.GB).toFixed(2)):(0,n.localize)(5,null,(j/ae.TB).toFixed(2))}}e.ByteSize=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;var K;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function ee(_){return{maxFileSize:_===0?300*ae.MB:16*ae.GB,maxHeapSize:_===0?700*ae.MB:2*700*ae.MB}}e.getPlatformLimits=ee}),define(Z[54],x([0,1,241,135,87,20]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function b(E,v){const d={onUnknownOption:I=>{console.warn((0,L.localize)(0,null,I))},onMultipleValues:(I,y)=>{console.warn((0,L.localize)(1,null,I,y))}},g=(0,k.parseArgs)(E,k.OPTIONS,v?d:void 0);return g.goto&&g._.forEach(I=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(I),(0,L.localize)(2,null))),g["max-memory"]&&p(parseInt(g["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function n(E){const v=E.findIndex(d=>!/^-/.test(d));if(v>-1)return[...E.slice(0,v),...E.slice(v+1)]}function f(E){let[,...v]=E;process.env.VSCODE_DEV&&(v=n(v)||[]);const d=!P(process.env);return b(v,d)}e.parseMainProcessArgv=f;function w(E){const[,,...v]=E;return b(v,!0)}e.parseCLIProcessArgv=w;function i(E,...v){const d=E.indexOf("--");return d===-1?E.push(...v):E.splice(d,0,...v),E}e.addArg=i;function P(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),define(Z[90],x([0,1,41,159,23,68,17,3,28,130,54]),function(V,e,p,L,k,M,b,n,f,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function P(d,g,I){return g["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):n.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,i.isLaunchedFromCli)(I)&&!g["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,i.isLaunchedFromCli)(I)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=new Promise(async y=>{const u=new k.CancellationTokenSource,h=setTimeout(()=>{d.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),u.dispose(!0),y({})},1e4);try{const o=await v(d,u.token);y(o)}catch(o){(0,b.isPromiseCanceledError)(o)||d.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),y({})}finally{clearTimeout(h),u.dispose()}})),E)}e.resolveShellEnv=P;let E;async function v(d,g){const I=new Promise(async(y,u)=>{const h=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",o);const c=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(c+"(.*)"+c),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",a);const r=await(0,w.getSystemShell)(n.OS,a);if(d.trace("getUnixShellEnvironment#shell",r),g.isCancellationRequested)return u(b.canceled);const s=L.basename(r);let l,m;/^pwsh(-preview)?$/.test(s)?(l=`& '${process.execPath}' -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,m=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,m=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),l);const S=(0,p.spawn)(r,[...m,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});g.onCancellationRequested(()=>(S.kill(),u(b.canceled))),S.on("error",F=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(F)),y({})});const D=[];S.stdout.on("data",F=>D.push(F));const R=[];S.stderr.on("data",F=>R.push(F)),S.on("close",(F,C)=>{const G=Buffer.concat(D).toString("utf8");d.trace("getUnixShellEnvironment#raw",G);const ne=Buffer.concat(R).toString("utf8");if(ne.trim()&&d.trace("getUnixShellEnvironment#stderr",ne),F||C)return u(new Error(`Failed to get environment (code ${F}, signal ${C})`));const ae=t.exec(G),K=ae?ae[1]:"{}";try{const ee=JSON.parse(K);h?ee.ELECTRON_RUN_AS_NODE=h:delete ee.ELECTRON_RUN_AS_NODE,o?ee.ELECTRON_NO_ATTACH_CONSOLE=o:delete ee.ELECTRON_NO_ATTACH_CONSOLE,delete ee.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",ee),y(ee)}catch(ee){d.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(ee)),u(ee)}})});try{return await I}catch(y){return d.error("getUnixShellEnvironment#error",(0,M.toErrorMessage)(y)),{}}}}),define(Z[91],x([0,1,3,7,20]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function M(f){return f.map(w=>({type:w.type,resource:L.URI.file(w.path)}))}e.toFileChanges=M;function b(f){const w=new n;for(const i of f)w.processEvent(i);return w.normalize()}e.normalizeFileChanges=b;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(w){const i=this.mapPathToChange.get(w.path);if(i){const P=i.type,E=w.type;P===1&&E===2?(this.mapPathToChange.delete(w.path),this.normalized.splice(this.normalized.indexOf(i),1)):P===2&&E===1?i.type=0:P===1&&E===0||(i.type=E)}else this.normalized.push(w),this.mapPathToChange.set(w.path,w)}normalize(){const w=[],i=[];return this.normalized.filter(P=>P.type!==2?(w.push(P),!1):!0).sort((P,E)=>P.path.length-E.path.length).filter(P=>i.some(E=>(0,k.isParent)(P.path,E,!p.isLinux))?!1:(i.push(P.path),!0)).concat(w)}}}),define(Z[173],x([0,1,9,2,8,81,19,117,91]),function(V,e,p,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(P,E,v,d){super();this.path=P,this.onDidFilesChange=E,this.onLogMessage=v,this.verboseLogging=d,this.fileChangesDelayer=this._register(new p.ThrottledDelayer(n.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(P){this.verboseLogging=P}async startWatching(){try{const{stat:P,symbolicLink:E}=await b.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let v=this.path;if(E)try{v=await(0,M.realpath)(v)}catch(d){if(this.onError(d),E.dangling)return}P.isDirectory()?this._register((0,n.watchFolder)(v,(d,g)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,k.join)(this.path,(0,k.basename)(g))})},d=>this.onError(d))):this._register((0,n.watchFile)(v,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(P){P.code!=="ENOENT"&&this.onError(P)}}onFileChange(P){this.fileChangesBuffer.push(P),this.verboseLogging&&this.onVerbose(`${P.type===1?"[ADDED]":P.type===2?"[DELETED]":"[CHANGED]"} ${P.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,f.normalizeFileChanges)(E);if(this.verboseLogging)for(const d of v)this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);v.length>0&&this.onDidFilesChange(v)})}onError(P){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${P}`})}onVerbose(P){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${P}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(Z[72],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...k){this._entries=new Map;for(let[M,b]of k)this.set(M,b)}set(k,M){const b=this._entries.get(k);return this._entries.set(k,M),b}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=p}),define(Z[174],x([0,1,9,17,70,167,5,72]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class w extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class i{constructor(d=new n.ServiceCollection,g=!1,I){this._activeInstantiations=new Set,this._services=d,this._strict=g,this._parent=I,this._services.set(b.IInstantiationService,this)}createChild(d){return new i(d,this._strict,this)}invokeFunction(d,...g){let I=E.traceInvocation(d),y=!1;try{return d({get:(h,o)=>{if(y)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(h,I);if(!c&&o!==b.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return c}},...g)}finally{y=!0,I.stop()}}createInstance(d,...g){let I,y;return d instanceof k.SyncDescriptor?(I=E.traceCreation(d.ctor),y=this._createInstance(d.ctor,d.staticArguments.concat(g),I)):(I=E.traceCreation(d),y=this._createInstance(d,g,I)),I.stop(),y}_createInstance(d,g=[],I){let y=b._util.getServiceDependencies(d).sort((o,c)=>o.index-c.index),u=[];for(const o of y){let c=this._getOrCreateServiceInstance(o.id,I);if(!c&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);u.push(c)}let h=y.length>0?y[0].index:g.length;if(g.length!==h){console.warn(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${g.length} static arguments`);let o=h-g.length;o>0?g=g.concat(new Array(o)):g=g.slice(0,h)}return new d(...[...g,...u])}_setServiceInstance(d,g){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,g);else if(this._parent)this._parent._setServiceInstance(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let g=this._services.get(d);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):g}_getOrCreateServiceInstance(d,g){let I=this._getServiceInstanceOrDescriptor(d);return I instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,I,g.branch(d,!0)):(g.branch(d,!1),I)}_safeCreateAndCacheServiceInstance(d,g,I){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,g,I)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,g,I){const y=new M.Graph(o=>o.id.toString());let u=0;const h=[{id:d,desc:g,_trace:I}];for(;h.length;){const o=h.pop();if(y.lookupOrInsertNode(o),u++>1e3)throw new w(y);for(let c of b._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const a={id:c.id,desc:t,_trace:o._trace.branch(c.id,!0)};y.insertEdge(o,a),h.push(a)}}}for(;;){const o=y.roots();if(o.length===0){if(!y.isEmpty())throw new w(y);break}for(const{data:c}of o){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const a=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,a)}y.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,g,I=[],y,u){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(g,I,y,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,g,I,y,u);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(d,g=[],I,y){if(I){const u=new p.IdleValue(()=>this._createInstance(d,g,y));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let c=u.value,t=c[o];return typeof t!="function"||(t=t.bind(c),h[o]=t),t},set(h,o,c){return u.value[o]=c,!0}})}else return this._createInstance(d,g,y)}}e.InstantiationService=i;var P;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(P||(P={}));class E{constructor(d,g){this.type=d,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return f?new E(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(d){return f?new E(0,d.name):E._None}branch(d,g){let I=new E(2,d.toString());return this._dep.push([d,g,I]),I}stop(){let d=Date.now()-this._start;E._totals+=d;let g=!1;function I(u,h){let o=[],c=new Array(u+1).join("	");for(const[t,a,r]of h._dep)if(a&&r){g=!0,o.push(`${c}CREATES -> ${t}`);let s=I(u+1,r);s&&o.push(s)}else o.push(`${c}uses -> ${t}`);return o.join(`
`)}let y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(d>2||g)&&console.log(y.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(Z[175],x([0,1,17,128,57]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends k.ResolvedKeybinding{constructor(n,f){super();if(f.length===0)throw(0,p.illegalArgument)("parts");this._os=n,this._parts=f}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new k.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=M}),define(Z[176],x([0,1,57,175]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends L.BaseResolvedKeybinding{constructor(b,n){super(n,b.parts)}_keyCodeToUILabel(b){if(this._os===2)switch(b){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(b)}_getLabel(b){return b.isDuplicateModifierCase()?"":this._keyCodeToUILabel(b.keyCode)}_getAriaLabel(b){return b.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(b.keyCode)}_keyCodeToElectronAccelerator(b){if(b>=93&&b<=108)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return p.KeyCodeUtils.toString(b)}_getElectronAccelerator(b){return b.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(b.keyCode)}_getUserSettingsLabel(b){if(b.isDuplicateModifierCase())return"";const n=p.KeyCodeUtils.toUserSettingsUS(b.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(b){return k.getDispatchStr(b)}static getDispatchStr(b){if(b.isModifierKey())return null;let n="";return b.ctrlKey&&(n+="ctrl+"),b.shiftKey&&(n+="shift+"),b.altKey&&(n+="alt+"),b.metaKey&&(n+="meta+"),n+=p.KeyCodeUtils.toString(b.keyCode),n}_getSingleModifierDispatchPart(b){return b.keyCode===5&&!b.shiftKey&&!b.altKey&&!b.metaKey?"ctrl":b.keyCode===4&&!b.ctrlKey&&!b.altKey&&!b.metaKey?"shift":b.keyCode===6&&!b.ctrlKey&&!b.shiftKey&&!b.metaKey?"alt":b.keyCode===57&&!b.ctrlKey&&!b.shiftKey&&!b.altKey?"meta":null}}e.USLayoutResolvedKeybinding=k}),define(Z[177],x([0,1,9]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(k,M){if(k.length===0)return Promise.resolve(!1);const b=[];let n=!1;for(let f of k){if(f===!0)return Promise.resolve(!0);(0,p.isThenable)(f)&&b.push(f.then(w=>{w&&(n=!0)},w=>{M(w),n=!0}))}return p.Promises.settled(b).then(()=>n)}e.handleVetos=L}),define(Z[6],x([0,1,68,4,2,3,5]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function n(){return new Date().toISOString()}var f;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class w extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class i extends w{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...a){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([t,...a]))}debug(t,...a){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([t,...a]))}info(t,...a){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([t,...a]))}warn(t,...a){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([t,...a]))}error(t,...a){if(this.checkLogLevel(f.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(f.Error,this.format(r))}else this.log(f.Error,this.format([t,...a]))}critical(t,...a){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([t,...a]))}flush(){}format(t){let a="";for(let r=0;r<t.length;r++){let s=t[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(l){}a+=(r>0?" ":"")+s}return a}}e.AbstractMessageLogger=i;class P extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!M.isWindows}trace(t,...a){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...a):console.log(`[main ${n()}]`,t,...a))}debug(t,...a){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...a):console.log(`[main ${n()}]`,t,...a))}info(t,...a){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...a):console.log(`[main ${n()}]`,t,...a))}warn(t,...a){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,t,...a):console.warn(`[main ${n()}]`,t,...a))}error(t,...a){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,t,...a):console.error(`[main ${n()}]`,t,...a))}critical(t,...a){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,t,...a):console.error(`[main ${n()}]`,t,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class E extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...a){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",t,...a)}debug(t,...a){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...a)}info(t,...a){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",t,...a)}warn(t,...a){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",t,...a)}error(t,...a){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",t,...a)}critical(t,...a){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...a)}dispose(){}flush(){}}e.ConsoleLogger=E;class v extends w{constructor(t,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(a)}trace(t,...a){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(t),...a])}debug(t,...a){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(t),...a])}info(t,...a){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(t),...a])}warn(t,...a){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(t),...a])}error(t,...a){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(t),...a])}critical(t,...a){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(t),...a])}extractMessage(t){return typeof t=="string"?t:(0,p.toErrorMessage)(t,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class d extends w{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const a of this.logServices)a.setLevel(t);super.setLevel(t)}trace(t,...a){for(const r of this.logServices)r.trace(t,...a)}debug(t,...a){for(const r of this.logServices)r.debug(t,...a)}info(t,...a){for(const r of this.logServices)r.info(t,...a)}warn(t,...a){for(const r of this.logServices)r.warn(t,...a)}error(t,...a){for(const r of this.logServices)r.error(t,...a)}critical(t,...a){for(const r of this.logServices)r.critical(t,...a)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class g extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...a){this.logger.trace(t,...a)}debug(t,...a){this.logger.debug(t,...a)}info(t,...a){this.logger.info(t,...a)}warn(t,...a){this.logger.warn(t,...a)}error(t,...a){this.logger.error(t,...a)}critical(t,...a){this.logger.critical(t,...a)}flush(){this.logger.flush()}}e.LogService=g;class I extends k.Disposable{constructor(t,a){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,a){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,a?.always?f.Trace:this.logLevel,a),this.loggers.set(t.toString(),r),a?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class y{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return f.Info}trace(t,...a){}debug(t,...a){}info(t,...a){}warn(t,...a){}error(t,...a){}critical(t,...a){}dispose(){}flush(){}}e.NullLogService=y;function u(c){if(c.verbose)return f.Trace;if(typeof c.logLevel=="string"){const t=h(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function h(c){switch(c){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=h;function o(c){switch(c){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=o});var te=this&&this.__param||function(V,e){return function(p,L){e(p,L,V)}};define(Z[178],x([0,1,9,18,40,77,48,20,5,6]),function(V,e,p,L,k,M,b,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(E){E.ERROR_INVALID_FILE="ERROR_INVALID_FILE",E.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,f.createDecorator)(e.UserConfigurationFileServiceId);let P=class{constructor(v,d,g){this.environmentService=v,this.fileService=d,this.logService=g,this.queue=new p.Queue}async updateSettings(v,d){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,v,d))}async doWrite(v,d,g){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,v.toString(),d);const{value:I,mtime:y,etag:u}=await this.fileService.readFile(v,{atomic:!0});let h=I.toString();const o=[];if((0,k.parse)(h,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(d,h,g)[0];if(c){h=h.substring(0,c.offset)+c.content+h.substring(c.offset+c.length);try{await this.fileService.writeFile(v,L.VSBuffer.fromString(h),{etag:u,mtime:y})}catch(t){if(t.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:v,path:d},g,I){return d.length?(0,M.setProperty)(g,d,v,I):[{content:JSON.stringify(v,null,I.insertSpaces&&I.tabSize?" ".repeat(I.tabSize):"	"),length:g.length,offset:0}]}};P=ue([te(0,b.IEnvironmentService),te(1,n.IFileService),te(2,w.ILogService)],P),e.UserConfigurationFileService=P}),define(Z[92],x([0,1,6]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(M,b){switch(b){case p.LogLevel.Trace:return M.trace;case p.LogLevel.Debug:return M.debug;case p.LogLevel.Info:return M.info;case p.LogLevel.Warning:return M.warn;case p.LogLevel.Error:return M.error;case p.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class k extends p.AbstractLogger{constructor(b=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(b),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(b){this._logger=b;for(const{level:n,args:f}of this.buffer)L(b,n).apply(b,f);this.buffer=[]}_log(b,...n){this._logger?L(this._logger,b).apply(this._logger,n):this.getLevel()<=b&&this.buffer.push({level:b,args:n})}trace(b,...n){this._log(p.LogLevel.Trace,b,...n)}debug(b,...n){this._log(p.LogLevel.Debug,b,...n)}info(b,...n){this._log(p.LogLevel.Info,b,...n)}warn(b,...n){this._log(p.LogLevel.Warning,b,...n)}error(b,...n){this._log(p.LogLevel.Error,b,...n)}critical(b,...n){this._log(p.LogLevel.Critical,b,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=k}),define(Z[179],x([0,1,9,18,15,20,5,92,6]),function(V,e,p,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const w=5*M.ByteSize.MB;let i=class extends f.AbstractLogger{constructor(v,d,g,I,y){super();this.name=v,this.resource=d,this.donotUseFormatters=I,this.fileService=y,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const v=arguments[0];if(v instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=v.stack,this._log(f.LogLevel.Error,this.format(d))}else this._log(f.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,this.format(arguments))}flush(){}log(v,d){this._log(v,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(v){if(v.fileOperationResult!==3)throw v}}_log(v,d){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>w&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=d:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(v)}] ${d}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(g))})}getCurrentTimestamp(){const v=I=>I<10?`0${I}`:I,d=I=>I<10?`00${I}`:I<100?`0${I}`:I,g=new Date;return`${g.getFullYear()}-${v(g.getMonth()+1)}-${v(g.getDate())} ${v(g.getHours())}:${v(g.getMinutes())}:${v(g.getSeconds())}.${d(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(v){return""}}stringifyLogLevel(v){switch(v){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}format(v){let d="";for(let g=0;g<v.length;g++){let I=v[g];if(typeof I=="object")try{I=JSON.stringify(I)}catch(y){}d+=(g>0?" ":"")+I}return d}};i=ue([te(4,M.IFileService)],i),e.FileLogger=i;let P=class extends f.AbstractLoggerService{constructor(v,d,g){super(v.getLevel(),v.onDidChangeLogLevel);this.instantiationService=d,this.fileService=g}doCreateLogger(v,d,g){const I=new n.BufferLogService(d);return(0,M.whenProviderRegistered)(v,this.fileService).then(()=>I.logger=this.instantiationService.createInstance(i,(0,k.basename)(v),v,I.getLevel(),!!g?.donotUseFormatters)),I}};P=ue([te(0,f.ILogService),te(1,b.IInstantiationService),te(2,M.IFileService)],P),e.FileLoggerService=P}),define(Z[180],x([0,1,4,7,6]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(E){this.service=E,this.onDidChangeLogLevel=p.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(E,v,d){switch(v){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=M;class b{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){b.setLevel(this.channel,E)}static setLevel(E,v){return E.call("setLevel",v)}}e.LogLevelChannelClient=b;class n{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,v){throw new Error(`Event not found: ${v}`)}async call(E,v,d){switch(v){case"createLogger":this.createLogger(L.URI.revive(d[0]),d[1]);return;case"log":return this.log(L.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${v}`)}createLogger(E,v){this.loggers.set(E.toString(),this.loggerService.createLogger(E,v))}consoleLog(E,v){let d=console.log;switch(E){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...v)}log(E,v){const d=this.loggers.get(E.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,I]of v)switch(g){case k.LogLevel.Trace:d.trace(I);break;case k.LogLevel.Debug:d.debug(I);break;case k.LogLevel.Info:d.info(I);break;case k.LogLevel.Warning:d.warn(I);break;case k.LogLevel.Error:d.error(I);break;case k.LogLevel.Critical:d.critical(I);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class f extends k.AbstractLoggerService{constructor(E,v,d){super(E,v);this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(E,v)=>{this.channel.call("consoleLog",[E,v])}})}doCreateLogger(E,v,d){return new w(this.channel,E,v,d)}}e.LoggerChannelClient=f;class w extends k.AbstractMessageLogger{constructor(E,v,d,g){super(g?.always);this.channel=E,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[v,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,v){const d=[[E,v]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(E){this.channel.call("log",[this.file,E])}}class i extends k.LogService{constructor(E,v){super(v);this.parent=E,this._register(E.onDidChangeLogLevel(d=>v.setLevel(d)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=i}),define(Z[93],x([0,1,20,6]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(f,w,i,P){try{const E=await new Promise((v,d)=>{V(["spdlog"],v,d)});return E.setFlushOn(L.LogLevel.Trace),E.createAsyncRotatingLogger(f,w,i,P)}catch(E){console.error(E)}return null}function M(f,w,i,P){const E=V.__$__nodeRequire("spdlog");return E.setFlushOn(L.LogLevel.Trace),E.createRotatingLogger(f,w,i,P)}e.createRotatingLogger=M;function b(f,w,i){switch(w){case L.LogLevel.Trace:f.trace(i);break;case L.LogLevel.Debug:f.debug(i);break;case L.LogLevel.Info:f.info(i);break;case L.LogLevel.Warning:f.warn(i);break;case L.LogLevel.Error:f.error(i);break;case L.LogLevel.Critical:f.critical(i);break;default:throw new Error("Invalid log level")}}class n extends L.AbstractMessageLogger{constructor(w,i,P,E){super();this.name=w,this.filepath=i,this.rotating=P,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(v=>{this._logger&&this._logger.setLevel(v)}))}_createSpdLogLogger(){const w=this.rotating?6:1,i=30/w*p.ByteSize.MB;return k(this.name,this.filepath,i,w).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:E,message:v}of this.buffer)b(this._logger,E,v);this.buffer=[]}})}log(w,i){this._logger?b(this._logger,w,i):this.getLevel()<=w&&this.buffer.push({level:w,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Z[181],x([0,1,10,15,28,20,179,6,93]),function(V,e,p,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let w=class extends n.AbstractLoggerService{constructor(P,E){super(P.getLevel(),P.onDidChangeLogLevel);this.fileService=E}doCreateLogger(P,E,v){if(P.scheme===p.Schemas.file){const d=new f.SpdLogLogger(v?.name||(0,k.generateUuid)(),P.fsPath,!v?.donotRotate,E);return v?.donotUseFormatters&&d.clearFormatters(),d}else return new b.FileLogger(v?.name??(0,L.basename)(P),P,E,!!v?.donotUseFormatters,this.fileService)}};w=ue([te(0,n.ILogService),te(1,M.IFileService)],w),e.LoggerService=w}),define(Z[182],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(b){return b.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function L(b){return b.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function k(b){return b.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function M(b){return!p(b)&&!L(b)&&!k(b)}e.isMenubarMenuItemAction=M}),define(Z[45],x([0,1,10,3,33,15]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let b;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const n=L.globals.vscode.context.configuration();if(n)b=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof V?.__$__nodeRequire=="function"){const n=(0,M.dirname)(p.FileAccess.asFileUri("",V));b=V.__$__nodeRequire((0,M.joinPath)(n,"product.json").fsPath);const f=V.__$__nodeRequire((0,M.joinPath)(n,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(b,{nameShort:`${b.nameShort} Dev`,nameLong:`${b.nameLong} Dev`,dataFolderName:`${b.dataFolderName}-dev`}),Object.assign(b,{version:f.version})}else b={},Object.keys(b).length===0&&Object.assign(b,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=b}),define(Z[94],x([0,1,18,17,141,20,45]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(P,E,v,d,g,I){let y;try{await f(P,E,v,d,g,I)}catch(u){y=u}finally{y&&g.errorTransformer&&(y=g.errorTransformer(y)),typeof y!="undefined"&&v.error(y),v.end()}}e.readFileIntoStream=n;async function f(P,E,v,d,g,I){w(I);const y=await P.open(E,{create:!1});try{w(I);let u=0,h=0,o=g&&typeof g.length=="number"?g.length:void 0,c=p.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),t=g&&typeof g.position=="number"?g.position:0,a=0;do h=await P.read(y,t,c.buffer,a,c.byteLength-a),t+=h,a+=h,u+=h,typeof o=="number"&&(o-=h),a===c.byteLength&&(await v.write(d(c)),c=p.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),a=0);while(h>0&&(typeof o!="number"||o>0)&&w(I)&&i(u,g));if(a>0){let r=a;typeof o=="number"&&(r=Math.min(a,o)),v.write(d(c.slice(0,r)))}}catch(u){throw(0,M.ensureFileSystemProviderError)(u)}finally{await P.close(y)}}function w(P){if(P.isCancellationRequested)throw(0,L.canceled)();return!0}function i(P,E){if(E?.limits){if(typeof E.limits.memory=="number"&&P>E.limits.memory)throw(0,M.createFileSystemProviderError)((0,k.localize)(0,null,b.default.nameShort),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&P>E.limits.size)throw(0,M.createFileSystemProviderError)((0,k.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[183],x([0,1,30,9,18,23,4,64,2,37,10,73,15,65,139,20,94,6]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class Ke extends f.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new b.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new b.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new b.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new b.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new b.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new b.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new g.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new g.FileChangesEvent(c,!0)))),this.watchedResources=w.TernarySearchTree.forUris(c=>{const t=this.getProvider(c.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,c){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,P.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:c});const t=new f.DisposableStore;return t.add(c.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(c)))),t.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:o}))),typeof c.onDidErrorOccur=="function"&&t.add(c.onDidErrorOccur(a=>this._onError.fire(new Error(a)))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:c}),this.provider.delete(o),(0,f.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){c.push(t)}}),!this.provider.has(o)&&await L.Promises.settled(c)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,c){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&c)}listCapabilities(){return n.Iterable.map(this.provider,([o,c])=>({scheme:o,capabilities:c.capabilities}))}async withProvider(o){if(!(0,E.isAbsolutePath)(o))throw new g.FileOperationError((0,d.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const c=this.provider.get(o.scheme);if(!c){const t=new Error;throw t.name="ENOPRO",t.message=(0,d.localize)(1,null,o.toString()),t}return c}async withReadProvider(o){const c=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(c)||(0,g.hasReadWriteCapability)(c)||(0,g.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const c=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(c)||(0,g.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,c){try{return await this.doResolveFile(o,c)}catch(t){throw(0,g.toFileSystemProviderErrorCode)(t)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,d.localize)(2,null,this.resourceForError(o)),1):(0,g.ensureFileSystemProviderError)(t)}}async doResolveFile(o,c){const t=await this.withProvider(o),a=this.isPathCaseSensitive(t),r=c?.resolveTo,s=c?.resolveSingleChildDescendants,l=c?.resolveMetadata,m=await t.stat(o);let S;return this.toFileStat(t,o,m,void 0,!!l,(D,R)=>{if(!S&&(S=w.TernarySearchTree.forUris(()=>!a),S.set(o,!0),r))for(const F of r)S.set(F,!0);return S.get(D.resource)||S.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&s?R===1:!1})}async toFileStat(o,c,t,a,r,s){const{providerExtUri:l}=this.getExtUri(o),m={resource:c,name:l.basename(c),isFile:(t.type&g.FileType.File)!=0,isDirectory:(t.type&g.FileType.Directory)!=0,isSymbolicLink:(t.type&g.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&g.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,g.etag)({mtime:t.mtime,size:t.size})};if(m.isDirectory&&s(m,a)){try{const S=await o.readdir(c),D=await L.Promises.settled(S.map(async([R,F])=>{try{const C=l.joinPath(c,R),G=r?await o.stat(C):{type:F};return await this.toFileStat(o,C,G,S.length,r,s)}catch(C){return this.logService.trace(C),null}}));m.children=(0,p.coalesce)(D)}catch(S){this.logService.trace(S),m.children=[]}return m}return m}async resolveAll(o){return L.Promises.settled(o.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const c=await this.withProvider(o);try{return!!await c.stat(o)}catch(t){return!1}}async canCreateFile(o,c){try{await this.doValidateCreateFile(o,c)}catch(t){return t}return!0}async doValidateCreateFile(o,c){if(!c?.overwrite&&await this.exists(o))throw new g.FileOperationError((0,d.localize)(3,null,this.resourceForError(o)),3,c)}async createFile(o,c=k.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const a=await this.writeFile(o,c);return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,a)),a}async writeFile(o,c,t){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(a);try{await this.validateWriteFile(a,o,t)||await this.mkdirp(a,r.dirname(o));let l;if((0,g.hasReadWriteCapability)(a)&&!(c instanceof k.VSBuffer))if((0,v.isReadableStream)(c)){const m=await(0,v.peekStream)(c,3);m.ended?l=k.VSBuffer.concat(m.buffer):l=m}else l=(0,v.peekReadable)(c,m=>k.VSBuffer.concat(m),3);else l=c;!(0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasReadWriteCapability)(a)&&l instanceof k.VSBuffer?await this.doWriteUnbuffered(a,o,t,l):await this.doWriteBuffered(a,o,t,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l)}catch(s){throw new g.FileOperationError((0,d.localize)(4,null,this.resourceForError(o),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,c,t){if(!!t?.unlock&&!(o.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(c)));let r;try{r=await o.stat(c)}catch(s){return}if((r.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,d.localize)(6,null,this.resourceForError(c)),0,t);if(this.throwIfFileIsReadonly(c,r),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==g.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,g.etag)({mtime:t.mtime,size:r.size}))throw new g.FileOperationError((0,d.localize)(7,null),3,t);return r}async readFile(o,c){const t=await this.withReadProvider(o);return c?.atomic?this.doReadFileAtomic(t,o,c):this.doReadFile(t,o,c)}async doReadFileAtomic(o,c,t){return new Promise((a,r)=>{this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,c,t);a(s)}catch(s){r(s)}})})}async doReadFile(o,c,t){const a=await this.doReadFileStream(o,c,{...t,preferUnbuffered:!0});return{...a,value:await(0,k.streamToBuffer)(a.value)}}async readFileStream(o,c){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,c)}async doReadFileStream(o,c,t){const a=new M.CancellationTokenSource,r=this.validateReadFile(c,t).then(l=>l,l=>{throw a.cancel(),l});let s;try{return typeof t?.etag=="string"&&t.etag!==g.ETAG_DISABLED&&await r,!((0,g.hasOpenReadWriteCloseCapability)(o)||(0,g.hasFileReadStreamCapability)(o))||(0,g.hasReadWriteCapability)(o)&&t?.preferUnbuffered?s=this.readFileUnbuffered(o,c,t):(0,g.hasFileReadStreamCapability)(o)?s=this.readFileStreamed(o,c,a.token,t):s=this.readFileBuffered(o,c,a.token,t),{...await r,value:s}}catch(l){s&&await(0,v.consumeStream)(s);const m=(0,d.localize)(8,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(l).toString());throw l instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(m,l.stat,t):new g.FileOperationError(m,(0,g.toFileOperationResult)(l),t)}}readFileStreamed(o,c,t,a=Object.create(null)){const r=o.readFileStream(c,a,t);return(0,v.transform)(r,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new g.FileOperationError((0,d.localize)(9,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),a)},s=>k.VSBuffer.concat(s))}readFileBuffered(o,c,t,a=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,I.readFileIntoStream)(o,c,r,s=>s,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new g.FileOperationError((0,d.localize)(10,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),a)},t),r}readFileUnbuffered(o,c,t){const a=(0,v.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r=await o.readFile(c);typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(c,r.byteLength,t),a.end(k.VSBuffer.wrap(r))}catch(r){a.error(r),a.end()}})(),a}async validateReadFile(o,c){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new g.FileOperationError((0,d.localize)(11,null,this.resourceForError(o)),0,c);if(typeof c?.etag=="string"&&c.etag!==g.ETAG_DISABLED&&c.etag===t.etag)throw new g.NotModifiedSinceFileOperationError((0,d.localize)(12,null),t,c);return this.validateReadFileLimits(o,t.size,c),t}validateReadFileLimits(o,c,t){if(t?.limits){let a;if(typeof t.limits.memory=="number"&&c>t.limits.memory&&(a=9),typeof t.limits.size=="number"&&c>t.limits.size&&(a=7),typeof a=="number")throw new g.FileOperationError((0,d.localize)(13,null,this.resourceForError(o)),a)}}async canMove(o,c,t){return this.doCanMoveCopy(o,c,"move",t)}async canCopy(o,c,t){return this.doCanMoveCopy(o,c,"copy",t)}async doCanMoveCopy(o,c,t,a){if(o.toString()!==c.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(r,o,s,c,t,a)}catch(r){return r}return!0}async move(o,c,t){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),s=await this.doMoveCopy(a,o,r,c,"move",!!t),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,s==="move"?2:3,l)),l}async copy(o,c,t){const a=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),s=await this.doMoveCopy(a,o,r,c,"copy",!!t),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,s==="copy"?3:2,l)),l}async doMoveCopy(o,c,t,a,r,s){if(c.toString()===a.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(o,c,t,a,r,s);if(l&&!m&&s&&await this.del(a,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(a)),r==="copy"){if(o===t&&(0,g.hasFileFolderCopyCapability)(o))await o.copy(c,a,{overwrite:s});else{const S=await this.resolve(c);S.isDirectory?await this.doCopyFolder(o,S,t,a):await this.doCopyFile(o,c,t,a)}return r}else return o===t?(await o.rename(c,a,{overwrite:s}),r):(await this.doMoveCopy(o,c,t,a,"copy",s),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(o,c,t,a){if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,c,t,a);if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,c,t,a);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,c,t,a);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,c,t,a)}async doCopyFolder(o,c,t,a){await t.mkdir(a),Array.isArray(c.children)&&await L.Promises.settled(c.children.map(async r=>{const s=this.getExtUri(t).providerExtUri.joinPath(a,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),t,s):this.doCopyFile(o,r.resource,t,s)}))}async doValidateMoveCopy(o,c,t,a,r,s){let l=!1;if(o===t){const{providerExtUri:S,isPathCaseSensitive:D}=this.getExtUri(o);if(D||(l=S.isEqual(c,a)),l&&r==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(c),this.resourceForError(a)));if(!l&&S.isEqualOrParent(a,c))throw new Error((0,d.localize)(15,null,this.resourceForError(c),this.resourceForError(a)))}const m=await this.exists(a);if(m&&!l){if(!s)throw new g.FileOperationError((0,d.localize)(16,null,this.resourceForError(c),this.resourceForError(a)),4);if(o===t){const{providerExtUri:S}=this.getExtUri(o);if(S.isEqualOrParent(c,a))throw new Error((0,d.localize)(17,null,this.resourceForError(c),this.resourceForError(a)))}}return{exists:m,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const c=this.isPathCaseSensitive(o);return{providerExtUri:c?E.extUri:E.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(c,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,t)),t}async mkdirp(o,c){const t=[],{providerExtUri:a}=this.getExtUri(o);for(;!a.isEqual(c,a.dirname(c));)try{if(((await o.stat(c)).type&g.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(c)));break}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(a.basename(c)),c=a.dirname(c)}for(let r=t.length-1;r>=0;r--){c=a.joinPath(c,t[r]);try{await o.mkdir(c)}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,c){try{await this.doValidateDelete(o,c)}catch(t){return t}return!0}async doValidateDelete(o,c){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!c?.useTrash&&!(t.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(o)));let r;try{r=await t.stat(o)}catch(l){}if(r)this.throwIfFileIsReadonly(o,r);else throw new g.FileOperationError((0,d.localize)(20,null,this.resourceForError(o)),1);if(!!!c?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(o)))}return t}async del(o,c){const t=await this.doValidateDelete(o,c),a=!!c?.useTrash,r=!!c?.recursive;await t.delete(o,{recursive:r,useTrash:a}),this._onDidRunOperation.fire(new g.FileOperationEvent(o,1))}onDidChangeFile(o,c){this._onDidChangeFilesRaw.fire({changes:o});let t,a;{for(const r of o)this.watchedResources.has(r.resource)?(t||(t=[]),t.push(r)):(a||(a=[]),a.push(r));t&&this._onDidFilesChange.fire(new g.FileChangesEvent(t,!c))}if(a){const r=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(a)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,c={recursive:!1,excludes:[]}){const t=new f.DisposableStore;{let a=!1,r=()=>{a=!0};t.add((0,f.toDisposable)(()=>r())),this.doWatch(o,c).then(s=>{a?(0,f.dispose)(s):r=()=>(0,f.dispose)(s)},s=>this.logService.error(s))}return c.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),t.add((0,f.toDisposable)(()=>{const a=this.watchedResources.get(o);typeof a=="number"&&(a<=1?this.watchedResources.delete(o):this.watchedResources.set(o,a-1))}))),t}async doWatch(o,c){const t=await this.withProvider(o),a=this.toWatchKey(t,o,c),r=this.activeWatchers.get(a)||{count:0,disposable:t.watch(o,c)};return this.activeWatchers.has(a)||this.activeWatchers.set(a,r),r.count+=1,(0,f.toDisposable)(()=>{r.count--,r.count===0&&((0,f.dispose)(r.disposable),this.activeWatchers.delete(a))})}toWatchKey(o,c,t){const{providerExtUri:a}=this.getExtUri(o);return[a.getComparisonKey(c),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,f.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,c,t,a){return this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(async()=>{const r=await o.open(c,{create:!0,unlock:t?.unlock??!1});try{(0,v.isReadableStream)(a)||(0,v.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(o,r,a):await this.doWriteReadableBufferedQueued(o,r,a)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await o.close(r)}})}async doWriteStreamBufferedQueued(o,c,t){let a=0,r;if((0,v.isReadableBufferedStream)(t)){if(t.buffer.length>0){const s=k.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,c,s,s.byteLength,a,0),a+=s.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise(async(s,l)=>{(0,v.listenStream)(r,{onData:async m=>{r.pause();try{await this.doWriteBuffer(o,c,m,m.byteLength,a,0)}catch(S){return l(S)}a+=m.byteLength,setTimeout(()=>r.resume())},onError:m=>l(m),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,c,t){let a=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(o,c,r,r.byteLength,a,0),a+=r.byteLength}async doWriteBuffer(o,c,t,a,r,s){let l=0;for(;l<a;)l+=await o.write(c,r+l,t.buffer,s+l,a-l)}async doWriteUnbuffered(o,c,t,a){return this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,c,t,a))}async doWriteUnbufferedQueued(o,c,t,a){let r;a instanceof k.VSBuffer?r=a:(0,v.isReadableStream)(a)?r=await(0,k.streamToBuffer)(a):(0,v.isReadableBufferedStream)(a)?r=await(0,k.bufferedStreamToBuffer)(a):r=(0,k.readableToBuffer)(a),await o.writeFile(c,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(o,c,t,a){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,c,t,a))}async doPipeBufferedQueued(o,c,t,a){let r,s;try{r=await o.open(c,{create:!1}),s=await t.open(a,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,S=0,D=0;do D=await o.read(r,m,l.buffer,S,l.byteLength-S),await this.doWriteBuffer(t,s,l,D,m,S),m+=D,S+=D,S===l.byteLength&&(S=0);while(D>0)}catch(l){throw(0,g.ensureFileSystemProviderError)(l)}finally{await L.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof s=="number"?t.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,c,t,a){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,c,t,a))}async doPipeUnbufferedQueued(o,c,t,a){return t.writeFile(a,await o.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,c,t,a){return this.writeQueue.queueFor(a,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,c,t,a))}async doPipeUnbufferedToBufferedQueued(o,c,t,a){const r=await t.open(a,{create:!0,unlock:!1});try{const s=await o.readFile(c);await this.doWriteBuffer(t,r,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(o,c,t,a){const r=await(0,k.streamToBuffer)(this.readFileBuffered(o,c,M.CancellationToken.None));await this.doWriteUnbuffered(t,a,void 0,r)}throwIfFileSystemIsReadonly(o,c){if(o.capabilities&2048)throw new g.FileOperationError((0,d.localize)(22,null,this.resourceForError(c)),6);return o}throwIfFileIsReadonly(o,c){if((c.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,d.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===i.Schemas.file?o.fsPath:o.toString(!0)}};u.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},u=ue([te(0,y.ILogService)],u),e.FileService=u}),define(Z[184],x([0,1,30,9,18,4,31,2,8,3,15,65,19,142,20,94,173,163,164,91,166,6,45]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I,y,u,h,o,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class a extends n.Disposable{constructor(s,l){super();this.logService=s,this.options=l,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:l,symbolicLink:m}=await E.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(l,m),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(s){try{const l=await E.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),m=[];return await Promise.all(l.map(async S=>{try{let D;S.isSymbolicLink()?D=(await this.stat((0,i.joinPath)(s,S.name))).type:D=this.toType(S),m.push([S.name,D])}catch(D){this.logService.trace(D)}})),m}catch(l){throw this.toFileSystemProviderError(l)}}toType(s,l){let m;return l?.dangling?m=d.FileType.Unknown:s.isFile()?m=d.FileType.File:s.isDirectory()?m=d.FileType.Directory:m=d.FileType.Unknown,l&&(m|=d.FileType.SymbolicLink),m}async readFile(s){try{const l=this.toFilePath(s);return await E.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(s,l,m){const S=(0,P.newWriteableStream)(D=>k.VSBuffer.concat(D.map(R=>k.VSBuffer.wrap(R))).buffer);return(0,g.readFileIntoStream)(this,s,S,D=>D.buffer,{...l,bufferSize:this.BUFFER_SIZE},m),S}async writeFile(s,l,m){let S;try{const D=this.toFilePath(s);if(!m.create||!m.overwrite){if(await E.Promises.exists(D)){if(!m.overwrite)throw(0,d.createFileSystemProviderError)((0,v.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!m.create)throw(0,d.createFileSystemProviderError)((0,v.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(s,{create:!0,unlock:m.unlock}),await this.write(S,0,l,0,l.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(s,D)}finally{typeof S=="number"&&await this.close(S)}}async open(s,l){try{const m=this.toFilePath(s);if((0,d.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:R}=await E.SymlinkSupport.stat(m);R.mode&128||await E.Promises.chmod(m,R.mode|128)}catch(R){this.logService.trace(R)}let S;if((0,d.isFileOpenForWriteOptions)(l)){if(w.isWindows)try{await E.Promises.truncate(m,0),S="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}S||(S="w")}else S="r";const D=await E.Promises.open(m,S);return this.mapHandleToPos.set(D,0),(0,d.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(D,s),D}catch(m){throw(0,d.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(s,m):this.toFileSystemProviderError(m)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await E.Promises.fdatasync(s)}catch(l){this.canFlush=!1,this.logService.error(l)}return await E.Promises.close(s)}catch(l){throw this.toFileSystemProviderError(l)}}async read(s,l,m,S,D){const R=this.normalizePos(s,l);let F=null;try{const C=await E.Promises.read(s,m,S,D,R);return typeof C=="number"?F=C:F=C.bytesRead,F}catch(C){throw this.toFileSystemProviderError(C)}finally{this.updatePos(s,R,F)}}normalizePos(s,l){return l===this.mapHandleToPos.get(s)?null:l}updatePos(s,l,m){const S=this.mapHandleToPos.get(s);typeof S=="number"&&(typeof l=="number"||(typeof m=="number"?this.mapHandleToPos.set(s,S+m):this.mapHandleToPos.delete(s)))}async write(s,l,m,S,D){return(0,L.retry)(()=>this.doWrite(s,l,m,S,D),100,3)}async doWrite(s,l,m,S,D){const R=this.normalizePos(s,l);let F=null;try{const C=await E.Promises.write(s,m,S,D,R);return typeof C=="number"?F=C:F=C.bytesWritten,F}catch(C){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),C)}finally{this.updatePos(s,R,F)}}async mkdir(s){try{await E.Promises.mkdir(this.toFilePath(s))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(s,l){try{const m=this.toFilePath(s);await this.doDelete(m,l)}catch(m){throw this.toFileSystemProviderError(m)}}async doDelete(s,l){l.recursive?await E.Promises.rm(s,E.RimRafMode.MOVE):await E.Promises.unlink(s)}async rename(s,l,m){const S=this.toFilePath(s),D=this.toFilePath(l);if(S!==D)try{await this.validateTargetDeleted(s,l,"move",m.overwrite),await E.Promises.move(S,D)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,v.localize)(2,null,(0,f.basename)(S),(0,f.basename)((0,f.dirname)(D)),R.toString()))),this.toFileSystemProviderError(R)}}async copy(s,l,m){const S=this.toFilePath(s),D=this.toFilePath(l);if(S!==D)try{await this.validateTargetDeleted(s,l,"copy",m.overwrite),await E.Promises.copy(S,D,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,v.localize)(3,null,(0,f.basename)(S),(0,f.basename)((0,f.dirname)(D)),R.toString()))),this.toFileSystemProviderError(R)}}async validateTargetDeleted(s,l,m,S){const D=this.toFilePath(s),R=this.toFilePath(l);let F=!1;if(!!(this.capabilities&1024)||(F=(0,b.isEqual)(D,R,!0)),F&&m==="copy")throw(0,d.createFileSystemProviderError)((0,v.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!F&&await E.Promises.exists(R)){if(!S)throw(0,d.createFileSystemProviderError)((0,v.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}watch(s,l){return l.recursive?this.watchRecursive(s,l):this.watchNonRecursive(s)}watchRecursive(s,l){const m={path:this.toFilePath(s),excludes:l.excludes},S=(0,p.insert)(this.recursiveFoldersToWatch,m);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{S(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof y.FileWatcher)this.recursiveWatcher.watch(this.recursiveFoldersToWatch);else if((0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let s,l;if(this.options?.watcher?.usePolling)s=u.FileWatcher,l=this.options?.watcher;else{let m;this.options?.enableLegacyRecursiveWatcher?m=!0:m=t.default.quality==="stable"&&w.isLinux,m&&this.recursiveFoldersToWatch.length===1?w.isWindows?s=o.FileWatcher:s=u.FileWatcher:s=y.FileWatcher}this.recursiveWatcher=new s(this.recursiveFoldersToWatch,m=>this._onDidChangeFile.fire((0,h.toFileChanges)(m)),m=>{m.type==="error"&&this._onDidWatchErrorOccur.fire(m.message),this.logService[m.type](m.message)},this.logService.getLevel()===c.LogLevel.Trace,l),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)}))}}watchNonRecursive(s){const l=new I.FileWatcher(this.toFilePath(s),S=>this._onDidChangeFile.fire((0,h.toFileChanges)(S)),S=>{S.type==="error"&&this._onDidWatchErrorOccur.fire(S.message),this.logService[S.type](S.message)},this.logService.getLevel()===c.LogLevel.Trace),m=this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)});return(0,n.combinedDisposable)(l,m)}toFilePath(s){return(0,f.normalize)(s.fsPath)}toFileSystemProviderError(s){if(s instanceof d.FileSystemProviderError)return s;let l;switch(s.code){case"ENOENT":l=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=d.FileSystemProviderErrorCode.NoPermissions;break;default:l=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(s,l)}async toFileSystemProviderWriteError(s,l){let m=this.toFileSystemProviderError(l);if(s&&m.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:S}=await E.SymlinkSupport.stat(this.toFilePath(s));S.mode&128||(m=(0,d.createFileSystemProviderError)(l,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(S){this.logService.trace(S)}return m}dispose(){super.dispose(),(0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,n.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=a}),define(Z[21],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(Z[185],x([0,1,58,6,21]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(n,f){this.productService=n,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(f);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,i,P]=w;let E=this.trustedExtensionUrlPublicKeys.get(n);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[n],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...E])}const v=Buffer.from(decodeURIComponent(P),"base64");if(v.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const d=v.slice(0,6),g=v.readUIntBE(0,6),I=Date.now()-g;if(I<0||I>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const y=v.slice(6),u=p.createVerify("SHA256");u.write(d),u.write(Buffer.from(i)),u.end();for(let h=0;h<E.length;h++){let o=E[h];if(o!==null){if(typeof o=="string")try{o=p.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),E[h]=o}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${n}:`,c),E[h]=null;continue}if(u.verify(o,y))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};M=ue([te(0,k.IProductService),te(1,L.ILogService)],M),e.ExtensionUrlTrustService=M}),define(Z[55],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(Z[186],x([0,1,14,2,37,10,3,15,7,28,48,6]),function(V,e,p,L,k,M,b,n,f,w,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let E=class extends L.Disposable{constructor(d,g){super();this.logService=g,this.validRoots=k.TernarySearchTree.forUris(()=>!b.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(d.appRoot)),this.addValidFileRoot(f.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=p.session;d.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(g,I)=>this.handleResourceRequest(g,I)),d.protocol.interceptFileProtocol(M.Schemas.file,(g,I)=>this.handleFileRequest(g,I)),this._register((0,L.toDisposable)(()=>{d.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?L.Disposable.None:(this.validRoots.set(d,!0),(0,L.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,g){const I=f.URI.parse(d.url);return this.logService.error(`Refused to load resource ${I.fsPath} from ${M.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3})}handleResourceRequest(d,g){const I=f.URI.parse(d.url),y=M.FileAccess.asFileUri(I);return this.validRoots.findSubstr(y)?g({path:y.fsPath}):this.validExtensions.has((0,n.extname)(y))?g({path:y.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${y.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),g({error:-3}))}createIPCObjectUrl(){let d;const g=f.URI.from({scheme:"vscode",path:(0,w.generateUuid)()}),I=g.toString(),y=async()=>d;return p.ipcMain.handle(I,y),this.logService.trace(`IPC Object URL: Registered new channel ${I}.`),{resource:g,update:u=>d=u,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${I}.`),p.ipcMain.removeHandler(I)}}}};E=ue([te(0,i.INativeEnvironmentService),te(1,P.ILogService)],E),e.ProtocolMainService=E}),define(Z[38],x([0,1,102,13]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(b,n){p.ok(L.isString(b)),p.ok(L.isObject(n)),p.ok(!this.data.has(b),"There is already an extension with this id"),this.data.set(b,n)}knows(b){return this.data.has(b)}as(b){return this.data.get(b)||null}}e.Registry=new k}),define(Z[187],x([0,1,4,38]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class M{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,w){this.schemasById[k(f)]=w,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const b=new M;L.Registry.add(e.Extensions.JSONContribution,b)}),define(Z[49],x([0,1,30,4,13,132,187,38]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var f;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(f=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=n.Registry.as(b.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,o=!0){this.registerConfigurations([h],o)}registerConfigurations(h,o=!0){const c=this.doRegisterConfigurations(h,o);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(h){const o=this.doDeregisterConfigurations(h);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:h,remove:o}){const c=[];c.push(...this.doDeregisterConfigurations(o)),c.push(...this.doRegisterConfigurations(h,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,p.distinct)(c))}registerDefaultConfigurations(h){const o=[],c=[];for(const t of h)for(const a in t)if(o.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]={...this.defaultValues[a]||{},...t[a]};const r={type:"object",default:this.defaultValues[a],description:M.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};c.push(v(a)),this.configurationProperties[a]=r,this.defaultLanguageConfigurationOverridesNode.properties[a]=r}else{this.defaultValues[a]=t[a];const r=this.configurationProperties[a];r&&(this.updatePropertyDefaultValue(a,r),this.updateSchema(a,r))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(h){const o=[];for(const c of h)for(const t in c)if(o.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const a=this.configurationProperties[t];a&&(this.updatePropertyDefaultValue(t,a),this.updateSchema(t,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const o of h)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(h,o){const c=[];return h.forEach(t=>{c.push(...this.validateAndRegisterProperties(t,o,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),c}doDeregisterConfigurations(h){const o=[],c=t=>{if(t.properties)for(const a in t.properties)o.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,t.properties[a]);t.allOf&&t.allOf.forEach(a=>c(a))};for(const t of h){c(t);const a=this.configurationContributors.indexOf(t);a!==-1&&this.configurationContributors.splice(a,1)}return o}validateAndRegisterProperties(h,o=!0,c,t=3){t=k.isUndefinedOrNull(h.scope)?t:h.scope;let a=[],r=h.properties;if(r)for(let l in r){if(o&&I(l)){delete r[l];continue}const m=r[l];if(this.updatePropertyDefaultValue(l,m),e.OVERRIDE_PROPERTY_PATTERN.test(l)?m.scope=void 0:(m.scope=k.isUndefinedOrNull(m.scope)?t:m.scope,m.restricted=k.isUndefinedOrNull(m.restricted)?!!c?.restrictedConfigurations?.includes(l):m.restricted),r[l].hasOwnProperty("included")&&!r[l].included){this.excludedConfigurationProperties[l]=r[l],delete r[l];continue}else this.configurationProperties[l]=r[l];!r[l].deprecationMessage&&r[l].markdownDeprecationMessage&&(r[l].deprecationMessage=r[l].markdownDeprecationMessage),a.push(l)}let s=h.allOf;if(s)for(let l of s)a.push(...this.validateAndRegisterProperties(l,o,c,t));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const o=c=>{let t=c.properties;if(t)for(const r in t)this.updateSchema(r,t[r]);let a=c.allOf;a&&a.forEach(o)};o(h)}updateSchema(h,o){switch(e.allSettings.properties[h]=o,o.scope){case 1:e.applicationSettings.properties[h]=o;break;case 2:e.machineSettings.properties[h]=o;break;case 6:e.machineOverridableSettings.properties[h]=o;break;case 3:e.windowSettings.properties[h]=o;break;case 4:e.resourceSettings.properties[h]=o;break;case 5:e.resourceSettings.properties[h]=o,this.resourceLanguageSettingsSchema.properties[h]=o;break}}removeFromSchema(h,o){switch(delete e.allSettings.properties[h],o.scope){case 1:delete e.applicationSettings.properties[h];break;case 2:delete e.machineSettings.properties[h];break;case 6:delete e.machineOverridableSettings.properties[h];break;case 3:delete e.windowSettings.properties[h];break;case 4:case 5:delete e.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const o=`[${h}]`,c={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,c),e.allSettings.properties[o]=c,e.applicationSettings.properties[o]=c,e.machineSettings.properties[o]=c,e.machineOverridableSettings.properties[o]=c,e.windowSettings.properties[o]=c,e.resourceSettings.properties[o]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,o){let c=this.defaultValues[h];k.isUndefined(c)&&(c=o.default),k.isUndefined(c)&&(c=d(o.type)),o.default=c}}const E="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(E);function v(u){return u.substring(1,u.length-1)}e.overrideIdentifierFromKey=v;function d(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new P;n.Registry.add(e.Extensions.Configuration,g);function I(u){return u.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(u)?M.localize(5,null,u):g.getConfigurationProperties()[u]!==void 0?M.localize(6,null,u):null:M.localize(4,null)}e.validateProperty=I;function y(){const u=[],h=g.getConfigurationProperties();for(const o of Object.keys(h))u.push([o,h[o].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=y}),define(Z[16],x([0,1,44,13,7,49,5,38]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function f(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof k.URI)}e.isConfigurationOverrides=f;var w;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function P(a,r){const s=r?a?r.keys.filter(C=>a.keys.indexOf(C)===-1):[...r.keys]:[],l=a?r?a.keys.filter(C=>r.keys.indexOf(C)===-1):[...a.keys]:[],m=[];if(r&&a){for(const C of a.keys)if(r.keys.indexOf(C)!==-1){const G=y(a.contents,C),ne=y(r.contents,C);p.equals(G,ne)||m.push(C)}}const S=[],D=C=>{const G={};for(const ne of C)for(const ae of ne.identifiers)G[c(ae)]=ne;return G},R=r?D(r.overrides):{},F=a?D(a.overrides):{};if(Object.keys(R).length)for(const C of s){const G=R[C];G&&S.push([(0,M.overrideIdentifierFromKey)(C),G.keys])}if(Object.keys(F).length)for(const C of l){const G=F[C];G&&S.push([(0,M.overrideIdentifierFromKey)(C),G.keys])}if(Object.keys(R).length&&Object.keys(F).length)for(const C of m){const G=F[C],ne=R[C];if(G&&ne){const ae=P({contents:G.contents,keys:G.keys,overrides:[]},{contents:ne.contents,keys:ne.keys,overrides:[]});S.push([(0,M.overrideIdentifierFromKey)(C),[...ae.added,...ae.removed,...ae.updated]])}}return{added:s,removed:l,updated:m,overrides:S}}e.compare=P;function E(a,r){const s=[];for(const l of Object.keys(a))if(M.OVERRIDE_PROPERTY_PATTERN.test(l)){const m={};for(const S in a[l])m[S]=a[l][S];s.push({identifiers:[(0,M.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(m),contents:v(m,r)})}return s}e.toOverrides=E;function v(a,r){const s=Object.create(null);for(let l in a)d(s,l,a[l],r);return s}e.toValuesTree=v;function d(a,r,s,l){const m=r.split("."),S=m.pop();let D=a;for(let R=0;R<m.length;R++){let F=m[R],C=D[F];switch(typeof C){case"undefined":C=D[F]=Object.create(null);break;case"object":break;default:l(`Ignoring ${r} as ${m.slice(0,R+1).join(".")} is ${JSON.stringify(C)}`);return}D=C}if(typeof D=="object"&&D!==null)try{D[S]=s}catch(R){l(`Ignoring ${r} as ${m.join(".")} is ${JSON.stringify(D)}`)}else l(`Ignoring ${r} as ${m.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=d;function g(a,r){const s=r.split(".");I(a,s)}e.removeFromValueTree=g;function I(a,r){const s=r.shift();if(r.length===0){delete a[s];return}if(Object.keys(a).indexOf(s)!==-1){const l=a[s];typeof l=="object"&&!Array.isArray(l)&&(I(l,r),Object.keys(l).length===0&&delete a[s])}}function y(a,r,s){function l(D,R){let F=D;for(const C of R){if(typeof F!="object"||F===null)return;F=F[C]}return F}const m=r.split("."),S=l(a,m);return typeof S=="undefined"?s:S}e.getConfigurationValue=y;function u(a,r,s){Object.keys(r).forEach(l=>{l!=="__proto__"&&(l in a?L.isObject(a[l])&&L.isObject(r[l])?u(a[l],r[l],s):s&&(a[l]=r[l]):a[l]=r[l])})}e.merge=u;function h(){const a=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=h;function o(){const a=Object.create(null),r=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let s in r){let l=r[s].default;d(a,s,l,m=>console.error(`Conflict in default settings: ${m}`))}return a}e.getDefaultValues=o;function c(a){return`[${a}]`}e.keyFromOverrideIdentifier=c;function t(a,r,s){const l=a.inspect(r),m=a.inspect(s);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:l.defaultValue}e.getMigratedSettingValue=t}),define(Z[188],x([0,1,30,4,40,2,37,44,13,7,16,49,38]),function(V,e,p,L,k,M,b,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(t={},a=[],r=[]){this._contents=t,this._keys=a,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,a){const r=this.getContentsForOverrideIdentifer(a);return r?t?(0,i.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const a of this.overrides)if(a.identifiers.indexOf(t)!==-1)return a.keys;return[]}override(t){const a=this.getContentsForOverrideIdentifer(t);if(!a||typeof a!="object"||!Object.keys(a).length)return this;let r={};for(const s of p.distinct([...Object.keys(this.contents),...Object.keys(a)])){let l=this.contents[s],m=a[s];m&&(typeof l=="object"&&typeof m=="object"?(l=n.deepClone(l),this.mergeContents(l,m)):l=m),r[s]=l}return new v(r,this.keys,this.overrides)}merge(...t){const a=n.deepClone(this.contents),r=n.deepClone(this.overrides),s=[...this.keys];for(const l of t){this.mergeContents(a,l.contents);for(const m of l.overrides){const[S]=r.filter(D=>p.equals(D.identifiers,m.identifiers));S?this.mergeContents(S.contents,m.contents):r.push(n.deepClone(m))}for(const m of l.keys)s.indexOf(m)===-1&&s.push(m)}return new v(a,s,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,a){for(const r of Object.keys(a)){if(r in t&&f.isObject(t[r])&&f.isObject(a[r])){this.mergeContents(t[r],a[r]);continue}t[r]=n.deepClone(a[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?n.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const a of this.overrides)if(a.identifiers.indexOf(t)!==-1)return a.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,a){this.addKey(t),(0,i.addToValueTree)(this.contents,t,a,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let a=this.keys.length;for(let r=0;r<a;r++)t.indexOf(this.keys[r])===0&&(a=r);this.keys.splice(a,1,t)}removeKey(t){let a=this.keys.indexOf(t);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=v;class d extends v{constructor(){const t=(0,i.getDefaultValues)(),a=(0,i.getConfigurationKeys)(),r=[];for(const s of Object.keys(t))P.OVERRIDE_PROPERTY_PATTERN.test(s)&&r.push({identifiers:[(0,P.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,i.toValuesTree)(t[s],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,a,r)}}e.DefaultConfigurationModel=d;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,a){if(!f.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,a)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,a){this._raw=t;const{contents:r,keys:s,overrides:l,restricted:m}=this.doParseRaw(t,a);this._configurationModel=new v(r,s,l),this._restrictedConfigurations=m||[]}doParseContent(t){let a={},r=null,s=[],l=[],m=[];function S(R){Array.isArray(s)?s.push(R):r!==null&&(s[r]=R)}let D={onObjectBegin:()=>{let R={};S(R),l.push(s),s=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{let R=[];S(R),l.push(s),s=R,r=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:S,onError:(R,F,C)=>{m.push({error:R,offset:F,length:C})}};if(t)try{k.visit(t,D),a=s[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return a}doParseRaw(t,a){const r=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,r,!0,a);t=s.raw;const l=(0,i.toValuesTree)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),m=Object.keys(t),S=(0,i.toOverrides)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:l,keys:m,overrides:S,restricted:s.restricted}}filter(t,a,r,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:t,restricted:[]};const l={},m=[];for(let S in t)if(P.OVERRIDE_PROPERTY_PATTERN.test(S)&&r){const D=this.filter(t[S],a,!1,s);l[S]=D.raw,m.push(...D.restricted)}else{const D=a[S],R=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&m.push(S),(R===void 0||s.scopes===void 0||s.scopes.includes(R))&&(s.skipRestricted&&D?.restricted||(l[S]=t[S]))}return{raw:l,restricted:m}}}e.ConfigurationModelParser=g;class I extends M.Disposable{constructor(t,a,r,s){super();this.userSettingsResource=t,this.scopes=a,this.fileService=s,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=I;class y{constructor(t,a,r=new v,s=new v,l=new b.ResourceMap,m=new v,S=new b.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=a,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=l,this._memoryConfiguration=m,this._memoryConfigurationByResource=S,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new b.ResourceMap,this._userConfiguration=null}getValue(t,a,r){return this.getConsolidateConfigurationModel(a,r).getValue(t)}updateValue(t,a,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new v,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,a===void 0?s.removeValue(t):s.setValue(t,a),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,a,r){const s=this.getConsolidateConfigurationModel(a,r),l=this.getFolderConfigurationModelForResource(a.resource,r),m=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,S=a.overrideIdentifier?this._defaultConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=a.overrideIdentifier?this.userConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),R=a.overrideIdentifier?this.localUserConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),F=a.overrideIdentifier?this.remoteUserConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),C=r?a.overrideIdentifier?this._workspaceConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,G=l?a.overrideIdentifier?l.freeze().override(a.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,ne=a.overrideIdentifier?m.override(a.overrideIdentifier).getValue(t):m.getValue(t),ae=s.getValue(t),K=p.distinct(p.flatten(s.overrides.map(ee=>ee.identifiers))).filter(ee=>s.getOverrideValue(t,ee)!==void 0);return{defaultValue:S,userValue:D,userLocalValue:R,userRemoteValue:F,workspaceValue:C,workspaceFolderValue:G,memoryValue:ne,value:ae,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,workspace:C!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,workspaceFolder:G!==void 0?{value:l?.freeze().getValue(t),override:a.overrideIdentifier?l?.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:m.getValue(t),override:a.overrideIdentifier?m.getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(t){const a=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,a){this._folderConfigurations.set(t,a),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,a){const r=a.filter(s=>P.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const l=(0,P.overrideIdentifierFromKey)(s),m=this._defaultConfiguration.getKeysForOverrideIdentifier(l),S=t.getKeysForOverrideIdentifier(l),D=[...S.filter(R=>m.indexOf(R)===-1),...m.filter(R=>S.indexOf(R)===-1),...m.filter(R=>!n.equals(this._defaultConfiguration.override(l).getValue(R),t.override(l).getValue(R)))];return[l,D]});return this.updateDefaultConfiguration(t),{keys:a,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:a,updated:r,removed:s,overrides:l}=(0,i.compare)(this.localUserConfiguration,t),m=[...a,...r,...s];return m.length&&this.updateLocalUserConfiguration(t),{keys:m,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:a,updated:r,removed:s,overrides:l}=(0,i.compare)(this.remoteUserConfiguration,t);let m=[...a,...r,...s];return m.length&&this.updateRemoteUserConfiguration(t),{keys:m,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:a,updated:r,removed:s,overrides:l}=(0,i.compare)(this.workspaceConfiguration,t);let m=[...a,...r,...s];return m.length&&this.updateWorkspaceConfiguration(t),{keys:m,overrides:l}}compareAndUpdateFolderConfiguration(t,a){const r=this.folderConfigurations.get(t),{added:s,updated:l,removed:m,overrides:S}=(0,i.compare)(r,a);let D=[...s,...l,...m];return(D.length||!r)&&this.updateFolderConfiguration(t,a),{keys:D,overrides:S}}compareAndDeleteFolderConfiguration(t){const a=this.folderConfigurations.get(t);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:s,removed:l,overrides:m}=(0,i.compare)(a,void 0);return{keys:[...r,...s,...l],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,a){let r=this.getConsolidatedConfigurationModelForResource(t,a);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},a){let r=this.getWorkspaceConsolidatedConfiguration();if(a&&t){const s=a.getFolder(t);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const l=this._memoryConfigurationByResource.get(t);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let a=this._foldersConsolidatedConfigurations.get(t);if(!a){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(a=r.merge(s),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(t,a)):a=r}return a}getFolderConfigurationModelForResource(t,a){if(a&&t){const r=a.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,a)=>{const{contents:r,overrides:s,keys:l}=this._folderConfigurations.get(a);return t.push([a,{contents:r,overrides:s,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>t.add(a)),this.userConfiguration.freeze().keys.forEach(a=>t.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>t.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>a.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>a.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>a.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(s=>a.add(s))),[...a.values()]}static parse(t){const a=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((m,S)=>(m.set(w.URI.revive(S[0]),this.parseConfigurationModel(S[1])),m),new b.ResourceMap);return new y(a,r,new v,s,l,new v,new b.ResourceMap,!1)}static parseConfigurationModel(t){return new v(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=y;function u(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,a=new Map;for(const s of c)s.keys.forEach(l=>t.add(l)),s.overrides.forEach(([l,m])=>{const S=(0,b.getOrSet)(a,l,new Set);m.forEach(D=>S.add(D))});const r=[];return a.forEach((s,l)=>r.push([l,[...s.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=u;class h{constructor(t,a,r,s){this.change=t,this.previous=a,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(S=>l.add(S)),t.overrides.forEach(([,S])=>S.forEach(D=>l.add(D))),this.affectedKeys=[...l.values()];const m=new v;this.affectedKeys.forEach(S=>m.setValue(S,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(a){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,a,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(t,a,this.currentWorkspace);return!n.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(t,a){let r=(0,i.toValuesTree)({[a]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(t=t[s],!t)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=h;class o extends h{constructor(t,a,r,s){super({keys:t.allKeys(),overrides:[]},void 0,t,a);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=o}),define(Z[189],x([0,1,9,4,2,15,16,188,49,38]),function(V,e,p,L,k,M,b,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends k.Disposable{constructor(E,v){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new n.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,v)),this.configuration=new n.Configuration(new n.DefaultConfigurationModel,new n.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new n.Configuration(new n.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,v){const d=typeof E=="string"?E:void 0,g=(0,b.isConfigurationOverrides)(E)?E:(0,b.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(d,g,void 0)}updateValue(E,v,d,g){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const v=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(d,v,1)}onDidDefaultConfigurationChange(E){const v=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new n.DefaultConfigurationModel,E);this.trigger(d,v,6)}trigger(E,v,d){const g=new n.ConfigurationChangeEvent(E,{data:v},this.configuration);g.source=d,g.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(Z[190],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(b,n=L.Unknown,f){super(b);this._message=b,this._code=n,this._detail=f,this.isHandled=n===L.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(b){return b instanceof k&&b._code===L.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof k&&b._code===L.NoResolverFound}static isHandled(b){return b instanceof k&&b.isHandled}}e.RemoteAuthorityResolverError=k}),define(Z[191],x([0,1,9,18,23,17,4,2,28,83,190]),function(V,e,p,L,k,M,b,n,f,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const P=30*1e3;var E;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function v(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(T){const A=new k.CancellationTokenSource;return setTimeout(()=>A.cancel(),T),A.token}function g(T,A){if(T.isCancellationRequested||A.isCancellationRequested)return k.CancellationToken.Cancelled;const W=new k.CancellationTokenSource;return T.onCancellationRequested(()=>W.cancel()),A.onCancellationRequested(()=>W.cancel()),W.token}class I{constructor(A){this._state="pending",this._disposables=new n.DisposableStore,this.promise=new Promise((W,z)=>{this._resolvePromise=W,this._rejectPromise=z}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function y(T,A){const W=new I(A);return W.registerDisposable(T.onControlMessage(z=>{const X=JSON.parse(z.toString()),U=$(X);U?W.reject(U):W.resolve(X)})),W.promise}function u(T,A,W,z,X,U){const N=new I(U);return A.connect(W,z,X,(Q,J)=>{N.didTimeout?(Q&&T.error(Q),J?.dispose()):Q||!J?N.reject(Q):N.resolve(J)}),N.promise}function h(T,A){const W=new I(A);return T.then(z=>{W.didTimeout||W.resolve(z)},z=>{W.didTimeout||W.reject(z)}),W.promise}async function o(T,A,W,z){const X=O(T,A);T.logService.trace(`${X} 1/6. invoking socketFactory.connect().`);let U;try{U=await u(T.logService,T.socketFactory,T.host,T.port,`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,z)}catch(re){throw T.logService.error(`${X} socketFactory.connect() failed or timed out. Error:`),T.logService.error(re),re}T.logService.trace(`${X} 2/6. socketFactory.connect() was successful.`);let N,Q;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(U,null),N=T.reconnectionProtocol,Q=!1):(N=new w.PersistentProtocol(U,null),Q=!0),T.logService.trace(`${X} 3/6. sending AuthRequest control message.`);const J={type:"auth",auth:T.connectionToken||"00000000000000000000"};N.sendControl(L.VSBuffer.fromString(JSON.stringify(J)));try{const re=await y(N,g(z,d(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const oe=new Error("Unexpected handshake message");throw oe.code="VSCODE_CONNECTION_ERROR",oe}T.logService.trace(`${X} 4/6. received SignRequest control message.`);const le=await h(T.signService.sign(re.data),z),ie={type:"connectionType",commit:T.commit,signedData:le,desiredConnectionType:A};return W&&(ie.args=W),T.logService.trace(`${X} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(L.VSBuffer.fromString(JSON.stringify(ie))),{protocol:N,ownsProtocol:Q}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(T.logService.error(`${X} the handshake timed out. Error:`),T.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${X} received error control message when negotiating connection. Error:`),T.logService.error(re)),Q&&j(N),re}}async function c(T,A,W,z){const X=Date.now(),U=O(T,A),{protocol:N,ownsProtocol:Q}=await o(T,A,W,z),J=new I(z);return J.registerDisposable(N.onControlMessage(re=>{const le=JSON.parse(re.toString()),ie=$(le);ie?(T.logService.error(`${U} received error control message when negotiating connection. Error:`),T.logService.error(ie),Q&&j(N),J.reject(ie)):(T.reconnectionProtocol&&T.reconnectionProtocol.endAcceptReconnection(),T.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${q(X)}!`),J.resolve({protocol:N,firstMessage:le}))})),J.promise}async function t(T,A){const{protocol:W}=await c(T,1,void 0,A);return{protocol:W}}async function a(T,A,W){const{protocol:z,firstMessage:X}=await c(T,2,A,W),U=X&&X.debugPort;return{protocol:z,debugPort:U}}async function r(T,A,W){const z=Date.now(),X=O(T,3),{protocol:U}=await o(T,3,A,W);return T.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${q(z)}!`),U}async function s(T,A,W){const{host:z,port:X,connectionToken:U}=await T.addressProvider.getAddress();return{commit:T.commit,host:z,port:X,connectionToken:U,reconnectionToken:A,reconnectionProtocol:W,socketFactory:T.socketFactory,signService:T.signService,logService:T.logService}}async function l(T,A,W){try{const z=(0,f.generateUuid)(),X=await s(T,z,null),{protocol:U}=await t(X,k.CancellationToken.None);return new ee(T,A,W,z,U)}catch(z){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(z),K.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(z)),z}}e.connectRemoteAgentManagement=l;async function m(T,A){try{const W=(0,f.generateUuid)(),z=await s(T,W,null),{protocol:X,debugPort:U}=await a(z,A,k.CancellationToken.None);return new _(T,A,W,X,U)}catch(W){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(W),K.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentExtensionHost=m;async function S(T,A,W){const z=await s(T,(0,f.generateUuid)(),null);return await r(z,{host:A,port:W},k.CancellationToken.None)}e.connectRemoteAgentTunnel=S;function D(T){return(0,p.createCancelablePromise)(A=>new Promise((W,z)=>{const X=setTimeout(W,T*1e3);A.onCancellationRequested(()=>{clearTimeout(X),W()})}))}var R;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class F{constructor(A,W){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=F;class C{constructor(A,W,z,X){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.durationSeconds=z,this.cancellableTimer=X,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=C;class G{constructor(A,W,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=z,this.type=2}}e.ReconnectionRunningEvent=G;class ne{constructor(A,W,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=z,this.type=4}}e.ConnectionGainEvent=ne;class ae{constructor(A,W,z,X){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=z,this.handled=X,this.type=3}}e.ReconnectionPermanentFailureEvent=ae;class K extends n.Disposable{constructor(A,W,z,X){super();this._connectionType=A,this._onDidStateChange=this._register(new b.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=W,this.reconnectionToken=z,this.protocol=X,this._isReconnecting=!1,this._onDidStateChange.fire(new ne(this.reconnectionToken,0,0)),this._register(X.onSocketClose(U=>{const N=H(this._connectionType,this.reconnectionToken,!0);U?U.type===0?(this._options.logService.info(`${N} received socket close event (hadError: ${U.hadError}).`),U.error&&this._options.logService.error(U.error)):(this._options.logService.info(`${N} received socket close event (wasClean: ${U.wasClean}, code: ${U.code}, reason: ${U.reason}).`),U.event&&this._options.logService.error(U.event)):this._options.logService.info(`${N} received socket close event.`),this._beginReconnecting()})),this._register(X.onSocketTimeout(()=>{const U=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${U} received socket timeout event.`),this._beginReconnecting()})),K._instances.push(this),K._permanentFailure&&this._gotoPermanentFailure(K._permanentFailureMillisSinceLastIncomingData,K._permanentFailureAttempt,K._permanentFailureHandled)}static triggerPermanentFailure(A,W,z){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=W,this._permanentFailureHandled=z,this._instances.forEach(X=>X._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(K._permanentFailure)return;const A=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const X=z<W.length?W[z]:W[W.length-1];try{if(X>0){const N=D(X);this._onDidStateChange.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X,N)),this._options.logService.info(`${A} waiting for ${X} seconds before reconnecting...`);try{await N}catch{}}if(K._permanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this._options.logService.info(`${A} resolving connection...`);const U=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${U.host}:${U.port}...`),await this._reconnect(U,d(P)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(U),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(U),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(i.RemoteAuthorityResolverError.isTemporarilyNotAvailable(U)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((0,M.isPromiseCanceledError)(U)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if(U instanceof i.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(U),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,i.RemoteAuthorityResolverError.isHandled(U));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(U),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!K._permanentFailure)}_gotoPermanentFailure(A,W,z){this._onDidStateChange.fire(new ae(this.reconnectionToken,A,W,z)),j(this.protocol)}}K._permanentFailure=!1,K._permanentFailureMillisSinceLastIncomingData=0,K._permanentFailureAttempt=0,K._permanentFailureHandled=!1,K._instances=[];class ee extends K{constructor(A,W,z,X,U){super(1,A,X,U);this.client=this._register(new w.Client(U,{remoteAuthority:W,clientId:z},A.ipcLogger))}async _reconnect(A,W){await t(A,W)}}e.ManagementPersistentConnection=ee;class _ extends K{constructor(A,W,z,X,U){super(2,A,z,X);this._startArguments=W,this.debugPort=U}async _reconnect(A,W){await a(A,this._startArguments,W)}}e.ExtensionHostPersistentConnection=_;function j(T){try{T.acceptDisconnect();const A=T.getSocket();T.dispose(),A.dispose()}catch(A){(0,M.onUnexpectedError)(A)}}function $(T){if(T&&T.type==="error"){const A=new Error(`Connection error: ${T.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function B(T,A){for(;T.length<A;)T+=" ";return T}function H(T,A,W){return`[remote-connection][${B(v(T),13)}][${A.substr(0,5)}\u2026][${W?"reconnect":"initial"}]`}function O(T,A){return`${H(A,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.host}:${T.port}]`}function q(T){return`${Date.now()-T} ms`}}),define(Z[74],x([0,1,10]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(w){return w.scheme===p.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=L;function k(w){if(!w)return;const i=w.indexOf("+");return i<0?w:w.substr(0,i)}e.getRemoteName=k;function M(w){return w.scheme!==p.Schemas.file&&w.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=M;function b(w){if(w.folders.length)return w.folders.every(i=>M(i.uri))?w.folders[0].uri:void 0;if(w.configuration&&M(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=b;function n(w){return b(w)?.scheme}e.getVirtualWorkspaceScheme=n;function f(w){return b(w)!==void 0}e.isVirtualWorkspace=f}),define(Z[95],x([0,1,4,3,5,6]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var b;(function(v){v.Http="http",v.Https="https"})(b=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(n=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=i;function P(v,d){return d?d!==1&&v<1024:!L.isWindows&&v<1024}e.isPortPrivileged=P;let E=class{constructor(d){this.logService=d,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,g){return this._tunnelProvider=d,d?(this._canElevate=g.elevation,this._canMakePublic=g.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async d=>{const g=[],I=Array.from(this._tunnels.values());for(let y of I){const u=Array.from(y.values());for(let h of u){const o=await h.value;o&&g.push(o)}}d(g)})}async dispose(){for(const d of this._tunnels.values()){for(const{value:g}of d.values())await g.then(I=>I?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,g,I,y,u=!1,h=!1,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${I} on local port ${y}.`),!d)return;g||(g="localhost");const c=this.retainOrCreateTunnel(d,g,I,y,u,h,o);return c?c.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,I);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(t);return(t.tunnelRemoteHost!==g||t.tunnelRemotePort!==I)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,public:d.public,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const g=this._tunnels.get(d.tunnelRemoteHost);if(g){const I=g.get(d.tunnelRemotePort);I&&(I.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,I))}}}}async tryDisposeTunnel(d,g,I){if(I.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${g}.`);const y=I.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(g),y}}async closeTunnel(d,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${g} `);const I=this._tunnels.get(d);if(I&&I.has(g)){const y=I.get(g);y.refcount=0,await this.tryDisposeTunnel(d,g,y)}}addTunnelToMap(d,g,I){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(g,{refcount:1,value:I})}async removeEmptyTunnelFromMap(d,g){const I=this._tunnels.get(d);I&&(await I.get(g)||I.delete(g),I.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,g){let I=[d];w(d)?(I.push(...e.LOCALHOST_ADDRESSES),I.push(...e.ALL_INTERFACES_ADDRESSES)):i(d)&&I.push(...e.ALL_INTERFACES_ADDRESSES);const y=I.map(u=>this._tunnels.get(u));for(const u of y){const h=u?.get(g);if(h)return h}}canTunnel(d){return!!f(d)}createWithProvider(d,g,I,y,u,h,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${I} on local port ${y}.`);const t={elevationRequired:u?P(y===void 0?I:y):!1},a={remoteAddress:{host:g,port:I},localAddressPort:y,public:h,protocol:o},r=d.forwardPort(a,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(g,I,r),r}};E=ue([te(0,M.ILogService)],E),e.AbstractTunnelService=E}),define(Z[50],x([0,1,18,146,49,5,38]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function n(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=n;function f(d){return d.res.statusCode===204}async function w(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);return f(d)?null:(await(0,p.streamToBuffer)(d.stream)).toString()}e.asText=w;async function i(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);if(f(d))return null;const I=(await(0,p.streamToBuffer)(d.stream)).toString();try{return JSON.parse(I)}catch(y){throw y.message+=`:
`+I,y}}e.asJson=i;function P(d){v(d)}e.updateProxyConfigurationsScope=P;let E;function v(d){const g=b.Registry.as(k.Extensions.Configuration),I=E;E={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[E],remove:I?[I]:[]})}v(2)}),define(Z[192],x([0,1,193,13]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(b,n){return b.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:b.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function M(b,n,f={}){const w=(0,p.parse)(b),i=f.proxyUrl||k(w,n);if(!i)return null;const P=(0,p.parse)(i);if(!/^https?:$/.test(P.protocol||""))return null;const E={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((v,d)=>{V(["http-proxy-agent"],v,d)}))(E):new(await new Promise((v,d)=>{V(["https-proxy-agent"],v,d)}))(E)}e.getProxyAgent=M}),define(Z[194],x([0,1,18,28]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(M,b,n){let f=n&&n.get("storage.serviceMachineId",0)||null;if(f)return f;try{const i=(await b.readFile(M.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(i)?i:null}catch(w){f=null}if(!f){f=(0,L.generateUuid)();try{await b.writeFile(M.serviceMachineIdResource,p.VSBuffer.fromString(f))}catch(w){}}return n&&n.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=k}),define(Z[75],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[195],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((k,M)=>V(["vsda"],k,M))}async sign(k){try{const M=await this.vsda(),b=new M.signer;if(b)return b.sign(k)}catch(M){}return k}}e.SignService=p}),define(Z[39],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(Z[22],x([0,1,14,9,4,2,3,33,13,5,177,6,39]),function(V,e,p,L,k,M,b,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var v;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(v=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let d=class ct extends M.Disposable{constructor(I,y){super();this.logService=I,this.stateMainService=y,this._onBeforeShutdown=this._register(new k.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new k.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new k.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new k.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ct.QUIT_AND_RESTART_KEY)}registerListeners(){const I=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),b.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};p.app.addListener("before-quit",I);const y=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!b.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",y),p.app.once("will-quit",u=>{this.logService.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",I),p.app.removeListener("window-all-closed",y),p.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const I=[];return this._onWillShutdown.fire({join(y){I.push(y)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(I)}catch(y){this.logService.error(y)}try{await this.stateMainService.close()}catch(y){this.logService.error(y)}})(),this.pendingWillShutdownPromise}set phase(I){if(I<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===I)return;this.logService.trace(`lifecycle (main): phase changed (value: ${I})`),this._phase=I;const y=this.phaseWhen.get(this._phase);y&&(y.open(),this.phaseWhen.delete(this._phase))}async when(I){if(I<=this._phase)return;let y=this.phaseWhen.get(I);y||(y=new L.Barrier,this.phaseWhen.set(I,y)),await y.wait()}registerWindow(I){const y=new M.DisposableStore;this.windowCounter++,y.add(I.onWillLoad(h=>this._onWillLoadWindow.fire({window:I,workspace:h.workspace,reason:h.reason})));const u=(0,f.assertIsDefined)(I.win);u.on("close",h=>{const o=I.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${I.id}`),h.preventDefault(),this.unload(I,1).then(c=>{if(c){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(I),I.close()})}),u.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${I.id}`),this.windowCounter--,y.dispose(),this.windowCounter===0&&(!b.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(I,y){await this.unload(I,3)||I.reload(y)}async unload(I,y){if(!I.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${I.id}`);const u=this._quitRequested?2:y;let h=await this.onBeforeUnloadWindowInRenderer(I,u);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${I.id})`),this.handleWindowUnloadVeto(h)):(h=await this.onBeforeUnloadWindowInMain(I,u),h?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${I.id})`),this.handleWindowUnloadVeto(h)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${I.id})`),await this.onWillUnloadWindowInRenderer(I,u),!1))}handleWindowUnloadVeto(I){return I?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(I){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(I),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(I,y){return new Promise(u=>{const h=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${h}`,c=`vscode:cancel${h}`;p.ipcMain.once(o,()=>{u(!1)}),p.ipcMain.once(c,()=>{u(!0)}),I.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:c,reason:y})})}onBeforeUnloadWindowInMain(I,y){const u=[];return this._onBeforeUnloadWindow.fire({reason:y,window:I,veto(h){u.push(h)}}),(0,i.handleVetos)(u,h=>this.logService.error(h))}onWillUnloadWindowInRenderer(I,y){return new Promise(u=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(o,()=>u()),I.send("vscode:onWillUnload",{replyChannel:o,reason:y})})}quit(I){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${I}`),I&&this.stateMainService.setItem(ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(y=>{this.pendingQuitPromiseResolve=y,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(I){this.logService.trace("Lifecycle#relaunch()");const y=process.argv.slice(1);if(I?.addArgs&&y.push(...I.addArgs),I?.removeArgs)for(const o of I.removeArgs){const c=y.indexOf(o);c>=0&&y.splice(c,1)}const u=()=>{try{if(b.isWindows){const o=(0,n.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:y})};p.app.once("quit",u),await this.quit(!0)&&p.app.removeListener("quit",u)}async kill(I){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const y of p.BrowserWindow.getAllWindows())if(y&&!y.isDestroyed()){let u;y.webContents&&!y.webContents.isDestroyed()?u=new Promise(h=>y.once("closed",h)):u=Promise.resolve(),y.destroy(),await u}})()]),p.app.exit(I)}};d.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",d=ue([te(0,P.ILogService),te(1,E.IStateMainService)],d),e.LifecycleMainService=d}),define(Z[196],x([0,1,4,2,5,22]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,k.createDecorator)("keyboardLayoutMainService");let b=class extends L.Disposable{constructor(w){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,w.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const w=await new Promise((i,P)=>{V(["native-keymap"],i,P)});this._keyboardLayoutData=n(w),w.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(w),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};b=ue([te(0,M.ILifecycleMainService)],b),e.KeyboardLayoutMainService=b;function n(f){const w=f.getKeyMap(),i=f.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:i}}}),define(Z[96],x([0,1,9,4,2,13,85,5]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,n.createDecorator)("storageService");var w;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var P;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(P=e.StorageTarget||(e.StorageTarget={}));class E extends k.Disposable{constructor(I={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,y){y===f?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:y,target:this.getKeyTargets(I)[y]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,y,u){return this.getStorage(y)?.get(I,u)}getBoolean(I,y,u){return this.getStorage(y)?.getBoolean(I,u)}getNumber(I,y,u){return this.getStorage(y)?.getNumber(I,u)}store(I,y,u,h){if((0,M.isUndefinedOrNull)(y)){this.remove(I,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(I,u,h),this.getStorage(u)?.set(I,y)})}remove(I,y){this.withPausedEmitters(()=>{this.updateKeyTarget(I,y,void 0),this.getStorage(y)?.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,y){const u=[],h=this.getKeyTargets(I);for(const o of Object.keys(h))h[o]===y&&u.push(o);return u}updateKeyTarget(I,y,u){const h=this.getKeyTargets(y);typeof u=="number"?h[I]!==u&&(h[I]=u,this.getStorage(y)?.set(f,JSON.stringify(h))):typeof h[I]=="number"&&(delete h[I],this.getStorage(y)?.set(f,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const y=this.get(f,I);if(y)try{return JSON.parse(y)}catch(u){}return Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(I=w.NONE){this._onWillSaveState.fire({reason:I}),await p.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const I=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return d(I,y,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class v extends E{constructor(){super();this.globalStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}e.InMemoryStorageService=v;async function d(g,I,y,u){const h=l=>{try{return JSON.parse(l)}catch(m){return l}},o=new Map,c=new Map;g.forEach((l,m)=>{o.set(m,l),c.set(m,h(l))});const t=new Map,a=new Map;I.forEach((l,m)=>{t.set(m,l),a.set(m,h(l))}),console.group(`Storage: Global (path: ${y})`);let r=[];o.forEach((l,m)=>{r.push({key:m,value:l})}),console.table(r),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${u})`);let s=[];t.forEach((l,m)=>{s.push({key:m,value:l})}),console.table(s),console.groupEnd(),console.log(a)}e.logStorage=d}),define(Z[197],x([0,1,3,33,7,28]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function b(w){if(p.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function n(w,i,P,E,v,d,g,I,y,u){const h=Object.create(null);h["common.machineId"]=g,h.sessionID=(0,M.generateUuid)()+Date.now(),h.commitHash=v,h.version=d,h["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,p.PlatformToString)(p.platform),h["common.nodePlatform"]=L.platform,h["common.nodeArch"]=E,h["common.product"]=u||"desktop";const o=f(I||[]);o&&(h["common.msftInternal"]=o);let c=0;const t=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),p.isLinuxSnap&&(h["common.snap"]="true");const a=b(P);a&&(h["common.platformDetail"]=a);try{const r=await w.readFile(k.URI.file(y));h["common.source"]=r.value.toString().slice(0,30)}catch(r){}return h}e.resolveCommonProperties=n;function f(w){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const P=i.toLowerCase();return w.some(E=>P===E)}e.verifyMicrosoftInternalDomain=f}),define(Z[29],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(M){M[M.NONE=0]="NONE",M[M.LOG=1]="LOG",M[M.USER=2]="USER"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(M){M.OFF="off",M.ERROR="error",M.ON="on"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[198],x([0,1,26,64,40,10,8,3,7,67,19,82,71,20,21,29]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function I(c,t){const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,s=new Map,l=2e4;function m(R,F,C,G){const ne=F.substring(R.length+1);return new Promise(async ae=>{let K;try{K=await i.Promises.readdir(F,{withFileTypes:!0})}catch(j){ae();return}if(G.count>=l){G.count+=K.length,G.maxReached=!0,ae();return}let ee=K.length;if(ee===0){ae();return}let _=K;G.count+K.length>l&&(G.maxReached=!0,ee=l-G.count,_=K.slice(0,ee)),G.count+=K.length;for(const j of _)if(j.isDirectory()){if(C.includes(j.name)||await m(R,(0,b.join)(F,j.name),C,G),--ee==0){ae();return}}else{const $=j.name.lastIndexOf(".");if($>=0){const B=j.name.substring($+1);B&&r.set(B,(r.get(B)??0)+1)}for(const B of a)B.relativePathPattern?.test(ne)!==!1&&B.filePattern.test(j.name)&&s.set(B.tag,(s.get(B.tag)??0)+1);if(--ee==0){ae();return}}})}const S={count:0,maxReached:!1};await m(c,c,t,S);const D=await h(c);return{configFiles:y(s),fileTypes:y(r),fileCount:S.count,maxFilesReached:S.maxReached,launchConfigFiles:D}}e.collectWorkspaceStats=I;function y(c){return[...L.Iterable.map(c.entries(),([t,a])=>({name:t,count:a}))].sort((t,a)=>a.count-t.count)}function u(){const c={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},t=p.cpus();return t&&t.length>0&&(c.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),c}e.getMachineInfo=u;async function h(c){try{const t=new Map,a=(0,b.join)(c,".vscode","launch.json"),r=await i.Promises.readFile(a),s=[],l=(0,k.parse)(r.toString(),s);if(s.length)return console.log(`Unable to parse ${a}`),[];if((0,k.getNodeType)(l)==="object"&&l.configurations)for(const m of l.configurations){const S=m.type;S&&(t.has(S)?t.set(S,t.get(S)+1):t.set(S,1))}return y(t)}catch(t){return[]}}e.collectLaunchConfigs=h;let o=class{constructor(t,a){this.telemetryService=t,this.productService=a}formatMachineInfo(t){const a=[];return a.push(`OS Version:       ${t.os}`),a.push(`CPUs:             ${t.cpus}`),a.push(`Memory (System):  ${t.memory}`),a.push(`VM:               ${t.vmHint}`),a.join(`
`)}formatEnvironment(t){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const r=p.cpus();return r&&r.length>0&&a.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),a.push(`Memory (System):  ${(p.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||a.push(`Load (avg):       ${p.loadavg().map(s=>Math.round(s)).join(", ")}`),a.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${t.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(t,a){return Promise.all([(0,P.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async r=>{let[s,l]=r,m=this.formatProcessList(t,s);return a.forEach(S=>{if((0,E.isRemoteDiagnosticError)(S))m+=`
${S.errorMessage}`,l+=`
${S.errorMessage}`;else if(m+=`

Remote: ${S.hostName}`,S.processes&&(m+=`
${this.formatProcessList(t,S.processes)}`),S.workspaceMetadata){l+=`
|  Remote: ${S.hostName}`;for(const D of Object.keys(S.workspaceMetadata)){const R=S.workspaceMetadata[D];let F=`${R.fileCount} files`;R.maxFilesReached&&(F=`more than ${F}`),l+=`|    Folder (${D}): ${F}`,l+=this.formatWorkspaceStats(R)}}}),{processInfo:m,workspaceInfo:l}})}async getSystemInfo(t,a){const{memory:r,vmHint:s,os:l,cpus:m}=u(),S={os:l,memory:r,cpus:m,vmHint:s,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:a};return n.isWindows||(S.load=`${p.loadavg().map(D=>Math.round(D)).join(", ")}`),n.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(t,a){const r=[];return(0,P.listProcesses)(t.mainPID).then(async s=>(r.push(""),r.push(this.formatEnvironment(t)),r.push(""),r.push(this.formatProcessList(t,s)),t.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(t))),a.forEach(l=>{if((0,E.isRemoteDiagnosticError)(l))r.push(`
${l.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${l.hostName}`),r.push(this.formatMachineInfo(l.machineInfo)),l.processes&&r.push(this.formatProcessList(t,l.processes)),l.workspaceMetadata)for(const m of Object.keys(l.workspaceMetadata)){const S=l.workspaceMetadata[m];let D=`${S.fileCount} files`;S.maxFilesReached&&(D=`more than ${D}`),r.push(`Folder (${m}): ${D}`),r.push(this.formatWorkspaceStats(S))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(t){const a=[],r=60;let s=0;const l=(R,F)=>{const C=` ${R}(${F})`;s+C.length>r?(a.push(m),m="|                 ",s=m.length):s+=C.length,m+=C};let m="|      File types:";const S=10;let D=t.fileTypes.length>S?S:t.fileTypes.length;for(let R=0;R<D;R++){const F=t.fileTypes[R];l(F.name,F.count)}if(a.push(m),t.configFiles.length>=0&&(m="|      Conf files:",s=0,t.configFiles.forEach(R=>{l(R.name,R.count)}),a.push(m)),t.launchConfigFiles.length>0){let R="|      Launch Configs:";t.launchConfigFiles.forEach(F=>{R+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),a.push(R)}return a.join(`
`)}expandGPUFeatures(t){const a=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(a-r.length)}  ${t[r]}`).join(`
                  `)}formatWorkspaceMetadata(t){const a=[],r=[];return t.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(a.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const m=f.URI.revive(l);if(m.scheme===M.Schemas.file){const S=m.fsPath;r.push(I(S,["node_modules",".git"]).then(D=>{let R=`${D.fileCount} files`;D.maxFilesReached&&(R=`more than ${R}`),a.push(`|    Folder (${(0,b.basename)(S)}): ${R}`),a.push(this.formatWorkspaceStats(D))}).catch(D=>{a.push(`|      Error: Unable to collect workspace stats for folder ${S} (${D.toString()})`)}))}else a.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(s=>a.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(t,a){const r=new Map;t.windows.forEach(l=>r.set(l.pid,l.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(t.mainPID,r,s,a,0),s.join(`
`)}formatProcessItem(t,a,r,s,l){const m=l===0;let S;m?S=s.pid===t?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(l)} ${s.name}`,s.name==="window"&&(S=`${S} (${a.get(s.pid)})`));const D=process.platform==="win32"?s.mem:p.totalmem()*(s.mem/100);r.push(`${s.load.toFixed(0).padStart(5," ")}	${(D/v.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(s.children)&&s.children.forEach(R=>this.formatProcessItem(t,a,r,R,l+1))}async reportWorkspaceStats(t){for(const{uri:a}of t.folders){const r=f.URI.revive(a);if(r.scheme!==M.Schemas.file)continue;const s=r.fsPath;try{const l=await I(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),l.fileTypes.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:m.name,count:m.count})}),l.launchConfigFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:m.name,count:m.count})}),l.configFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};o=ue([te(0,g.ITelemetryService),te(1,d.IProductService)],o),e.DiagnosticsService=o}),define(Z[199],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(M){this.appender=M}listen(M,b){throw new Error(`Event not found: ${b}`)}call(M,b,{eventName:n,data:f}){return this.appender.log(n,f),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class L{constructor(M){this.channel=M}log(M,b){return this.channel.call("log",{eventName:M,data:b}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[60],x([0,1,9,44,13,16,29]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryConfiguration=e.getTelemetryLevel=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(y,u){return Promise.resolve(void 0)}publicLog2(y,u){return this.publicLog(y,u)}publicLogError(y,u){return Promise.resolve(void 0)}publicLogError2(y,u){return this.publicLogError(y,u)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class n{async publicLog(u,h,o){}async publicLogError(u,h,o){}}e.NullEndpointTelemetryService=n;function f(...y){return{log:(u,h)=>y.forEach(o=>o.log(u,h)),flush:()=>p.Promises.settled(y.map(u=>u.flush()))}}e.combinedAppender=f,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(y,u){return u.onDidChangeConfiguration(h=>{h.source!==6&&y.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(h.source),configurationKeys:g(h.sourceConfig)})})}e.configurationTelemetry=w;function i(y,u){return u.disableTelemetry||!y.enableTelemetry?0:u.isBuilt?2:1}e.getTelemetryLevel=i;function P(y){const u=y.getValue(b.TELEMETRY_SETTING_ID),h=y.getValue(b.TELEMETRY_OLD_SETTING_ID);return h!==void 0&&h===!1?"off":u??"on"}e.getTelemetryConfiguration=P;function E(y){const u=Object.create(null),h=Object.create(null),o=Object.create(null);d(y,o);for(let c in o){c=c.length>150?c.substr(c.length-149):c;const t=o[c];typeof t=="number"?h[c]=t:typeof t=="boolean"?h[c]=t?1:0:typeof t=="string"?u[c]=t.substring(0,1023):typeof t!="undefined"&&t!==null&&(u[c]=t)}return{properties:u,measurements:h}}e.validateTelemetryData=E;function v(y){if(!y)return"none";let u="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(o=>{y.indexOf(`${o}+`)===0&&(u=o)}),u}e.cleanRemoteAuthority=v;function d(y,u,h=0,o){if(!!y)for(let c of Object.getOwnPropertyNames(y)){const t=y[c],a=o?o+c:c;Array.isArray(t)?u[a]=(0,L.safeStringify)(t):t instanceof Date?u[a]=t.toISOString():(0,k.isObject)(t)?h<2?d(t,u,h+1,a+"."):u[a]=(0,L.safeStringify)(t):u[a]=t}}function g(y){if(!y)return[];const u=[];return I(u,"",y),u}function I(y,u,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(o=>I(y,u?`${u}.${o}`:o,h[o])):y.push(u)}}),define(Z[200],x([0,1,30,23,17,44,3,33,7,16,48,168,171,162,20,6,21,50,194,96,29,60]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I,y,u,h,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=b.isWeb?"web":(0,P.getTargetPlatform)(b.platform,n.arch);var a;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(a||(a={}));function r(...U){return String(U.reduce((N,Q)=>N|Q,0))}var s;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class R{constructor(N=D){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,Q=this.state.pageSize){return new R({...this.state,pageNumber:N,pageSize:Q})}withFilter(N,...Q){const J=[...this.state.criteria,...Q.length?Q.map(re=>({filterType:N,value:re})):[{filterType:N}]];return new R({...this.state,criteria:J})}withSortBy(N){return new R({...this.state,sortBy:N})}withSortOrder(N){return new R({...this.state,sortOrder:N})}withFlags(...N){return new R({...this.state,flags:N.reduce((Q,J)=>Q|J,0)})}withAssetTypes(...N){return new R({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:Q,pageSize:J,sortBy:re,sortOrder:le,flags:ie,assetTypes:oe}=this.state;return{filters:[{criteria:N,pageNumber:Q,pageSize:J,sortBy:re,sortOrder:le}],assetTypes:oe,flags:ie}}get searchText(){const N=this.state.criteria.filter(Q=>Q.filterType===s.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function F(U,N){const Q=(U||[]).filter(J=>J.statisticName===N)[0];return Q?Q.value:0}function C(U){const N="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(J=>J.assetType.indexOf(N)===0).reduce((J,re)=>{const le=K(U,re.assetType);return le&&J.push([re.assetType.substring(N.length),le]),J},[])}function G(U){if(U.properties){const N=U.properties.filter(re=>re.key===l.Repository),Q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=N.filter(re=>Q.test(re.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return K(U,l.Repository)}function ne(U){return{uri:`${U.fallbackAssetUri}/${l.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${l.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ae(U){const N=K(U,l.Icon);if(N)return N;const Q=P.DefaultIconPath;return{uri:Q,fallbackUri:Q}}function K(U,N){return U.files.filter(J=>J.assetType===N)[0]?{uri:`${U.assetUri}/${N}`,fallbackUri:`${U.fallbackAssetUri}/${N}`}:null}function ee(U,N){const Q=U.properties?U.properties.filter(re=>re.key===N):[],J=Q.length>0&&Q[0].value;return J?J.split(",").map(re=>(0,E.adoptToGalleryExtensionId)(re)):[]}function _(U){const N=U.properties?U.properties.filter(Q=>Q.key===m.Engine):[];return N.length>0&&N[0].value||""}function j(U){const N=U.properties?U.properties.filter(J=>J.key===m.LocalizedLanguages):[],Q=N.length>0&&N[0].value||"";return Q?Q.split(","):[]}function $(U){return U.indexOf("preview")!==-1}function B(U){return U.targetPlatform?(0,P.toTargetPlatform)(U.targetPlatform):"undefined"}function H(U){const N=(0,p.distinct)(U.versions.map(B)),Q=!!U.tags?.includes(P.WEB_EXTENSION_TAG),J=N.indexOf("web");return Q?J===-1&&N.push("web"):J!==-1&&N.splice(J,1),N}function O(U,N){const Q=(0,P.getFallbackTargetPlarforms)(N);for(let J=0;J<U.length;J++){const re=U[J];if(re.version===U[J-1]?.version){let le=J;const ie=B(re);if(ie===N)for(;le>0&&U[le-1].version===re.version;)le--;else if(Q.includes(ie))for(;le>0&&U[le-1].version===re.version&&B(U[le-1])!==N;)le--;le!==J&&(U.splice(J,1),U.splice(le,0,re))}}return U}e.sortExtensionVersions=O;function q(U,N,Q,J,re){const le=H(U);let ie=U.versions[0];return ie=U.versions.find(oe=>oe.version===ie.version&&(0,P.isTargetPlatformCompatible)(B(oe),le,re))||ie,T(U,ie,le,N,Q,J)}function T(U,N,Q,J,re,le){const ie={manifest:K(N,l.Manifest),readme:K(N,l.Details),changelog:K(N,l.Changelog),license:K(N,l.License),repository:G(N),download:ne(N),icon:ae(N),coreTranslations:C(N)};return{identifier:{id:(0,E.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:N.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,description:U.shortDescription||"",installCount:F(U.statistics,"install"),rating:F(U.statistics,"averagerating"),ratingCount:F(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:Q,assets:ie,properties:{dependencies:ee(N,m.Dependency),extensionPack:ee(N,m.ExtensionPack),engine:_(N),localizedLanguages:j(N),targetPlatform:B(N)},preview:$(U.flags),telemetryData:{index:(re.pageNumber-1)*re.pageSize+J,querySource:le}}}let A=class{constructor(N,Q,J,re,le,ie,oe,ge){this.requestService=Q,this.logService=J,this.environmentService=re,this.telemetryService=le,this.fileService=ie,this.productService=oe,this.configurationService=ge;const fe=oe.extensionsGallery;this.extensionsGalleryUrl=fe&&fe.serviceUrl,this.extensionsControlUrl=fe&&fe.controlUrl,this.commonHeadersPromise=X(oe.version,oe,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,Q){const J=[];let re=new R().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,N.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...N.map(({id:ie})=>ie.toLowerCase()));N.every(ie=>!ie.version)&&(re=re.withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties,a.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(re,t,L.CancellationToken.None);for(let ie=0;ie<le.length;ie++){const oe=le[ie];if(!oe.versions.length)continue;const ge=(0,E.getGalleryExtensionId)(oe.publisher.publisherName,oe.extensionName),fe=N.find(de=>(0,E.areSameExtensions)(de,{id:ge}))?.version;if(fe){const de=oe.versions.find(Pe=>Pe.version===fe);de&&J.push(T(oe,de,H(oe),ie,re))}else J.push(q(oe,ie,re,void 0,t))}return J}async getCompatibleExtension(N,Q){const J=(0,P.isIExtensionIdentifier)(N)?null:N;if(J){if((0,P.isNotWebExtensionInWebTargetPlatform)(J.allTargetPlatforms,Q))return null;if(await this.isExtensionCompatible(J,Q))return J}const{id:re,uuid:le}=J?J.identifier:N;let ie=new R().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");le?ie=ie.withFilter(s.ExtensionId,le):ie=ie.withFilter(s.ExtensionName,re);const{galleryExtensions:oe}=await this.queryGallery(ie,Q,L.CancellationToken.None),[ge]=oe;if(!ge||!ge.versions.length)return null;const fe=H(ge);if((0,P.isNotWebExtensionInWebTargetPlatform)(fe,Q))return null;for(let de of ge.versions){if(!_(de)){const Pe=await this.getEngine(de);de={...de,properties:[...de.properties||[],{key:m.Engine,value:Pe}]}}if(await this.isRawExtensionVersionCompatible(de,fe,Q))return T(ge,de,fe,0,ie)}return null}async isExtensionCompatible(N,Q){if(!(0,P.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,Q))return!1;let J=N.properties.engine;if(!J){const re=await this.getManifest(N,L.CancellationToken.None);if(!re)throw new Error("Manifest was not found");J=re.engines.vscode}return(0,v.isEngineValid)(J,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(N,Q,J){if(!(0,P.isTargetPlatformCompatible)(B(N),Q,J))return!1;const re=await this.getEngine(N);return(0,v.isEngineValid)(re,this.productService.version,this.productService.date)}async query(N,Q){const J=L.CancellationToken.isCancellationToken(N)?{}:N,re=L.CancellationToken.isCancellationToken(N)?N:Q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=J.text||"";const ie=(0,M.getOrDefault)(J,pe=>pe.pageSize,50);let oe=new R().withFlags(a.IncludeLatestVersionOnly,a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,ie).withFilter(s.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,me,be)=>(oe=oe.withFilter(s.Category,be||me),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,me,be)=>(oe=oe.withFilter(s.Tag,be||me),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(s.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),oe=oe.withFilter(s.SearchText,le)),oe=oe.withSortBy(0)):J.ids?oe=oe.withFilter(s.ExtensionId,...J.ids):J.names?oe=oe.withFilter(s.ExtensionName,...J.names):oe=oe.withSortBy(4),typeof J.sortBy=="number"&&(oe=oe.withSortBy(J.sortBy)),typeof J.sortOrder=="number"&&(oe=oe.withSortOrder(J.sortOrder));const{galleryExtensions:ge,total:fe}=await this.queryGallery(oe,t,re),de=ge.map((pe,me)=>q(pe,me,oe,J.source,t)),Pe=async(pe,me)=>{if(me.isCancellationRequested)throw(0,k.canceled)();const be=oe.withPage(pe+1),{galleryExtensions:ke}=await this.queryGallery(be,t,me);return ke.map((Ae,Ue)=>q(Ae,Ue,be,J.source,t))};return{firstPage:de,total:fe,pageSize:oe.pageSize,getPage:Pe}}async queryGallery(N,Q,J){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,a.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,r(a.Unpublished));const re=await this.commonHeadersPromise,le=JSON.stringify(N.raw),ie={...re,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},oe=new Date().getTime();let ge,fe,de=0;try{if(ge=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:ie},J),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:de};const Pe=await(0,y.asJson)(ge);if(Pe){const pe=Pe.results[0],me=pe.extensions;me.forEach(ke=>O(ke.versions,Q));const be=pe.resultMetadata&&pe.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return de=be&&be.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:de}}return{galleryExtensions:[],total:de}}catch(Pe){throw fe=Pe,Pe}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-oe,success:!!ge&&(0,y.isSuccess)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:fe?(0,k.isPromiseCanceledError)(fe)?"canceled":(0,k.getErrorMessage)(fe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(N,Q,J,re){if(!this.isEnabled())return;const le=b.isWeb?this.api(`/itemName/${N}.${Q}/version/${J}/statType/${re==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${Q}/${J}/stats?statType=${re}`),ie=b.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.commonHeadersPromise,Accept:ie};try{await this.requestService.request({type:"POST",url:le,headers:ge},L.CancellationToken.None)}catch(fe){}}async download(N,Q,J){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const re=(0,E.getGalleryExtensionTelemetryData)(N),le=new Date().getTime(),ie=de=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...re,duration:de}),oe=J===1?"install":J===2?"update":"",ge=oe?{uri:`${N.assets.download.uri}${f.URI.parse(N.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${N.assets.download.fallbackUri}${f.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:N.assets.download,fe=await this.getAsset(ge);await this.fileService.writeFile(Q,fe.stream),ie(new Date().getTime()-le)}async getReadme(N,Q){if(N.assets.readme){const J=await this.getAsset(N.assets.readme,{},Q);return await(0,y.asText)(J)||""}return""}async getManifest(N,Q){if(N.assets.manifest){const J=await this.getAsset(N.assets.manifest,{},Q),re=await(0,y.asText)(J);return re?JSON.parse(re):null}return null}async getManifestFromRawExtensionVersion(N,Q){const J=K(N,l.Manifest);if(!J)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},le=await this.getAsset(J,{headers:re});return await(0,y.asJson)(le)}async getCoreTranslation(N,Q){const J=N.assets.coreTranslations.filter(re=>re[0]===Q.toUpperCase())[0];if(J){const re=await this.getAsset(J[1]),le=await(0,y.asText)(re);return le?JSON.parse(le):null}return null}async getChangelog(N,Q){if(N.assets.changelog){const J=await this.getAsset(N.assets.changelog,{},Q);return await(0,y.asText)(J)||""}return""}async getAllCompatibleVersions(N,Q){let J=new R().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?J=J.withFilter(s.ExtensionId,N.identifier.uuid):J=J.withFilter(s.ExtensionName,N.identifier.id);const{galleryExtensions:re}=await this.queryGallery(J,Q,L.CancellationToken.None);if(!re.length)return[];const le=H(re[0]);if((0,P.isNotWebExtensionInWebTargetPlatform)(le,Q))return[];const ie=[];for(const oe of re[0].versions)try{ie[ie.length-1]?.version!==oe.version&&await this.isRawExtensionVersionCompatible(oe,le,Q)&&ie.push({version:oe.version,date:oe.lastUpdated})}catch(ge){}return ie}async getAsset(N,Q={},J=L.CancellationToken.None){const re=await this.commonHeadersPromise,le={type:"GET"},ie={...re,...Q.headers||{}};Q={...Q,...le,headers:ie};const oe=N.uri,ge=N.fallbackUri,fe={...Q,url:oe};try{const de=await this.requestService.request(fe,J);if(de.res.statusCode===200)return de;const Pe=await(0,y.asText)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${Pe}`)}catch(de){if((0,k.isPromiseCanceledError)(de))throw de;const Pe=(0,k.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:oe,message:Pe});const pe={...Q,url:ge};return this.requestService.request(pe,J)}}async getEngine(N){let Q=_(N);if(!Q){const J=await this.getManifestFromRawExtensionVersion(N,L.CancellationToken.None);if(!J)throw new Error("Manifest was not found");Q=J.engines.vscode}return Q}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const Q=await(0,y.asJson)(N),J=new Map;if(Q)for(const re of Q.malicious){const le=J.get(re)||{id:{id:re},malicious:!0,slow:!1};le.malicious=!0,J.set(re,le)}return[...J.values()]}};A=ue([te(1,y.IRequestService),te(2,g.ILogService),te(3,i.IEnvironmentService),te(4,o.ITelemetryService),te(5,d.IFileService),te(6,I.IProductService),te(7,w.IConfigurationService)],A);let W=class extends A{constructor(N,Q,J,re,le,ie,oe,ge){super(N,Q,J,re,le,ie,oe,ge)}};W=ue([te(0,h.IStorageService),te(1,y.IRequestService),te(2,g.ILogService),te(3,i.IEnvironmentService),te(4,o.ITelemetryService),te(5,d.IFileService),te(6,I.IProductService),te(7,w.IConfigurationService)],W),e.ExtensionGalleryService=W;let z=class extends A{constructor(N,Q,J,re,le,ie,oe){super(void 0,N,Q,J,re,le,ie,oe)}};z=ue([te(0,y.IRequestService),te(1,g.ILogService),te(2,i.IEnvironmentService),te(3,o.ITelemetryService),te(4,d.IFileService),te(5,I.IProductService),te(6,w.IConfigurationService)],z),e.ExtensionGalleryServiceWithNoStorageService=z;async function X(U,N,Q,J,re,le){const ie={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U}`},oe=await(0,u.getServiceMachineId)(Q,re,le);return(0,c.getTelemetryLevel)(N,Q)>=2&&(0,c.getTelemetryConfiguration)(J)==="on"&&(ie["X-Market-User-Id"]=oe),ie}e.resolveMarketplaceHeaders=X}),define(Z[201],x([0,1,2,44,3,25,147,16,49,45,38,29,60]),function(V,e,p,L,k,M,b,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(I,y){this._configurationService=y,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appender=I.appender,this._commonProperties=I.commonProperties||Promise.resolve({}),this._piiPaths=I.piiPaths||[],this._userOptIn=!0,this._errorOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!I.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(u),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(u=>{const h=/^[a-f0-9]+$/i.test(u["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!h})})}setExperimentProperty(I,y){this._experimentProperties[I]=y}setEnabled(I){this._enabled=I}_updateUserOptIn(){const I=(0,E.getTelemetryConfiguration)(this._configurationService);this._errorOptIn=I!=="off",this._userOptIn=I==="on"}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const I=await this._commonProperties;let y=I.sessionID,u=I["common.instanceId"],h=I["common.machineId"],o=I["common.firstSessionDate"],c=I["common.msftInternal"];return{sessionId:y,instanceId:u,machineId:h,firstSessionDate:o,msftInternal:c}}dispose(){this._disposables.dispose()}publicLog(I,y,u){return this.isOptedIn?this._commonProperties.then(h=>{y=(0,L.mixin)(y,h),y=(0,L.mixin)(y,this._experimentProperties),y=(0,L.cloneAndChange)(y,o=>{if(typeof o=="string")return this._cleanupInfo(o,u)}),this._appender.log(I,y)},h=>{console.error(h)}):Promise.resolve(void 0)}publicLog2(I,y,u){return this.publicLog(I,y,u)}publicLogError(I,y){return!this.sendErrorTelemetry||!this._errorOptIn?Promise.resolve(void 0):this.publicLog(I,y,!0)}publicLogError2(I,y){return this.publicLogError(I,y)}_anonymizeFilePaths(I){let y=I;const u=[];for(let t of this._cleanupPatterns)for(;;){const a=t.exec(I);if(!a)break;u.push([a.index,t.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(y="";;){const t=o.exec(I);if(!t)break;!h.test(t[0])&&u.every(([a,r])=>t.index<a||t.index>=r)&&(y+=I.substring(c,t.index)+"<REDACTED: user-file-path>",c=o.lastIndex)}return c<I.length&&(y+=I.substr(c)),y}_removePropertiesWithPossibleUserInfo(I){if(!I)return I;const y=I.toLowerCase(),u=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(y)?"<REDACTED: secret>":u.test(y)?"<REDACTED: email>":I}_cleanupInfo(I,y){let u=I;y&&(u=this._anonymizeFilePaths(u));for(let h of this._cleanupPatterns)u=u.replace(h,"");return u=this._removePropertiesWithPossibleUserInfo(u),u}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=ue([te(1,n.IConfigurationService)],v),e.TelemetryService=v;const d=k.isWeb?"":" "+(0,b.localize)(0,null);i.Registry.as(f.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(1,null),properties:{[P.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,b.localize)(2,null),(0,b.localize)(3,null),(0,b.localize)(4,null)],markdownDescription:w.default.privacyStatementUrl?(0,b.localize)(6,null,w.default.nameLong,w.default.privacyStatementUrl)+d:(0,b.localize)(5,null,w.default.nameLong)+d,default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),i.Registry.as(f.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(7,null),properties:{[P.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,b.localize)(9,null,w.default.nameLong,w.default.privacyStatementUrl):(0,b.localize)(8,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,b.localize)(10,null,`\`#${P.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[202],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(Z[203],x([0,1,108,4,2,5,38,202]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var f;(function(I){function y(u){return u&&typeof u=="object"&&typeof u.id=="string"}I.isThemeColor=y})(f=e.ThemeColor||(e.ThemeColor={}));function w(I){return{id:I}}e.themeColorFromId=w;var i;(function(I){function y(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||f.isThemeColor(a.color))}I.isThemeIcon=y;const u=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function h(a){const r=u.exec(a);if(!r)return;let[,s]=r;return{id:s}}I.fromString=h;function o(a,r){let s=a.id;const l=s.lastIndexOf("~");return l!==-1&&(s=s.substring(0,l)),r&&(s=`${s}~${r}`),{id:s}}I.modify=o;function c(a,r){return a.id===r.id&&a.color?.id===r.color?.id}I.isEqual=c;function t(a,r){return{id:a.id,color:r?w(r):void 0}}I.asThemeIcon=t,I.asClassNameArray=p.CSSIcon.asClassNameArray,I.asClassName=p.CSSIcon.asClassName,I.asCSSSelector=p.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function P(I){switch(I){case n.ColorScheme.DARK:return"vs-dark";case n.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(y){return this.themingParticipants.push(y),this.onThemingParticipantAddedEmitter.fire(y),(0,k.toDisposable)(()=>{const u=this.themingParticipants.indexOf(y);this.themingParticipants.splice(u,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new E;b.Registry.add(e.Extensions.ThemingContribution,v);function d(I){return v.onColorThemeChange(I)}e.registerThemingParticipant=d;class g extends k.Disposable{constructor(y){super();this.themeService=y,this.theme=y.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(u=>this.onThemeChange(u)))}onThemeChange(y){this.theme=y,this.updateStyles()}updateStyles(){}getColor(y,u){let h=this.theme.getColor(y);return h&&u&&(h=u(h,this.theme)),h?h.toString():null}}e.Themable=g}),define(Z[61],x([0,1,14,3,5,39]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const b="#FFFFFF",n="#1E1E1E",f="#000000",w="theme",i="themeBackground",P="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let E=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return f;let d=this.stateMainService.getItem(i,null);if(!d){let g;(L.isWindows||L.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(w,"vs-dark").split(" ")[0],d=g==="hc-black"?f:g==="vs"?b:n}return L.isMacintosh&&d.toUpperCase()===n&&(d="#171717"),d}saveWindowSplash(d,g){this.stateMainService.setItems([{key:w,data:g.baseTheme},{key:i,data:g.colorInfo.background},{key:P,data:g}]),typeof d=="number"&&this.updateBackgroundColor(d,g)}updateBackgroundColor(d,g){for(const I of p.BrowserWindow.getAllWindows())if(I.id===d){I.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(P)}};E=ue([te(0,M.IStateMainService)],E),e.ThemeMainService=E}),define(Z[42],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L=e.StateType||(e.StateType={}));var k;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,b)=>({type:"idle",updateType:M,error:b}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(Z[204],x([0,1,3,148,49,38]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[205],x([0,1,4,42]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(n){this.service=n}listen(n,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=k;class M{constructor(n){this.channel=n,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(Z[97],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(Z[206],x([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(n){this.handler=n}listen(n,f){throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"handleURL":return this.handler.handleURL(p.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class k{constructor(n){this.channel=n}handleURL(n,f){return this.channel.call("handleURL",[n.toJSON(),f])}}e.URLHandlerChannelClient=k;class M{constructor(n){this.next=n}async routeCall(n,f,w,i){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(w){const P=p.URI.revive(w);if(P&&P.query){const E=/\bwindowId=(\d+)/.exec(P.query);if(E){const v=E[1],d=new RegExp(`window:${v}`),g=n.connections.find(I=>d.test(I.ctx));if(g)return g}}}return this.next.routeCall(n,f,w,i)}routeEvent(n,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=M}),define(Z[207],x([0,1,9,2,7,21]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class b extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(w,i){const P=[...this.handlers.values()];return(0,p.first)(P.map(E=>()=>E.handleURL(w,i)),void 0,!1).then(E=>E||!1)}registerHandler(w){return this.handlers.add(w),(0,L.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=b;let n=class extends b{constructor(w){super();this.productService=w}create(w){let{authority:i,path:P,query:E,fragment:v}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&P&&P.indexOf("/")!==0&&(P=`/${P}`),k.URI.from({scheme:this.productService.urlProtocol,authority:i,path:P,query:E,fragment:v})}};n=ue([te(0,M.IProductService)],n),e.NativeURLService=n}),define(Z[208],x([0,1,14,9,4,2,3,7]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(i){try{return n.URI.parse(i)}catch(P){return null}}class w{constructor(P,E,v,d,g){if(this.urlService=E,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=P,b.isWindows){const u=d.isBuilt?[]:[`"${d.appRoot}"`];u.push("--open-url","--"),p.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,u)}const I=k.Event.map(k.Event.fromNodeEventEmitter(p.app,"open-url",(u,h)=>({event:u,url:h})),({event:u,url:h})=>(u.preventDefault(),h));this.disposables.add(I(u=>{const h=f(u);!h||this.urlService.open(h,{originalUrl:u})})),v.getWindows().filter(u=>u.isReady).length>0?this.flush():k.Event.once(v.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const P=[];for(const E of this.uris)await this.urlService.open(E.uri,{originalUrl:E.url})||P.push(E);P.length!==0&&(this.uris=P,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(Z[209],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(Z[210],x([0,1,14,2,10,7]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class b extends L.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(k.Schemas.vscodeWebview,f)}handleWebviewRequest(f,w){try{const i=M.URI.parse(f.url),P=b.validWebviewFilePaths.get(i.path);if(typeof P=="string"){const E=`vs/workbench/contrib/webview/browser/pre/${P}`,v=k.FileAccess.asFileUri(E,V);return w(decodeURIComponent(v.fsPath))}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=b,b.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[62],x([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(w){return!!w.workspaceUri}e.isWorkspaceToOpen=L;function k(w){return!!w.folderUri}e.isFolderToOpen=k;function M(w){return!!w.fileUri}e.isFileToOpen=M;function b(w){const i=n(w),P=w.getValue("window.menuBarVisibility");return P==="default"||i==="native"&&P==="compact"||p.isMacintosh&&p.isNative?"classic":P}e.getMenuBarVisibility=b;function n(w){if(p.isWeb)return"custom";const i=w.getValue("window");if(i){if(p.isMacintosh&&i.nativeTabs===!0||p.isMacintosh&&i.nativeFullScreen===!1)return"native";const v=i.titleBarStyle;if(v==="native"||v==="custom")return v}return p.isLinux?"native":"custom"}e.getTitleBarStyle=n;function f(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=f}),define(Z[36],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(w){w[w.INITIAL=1]="INITIAL",w[w.LOAD=2]="LOAD",w[w.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var k;(function(w){w[w.CLOSE=1]="CLOSE",w[w.QUIT=2]="QUIT",w[w.RELOAD=3]="RELOAD",w[w.LOAD=4]="LOAD"})(k=e.UnloadReason||(e.UnloadReason={}));var M;(function(w){w[w.CLI=0]="CLI",w[w.DOCK=1]="DOCK",w[w.MENU=2]="MENU",w[w.DIALOG=3]="DIALOG",w[w.DESKTOP=4]="DESKTOP",w[w.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const b=function(w=1){return{width:1024,height:768,mode:w}};e.defaultWindowState=b;var n;(function(w){w[w.Maximized=0]="Maximized",w[w.Normal=1]="Normal",w[w.Minimized=2]="Minimized",w[w.Fullscreen=3]="Fullscreen"})(n=e.WindowMode||(e.WindowMode={}));var f;(function(w){w[w.UNRESPONSIVE=1]="UNRESPONSIVE",w[w.CRASHED=2]="CRASHED",w[w.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(Z[211],x([0,1,14,4,2,210,36]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let n=class extends k.Disposable{constructor(w){super();this.windowsMainService=w,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,i){let P;if(typeof w.windowId=="number"){const{windowId:E}=w,v=this.windowsMainService.getWindowById(E);if(!v?.win)throw new Error(`Invalid windowId: ${E}`);P=v.win.webContents}else{const{webContentsId:E}=w;if(P=p.webContents.fromId(E),!P)throw new Error(`Invalid webContentsId: ${E}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(i)}async findInFrame(w,i,P,E){const v=this.getFrameByName(w,i),d=v;if(typeof d.findInFrame=="function"){d.findInFrame(P,{findNext:E.findNext,forward:E.forward});const g=(I,y)=>{y.finalUpdate&&(this._onFoundInFrame.fire(y),v.removeListener("found-in-frame",g))};v.on("found-in-frame",g)}}async stopFindInFrame(w,i,P){const v=this.getFrameByName(w,i);typeof v.stopFindInFrame=="function"&&v.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,i){const P=this.windowsMainService.getWindowById(w.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${w}`);const E=P.win.webContents.mainFrame.framesInSubtree.find(v=>v.name===i);if(!E)throw new Error(`Unknown frame: ${i}`);return E}};n=ue([te(0,b.IWindowsMainService)],n),e.WebviewMainService=n}),define(Z[212],x([0,1,9,4,2]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends k.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:f,getActiveWindowId:w}){super();this.disposables=this._register(new k.DisposableStore),L.Event.latch(L.Event.any(n,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>w()),(async()=>{try{const P=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:P}catch(P){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(Z[213],x([0,1,37,15,7,5]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var b;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(b=e.WorkbenchState||(e.WorkbenchState={}));function n(E){const v=E;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=n;function f(E){const v=E;return!!(v&&typeof v=="object"&&k.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=f;class w{constructor(v,d,g,I){this._id=v,this._configuration=g,this._ignorePathCasing=I,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(v){this._id=v.id,this._configuration=v.configuration,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v.with({scheme:v.scheme,authority:v.authority,path:v.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=w;class i{constructor(v,d){this.raw=d,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,L.joinPath)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function P(E){return new i({uri:E,index:0,name:(0,L.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=P}),define(Z[27],x([0,1,31,40,77,34,10,8,3,15,7,151,5,74,213]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(_){return(typeof _=="string"?(0,n.extname)(_):(0,w.extname)(_))===g}e.hasWorkspaceFileExtension=I,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function y(_){return _.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function u(_){return _.hasOwnProperty("folderUri")}e.isRecentFolder=u;function h(_){return _.hasOwnProperty("fileUri")}e.isRecentFile=h;function o(_){const j=_;return typeof j?.id=="string"&&i.URI.isUri(j.uri)}e.isSingleFolderWorkspaceIdentifier=o;function c(_){if(_.configuration)return{id:_.id,configPath:_.configuration};if(_.folders.length===1)return{id:_.id,uri:_.folders[0].uri}}e.toWorkspaceIdentifier=c;function t(_){const j=_;return typeof j?.id=="string"&&i.URI.isUri(j.configPath)}e.isWorkspaceIdentifier=t;function a(_){const j=_;if(j?.uri)return{id:j.id,uri:i.URI.revive(j.uri)};const $=_;if($?.configPath)return{id:$.id,configPath:i.URI.revive($.configPath)};if(_?.id)return{id:_.id}}e.reviveIdentifier=a;function r(_,j){return w.extUriBiasedIgnorePathCase.isEqualOrParent(_,j.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function s(_){return l(_)||m(_)}e.isStoredWorkspaceFolder=s;function l(_){const j=_;return typeof j?.path=="string"&&(!j.name||typeof j.name=="string")}e.isRawFileWorkspaceFolder=l;function m(_){const j=_;return typeof j?.uri=="string"&&(!j.name||typeof j.name=="string")}e.isRawUriWorkspaceFolder=m;function S(_,j,$,B,H=!f.isWindows,O){if(_.scheme!==B.scheme)return{name:$,uri:_.toString(!0)};let q=j?void 0:O.relativePath(B,_);if(q!==void 0)q.length===0?q=".":f.isWindows&&_.scheme===b.Schemas.file&&!H&&(q=q.replace(/\//g,"\\"));else if(_.scheme===b.Schemas.file)q=_.fsPath,f.isWindows&&(q=(0,M.normalizeDriveLetter)(q),H&&(q=(0,p.toSlashes)(q)));else{if(!O.isEqualAuthority(_.authority,B.authority))return{name:$,uri:_.toString(!0)};q=_.path}return{name:$,path:q}}e.getStoredWorkspaceFolder=S;function D(_,j,$){let B=[],H=new Set;const O=$.dirname(j);for(let q of _){let T;if(l(q))q.path&&(T=$.resolvePath(O,q.path));else if(m(q))try{T=i.URI.parse(q.uri),T.path[0]!=="/"&&(T=T.with({path:"/"+T.path}))}catch(A){console.warn(A)}if(T){let A=$.getComparisonKey(T);if(!H.has(A)){H.add(A);const W=q.name||$.basenameOrAuthority(T);B.push(new d.WorkspaceFolder({uri:T,name:W,index:B.length},q))}}}return B}e.toWorkspaceFolders=D;function R(_,j,$,B,H){let O=F(j,_);const q=H.dirname(j),T=H.dirname(B),A=[],W=C(O.folders);for(const N of O.folders){const Q=l(N)?H.resolvePath(q,N.path):i.URI.parse(N.uri);let J;$?J=!1:J=!l(N)||(0,n.isAbsolute)(N.path),A.push(S(Q,J,N.name,T,W,H))}const z={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},X=k.setProperty(_,["folders"],A,z);let U=k.applyEdits(_,X);return O.remoteAuthority===(0,v.getRemoteAuthority)(B)&&(U=k.applyEdits(U,k.removeProperty(U,["remoteAuthority"],z))),U}e.rewriteWorkspaceFileForNewLocation=R;function F(_,j){let $=L.parse(j);if($&&Array.isArray($.folders))$.folders=$.folders.filter(B=>s(B));else throw new Error(`${_} looks like an invalid workspace file.`);return $}function C(_){return f.isWindows?_.some(j=>l(j)&&j.path.indexOf("/")>=0):!0}e.useSlashForPath=C;function G(_){return _.workspace&&typeof _.workspace=="object"&&typeof _.workspace.id=="string"&&typeof _.workspace.configPath=="string"}function ne(_){return typeof _.folderUri=="string"}function ae(_){return typeof _.fileUri=="string"}function K(_,j){const $={workspaces:[],files:[]};if(_){const B=function(O,q){for(let T=0;T<O.length;T++)try{q(O[T],T)}catch(A){j.warn(`Error restoring recent entry ${JSON.stringify(O[T])}: ${A.toString()}. Skip entry.`)}},H=_;if(Array.isArray(H.entries))B(H.entries,O=>{const q=O.label,T=O.remoteAuthority;G(O)?$.workspaces.push({label:q,remoteAuthority:T,workspace:{id:O.workspace.id,configPath:i.URI.parse(O.workspace.configPath)}}):ne(O)?$.workspaces.push({label:q,remoteAuthority:T,folderUri:i.URI.parse(O.folderUri)}):ae(O)&&$.files.push({label:q,remoteAuthority:T,fileUri:i.URI.parse(O.fileUri)})});else{const O=_;Array.isArray(O.workspaces3)&&B(O.workspaces3,(q,T)=>{const A=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[T]||void 0;typeof q=="object"&&typeof q.id=="string"&&typeof q.configURIPath=="string"?$.workspaces.push({label:A,workspace:{id:q.id,configPath:i.URI.parse(q.configURIPath)}}):typeof q=="string"&&$.workspaces.push({label:A,folderUri:i.URI.parse(q)})}),Array.isArray(O.files2)&&B(O.files2,(q,T)=>{const A=Array.isArray(O.fileLabels)&&O.fileLabels[T]||void 0;typeof q=="string"&&$.files.push({label:A,fileUri:i.URI.parse(q)})})}}return $}e.restoreRecentlyOpened=K;function ee(_){const j={entries:[]};for(const $ of _.workspaces)u($)?j.entries.push({folderUri:$.folderUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority}):j.entries.push({workspace:{id:$.workspace.id,configPath:$.workspace.configPath.toString()},label:$.label,remoteAuthority:$.remoteAuthority});for(const $ of _.files)j.entries.push({fileUri:$.fileUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority});return j}e.toStoreData=ee}),define(Z[51],x([0,1,5,27]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService");function k(M){const b=M;return b&&(0,L.isWorkspaceIdentifier)(b.workspace)}e.isWorkspaceBackupInfo=k}),define(Z[52],x([0,1,14,9,79,34,2,66,8,3,13,19,133,5,6,39,27]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,v.createDecorator)("dialogMainService");let y=class gt{constructor(h,o){this.stateMainService=h,this.logService=o,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(h,o){return this.doPick({...h,pickFolders:!0,pickFiles:!0,title:(0,E.localize)(0,null)},o)}pickFolder(h,o){return this.doPick({...h,pickFolders:!0,title:(0,E.localize)(1,null)},o)}pickFile(h,o){return this.doPick({...h,pickFiles:!0,title:(0,E.localize)(2,null)},o)}pickWorkspace(h,o){const c=(0,E.localize)(3,null),t=(0,M.mnemonicButtonLabel)((0,E.localize)(4,null)),a=I.WORKSPACE_FILTER;return this.doPick({...h,pickFiles:!0,title:c,filters:a,buttonLabel:t},o)}async doPick(h,o){const c={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters};c.defaultPath=h.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(c.properties=void 0,h.pickFiles&&h.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&c.properties.push("treatPackageAsDirectory");const t=o||p.BrowserWindow.getFocusedWindow(),a=await this.showOpenDialog(c,(0,i.withNullAsUndefined)(t));if(a&&a.filePaths&&a.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,f.dirname)(a.filePaths[0])),a.filePaths}getWindowDialogQueue(h){if(h){let o=this.windowDialogQueues.get(h.id);return o||(o=new L.Queue,this.windowDialogQueues.set(h.id,o)),o}else return this.noWindowDialogueQueue}showMessageBox(h,o){return this.getWindowDialogQueue(o).queue(async()=>o?p.dialog.showMessageBox(o,h):p.dialog.showMessageBox(h))}async showSaveDialog(h,o){const c=this.acquireFileDialogLock(h,o);if(!c)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(o).queue(async()=>{let t;return o?t=await p.dialog.showSaveDialog(o,h):t=await p.dialog.showSaveDialog(h),t.filePath=this.normalizePath(t.filePath),t})}finally{(0,b.dispose)(c)}}normalizePath(h){return h&&w.isMacintosh&&(h=(0,n.normalizeNFC)(h)),h}normalizePaths(h){return h.map(o=>this.normalizePath(o))}async showOpenDialog(h,o){h.defaultPath&&(await P.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const c=this.acquireFileDialogLock(h,o);if(!c)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(o).queue(async()=>{let t;return o?t=await p.dialog.showOpenDialog(o,h):t=await p.dialog.showOpenDialog(h),t.filePaths=this.normalizePaths(t.filePaths),t})}finally{(0,b.dispose)(c)}}acquireFileDialogLock(h,o){if(!o)return b.Disposable.None;let c=this.windowFileDialogLocks.get(o.id);c||(c=new Set,this.windowFileDialogLocks.set(o.id,c));const t=(0,k.hash)(h);if(!c.has(t))return c.add(t),(0,b.toDisposable)(()=>{c?.delete(t),c?.size===0&&this.windowFileDialogLocks.delete(o.id)})}};y.workingDirPickerStorageKey="pickerWorkingDir",y=ue([te(0,g.IStateMainService),te(1,d.ILogService)],y),e.DialogMainService=y}),define(Z[214],x([0,1,4,2,27]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{constructor(n,f){super();this.logService=n,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,f)=>(n?n.push(f):n=[f],n),M.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const f=new Map,w=new Set;return n.forEach(i=>{const P=this.storageMainService.globalStorage.get(i.key);typeof P=="string"?f.set(i.key,P):w.add(i.key)}),{changed:Array.from(f.entries()),deleted:Array.from(w.values())}}listen(n,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(n,f,w){const i=(0,k.reviveIdentifier)(w.workspace),P=await this.withStorageInitialized(i);switch(f){case"getItems":return Array.from(P.items.entries());case"updateItems":{const E=w;if(E.insert)for(const[v,d]of E.insert)P.set(v,d);E.delete&&E.delete.forEach(v=>P.delete(v));break}case"close":{if(i)return P.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(n){const f=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await f.init()}catch(w){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${w}`)}return f}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[215],x([0,1,4,2,8,28,19,85,123,6,96,29,27]),function(V,e,p,L,k,M,b,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class v extends L.Disposable{constructor(y){super();this.logService=y,this._onDidChangeStorage=this._register(new p.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new p.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const y=await this.doCreate();this.storage.dispose(),this.storage=y,this._register(y.onDidChangeStorage(h=>this._onDidChangeStorage.fire({key:h}))),await this.doInit(y);const u=y.getBoolean(i.IS_NEW_KEY);u===void 0?y.set(i.IS_NEW_KEY,!0):u&&y.set(i.IS_NEW_KEY,!1)}catch(y){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${y}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?y=>this.logService.trace(y):void 0,logError:y=>this.logService.error(y)}}doInit(y){return y.init()}get items(){return this.storage.items}get(y,u){return this.storage.get(y,u)}set(y,u){return this.storage.set(y,u)}delete(y){return this.storage.delete(y)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class d extends v{constructor(y,u,h){super(u);this.options=y,this.environmentService=h}async doCreate(){let y;return this.options.useInMemoryStorage?y=f.SQLiteStorageDatabase.IN_MEMORY_PATH:y=(0,k.join)(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new n.Storage(new f.SQLiteStorageDatabase(y,{logging:this.createLoggingOptions()}))}async doInit(y){await super.doInit(y),this.updateTelemetryState(y)}updateTelemetryState(y){y.get(P.instanceStorageKey,void 0)===void 0&&y.set(P.instanceStorageKey,(0,M.generateUuid)()),y.get(P.firstSessionDateStorageKey,void 0)===void 0&&y.set(P.firstSessionDateStorageKey,new Date().toUTCString());const o=y.get(P.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();y.set(P.lastSessionDateStorageKey,typeof o=="undefined"?null:o),y.set(P.currentSessionDateStorageKey,c)}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class g extends v{constructor(y,u,h,o){super(h);this.workspace=y,this.options=u,this.environmentService=o}async doCreate(){const{storageFilePath:y,wasCreated:u}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new f.SQLiteStorageDatabase(y,{logging:this.createLoggingOptions()}),{hint:u?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const y=(0,k.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),u=(0,k.join)(y,g.WORKSPACE_STORAGE_NAME);return await b.Promises.exists(y)?{storageFilePath:u,wasCreated:!1}:(await b.Promises.mkdir(y,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(y),{storageFilePath:u,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(y){let u;if((0,E.isSingleFolderWorkspaceIdentifier)(this.workspace)?u={folder:this.workspace.uri.toString()}:(0,E.isWorkspaceIdentifier)(this.workspace)&&(u={workspace:this.workspace.configPath.toString()}),u)try{const h=(0,k.join)(y,g.WORKSPACE_META_NAME);await b.Promises.exists(h)||await b.Promises.writeFile(h,JSON.stringify(u,void 0,2))}catch(h){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(Z[98],x([0,1,43,2,48,5,22,6,215]),function(V,e,p,L,k,M,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let w=class extends L.Disposable{constructor(P,E,v){super();this.logService=P,this.environmentService=E,this.lifecycleMainService=v,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async P=>{P.workspace&&this.workspaceStorage(P.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(P=>{P.join(this.globalStorage.close());for(const[,E]of this.mapWorkspaceToStorage)P.join(E.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const P=new f.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(P.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),P}createWorkspaceStorage(P){return new f.WorkspaceStorageMain(P,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(P){let E=this.mapWorkspaceToStorage.get(P.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${P.id})`),E=this.createWorkspaceStorage(P),this.mapWorkspaceToStorage.set(P.id,E),(0,p.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${P.id})`),this.mapWorkspaceToStorage.delete(P.id)})),E}};w=ue([te(0,n.ILogService),te(1,k.IEnvironmentService),te(2,b.ILifecycleMainService)],w),e.StorageMainService=w}),define(Z[99],x([0,1,15,7,27]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(f,w,i){for(const E of f){const v=E.openedWorkspace;if((0,k.isWorkspaceIdentifier)(v)){const d=i(v);if(d){if(d.folders.some(g=>p.extUriBiasedIgnorePathCase.isEqualOrParent(w,g.uri)))return E}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(w,v.configPath))return E}}const P=f.filter(E=>(0,k.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(w,E.openedWorkspace.uri));if(P.length)return P.sort((E,v)=>-(E.openedWorkspace.uri.path.length-v.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function b(f,w){for(const i of f)if((0,k.isWorkspaceIdentifier)(i.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,w)||(0,k.isSingleFolderWorkspaceIdentifier)(i.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,w))return i}e.findWindowOnWorkspaceOrFolder=b;function n(f,w){const i=P=>w.some(E=>p.extUriBiasedIgnorePathCase.isEqual(L.URI.file(E),L.URI.file(P)));for(const P of f)if(P.config?.extensionDevelopmentPath?.some(E=>i(E)))return P}e.findWindowOnExtensionDevelopmentPath=n}),define(Z[216],x([0,1,14,2,3,15,7,16,22,6,39,36,27]),function(V,e,p,L,k,M,b,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let v=class mt extends L.Disposable{constructor(h,o,c,t,a){super();this.windowsMainService=h,this.stateMainService=o,this.lifecycleMainService=c,this.logService=t,this.configurationService=a,this._state=d(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(a=>!a.isExtensionDevelopmentHost)),t&&(h.lastActiveWindow=this.toWindowState(t))}const o=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const c=I(h);this.stateMainService.setItem(mt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(c=>{const t=(0,E.isWorkspaceIdentifier)(h.openedWorkspace)&&c.workspace?.id===h.openedWorkspace.id,a=(0,E.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&c.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(c.folderUri,h.openedWorkspace.uri);(t||a)&&(c.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(h){return{workspace:(0,E.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,E.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const o=this.doGetNewWindowState(h),c=this.configurationService.getValue("window");let t;return o.hasDefaultState?t=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||c?.restoreFullscreen),t&&k.isMacintosh&&this.windowsMainService.getWindows().some(a=>a.isFullScreen)&&(t=!1)),o.mode===3&&!t&&(o.mode=1),o}doGetNewWindowState(h){const o=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=h.workspace;if((0,E.isWorkspaceIdentifier)(l)){const S=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===l.id).map(D=>D.uiState);if(S.length)return S[0]}if((0,E.isSingleFolderWorkspaceIdentifier)(l)){const S=this.state.openedWindows.filter(D=>D.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(D.folderUri,l.uri)).map(D=>D.uiState);if(S.length)return S[0]}else if(h.backupPath){const S=this.state.openedWindows.filter(D=>D.backupPath===h.backupPath).map(D=>D.uiState);if(S.length)return S[0]}const m=this.lastClosedState||this.state.lastActiveWindow;if(!o&&m)return m.uiState}let c;const t=p.screen.getAllDisplays();if(t.length===1)c=t[0];else{if(k.isMacintosh){const l=p.screen.getCursorScreenPoint();c=p.screen.getDisplayNearestPoint(l)}!c&&o&&(c=p.screen.getDisplayMatching(o.getBounds())),c||(c=p.screen.getPrimaryDisplay()||t[0])}let a=(0,P.defaultWindowState)();a.x=Math.round(c.bounds.x+c.bounds.width/2-a.width/2),a.y=Math.round(c.bounds.y+c.bounds.height/2-a.height/2);const r=this.configurationService.getValue("window");let s=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")a.mode=0,s=!1;else if(r.newWindowDimensions==="fullscreen")a.mode=3,s=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&o){const l=o.serializeWindowState();l.mode===3?a.mode=3:a=l,s=a.mode!==3&&r.newWindowDimensions==="offset"}}return s&&(a=this.ensureNoOverlap(a)),a.hasDefaultState=!0,a}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const o=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;o.some(c=>c.x===h.x||c.y===h.y);)h.x+=30,h.y+=30;return h}};v.windowsStateStorageKey="windowsState",v=ue([te(0,P.IWindowsMainService),te(1,i.IStateMainService),te(2,f.ILifecycleMainService),te(3,w.ILogService),te(4,n.IConfigurationService)],v),e.WindowsStateHandler=v;function d(u){const h={openedWindows:[]},o=u||{openedWindows:[]};return o.lastActiveWindow&&(h.lastActiveWindow=g(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=g(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(h.openedWindows=o.openedWindows.map(c=>g(c))),h}e.restoreWindowsState=d;function g(u){const h={uiState:u.uiState};return u.backupPath&&(h.backupPath=u.backupPath),u.remoteAuthority&&(h.remoteAuthority=u.remoteAuthority),u.folder&&(h.folderUri=b.URI.parse(u.folder)),u.workspaceIdentifier&&(h.workspace={id:u.workspaceIdentifier.id,configPath:b.URI.parse(u.workspaceIdentifier.configURIPath)}),h}function I(u){return{lastActiveWindow:u.lastActiveWindow&&y(u.lastActiveWindow),lastPluginDevelopmentHostWindow:u.lastPluginDevelopmentHostWindow&&y(u.lastPluginDevelopmentHostWindow),openedWindows:u.openedWindows.map(h=>y(h))}}e.getWindowsStateStoreData=I;function y(u){return{workspaceIdentifier:u.workspace&&{id:u.workspace.id,configURIPath:u.workspace.configPath.toString()},folder:u.folderUri&&u.folderUri.toString(),backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.uiState}}}),define(Z[100],x([0,1,58,32,10,3,15]),function(V,e,p,L,k,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(w){function i(){let P=w.scheme===k.Schemas.file?(0,b.originalFSPath)(w):w.toString();return M.isLinux||(P=P.toLowerCase()),(0,p.createHash)("md5").update(P).digest("hex")}return{id:i(),configPath:w}}e.getWorkspaceIdentifier=n;function f(w,i){function P(){if(w.scheme!==k.Schemas.file)return(0,p.createHash)("md5").update(w.toString()).digest("hex");if(!i)try{i=(0,L.statSync)(w.fsPath)}catch(d){return}let v;return M.isLinux?v=i.ino:M.isMacintosh?v=i.birthtime.getTime():M.isWindows&&(typeof i.birthtimeMs=="number"?v=Math.floor(i.birthtimeMs):v=i.birthtime.getTime()),(0,p.createHash)("md5").update(w.fsPath).update(v?String(v):"").digest("hex")}const E=P();if(typeof E=="string")return{id:E,uri:w}}e.getSingleFolderWorkspaceIdentifier=f}),define(Z[56],x([0,1,58,59,26,18,17,4,2,8,3,28,35,83,217]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(S){this.socket=S,this._errorListener=D=>{if(D){if(D.code==="EPIPE")return;(0,b.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(S){const D=R=>S(M.VSBuffer.wrap(R));return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(S){const D=R=>{S({type:0,hadError:R,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(S){return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(S){if(!this.socket.destroyed)try{this.socket.write(S.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,b.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,b.onUnexpectedError)(D)}}end(){this.socket.end()}drain(){return new Promise((S,D)=>{if(this.socket.bufferSize===0){S();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),S()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=g;var I;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(I||(I={}));var y;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(y||(y={}));class u extends f.Disposable{constructor(S,D,R,F){super();this._onDidZlibFlush=this._register(new n.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new n.Emitter),this._onClose=this._register(new n.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=S,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=D,this._recordInflateBytes=F,D?(this._zlibInflate=d.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",C=>{console.error(C),(0,b.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibInflate.on("data",C=>{this._pendingInflateData.push(C)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",C=>{console.error(C),(0,b.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibDeflate.on("data",C=>{this._pendingDeflateData.push(C)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new v.ChunkStream,this._register(this.socket.onData(C=>this._acceptChunk(C))),this._register(this.socket.onClose(C=>this._onClose.fire(C)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):M.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this._onData.event(S)}onClose(S){return this._onClose.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){this._totalOutgoingDataBytes+=S.byteLength,this._zlibDeflate?(this._zlibDeflate.write(S.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let D=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.length-4),this._isEnded||this._write(M.VSBuffer.wrap(D),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(S,!1)}_write(S,D){let R=2;S.byteLength<126?R+=0:S.byteLength<2**16?R+=2:R+=8;const F=M.VSBuffer.alloc(R);if(D?F.writeUInt8(194,0):F.writeUInt8(130,0),S.byteLength<126)F.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){F.writeUInt8(126,1);let C=1;F.writeUInt8(S.byteLength>>>8&255,++C),F.writeUInt8(S.byteLength>>>0&255,++C)}else{F.writeUInt8(127,1);let C=1;F.writeUInt8(0,++C),F.writeUInt8(0,++C),F.writeUInt8(0,++C),F.writeUInt8(0,++C),F.writeUInt8(S.byteLength>>>24&255,++C),F.writeUInt8(S.byteLength>>>16&255,++C),F.writeUInt8(S.byteLength>>>8&255,++C),F.writeUInt8(S.byteLength>>>0&255,++C)}this._totalOutgoingWireBytes+=F.byteLength+S.byteLength,this.socket.write(M.VSBuffer.concat([F,S]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(S){if(S.byteLength!==0){for(this._totalIncomingWireBytes+=S.byteLength,this._incomingData.acceptChunk(S);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),F=(D.readUInt8(0)&128)>>>7,C=D.readUInt8(1),G=(C&128)>>>7,ne=C&127;this._state.state=2,this._state.readLen=2+(G?4:0)+(ne===126?2:0)+(ne===127?8:0),this._state.fin=F,this._state.mask=0}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),R=D.readUInt8(1),F=(R&128)>>>7;let C=R&127,G=1;C===126?C=D.readUInt8(++G)*2**8+D.readUInt8(++G):C===127&&(C=D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*2**24+D.readUInt8(++G)*2**16+D.readUInt8(++G)*2**8+D.readUInt8(++G));let ne=0;F&&(ne=D.readUInt8(++G)*2**24+D.readUInt8(++G)*2**16+D.readUInt8(++G)*2**8+D.readUInt8(++G)),this._state.state=3,this._state.readLen=C,this._state.mask=ne}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);h(D,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(D.buffer)),this._zlibInflate.write(D.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(M.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=D.byteLength,this._onData.fire(D))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await n.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=u;function h(m,S){if(S===0)return;let D=m.byteLength>>>2;for(let ae=0;ae<D;ae++){const K=m.readUInt32BE(ae*4);m.writeUInt32BE(K^S,ae*4)}let R=D*4,F=m.byteLength-R;const C=S>>>24&255,G=S>>>16&255,ne=S>>>8&255;F>=1&&m.writeUInt8(m.readUInt8(R)^C,R),F>=2&&m.writeUInt8(m.readUInt8(R+1)^G,R+1),F>=3&&m.writeUInt8(m.readUInt8(R+2)^ne,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function c(){const m=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let S;return e.XDG_RUNTIME_DIR?S=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):S=(0,w.join)((0,k.tmpdir)(),`vscode-ipc-${m}.sock`),a(S),S}e.createRandomIPCHandle=c;function t(m,S,D){const R=(0,p.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${D}-${S}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${D}-${S}.sock`):F=(0,w.join)(m,`${D}-${S}.sock`),a(F),F}e.createStaticIPCHandle=t;function a(m){const S=o[i.platform];typeof S=="number"&&m.length>=S&&console.warn(`WARNING: IPC handle "${m}" is longer than ${S} chars, try a shorter --user-data-dir`)}class r extends E.IPCServer{constructor(S){super(r.toClientConnectionEvent(S));this.server=S}static toClientConnectionEvent(S){const D=n.Event.fromNodeEventEmitter(S,"connection");return n.Event.map(D,R=>({protocol:new v.Protocol(new g(R)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function s(m){return new Promise((S,D)=>{const R=(0,L.createServer)();R.on("error",D),R.listen(m,()=>{R.removeListener("error",D),S(new r(R))})})}e.serve=s;function l(m,S){return new Promise((D,R)=>{const F=(0,L.createConnection)(m,()=>{F.removeListener("error",R),D(v.Client.fromSocket(new g(F),S))});F.once("error",R)})}e.connect=l}),define(Z[218],x([0,1,56]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(f){this.driver=f}listen(f,w){throw new Error("No event found")}call(f,w,i){switch(w){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(i);case"getLocalizedStrings":return this.driver.getLocalizedStrings(i)}throw new Error(`Call not found: ${w}`)}}e.DriverChannel=L;class k{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,w){return this.channel.call("dispatchKeybinding",[f,w])}click(f,w,i,P){return this.channel.call("click",[f,w,i,P])}doubleClick(f,w){return this.channel.call("doubleClick",[f,w])}setValue(f,w,i){return this.channel.call("setValue",[f,w,i])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,w){return this.channel.call("isActiveElement",[f,w])}getElements(f,w,i){return this.channel.call("getElements",[f,w,i])}getElementXY(f,w,i,P){return this.channel.call("getElementXY",[f,w,i,P])}typeInEditor(f,w,i){return this.channel.call("typeInEditor",[f,w,i])}getTerminalBuffer(f,w){return this.channel.call("getTerminalBuffer",[f,w])}writeInTerminal(f,w,i){return this.channel.call("writeInTerminal",[f,w,i])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=k;class M{constructor(f){this.registry=f}listen(f,w){throw new Error(`Event not found: ${w}`)}call(f,w,i){switch(w){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${w}`)}}e.WindowDriverRegistryChannel=M;async function b(n){const f=await(0,p.connect)(n,"driverClient"),w=f.getChannel("driver"),i=new k(w);return{client:f,driver:i}}e.connect=b}),define(Z[219],x([0,1,9,4,106,57,2,3,78,35,56,155,218,176,22,36]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function I(h){return h<21}let y=class{constructor(o,c,t,a){this.windowServer=o,this.options=c,this.windowsMainService=t,this.lifecycleMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(o){return this.registeredWindowIds.add(o),this.reloadingWindowIds.delete(o),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(o){this.reloadingWindowIds.add(o)}async getWindowIds(){return this.windowsMainService.getWindows().map(o=>o.id).filter(o=>this.registeredWindowIds.has(o)&&!this.reloadingWindowIds.has(o))}async capturePage(o){await this.whenUnfrozen(o);const c=this.windowsMainService.getWindowById(o);if(!c?.win)throw new Error("Invalid window");return(await c.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(o){await this.whenUnfrozen(o);const c=this.windowsMainService.getWindowById(o);if(!c)throw new Error("Invalid window");this.reloadingWindowIds.add(o),this.lifecycleMainService.reload(c)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(o,c){await this.whenUnfrozen(o);const t=k.KeybindingParser.parseUserBinding(c);for(let a of t)await this._dispatchKeybinding(o,a)}async _dispatchKeybinding(o,c){if(c instanceof f.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const t=this.windowsMainService.getWindowById(o);if(!t?.win)throw new Error("Invalid window");const a=t.win.webContents,r=new M.SimpleKeybinding(!1,!1,!1,!1,c.keyCode),l=new v.USLayoutResolvedKeybinding(r.toChord(),n.OS).getElectronAccelerator(),m=[];c.ctrlKey&&m.push("ctrl"),c.metaKey&&m.push("meta"),c.shiftKey&&m.push("shift"),c.altKey&&m.push("alt"),a.sendInputEvent({type:"keyDown",keyCode:l,modifiers:m}),I(c.keyCode)||a.sendInputEvent({type:"char",keyCode:l,modifiers:m}),a.sendInputEvent({type:"keyUp",keyCode:l,modifiers:m}),await(0,p.timeout)(100)}async click(o,c,t,a){await(await this.getWindowDriver(o)).click(c,t,a)}async doubleClick(o,c){await(await this.getWindowDriver(o)).doubleClick(c)}async setValue(o,c,t){await(await this.getWindowDriver(o)).setValue(c,t)}async getTitle(o){return await(await this.getWindowDriver(o)).getTitle()}async isActiveElement(o,c){return await(await this.getWindowDriver(o)).isActiveElement(c)}async getElements(o,c,t){return await(await this.getWindowDriver(o)).getElements(c,t)}async getElementXY(o,c,t,a){return await(await this.getWindowDriver(o)).getElementXY(c,t,a)}async typeInEditor(o,c,t){await(await this.getWindowDriver(o)).typeInEditor(c,t)}async getTerminalBuffer(o,c){return await(await this.getWindowDriver(o)).getTerminalBuffer(c)}async writeInTerminal(o,c,t){await(await this.getWindowDriver(o)).writeInTerminal(c,t)}async getLocaleInfo(o){return await(await this.getWindowDriver(o)).getLocaleInfo()}async getLocalizedStrings(o){return await(await this.getWindowDriver(o)).getLocalizedStrings()}async getWindowDriver(o){await this.whenUnfrozen(o);const c=`window:${o}`,t=new w.StaticRouter(r=>r===c),a=this.windowServer.getChannel("windowDriver",t);return new P.WindowDriverChannelClient(a)}async whenUnfrozen(o){for(;this.reloadingWindowIds.has(o);)await L.Event.toPromise(this.onDidReloadingChange.event)}};y=ue([te(2,g.IWindowsMainService),te(3,d.ILifecycleMainService)],y),e.Driver=y;async function u(h,o,c,t){const a=c.driverVerbose,r=t.createInstance(y,h,{verbose:a}),s=new E.WindowDriverRegistryChannel(r);h.registerChannel("windowDriverRegistry",s);const l=await(0,i.serve)(o),m=new E.DriverChannel(r);return l.registerChannel("driver",m),(0,b.combinedDisposable)(l,h)}e.serve=u}),define(Z[24],x([0,1,47,8,56,48,160,5]),function(V,e,p,L,k,M,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,n.refineServiceDecorator)(M.IEnvironmentService);class f extends b.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ue([p.memoize],f.prototype,"cachedLanguagesPath",null),ue([p.memoize],f.prototype,"backupHome",null),ue([p.memoize],f.prototype,"backupWorkspacesPath",null),ue([p.memoize],f.prototype,"mainIPCHandle",null),ue([p.memoize],f.prototype,"mainLockfile",null),ue([p.memoize],f.prototype,"sandbox",null),ue([p.memoize],f.prototype,"driverVerbose",null),ue([p.memoize],f.prototype,"disableUpdates",null),ue([p.memoize],f.prototype,"disableKeytar",null),ue([p.memoize],f.prototype,"codeCachePath",null),ue([p.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(Z[220],x([0,1,58,32,31,10,8,3,15,7,19,51,16,24,20,6,27]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let y=class{constructor(h,o,c){this.configurationService=o,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,a)=>(0,k.isEqual)(t,a,!n.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await i.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let o=[];try{Array.isArray(h.rootURIWorkspaces)&&(o=h.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:w.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(o);let c=[];try{Array.isArray(h.folderURIWorkspaces)&&(c=h.folderURIWorkspaces.map(t=>w.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,o){this.workspaces.some(t=>h.workspace.id===t.workspace.id)||(this.workspaces.push(h),this.saveSync());const c=this.getBackupPath(h.workspace.id);return o&&this.moveBackupFolderSync(c,o),c}moveBackupFolderSync(h,o){if(L.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),L.existsSync(o))try{L.renameSync(o,h)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(h){const o=h.id,c=this.workspaces.findIndex(t=>t.workspace.id===o);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(o=>this.backupUriComparer.isEqual(h,o))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const o=this.folders.findIndex(c=>this.backupUriComparer.isEqual(h,c));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(h,o){const c=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:o}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(h){const o=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,h));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(h){return(0,b.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const o=new Set,c=[];for(let t of h){const a=t.workspace;if(!(0,I.isWorkspaceIdentifier)(a))return[];if(!o.has(a.id)){o.add(a.id);const r=this.getBackupPath(a.id);await this.doHasBackups(r)?a.configPath.scheme!==M.Schemas.file||await i.Promises.exists(a.configPath.fsPath)?c.push(t):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return c}async validateFolders(h){if(!Array.isArray(h))return[];const o=[],c=new Set;for(let t of h){const a=this.backupUriComparer.getComparisonKey(t);if(!c.has(a)){c.add(a);const r=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(r)?t.scheme!==M.Schemas.file||await i.Promises.exists(t.fsPath)?o.push(t):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return o}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const o=[],c=new Set;for(let t of h){const a=t.backupFolder;if(typeof a!="string")return[];if(!c.has(a)){c.add(a);const r=this.getBackupPath(a);await this.doHasBackups(r)?o.push(t):await this.deleteStaleBackup(r)}}return o}async deleteStaleBackup(h){try{await i.Promises.exists(h)&&await i.Promises.rm(h,i.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const c=this.getBackupPath(o);try{await i.Promises.rename(h,c)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const c=this.getBackupPath(o);try{L.renameSync(h,c)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const h=[];for(const o of this.workspaces)await this.hasBackups(o)&&h.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&h.push(o);return h}hasBackups(h){let o;return w.URI.isUri(h)?o=this.getBackupPath(this.getFolderHash(h)):(0,P.isWorkspaceBackupInfo)(h)?o=this.getBackupPath(h.workspace.id):o=h.backupFolder,this.doHasBackups(o)}async doHasBackups(h){try{const o=await i.Promises.readdir(h);for(const c of o)try{if((await i.Promises.readdir((0,b.join)(h,c))).length>0)return!0}catch(t){}}catch(o){}return!1}saveSync(){try{(0,i.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await i.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderURIWorkspaces:this.folders.map(h=>h.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){let o;return h.scheme===M.Schemas.file?o=n.isLinux?h.fsPath:h.fsPath.toLowerCase():o=h.toString().toLowerCase(),(0,p.createHash)("md5").update(o).digest("hex")}};y=ue([te(0,v.IEnvironmentMainService),te(1,E.IConfigurationService),te(2,g.ILogService)],y),e.BackupMainService=y}),define(Z[221],x([0,1,59,56]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,M,b,n){const f=i=>n(i,void 0),w=p.createConnection({host:k,port:M},()=>{w.removeListener("error",f);const i=Buffer.alloc(16);for(let d=0;d<16;d++)i[d]=Math.round(Math.random()*256);const P=i.toString("base64");let E=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${M}/?${b}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`];w.write(E.join(`\r
`)+`\r
\r
`);const v=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",v),n(void 0,new L.NodeSocket(w)))};w.on("data",v)});w.once("error",f)}}}),define(Z[222],x([0,1,59,9,2,115,16,6,21,191,95,221,75]),function(V,e,p,L,k,M,b,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function v(y,u,h,o,c){return new d(y,u,h,o,c).waitForReady()}class d extends k.Disposable{constructor(u,h,o,c,t){super();this.defaultTunnelHost=h,this.suggestedLocalPort=t,this.public=!1,this._socketsDispose=new Map,this._options=u,this._server=p.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let u=await(0,M.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(u){u.pause();const h=(0,i.isLocalhost)(this.tunnelRemoteHost)||(0,i.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,w.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),c=o.getSocket().socket,t=o.readEntireBuffer();o.dispose(),t.byteLength>0&&u.write(t.buffer),u.on("end",()=>{this._socketsDispose.delete(u.localAddress),c.end()}),u.on("close",()=>c.end()),u.on("error",()=>{this._socketsDispose.delete(u.localAddress),c.destroy()}),c.on("end",()=>u.end()),c.on("close",()=>u.end()),c.on("error",()=>{u.destroy()}),u.pipe(c),c.pipe(u),this._socketsDispose.set(u.localAddress,()=>{u.end(),c.end()})}}let g=class extends i.AbstractTunnelService{constructor(u,h,o,c,t){super(h);this.socketFactory=u,this.signService=o,this.productService=c,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(u,h,o,c,t,a,r){const s=this.getTunnelFromMap(h,o);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,o,c,t,a,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${o} on local port ${c}.`);const l={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:u,signService:this.signService,logService:this.logService,ipcLogger:null},m=v(l,this.defaultTunnelHost,h,o,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,o,m),m}}};g=ue([te(1,n.ILogService),te(2,E.ISignService),te(3,f.IProductService),te(4,b.IConfigurationService)],g),e.BaseTunnelService=g;let I=class extends g{constructor(u,h,o,c){super(P.nodeSocketFactory,u,h,o,c)}};I=ue([te(0,n.ILogService),te(1,E.ISignService),te(2,f.IProductService),te(3,b.IConfigurationService)],I),e.TunnelService=I}),define(Z[223],x([0,1,193,18,17,2,13,16,48,90,6,192,217]),function(V,e,p,L,k,M,b,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let v=class extends M.Disposable{constructor(g,I,y){super();this.environmentService=I,this.logService=y,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,I){this.logService.trace("RequestService#request",g.url);const{proxyUrl:y,strictSSL:u}=this,h={...process.env,...await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=g.agent?g.agent:await(0,P.getProxyAgent)(g.url||"",h,{proxyUrl:y,strictSSL:u});return g.agent=o,g.strictSSL=u,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,I)}async getNodeRequest(g){return((0,p.parse)(g.url).protocol==="https:"?await new Promise((u,h)=>{V(["https"],u,h)}):await new Promise((u,h)=>{V(["http"],u,h)})).request}_request(g,I){return new Promise(async(y,u)=>{let h;const o=(0,p.parse)(g.url),c=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),t={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,b.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(t.auth=g.user+":"+g.password),h=c(t,a=>{const r=(0,b.isNumber)(g.followRedirects)?g.followRedirects:3;if(a.statusCode&&a.statusCode>=300&&a.statusCode<400&&r>0&&a.headers.location)this._request({...g,url:a.headers.location,followRedirects:r-1},I).then(y,u);else{let s=a;a.headers["content-encoding"]==="gzip"&&(s=a.pipe((0,E.createGunzip)())),y({res:a,stream:(0,L.streamToBufferReadableStream)(s)})}}),h.on("error",u),g.timeout&&h.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&h.write(g.data),h.end(),I.onCancellationRequested(()=>{h.abort(),u((0,k.canceled)())})})}async resolveProxy(g){}};v=ue([te(0,n.IConfigurationService),te(1,f.INativeEnvironmentService),te(2,i.ILogService)],v),e.RequestService=v}),define(Z[224],x([0,1,14,223]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(b){return p.net.request}class M extends L.RequestService{request(n,f){return super.request({...n||{},getRawRequest:k},f)}}e.RequestMainService=M}),define(Z[225],x([0,1,14,9,4,2,10,13,84,24,22,6,45,55,61]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends M.Disposable{constructor(y,u,h,o,c,t,a){super();this.machineId=y,this.userEnv=u,this.environmentMainService=h,this.lifecycleMainService=o,this.logService=c,this.themeMainService=t,this.protocolMainService=a,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new k.Emitter),this.onDidError=k.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),p.ipcMain.on("vscode:createSharedProcessMessageChannel",async(y,u)=>this.onWindowConnection(y,u))}async onWindowConnection(y,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const h=await this.connect();if(y.sender.isDestroyed())return h.close();y.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[h])}onWillShutdown(){const y=this.window;!y||(!y.isDestroyed()&&!y.webContents.isDestroyed()&&y.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(y.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{y.close()}catch(u){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(y=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),y()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(y=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),y()}))})()),this._whenIpcReady}createWindow(){const y=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${y.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),y.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:E.default}),this.window.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",V).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=y=>{this.logService.trace("SharedProcess#close prevented"),y.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(y,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(y,u,h)=>this._onDidError.fire({type:3,details:{reason:h,exitCode:u}})))}async connect(){await this.whenIpcReady;const y=(0,n.assertIsDefined)(this.window);return(0,f.connect)(y)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};g=ue([te(2,w.IEnvironmentMainService),te(3,i.ILifecycleMainService),te(4,P.ILogService),te(5,d.IThemeMainService),te(6,v.IProtocolMainService)],g),e.SharedProcess=g}),define(Z[226],x([0,1,9,18,8,13,7,24,20,6]),function(V,e,p,L,k,M,b,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(v,d,g){this.storagePath=v,this.logService=d,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(v){v.fileOperationResult!==1&&this.logService.error(v)}}getItem(v,d){const g=this.storage[v];return(0,M.isUndefinedOrNull)(g)?d:g}setItem(v,d){this.setItems([{key:v,data:d}])}setItems(v){let d=!1;for(const{key:g,data:I}of v)this.storage[g]!==I&&((0,M.isUndefinedOrNull)(I)?(0,M.isUndefined)(this.storage[g])||(this.storage[g]=void 0,d=!0):(this.storage[g]=I,d=!0));d&&this.save()}removeItem(v){(0,M.isUndefined)(this.storage[v])||(this.storage[v]=void 0,this.save())}async save(v){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),v)}async doSave(){if(!this.initializing)return;await this.initializing;const v=JSON.stringify(this.storage,null,4);if(v!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(v)),this.lastSavedStorageContents=v}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let P=class yt{constructor(v,d,g){this.fileStorage=new i(b.URI.file((0,k.join)(v.userDataPath,yt.STATE_FILE)),d,g)}async init(){return this.fileStorage.init()}getItem(v,d){return this.fileStorage.getItem(v,d)}setItem(v,d){this.fileStorage.setItem(v,d)}setItems(v){this.fileStorage.setItems(v)}removeItem(v){this.fileStorage.removeItem(v)}close(){return this.fileStorage.close()}};P.STATE_FILE="storage.json",P=ue([te(0,n.IEnvironmentMainService),te(1,w.ILogService),te(2,f.IFileService)],P),e.StateMainService=P}),define(Z[76],x([0,1,9,23,4,16,24,22,6,21,50,42]),function(V,e,p,L,k,M,b,n,f,w,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(d,g,I){return`${I.updateUrl}/api/update/${d}/${g}/${I.commit}`}e.createUpdateURL=E;let v=class{constructor(g,I,y,u,h,o){this.lifecycleMainService=g,this.configurationService=I,this.environmentMainService=y,this.requestService=u,this.logService=h,this.productService=o,this._state=P.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),I=this.getProductQuality(g);if(!I){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(I),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(P.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,y=>this.logService.error(y))}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,p.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},L.CancellationToken.None).then(g=>g.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};v=ue([te(0,n.ILifecycleMainService),te(1,M.IConfigurationService),te(2,b.IEnvironmentMainService),te(3,i.IRequestService),te(4,f.ILogService),te(5,w.IProductService)],v),e.AbstractUpdateService=v}),define(Z[227],x([0,1,14,47,4,2,16,24,22,6,21,50,29,42,76]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends d.AbstractUpdateService{constructor(y,u,h,o,c,t,a){super(y,u,o,c,t,a);this.telemetryService=h,this.disposables=new M.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(p.autoUpdater,"error",(y,u)=>u)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(y,u,h)=>({url:u,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(y,u,h,o)=>({releaseNotes:u,version:h,productVersion:h,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(y){this.logService.error("UpdateService error:",y);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?y:void 0;this.setState(v.State.Idle(1,h))}buildUpdateFeedUrl(y){let u;this.productService.darwinUniversalAssetId?u=this.productService.darwinUniversalAssetId:u=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,d.createUpdateURL)(u,y,this.productService);try{p.autoUpdater.setFeedURL({url:h})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return h}doCheckForUpdates(y){this.setState(v.State.CheckingForUpdates(y)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(y){this.state.type==="checking for updates"&&this.setState(v.State.Downloading(y))}onUpdateDownloaded(y){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:y.version}),this.setState(v.State.Ready(y)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(v.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([L.memoize],g.prototype,"onRawError",null),ue([L.memoize],g.prototype,"onRawUpdateNotAvailable",null),ue([L.memoize],g.prototype,"onRawUpdateAvailable",null),ue([L.memoize],g.prototype,"onRawUpdateDownloaded",null),g=ue([te(0,f.ILifecycleMainService),te(1,b.IConfigurationService),te(2,E.ITelemetryService),te(3,n.IEnvironmentMainService),te(4,P.IRequestService),te(5,w.ILogService),te(6,i.IProductService)],g),e.DarwinUpdateService=g}),define(Z[228],x([0,1,41,32,9,4,8,24,22,6,29,42]),function(V,e,p,L,k,M,b,n,f,w,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{constructor(g,I,y){if(this.lifecycleMainService=g,this.logService=y,this._state=P.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,I.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(P.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,u=>this.logService.error(u))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,k.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};E=ue([te(0,f.ILifecycleMainService),te(1,n.IEnvironmentMainService),te(2,w.ILogService)],E);let v=class extends E{constructor(g,I,y,u,h,o){super(y,u,h);this.snap=g,this.snapRevision=I,this.telemetryService=o;const c=(0,L.watch)(b.dirname(this.snap)),t=M.Event.fromNodeEventEmitter(c,"change",(l,m)=>m),a=M.Event.filter(t,l=>l==="current"),s=M.Event.debounce(a,(l,m)=>m,2e3)(()=>this.checkForUpdates(!1));y.onWillShutdown(()=>{s.dispose(),c.close()})}doCheckForUpdates(){this.setState(P.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(P.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+b.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((y,u)=>(0,L.realpath)(`${b.dirname(this.snap)}/current`,(h,o)=>h?u(h):y(o))),I=b.basename(g);return this.snapRevision!==I}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};v=ue([te(2,f.ILifecycleMainService),te(3,n.IEnvironmentMainService),te(4,w.ILogService),te(5,i.ITelemetryService)],v),e.SnapUpdateService=v}),define(Z[46],x([0,1,14,32,4,40,34,2,10,8,3,15,13,19,153,51,52,24,5,6,21,99,27,100]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I,y,u,h,o,c,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,u.createDecorator)("workspacesManagementMainService");let r=class extends n.Disposable{constructor(l,m,S,D,R){super();this.environmentMainService=l,this.logService=m,this.backupMainService=S,this.dialogMainService=D,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(l){return this.doResolveLocalWorkspace(l,m=>(0,L.readFileSync)(m,"utf8"))}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,m=>v.Promises.readFile(m,"utf8"))}doResolveLocalWorkspace(l,m){if(!!this.isWorkspacePath(l)&&l.scheme===f.Schemas.file)try{const S=m(l.fsPath);return S instanceof Promise?S.then(D=>this.doResolveWorkspace(l,D),D=>{}):this.doResolveWorkspace(l,S)}catch{return}}isWorkspacePath(l){return(0,t.isUntitledWorkspace)(l,this.environmentMainService)||(0,t.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,m){try{const S=this.doParseStoredWorkspace(l,m),D=(0,a.getWorkspaceIdentifier)(l);return{id:D.id,configPath:D.configPath,folders:(0,t.toWorkspaceFolders)(S.folders,D.configPath,P.extUriBiasedIgnorePathCase),remoteAuthority:S.remoteAuthority,transient:S.transient}}catch(S){this.logService.warn(S.toString())}}doParseStoredWorkspace(l,m){const S=(0,M.parse)(m);if(S&&Array.isArray(S.folders))S.folders=S.folders.filter(D=>(0,t.isStoredWorkspaceFolder)(D));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return S}async createUntitledWorkspace(l,m){const{workspace:S,storedWorkspace:D}=this.newUntitledWorkspace(l,m),R=S.configPath.fsPath;return await v.Promises.mkdir((0,w.dirname)(R),{recursive:!0}),await v.Promises.writeFile(R,JSON.stringify(D,null,"	")),S}createUntitledWorkspaceSync(l,m){const{workspace:S,storedWorkspace:D}=this.newUntitledWorkspace(l,m),R=S.configPath.fsPath;return(0,L.mkdirSync)((0,w.dirname)(R),{recursive:!0}),(0,v.writeFileSync)(R,JSON.stringify(D,null,"	")),S}newUntitledWorkspace(l=[],m){const S=(Date.now()+Math.round(Math.random()*1e3)).toString(),D=(0,P.joinPath)(this.untitledWorkspacesHome,S),R=(0,P.joinPath)(D,t.UNTITLED_WORKSPACE_NAME),F=[];for(const C of l)F.push((0,t.getStoredWorkspaceFolder)(C.uri,!0,C.name,D,!i.isWindows,P.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(R),storedWorkspace:{folders:F,remoteAuthority:m}}}async getWorkspaceIdentifier(l){return(0,a.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,t.isUntitledWorkspace)(l.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(l){!this.isUntitledWorkspace(l)||(this.doDeleteUntitledWorkspaceSync(l),this._onDidDeleteUntitledWorkspace.fire(l))}async deleteUntitledWorkspace(l){this.deleteUntitledWorkspaceSync(l)}doDeleteUntitledWorkspaceSync(l){const m=(0,P.originalFSPath)(l.configPath);try{(0,v.rimrafSync)((0,w.dirname)(m));const S=(0,w.join)(this.environmentMainService.workspaceStorageHome.fsPath,l.id);(0,L.existsSync)(S)&&(0,v.writeFileSync)((0,w.join)(S,"obsolete"),"")}catch(S){this.logService.warn(`Unable to delete untitled workspace ${m} (${S}).`)}}getUntitledWorkspacesSync(){const l=[];try{const m=(0,v.readdirSync)(this.untitledWorkspacesHome.fsPath).map(S=>(0,P.joinPath)(this.untitledWorkspacesHome,S,t.UNTITLED_WORKSPACE_NAME));for(const S of m){const D=(0,a.getWorkspaceIdentifier)(S),R=this.resolveLocalWorkspaceSync(S);R?l.push({workspace:D,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(D)}}catch(m){m.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${m}).`)}return l}async enterWorkspace(l,m,S){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,m,S))return;const R=this.doEnterWorkspace(l,(0,a.getWorkspaceIdentifier)(S));if(!!R)return this._onDidEnterWorkspace.fire({window:l,workspace:R.workspace}),R}async isValidTargetWorkspacePath(l,m,S){if(!S)return!0;if((0,t.isWorkspaceIdentifier)(l.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,S))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(m,S)){const D={title:this.productService.nameLong,type:"info",buttons:[(0,b.mnemonicButtonLabel)((0,d.localize)(0,null))],message:(0,d.localize)(1,null,(0,P.basename)(S)),detail:(0,d.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(D,(0,E.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(l,m){if(!l.config)return;l.focus();let S;return l.config.extensionDevelopmentPath||(S=this.backupMainService.registerWorkspaceBackupSync({workspace:m,remoteAuthority:l.remoteAuthority},l.config.backupPath)),(0,t.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&this.deleteUntitledWorkspaceSync(l.openedWorkspace),l.config.workspace=m,l.config.backupPath=S,{workspace:m,backupPath:S}}};r=ue([te(0,y.IEnvironmentMainService),te(1,h.ILogService),te(2,g.IBackupMainService),te(3,I.IDialogMainService),te(4,o.IProductService)],r),e.WorkspacesManagementMainService=r}),define(Z[101],x([0,1,14,30,23,3,13,7,19,16,54,5,6,97,36,27,46]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,P.createDecorator)(e.ID);let y=class{constructor(h,o,c,t,a){this.logService=h,this.windowsMainService=o,this.urlService=c,this.workspacesManagementMainService=t,this.configurationService=a}async start(h,o){this.logService.trace("Received data from other instance: ",h,o),M.isMacintosh&&p.app.focus({steal:!0});const c=this.parseOpenUrl(h);if(c.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:a,url:r}of c)this.urlService.open(a,{originalUrl:r})})}else return this.startOpenWindow(h,o)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?(0,L.coalesce)(h._urls.map(o=>{try{return{uri:n.URI.parse(o),url:o}}catch(c){return null}})):[]}async startOpenWindow(h,o){const c=(0,i.isLaunchedFromCli)(o)?0:4;let t=[];const a=h.wait&&h.waitMarkerFilePath?n.URI.file(h.waitMarkerFilePath):void 0,r=h.remote||void 0;if(h.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,{context:c,cli:h,userEnv:o,waitMarkerFileURI:a,remoteAuthority:r});else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let s=!1;if(h["new-window"]||h["unity-launch"])s=!0;else if(h["reuse-window"])s=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":s=!0;break;case"off":s=!1;break;default:s=!M.isMacintosh}if(s)t=this.windowsMainService.open({context:c,cli:h,userEnv:o,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:a,remoteAuthority:r});else{const l=this.windowsMainService.getLastActiveWindow();l?(l.focus(),t=[l]):t=this.windowsMainService.open({context:c,cli:h,forceEmpty:!0,remoteAuthority:r})}}else t=this.windowsMainService.open({context:c,cli:h,userEnv:o,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],waitMarkerFileURI:a,gotoLineMode:h.goto,remoteAuthority:r});if(a&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,f.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const h=[];return p.BrowserWindow.getAllWindows().forEach(o=>{const c=this.windowsMainService.getWindowById(o.id);c?h.push(this.codeWindowToInfo(c)):h.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(h){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(t=>new Promise(a=>{const r=t.remoteAuthority;if(r){const s=`vscode:getDiagnosticInfoResponse${t.id}`,l={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:s,args:l}),p.ipcMain.once(s,(m,S)=>{S||a({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),a(S)}),setTimeout(()=>{a({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else a(void 0)})))).filter(t=>!!t)}getFolderURIs(h){const o=[],c=h.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(c))o.push(c.uri);else if((0,g.isWorkspaceIdentifier)(c)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);t&&t.folders.forEach(r=>{o.push(r.uri)})}return o}codeWindowToInfo(h){const o=this.getFolderURIs(h),c=(0,b.assertIsDefined)(h.win);return this.browserWindowToInfo(c,o,h.remoteAuthority)}browserWindowToInfo(h,o=[],c){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:o,remoteAuthority:c}}};y=ue([te(0,E.ILogService),te(1,d.IWindowsMainService),te(2,v.IURLService),te(3,I.IWorkspacesManagementMainService),te(4,w.IConfigurationService)],y),e.LaunchMainService=y}),define(Z[53],x([0,1,41,14,26,114,47,4,34,2,10,8,3,7,81,67,19,145,52,24,5,22,6,21,29,61,36,27,46]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I,y,u,h,o,c,t,a,r,s,l,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,o.createDecorator)("nativeHostMainService");let D=class ut extends w.Disposable{constructor(F,C,G,ne,ae,K,ee,_,j,$){super();this.sharedProcess=F,this.windowsMainService=C,this.dialogMainService=G,this.lifecycleMainService=ne,this.environmentMainService=ae,this.telemetryService=K,this.logService=ee,this.productService=_,this.themeMainService=j,this.workspacesManagementMainService=$,this.onDidOpenWindow=n.Event.map(this.windowsMainService.onDidOpenWindow,B=>B.id),this.onDidMaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(B,H)=>H.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidUnmaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(B,H)=>H.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidBlurWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(B,H)=>H.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidFocusWindow=n.Event.any(n.Event.map(n.Event.filter(n.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),B=>!!B),B=>B.id),n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(B,H)=>H.id),B=>!!this.windowsMainService.getWindowById(B))),this.onDidResumeOS=n.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new n.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=n.Event.debounce(n.Event.any(n.Event.filter(n.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(B,H,O)=>O),B=>!(Array.isArray(B)&&B.length===1&&B[0]==="workArea")),n.Event.fromNodeEventEmitter(L.screen,"display-added"),n.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(C=>({id:C.id,workspace:C.openedWorkspace,title:C.win?.getTitle()??"",filename:C.getRepresentedFilename(),dirty:C.isDocumentEdited()}))}async getWindowCount(F){return this.windowsMainService.getWindowCount()}async getActiveWindowId(F){const C=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(C)return C.id}openWindow(F,C,G){return Array.isArray(C)?this.doOpenWindow(F,C,G):this.doOpenEmptyWindow(F,C)}async doOpenWindow(F,C,G=Object.create(null)){C.length>0&&this.windowsMainService.open({context:5,contextWindowId:F,urisToOpen:C,cli:this.environmentMainService.args,forceNewWindow:G.forceNewWindow,forceReuseWindow:G.forceReuseWindow,preferNewWindow:G.preferNewWindow,diffMode:G.diffMode,addMode:G.addMode,gotoLineMode:G.gotoLineMode,noRecentEntry:G.noRecentEntry,waitMarkerFileURI:G.waitMarkerFileURI,remoteAuthority:G.remoteAuthority||void 0})}async doOpenEmptyWindow(F,C){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:F},C)}async toggleFullScreen(F){const C=this.windowById(F);C&&C.toggleFullScreen()}async handleTitleDoubleClick(F){const C=this.windowById(F);C&&C.handleTitleDoubleClick()}async isMaximized(F){const C=this.windowById(F);return C?.win?C.win.isMaximized():!1}async maximizeWindow(F){const C=this.windowById(F);C?.win&&C.win.maximize()}async unmaximizeWindow(F){const C=this.windowById(F);C?.win&&C.win.unmaximize()}async minimizeWindow(F){const C=this.windowById(F);C?.win&&C.win.minimize()}async focusWindow(F,C){C&&typeof C.windowId=="number"&&(F=C.windowId);const G=this.windowById(F);G&&G.focus({force:C?.force??!1})}async setMinimumSize(F,C,G){const ne=this.windowById(F);if(ne?.win){const[ae,K]=ne.win.getSize(),[ee,_]=ne.win.getMinimumSize(),[j,$]=[C??ee,G??_],[B,H]=[Math.max(ae,j),Math.max(K,$)];(ee!==j||_!==$)&&ne.win.setMinimumSize(j,$),(ae!==B||K!==H)&&ne.win.setSize(B,H)}}async saveWindowSplash(F,C){this.themeMainService.saveWindowSplash(F,C)}async installShellCommand(F){const{source:C,target:G}=await this.getShellCommandLink();try{const{symbolicLink:ne}=await I.SymlinkSupport.stat(C);if(ne&&!ne.dangling){const ae=await(0,d.realpath)(C);if(G===ae)return}await I.Promises.unlink(C)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await I.Promises.symlink(G,C)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:ae}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,y.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,y.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ae===0)try{const K=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${G}' '${C}'\\" with administrator privileges"`;await(0,M.promisify)(p.exec)(K)}catch(K){throw new Error((0,y.localize)(3,null,C))}}}async uninstallShellCommand(F){const{source:C}=await this.getShellCommandLink();try{await I.Promises.unlink(C)}catch(G){switch(G.code){case"EACCES":const{response:ne}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,y.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ne===0)try{const ae=`osascript -e "do shell script \\"rm '${C}'\\" with administrator privileges"`;await(0,M.promisify)(p.exec)(ae)}catch(ae){throw new Error((0,y.localize)(7,null,C))}break;case"ENOENT":break;default:throw G}}}async getShellCommandLink(){const F=(0,P.resolve)(this.environmentMainService.appRoot,"bin","code"),C=`/usr/local/bin/${this.productService.applicationName}`;if(!await I.Promises.exists(F))throw new Error((0,y.localize)(8,null,F));return{source:C,target:F}}async showMessageBox(F,C){return this.dialogMainService.showMessageBox(C,this.toBrowserWindow(F))}async showSaveDialog(F,C){return this.dialogMainService.showSaveDialog(C,this.toBrowserWindow(F))}async showOpenDialog(F,C){return this.dialogMainService.showOpenDialog(C,this.toBrowserWindow(F))}toBrowserWindow(F){const C=this.windowById(F);if(C?.win)return C.win}async pickFileFolderAndOpen(F,C){const G=await this.dialogMainService.pickFileFolder(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openFileFolder",C.telemetryExtraData),this.doOpenPicked(await Promise.all(G.map(async ne=>await I.SymlinkSupport.existsDirectory(ne)?{folderUri:v.URI.file(ne)}:{fileUri:v.URI.file(ne)})),C,F))}async pickFolderAndOpen(F,C){const G=await this.dialogMainService.pickFolder(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openFolder",C.telemetryExtraData),this.doOpenPicked(G.map(ne=>({folderUri:v.URI.file(ne)})),C,F))}async pickFileAndOpen(F,C){const G=await this.dialogMainService.pickFile(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openFile",C.telemetryExtraData),this.doOpenPicked(G.map(ne=>({fileUri:v.URI.file(ne)})),C,F))}async pickWorkspaceAndOpen(F,C){const G=await this.dialogMainService.pickWorkspace(C);G&&(this.sendPickerTelemetry(G,C.telemetryEventName||"openWorkspace",C.telemetryExtraData),this.doOpenPicked(G.map(ne=>({workspaceUri:v.URI.file(ne)})),C,F))}doOpenPicked(F,C,G){this.windowsMainService.open({context:3,contextWindowId:G,cli:this.environmentMainService.args,urisToOpen:F,forceNewWindow:C.forceNewWindow})}sendPickerTelemetry(F,C,G){const ne=F?F.length:0;this.telemetryService.publicLog(C,{...G,outcome:ne?"success":"canceled",numberOfPaths:ne})}async showItemInFolder(F,C){L.shell.showItemInFolder(C)}async setRepresentedFilename(F,C){const G=this.windowById(F);G&&G.setRepresentedFilename(C)}async setDocumentEdited(F,C){const G=this.windowById(F);G&&G.setDocumentEdited(C)}async openExternal(F,C){return E.isLinuxSnap?this.safeSnapOpenExternal(C):L.shell.openExternal(C),!0}safeSnapOpenExternal(F){const C=process.env.GDK_PIXBUF_MODULE_FILE,G=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(F),process.env.GDK_PIXBUF_MODULE_FILE=C,process.env.GDK_PIXBUF_MODULEDIR=G}moveItemToTrash(F,C){return L.shell.trashItem(C)}async isAdmin(){let F;return E.isWindows?F=(await new Promise((C,G)=>{V(["native-is-elevated"],C,G)}))():F=process.getuid()===0,F}async writeElevated(F,C,G,ne){const ae=await new Promise((K,ee)=>{V(["sudo-prompt"],K,ee)});return new Promise((K,ee)=>{const _=[`"${this.cliPath}"`];ne?.unlock&&_.push("--file-chmod"),_.push("--file-write",`"${C.fsPath}"`,`"${G.fsPath}"`);const j={name:this.productService.nameLong.replace("-",""),icns:E.isMacintosh&&this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ae.exec(_.join(" "),j,($,B,H)=>{B&&this.logService.trace(`[sudo-prompt] received stdout: ${B}`),H&&this.logService.trace(`[sudo-prompt] received stderr: ${H}`),$?ee($):K(void 0)})})}get cliPath(){return E.isWindows?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):E.isLinux?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,P.join)(this.environmentMainService.appRoot,"bin","code"):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}async killProcess(F,C,G){process.kill(C,G)}async readClipboardText(F,C){return L.clipboard.readText(C)}async writeClipboardText(F,C,G){return L.clipboard.writeText(C,G)}async readClipboardFindText(F){return L.clipboard.readFindText()}async writeClipboardFindText(F,C){return L.clipboard.writeFindText(C)}async writeClipboardBuffer(F,C,G,ne){return L.clipboard.writeBuffer(C,Buffer.from(G),ne)}async readClipboardBuffer(F,C){return L.clipboard.readBuffer(C)}async hasClipboard(F,C,G){return L.clipboard.has(C,G)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,C){const G=this.windowById(F);G&&G.updateTouchBar(C)}async notifyReady(F){const C=this.windowById(F);C&&C.setReady()}async relaunch(F,C){return this.lifecycleMainService.relaunch(C)}async reload(F,C){const G=this.windowById(F);if(G){if((0,m.isWorkspaceIdentifier)(G.openedWorkspace)){const ne=G.openedWorkspace.configPath;if(ne.scheme===i.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ne))?.transient)return this.openWindow(G.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(G,C?.disableExtensions!==void 0?{_:[],"disable-extensions":C.disableExtensions}:void 0)}}async closeWindow(F){this.closeWindowById(F,F)}async closeWindowById(F,C){const G=this.windowById(C);if(G?.win)return G.win.close()}async quit(F){const C=this.windowsMainService.getLastActiveWindow();C?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&C.win?C.win.close():this.lifecycleMainService.quit()}async exit(F,C){await this.lifecycleMainService.kill(C)}async resolveProxy(F,C){const ne=this.windowById(F)?.win?.webContents?.session;if(ne)return ne.resolveProxy(C)}async openDevTools(F,C){const G=this.windowById(F);G?.win&&G.win.webContents.openDevTools(C)}async toggleDevTools(F){const C=this.windowById(F);C?.win&&C.win.webContents.toggleDevTools()}async sendInputEvent(F,C){const G=this.windowById(F);G?.win&&(C.type==="mouseDown"||C.type==="mouseUp")&&G.win.webContents.sendInputEvent(C)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(F,C,G,ne){if(!E.isWindows)return;const ae=await new Promise((K,ee)=>{V(["vscode-windows-registry"],K,ee)});try{return ae.GetStringRegKey(C,G,ne)}catch{return}}async getPassword(F,C,G){const ne=await this.withKeytar(),ae=await ne.getPassword(C,G);if(ae)try{let{content:K,hasNextChunk:ee}=JSON.parse(ae);if(!K||!ee)return ae;let _=1;for(;ee;){const j=await ne.getPassword(C,`${G}-${_}`),$=JSON.parse(j);K+=$.content,ee=$.hasNextChunk,_++}return K}catch{return ae}return ae}async setPassword(F,C,G,ne){const ae=await this.withKeytar(),K=3,ee=async(_,j,$)=>{let B=0,H;for(;B<K;)try{await ae.setPassword(_,j,$);return}catch(O){H=O,this.logService.warn("Error attempting to set a password: ",O),B++,await new Promise(q=>setTimeout(q,200))}throw H};if(E.isWindows&&ne.length>ut.MAX_PASSWORD_LENGTH){let _=0,j=0,$=!0;for(;$;){const B=ne.substring(_,_+ut.PASSWORD_CHUNK_SIZE);_+=ut.PASSWORD_CHUNK_SIZE,$=ne.length-_>0;const H={content:B,hasNextChunk:$};await ee(C,j?`${G}-${j}`:G,JSON.stringify(H)),j++}}else await ee(C,G,ne);this._onDidChangePassword.fire({service:C,account:G})}async deletePassword(F,C,G){const ae=await(await this.withKeytar()).deletePassword(C,G);return ae&&this._onDidChangePassword.fire({service:C,account:G}),ae}async findPassword(F,C){return(await this.withKeytar()).findPassword(C)}async findCredentials(F,C){return(await this.withKeytar()).findCredentials(C)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((F,C)=>{V(["keytar"],F,C)})}windowById(F){if(typeof F=="number")return this.windowsMainService.getWindowById(F)}};D.MAX_PASSWORD_LENGTH=2500,D.PASSWORD_CHUNK_SIZE=D.MAX_PASSWORD_LENGTH-100,ue([b.memoize],D.prototype,"cliPath",null),D=ue([te(1,l.IWindowsMainService),te(2,u.IDialogMainService),te(3,c.ILifecycleMainService),te(4,h.IEnvironmentMainService),te(5,r.ITelemetryService),te(6,t.ILogService),te(7,a.IProductService),te(8,s.IThemeMainService),te(9,S.IWorkspacesManagementMainService)],D),e.NativeHostMainService=D}),define(Z[229],x([0,1,14,23,4,79,2,28,88,6,53,21,36]),function(V,e,p,L,k,M,b,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var v;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let d=class extends b.Disposable{constructor(I,y,u,h,o){super();this.logService=I,this.windowsMainService=y,this.nativeHostMainService=u,this.encryptionMainService=h,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=v.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const I=k.Event.fromNodeEventEmitter(p.app,"login",(y,u,h,o,c)=>({event:y,webContents:u,req:h,authInfo:o,callback:c}));this._register(I(this.onLogin,this))}async onLogin({event:I,authInfo:y,req:u,callback:h}){if(!y.isProxy)return;if(!this.pendingProxyResolve&&this.state===v.LoginDialogShown&&u.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}I.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(y);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(o?.username,o?.password)}async resolveProxyCredentials(I){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const y=await this.doResolveProxyCredentials(I);if(y)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),y;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(I){this.logService.trace("auth#doResolveProxyCredentials - enter",I);const y=String((0,M.hash)({scheme:I.scheme,host:I.host,port:I.port}));let u,h;try{const a=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y);if(a){const r=JSON.parse(await this.encryptionMainService.decrypt(a));u=r.username,h=r.password}}catch(a){this.logService.error(a)}if(this.state!==v.StoredCredentialsUsed&&typeof u=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=v.StoredCredentialsUsed,{username:u,password:h};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const c={authInfo:I,username:this.sessionCredentials?.username??u,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,c),this.state=v.LoginDialogShown;const t=await new Promise(a=>{const r=async(s,l,m)=>{if(l===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),o.win?.webContents.off("ipc-message",r),m){const S={username:m.username,password:m.password};try{if(m.remember){const D=await this.encryptionMainService.encrypt(JSON.stringify(S));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y,D)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y)}catch(D){this.logService.error(D)}a({username:S.username,password:S.password})}else a(void 0)};o.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=t,t}};d=ue([te(0,w.ILogService),te(1,E.IWindowsMainService),te(2,i.INativeHostMainService),te(3,f.IEncryptionMainService),te(4,P.IProductService)],d),e.ProxyAuthHandler=d}),define(Z[230],x([0,1,14,26,34,2,10,3,82,143,71,52,24,5,101,6,53,45,21,55,62]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I,y,u,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,v.createDecorator)("issueMainService");let c=class St{constructor(a,r,s,l,m,S,D,R,F){this.userEnv=a,this.environmentMainService=r,this.launchMainService=s,this.logService=l,this.diagnosticsService=m,this.dialogMainService=S,this.nativeHostMainService=D,this.protocolMainService=R,this.productService=F,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async a=>{const[r,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(r,s);this.safeSend(a,"vscode:issueSystemInfoResponse",l)}),p.ipcMain.on("vscode:listProcesses",async a=>{const r=[];try{const s=await this.launchMainService.getMainProcessId();r.push({name:(0,w.localize)(0,null),rootProcess:await(0,f.listProcesses)(s)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(m=>{(0,i.isRemoteDiagnosticError)(m)?r.push({name:m.hostName,rootProcess:m}):m.processes&&r.push({name:m.hostName,rootProcess:m.processes})})}catch(s){this.logService.error(`Listing processes failed: ${s}`)}this.safeSend(a,"vscode:listProcessesResponse",r)}),p.ipcMain.on("vscode:issueReporterClipboard",async a=>{const r={title:this.productService.nameLong,message:(0,w.localize)(1,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(2,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const s=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(a,"vscode:issueReporterClipboardResponse",s.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async a=>{const r=await this.getPerformanceInfo();this.safeSend(a,"vscode:issuePerformanceInfoResponse",r)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const a={title:this.productService.nameLong,message:(0,w.localize)(4,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(a,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(a,r)=>{const{id:s,from:l,args:m}=r;let S;switch(l){case"issueReporter":S=this.issueReporterParentWindow;break;case"processExplorer":S=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}S&&S.webContents.send("vscode:runAction",{id:s,from:l,args:m})}),p.ipcMain.on("vscode:openExternal",(a,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),p.ipcMain.on("vscode:closeIssueReporter",a=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",a=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async a=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(a,"vscode:windowsInfoResponse",r.windows)})}safeSend(a,r,...s){a.sender.isDestroyed()||a.sender.send(r,...s)}async openReporter(a){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new M.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,s,{backgroundColor:a.styles.backgroundColor,title:(0,w.localize)(7,null),zoomLevel:a.zoomLevel,alwaysOnTop:!1}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:a,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:y.default}),this.issueReporterWindow.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",V).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(a){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new M.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,s,{backgroundColor:a.styles.backgroundColor,title:(0,w.localize)(8,null),zoomLevel:a.zoomLevel,alwaysOnTop:!0}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:a,product:y.default}),this.processExplorerWindow.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",V).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(a,r,s){const l=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:a.width,height:a.height,minWidth:300,minHeight:200,x:a.x,y:a.y,title:s.title,backgroundColor:s.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,o.zoomLevelToZoomFactor)(s.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:s.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[a,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(a,r)}getWindowPosition(a,r,s){let l;const m=p.screen.getAllDisplays();if(m.length===1)l=m[0];else{if(n.isMacintosh){const R=p.screen.getCursorScreenPoint();l=p.screen.getDisplayNearestPoint(R)}!l&&a&&(l=p.screen.getDisplayMatching(a.getBounds())),l||(l=p.screen.getPrimaryDisplay()||m[0])}const S={width:r,height:s},D=l.bounds;return S.x=D.x+D.width/2-S.width/2,S.y=D.y+D.height/2-S.height/2,D.width>0&&D.height>0&&(S.x<D.x&&(S.x=D.x),S.y<D.y&&(S.y=D.y),S.x>D.x+D.width&&(S.x=D.x),S.y>D.y+D.height&&(S.y=D.y),S.width>D.width&&(S.width=D.width),S.height>D.height&&(S.height=D.height)),S}async getPerformanceInfo(){try{const[a,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(a,r)}catch(a){throw this.logService.warn("issueService#getPerformanceInfo ",a.message),a}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=ue([te(1,E.IEnvironmentMainService),te(2,d.ILaunchMainService),te(3,g.ILogService),te(4,i.IDiagnosticsService),te(5,P.IDialogMainService),te(6,I.INativeHostMainService),te(7,h.IProtocolMainService),te(8,u.IProductService)],c),e.IssueMainService=c}),define(Z[231],x([0,1,23,16,24,22,6,53,21,50,29,42,76]),function(V,e,p,L,k,M,b,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let v=class extends E.AbstractUpdateService{constructor(g,I,y,u,h,o,c,t){super(g,I,u,h,o,t);this.telemetryService=y,this.nativeHostMainService=c}buildUpdateFeedUrl(g){return(0,E.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(P.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},p.CancellationToken.None).then(w.asJson).then(I=>{!I||!I.url||!I.version||!I.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(P.State.Idle(1))):this.setState(P.State.AvailableForDownload(I))}).then(void 0,I=>{this.logService.error(I),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const y=g?I.message||I:void 0;this.setState(P.State.Idle(1,y))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(P.State.Idle(1))}};v=ue([te(0,M.ILifecycleMainService),te(1,L.IConfigurationService),te(2,i.ITelemetryService),te(3,k.IEnvironmentMainService),te(4,w.IRequestService),te(5,b.ILogService),te(6,n.INativeHostMainService),te(7,f.IProductService)],v),e.LinuxUpdateService=v}),define(Z[232],x([0,1,41,32,26,9,23,47,8,7,112,19,16,24,20,22,6,53,21,50,29,42,76]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I,y,u,h,o,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(m,S=1e3){for(;!m();)await(0,M.timeout)(S)}let r;function s(){return typeof r=="undefined"&&(r=L.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),r}let l=class extends t.AbstractUpdateService{constructor(S,D,R,F,C,G,ne,ae,K){super(S,D,F,C,G,K);this.telemetryService=R,this.fileService=ne,this.nativeHostMainService=ae}get cachePath(){const S=f.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return P.Promises.mkdir(S,{recursive:!0}).then(()=>S)}initialize(){super.initialize(),s()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(S){let D="win32";return process.arch!=="ia32"&&(D+=`-${process.arch}`),s()===1?D+="-archive":this.productService.target==="user"&&(D+="-user"),(0,t.createUpdateURL)(D,S,this.productService)}doCheckForUpdates(S){!this.url||(this.setState(c.State.CheckingForUpdates(S)),this.requestService.request({url:this.url},b.CancellationToken.None).then(h.asJson).then(D=>{const R=s();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S}),this.setState(c.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(c.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(c.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(F=>P.Promises.exists(F).then(C=>{if(C)return Promise.resolve(F);const G=D.url,ne=D.hash,ae=`${F}.tmp`;return this.requestService.request({url:G},b.CancellationToken.None).then(K=>this.fileService.writeFile(w.URI.file(ae),K.stream)).then(ne?()=>(0,i.checksum)(ae,D.hash):()=>{}).then(()=>P.Promises.rename(ae,F)).then(()=>F)})).then(F=>{const C=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:F},C&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(D)):this.setState(c.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S});const R=S?D.message||D:void 0;this.setState(c.State.Idle(s(),R))}))}async doDownloadUpdate(S){S.update.url&&this.nativeHostMainService.openExternal(void 0,S.update.url),this.setState(c.State.Idle(s()))}async getUpdatePackagePath(S){const D=await this.cachePath;return f.join(D,`CodeSetup-${this.productService.quality}-${S}.exe`)}async cleanup(S=null){const D=S?G=>!new RegExp(`${this.productService.quality}-${S}\\.exe$`).test(G):()=>!0,R=await this.cachePath,C=(await P.Promises.readdir(R)).filter(D).map(async G=>{try{await P.Promises.unlink(f.join(R,G))}catch(ne){}});await Promise.all(C)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const S=this.state.update;this.setState(c.State.Updating(S));const D=await this.cachePath;this.availableUpdate.updateFilePath=f.join(D,`CodeSetup-${this.productService.quality}-${S.version}.flag`),await P.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(s()))});const F=`${this.productService.win32MutexName}-ready`,C=await new Promise((G,ne)=>{V(["windows-mutex"],G,ne)});a(()=>C.isActive(F)).then(()=>this.setState(c.State.Ready(S)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return s()}};ue([n.memoize],l.prototype,"cachePath",null),l=ue([te(0,g.ILifecycleMainService),te(1,E.IConfigurationService),te(2,o.ITelemetryService),te(3,v.IEnvironmentMainService),te(4,h.IRequestService),te(5,I.ILogService),te(6,d.IFileService),te(7,y.INativeHostMainService),te(8,u.IProductService)],l),e.Win32UpdateService=l}),define(Z[233],x([0,1,14,9,23,4,34,2,10,8,73,3,7,149,51,16,52,24,54,200,20,22,6,21,55,98,29,203,61,62,36,27,46]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I,y,u,h,o,c,t,a,r,s,l,m,S,D,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var G;(function(ae){ae[ae.NONE=0]="NONE",ae[ae.LOADING=1]="LOADING",ae[ae.NAVIGATING=2]="NAVIGATING",ae[ae.READY=3]="READY"})(G||(G={}));let ne=class extends n.Disposable{constructor(K,ee,_,j,$,B,H,O,q,T,A,W,z,X){super();this.logService=ee,this.environmentMainService=_,this.fileService=j,this.configurationService=B,this.themeMainService=H,this.workspacesManagementMainService=O,this.backupMainService=q,this.telemetryService=T,this.dialogMainService=A,this.lifecycleMainService=W,this.productService=z,this.protocolMainService=X,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[U,N]=this.restoreWindowState(K.state);this.windowState=U,this.logService.trace("window#ctor: using window state",U);const Q=this.windowState.mode===0||this.windowState.mode===3,J=this.configurationService.getValue("window"),re={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!Q,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,D.zoomLevelToZoomFactor)(J?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};P.isLinux?re.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):P.isWindows&&!this.environmentMainService.isBuilt&&(re.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),P.isMacintosh&&!this.useNativeFullScreen()&&(re.fullscreenable=!1),P.isMacintosh&&(re.acceptFirstMouse=!0,J?.clickThroughInactive===!1&&(re.acceptFirstMouse=!1));const le=P.isMacintosh&&J?.nativeTabs===!0;le&&(re.tabbingIdentifier=this.productService.nameShort);const ie=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(ie&&(re.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,P.isMacintosh||(re.frame=!1)),(0,i.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(re),(0,i.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),P.isMacintosh&&ie&&this._win.setSheetOffset(22),P.isMacintosh&&N&&(!le||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(oe=>typeof oe=="number")){const oe=this.windowState;this._win.setBounds({width:oe.width,height:oe.height,x:oe.x,y:oe.y})}Q&&((0,i.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,i.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,h.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:U=>$.globalStorage.get(U),store:(U,N)=>$.globalStorage.set(U,N)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(K){P.isMacintosh?this._win.setRepresentedFilename(K):this.representedFilename=K}getRepresentedFilename(){return P.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(K){P.isMacintosh&&this._win.setDocumentEdited(K),this.documentEdited=K}isDocumentEdited(){return P.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(K){P.isMacintosh&&K?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(K=>{if(this.isReady)return K(this);this.whenReadyCallbacks.push(K)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(K=>{function ee(){_.dispose(),j.dispose(),K()}const _=this.onDidClose(()=>ee()),j=this.onWillLoad(()=>ee())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",($,B)=>this.onWindowError(2,B)),this._win.webContents.on("did-fail-load",($,B,H)=>this.onWindowError(3,{reason:H,exitCode:B})),this._win.webContents.on("will-prevent-unload",$=>{$.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const K=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),ee=$=>{for(let B=$;B;B=B.parent)if(B.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},_=$=>$.resourceType==="xhr"||ee($.frame);this._win.webContents.session.webRequest.onBeforeRequest(($,B)=>{const H=E.URI.parse($.url);return H.path.endsWith(".svg")&&!K.has(H.scheme)?B({cancel:!_($)}):B({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived(($,B)=>{const H=$.responseHeaders,O=H["content-type"]||H["Content-Type"];if(O&&Array.isArray(O)){const q=E.URI.parse($.url);if(q.path.endsWith(".svg")&&K.has(q.scheme))return H["Content-Type"]=["image/svg+xml"],B({cancel:!1,responseHeaders:H});if(!q.path.includes(f.Schemas.vscodeRemoteResource)&&O.some(T=>T.toLowerCase().includes("image/svg")))return B({cancel:!_($)})}return B({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",$=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",$,this._win)}),this._win.on("unmaximize",$=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",$,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace($=>this.onDidDeleteUntitledWorkspace($)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async($,B)=>{const H=await this.marketplaceHeadersPromise;B({cancel:!1,requestHeaders:Object.assign($.requestHeaders,H)})})}async onWindowError(K,ee){switch(K){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:K,reason:ee?.reason,code:ee?.exitCode}),K){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(K===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const _=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,v.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,b.mnemonicButtonLabel)((0,v.localize)(2,null))],message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;_.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):_.response===2&&this.destroyWindow()}else if(K===2){let _;ee?_=(0,v.localize)(6,null,ee.reason,ee.exitCode??"<unknown>"):_=(0,v.localize)(5,null);const j=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,v.localize)(7,null)),(0,b.mnemonicButtonLabel)((0,v.localize)(8,null))],message:_,detail:(0,v.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;j.response===0?this.reload():j.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(K){this.openedWorkspace?.id===K.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const K=this.getMenuBarVisibility();K!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=K,this.setMenuBarVisibility(K));let ee=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;ee?.endsWith("/")&&(ee=ee.substr(0,ee.length-1));const _=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((ee||"").indexOf("@")===-1&&(ee!==this.currentHttpProxy||_!==this.currentNoProxy)){this.currentHttpProxy=ee,this.currentNoProxy=_;const j=ee||"",$=_?`${_},<local>`:"<local>";this.logService.trace(`Setting proxy to '${j}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:j,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(K){P.isMacintosh&&K.win&&this._win.addTabbedWindow(K.win)}load(K,ee=Object.create(null)){this.isDocumentEdited()&&(!ee.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),ee.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(K,ee),this.readyState===0?this.currentConfig=K:(this.pendingLoadConfig=K,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",V).toString(!0));const _=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:K.workspace,reason:ee.isReload?3:_?2:1})}updateConfiguration(K,ee){const _=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(_){const j=(0,u.isLaunchedFromCli)(_)&&!(0,u.isLaunchedFromCli)(K.userEnv),$=this.isExtensionDevelopmentHost;(j||$)&&(K.userEnv={..._,...K.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(K.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),ee.disableExtensions!==void 0&&(K["disable-extensions"]=ee.disableExtensions),K.fullscreen=this.isFullScreen,K.maximized=this._win.isMaximized(),K.partsSplash=this.themeMainService.getWindowSplash(),(0,i.mark)("code/willOpenNewWindow"),K.perfMarks=(0,i.getMarks)(),this.configObjectUrl.update(K)}async reload(K){const ee=Object.assign({},this.currentConfig);ee.workspace=await this.validateWorkspaceBeforeReload(ee),delete ee.filesToOpenOrCreate,delete ee.filesToDiff,delete ee.filesToWait,this.isExtensionDevelopmentHost&&K&&(ee.verbose=K.verbose,ee.debugId=K.debugId,ee["inspect-extensions"]=K["inspect-extensions"],ee["inspect-brk-extensions"]=K["inspect-brk-extensions"],ee["extensions-dir"]=K["extensions-dir"]),ee.isInitialStartup=!1,this.load(ee,{isReload:!0,disableExtensions:K?.["disable-extensions"]})}async validateWorkspaceBeforeReload(K){if((0,F.isWorkspaceIdentifier)(K.workspace)){const ee=K.workspace.configPath;if(ee.scheme===f.Schemas.file&&!await this.fileService.exists(ee))return}else if((0,F.isSingleFolderWorkspaceIdentifier)(K.workspace)){const ee=K.workspace.uri;if(ee.scheme===f.Schemas.file&&!await this.fileService.exists(ee))return}return K.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let _;try{_=p.screen.getDisplayMatching(this.getBounds())}catch(B){}const j=(0,R.defaultWindowState)();return{mode:3,display:_?_.id:void 0,width:this.windowState.width||j.width,height:this.windowState.height||j.height,x:this.windowState.x||0,y:this.windowState.y||0}}const K=Object.create(null);let ee;if(!P.isMacintosh&&this._win.isMaximized()?ee=0:ee=1,ee===0?K.mode=0:K.mode=1,ee===1||ee===0){let _;ee===1?_=this.getBounds():_=this._win.getNormalBounds(),K.x=_.x,K.y=_.y,K.width=_.width,K.height=_.height}return K}restoreWindowState(K){(0,i.mark)("code/willRestoreCodeWindowState");let ee=!1;if(K)try{const _=p.screen.getAllDisplays();ee=_.length>1,K=this.validateWindowState(K,_)}catch(_){this.logService.warn(`Unexpected error validating window state: ${_}
${_.stack}`)}return(0,i.mark)("code/didRestoreCodeWindowState"),[K||(0,R.defaultWindowState)(),ee]}validateWindowState(K,ee){if(this.logService.trace(`window#validateWindowState: validating window state on ${ee.length} display(s)`,K),typeof K.x!="number"||typeof K.y!="number"||typeof K.width!="number"||typeof K.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(K.width<=0||K.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(ee.length===1){const $=this.getWorkingArea(ee[0]);if($){let B=function(){!K||typeof K.x!="number"||typeof K.y!="number"||!$||(K.x<$.x&&(K.x=$.x),K.y<$.y&&(K.y=$.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",$),B(),K.width>$.width&&(K.width=$.width),K.height>$.height&&(K.height=$.height),K.x>$.x+$.width-128&&(K.x=$.x+$.width-K.width),K.y>$.y+$.height-128&&(K.y=$.y+$.height-K.height),B()}return K}if(K.display&&K.mode===3){const $=ee.find(B=>B.id===K.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const B=(0,R.defaultWindowState)(3);return B.x=$.bounds.x,B.y=$.bounds.y,B}}let _,j;try{_=p.screen.getDisplayMatching({x:K.x,y:K.y,width:K.width,height:K.height}),j=this.getWorkingArea(_)}catch($){}if(_&&j&&K.x+K.width>j.x&&K.y+K.height>j.y&&K.x<j.x+j.width&&K.y<j.y+j.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",j),K}getWorkingArea(K){if(K.workArea.width>0&&K.workArea.height>0)return K.workArea;if(K.bounds.width>0&&K.bounds.height>0)return K.bounds}getBounds(){const[K,ee]=this._win.getPosition(),[_,j]=this._win.getSize();return{x:K,y:ee,width:_,height:j}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(K){this.useNativeFullScreen()?this.setNativeFullScreen(K):this.setSimpleFullScreen(K),this.sendWhenReady(K?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(K){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(K)}setSimpleFullScreen(K){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(K),this._win.webContents.focus()}useNativeFullScreen(){const K=this.configurationService.getValue("window");return!K||typeof K.nativeFullScreen!="boolean"||K.nativeTabs?!0:K.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let K=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(K)<0&&(K="classic"),K}setMenuBarVisibility(K,ee=!0){P.isMacintosh||(K==="toggle"&&ee&&this.send("vscode:showInfoMessage",(0,v.localize)(10,null)),K==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(K)}):this.doSetMenuBarVisibility(K))}doSetMenuBarVisibility(K){const ee=this.isFullScreen;switch(K){case"classic":this._win.setMenuBarVisibility(!ee),this._win.autoHideMenuBar=ee;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(P.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(K,ee,..._){this.isReady?this.send(K,..._):this.ready().then(()=>{ee.isCancellationRequested||this.send(K,..._)})}send(K,...ee){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${K} for window that is destroyed`);return}this._win.webContents.send(K,...ee)}}updateTouchBar(K){!P.isMacintosh||this.touchBarGroups.forEach((ee,_)=>{const j=K[_];ee.segments=this.createTouchBarGroupSegments(j)})}createTouchBar(){if(!!P.isMacintosh){for(let K=0;K<10;K++){const ee=this.createTouchBarGroup();this.touchBarGroups.push(ee)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(K=[]){const ee=this.createTouchBarGroupSegments(K),_=new p.TouchBar.TouchBarSegmentedControl({segments:ee,mode:"buttons",segmentStyle:"automatic",change:j=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:_.segments[j].id,from:"touchbar"})}});return _}createTouchBarGroupSegments(K=[]){return K.map(_=>{let j;_.icon&&!m.ThemeIcon.isThemeIcon(_.icon)&&_.icon?.dark?.scheme===f.Schemas.file&&(j=p.nativeImage.createFromPath(E.URI.revive(_.icon.dark).fsPath),j.isEmpty()&&(j=void 0));let $;return typeof _.title=="string"?$=_.title:$=_.title.value,{id:_.id,label:j?void 0:$,icon:j}})}dispose(){super.dispose(),this._win=null}};ne=ue([te(1,t.ILogService),te(2,y.IEnvironmentMainService),te(3,o.IFileService),te(4,s.IStorageMainService),te(5,g.IConfigurationService),te(6,S.IThemeMainService),te(7,C.IWorkspacesManagementMainService),te(8,d.IBackupMainService),te(9,l.ITelemetryService),te(10,I.IDialogMainService),te(11,c.ILifecycleMainService),te(12,a.IProductService),te(13,r.IProtocolMainService)],ne),e.CodeWindow=ne}),define(Z[63],x([0,1,14,30,9,4,34,2,10,3,15,7,19,152,5,22,6,39,27,46]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I,y,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let o=class qe extends n.Disposable{constructor(m,S,D,R){super();this.stateMainService=m,this.logService=S,this.workspacesManagementMainService=D,this.lifecycleMainService=R,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(m=>this.addRecentlyOpened([{workspace:m.workspace}])))}handleWindowsJumpList(){!w.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(m){const S=[],D=[];for(let R of m)if((0,u.isRecentWorkspace)(R))!this.workspacesManagementMainService.isUntitledWorkspace(R.workspace)&&a(S,R.workspace)===-1&&S.push(R);else if((0,u.isRecentFolder)(R))r(S,R.folderUri)===-1&&S.push(R);else{const F=s(D,R.fileUri)>=0,C=R.fileUri.scheme===f.Schemas.file&&qe.COMMON_FILES_FILTER.indexOf((0,i.basename)(R.fileUri))>=0;!F&&!C&&(D.push(R),w.isWindows&&R.fileUri.scheme===f.Schemas.file&&p.app.addRecentDocument(R.fileUri.fsPath))}this.addEntriesFromStorage(S,D),S.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(S.length=qe.MAX_TOTAL_RECENT_ENTRIES),D.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(D.length=qe.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:S,files:D}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(m){const S=C=>{const G=t(C);for(const ne of m)if(i.extUriBiasedIgnorePathCase.isEqual(ne,G))return!1;return!0},D=this.getRecentlyOpened(),R=D.workspaces.filter(S),F=D.files.filter(S);(R.length!==D.workspaces.length||F.length!==D.files.length)&&(this.saveRecentlyOpened({files:F,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;p.app.clearRecentDocuments();const m=this.getRecentlyOpened(),S=[];let D=0;for(let F=0;F<m.workspaces.length&&D<qe.MAX_MACOS_DOCK_RECENT_WORKSPACES;F++){const C=t(m.workspaces[F]);if(C.scheme===f.Schemas.file){const G=(0,i.originalFSPath)(C);await E.Promises.exists(G)&&(S.push(G),D++)}}const R=[];for(let F=0;F<m.files.length&&D<qe.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;F++){const C=t(m.files[F]);if(C.scheme===f.Schemas.file){const G=(0,i.originalFSPath)(C);if(qe.COMMON_FILES_FILTER.includes((0,i.basename)(C))||S.includes(G))continue;await E.Promises.exists(G)&&(R.push(G),D++)}}R.reverse().forEach(F=>p.app.addRecentDocument(F)),S.reverse().forEach(F=>p.app.addRecentDocument(F))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(m){const S=[],D=[],R=m?.config?.workspace;(0,u.isWorkspaceIdentifier)(R)&&!this.workspacesManagementMainService.isUntitledWorkspace(R)?S.push({workspace:R}):(0,u.isSingleFolderWorkspaceIdentifier)(R)&&S.push({folderUri:R.uri});const F=m?.config?.filesToOpenOrCreate;if(F)for(let C of F){const G=C.fileUri;G&&s(D,G)===-1&&D.push({fileUri:G})}return this.addEntriesFromStorage(S,D),{workspaces:S,files:D}}addEntriesFromStorage(m,S){let D=this.getRecentlyOpenedFromStorage();for(let R of D.workspaces){let F=(0,u.isRecentFolder)(R)?r(m,R.folderUri):a(m,R.workspace);F>=0?m[F].label=m[F].label||R.label:m.push(R)}for(let R of D.files){let F=s(S,R.fileUri);F>=0?S[F].label=S[F].label||R.label:S.push(R)}}getRecentlyOpenedFromStorage(){const m=this.stateMainService.getItem(qe.recentlyOpenedStorageKey);return(0,u.restoreRecentlyOpened)(m,this.logService)}saveRecentlyOpened(m){const S=(0,u.toStoreData)(m);this.stateMainService.setItem(qe.recentlyOpenedStorageKey,S)}updateWindowsJumpList(){if(!w.isWindows)return;const m=[];if(m.push({type:"tasks",items:[{type:"task",title:(0,v.localize)(0,null),description:(0,v.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let S=[];for(let F of p.app.getJumpListSettings().removedItems){const C=F.args;if(C){const G=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);G&&S.push(P.URI.parse(G[2]))}}this.removeRecentlyOpened(S);let D=!1;const R=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(F=>{const C=(0,u.isRecentWorkspace)(F)?F.workspace:F.folderUri,{title:G,description:ne}=this.getWindowsJumpListLabel(C,F.label);let ae;return P.URI.isUri(C)?ae=`--folder-uri "${C.toString()}"`:(D=!0,ae=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:G.substr(0,255),description:ne.substr(0,255),program:process.execPath,args:ae,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&m.push({type:"custom",name:D?(0,v.localize)(2,null):(0,v.localize)(3,null),items:R})}m.push({type:"recent"});try{p.app.setJumpList(m)}catch(S){this.logService.warn("updateWindowsJumpList#setJumpList",S)}}getWindowsJumpListLabel(m,S){if(S)return{title:(0,b.splitName)(S).name,description:S};if(P.URI.isUri(m))return{title:(0,i.basename)(m),description:c(m)};if(this.workspacesManagementMainService.isUntitledWorkspace(m))return{title:(0,v.localize)(4,null),description:""};let D=(0,i.basename)(m.configPath);return D.endsWith(u.WORKSPACE_EXTENSION)&&(D=D.substr(0,D.length-u.WORKSPACE_EXTENSION.length-1)),{title:(0,v.localize)(5,null,D),description:c(m.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=ue([te(0,y.IStateMainService),te(1,I.ILogService),te(2,h.IWorkspacesManagementMainService),te(3,g.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function c(l){return l.scheme==="file"?(0,b.normalizeDriveLetter)(l.fsPath):l.toString()}function t(l){return(0,u.isRecentFolder)(l)?l.folderUri:(0,u.isRecentFile)(l)?l.fileUri:l.workspace.configPath}function a(l,m){return l.findIndex(S=>(0,u.isRecentWorkspace)(S)&&S.workspace.id===m.id)}function r(l,m){return l.findIndex(S=>(0,u.isRecentFolder)(S)&&i.extUriBiasedIgnorePathCase.isEqual(S.folderUri,m))}function s(l,m){return l.findIndex(S=>i.extUriBiasedIgnorePathCase.isEqual(S.fileUri,m))}}),define(Z[234],x([0,1,14,9,23,34,3,7,144,16,24,22,6,182,53,21,39,29,42,62,36,63]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I,y,u,h,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let a=class wt{constructor(l,m,S,D,R,F,C,G,ne,ae,K){this.updateService=l,this.configurationService=m,this.windowsMainService=S,this.environmentMainService=D,this.telemetryService=R,this.workspacesHistoryMainService=F,this.stateMainService=C,this.lifecycleMainService=G,this.logService=ne,this.nativeHostMainService=ae,this.productService=K,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(b.isMacintosh||(0,h.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const l=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);l&&(l.menus&&(this.menubarMenus=l.menus),l.keybindings&&(this.keybindings=l.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(F,C,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(F,C,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(F,C,G)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(F,C,G)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const l=this.productService.twitterUrl;l&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(l,"openTwitterUrl"));const m=this.productService.requestFeatureUrl;m&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(m,"openUserVoiceUrl"));const S=this.productService.reportIssueUrl;S&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(S,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(b.language){const F=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${F}lang=${b.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(l=>this.onDidChangeWindowsCount(l)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let l=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof l!="boolean"?!0:l}get currentEnableNativeTabs(){if(!b.isMacintosh)return!1;let l=this.configurationService.getValue("window.nativeTabs");return typeof l!="boolean"?!1:l}updateMenu(l,m){this.menubarMenus=l.menus,this.keybindings=l.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,l),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(l){!b.isMacintosh||(l.oldCount===0&&l.newCount>0||l.oldCount>0&&l.newCount===0)&&(this.closedLastWindow=l.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!b.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const l=p.Menu.getApplicationMenu();if(l&&this.oldMenus.push(l),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(b.isMacintosh?new p.Menu:null);return}const m=new p.Menu;let S;if(b.isMacintosh){const R=new p.Menu;S=new p.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),m.append(S)}if(b.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new p.Menu;R.append(new p.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:R});this.setMenuById(R,"File"),m.append(F)}if(this.shouldDrawMenu("Edit")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),m.append(F)}if(this.shouldDrawMenu("Selection")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),m.append(F)}if(this.shouldDrawMenu("View")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:R});this.setMenuById(R,"View"),m.append(F)}if(this.shouldDrawMenu("Go")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),m.append(F)}if(this.shouldDrawMenu("Run")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),m.append(F)}if(this.shouldDrawMenu("Terminal")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),m.append(F)}let D;if(this.shouldDrawMenu("Window")){const R=new p.Menu;D=new p.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(D&&m.append(D),this.shouldDrawMenu("Help")){const R=new p.Menu,F=new p.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),m.append(F)}m.items&&m.items.length>0?p.Menu.setApplicationMenu(m):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(l){const m=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),S=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const ee=new p.Menu;this.setMenuById(ee,"Preferences"),D=new p.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:ee})}const R=new p.Menu,F=new p.MenuItem({label:f.localize(12,null),role:"services",submenu:R}),C=new p.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),G=new p.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ne=new p.MenuItem({label:f.localize(15,null),role:"unhide"}),ae=new p.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const ee=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||ee?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),K=[m];K.push(...S),D&&K.push(r(),D),K.push(r(),F,r(),C,G,ne,r(),ae),K.forEach(ee=>l.append(ee))}shouldDrawMenu(l){if(!b.isMacintosh&&(0,h.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(l){case"File":case"Help":if(b.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[l];case"Window":if(b.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[l]}}setMenu(l,m){m.forEach(S=>{if((0,v.isMenubarMenuItemSeparator)(S))l.append(r());else if((0,v.isMenubarMenuItemSubmenu)(S)){const D=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(S.label),submenu:D});this.setMenu(D,S.submenu.items),l.append(R)}else(0,v.isMenubarMenuItemRecentAction)(S)?l.append(this.createOpenRecentMenuItem(S)):(0,v.isMenubarMenuItemAction)(S)&&(S.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(l),b.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[S.id]?l.append(new p.MenuItem(this.likeAction(S.id,{label:this.mnemonicLabel(S.label),click:this.fallbackMenuHandlers[S.id]}))):l.append(this.createMenuItem(S.label,S.id,!1,S.checked)):l.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)):l.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)))})}setMenuById(l,m){this.menubarMenus&&this.menubarMenus[m]&&this.setMenu(l,this.menubarMenus[m].items)}insertCheckForUpdatesItems(l){const m=this.getUpdateMenuItems();m.length&&(m.forEach(S=>l.append(S)),l.append(r()))}createOpenRecentMenuItem(l){const m=n.URI.revive(l.uri),S=l.id,D=S==="openRecentFile"?{fileUri:m}:S==="openRecentWorkspace"?{workspaceUri:m}:{folderUri:m};return new p.MenuItem(this.likeAction(S,{label:l.label,click:(R,F,C)=>{const G=this.isOptionClick(C);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:G,gotoLineMode:!1,remoteAuthority:l.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([m])}},!1))}isOptionClick(l){return!!(l&&(!b.isMacintosh&&(l.ctrlKey||l.shiftKey)||b.isMacintosh&&(l.metaKey||l.altKey)))}createRoleMenuItem(l,m,S){const D={label:this.mnemonicLabel(l),role:S,enabled:!0};return new p.MenuItem(this.withKeybinding(m,D))}setMacWindowMenu(l){const m=new p.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),S=new p.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new p.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),F=[];this.currentEnableNativeTabs&&(F.push(r()),F.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),F.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),F.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),F.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),F.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[m,S,r(),R,...F,r(),D].forEach(C=>l.append(C))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(l,m,S,D){const R=this.mnemonicLabel(l),F=typeof m=="function"?m:(K,ee,_)=>{const j=K?K.userSettingsLabel:null;let $=m;Array.isArray(m)&&($=this.isOptionClick(_)?m[1]:m[0]),j&&_.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:j}):this.runActionInRenderer({type:"commandId",commandId:$})},C=typeof S=="boolean"?S:this.windowsMainService.getWindowCount()>0,G=typeof D=="boolean"?D:!1,ne={label:R,click:F,enabled:C};G&&(ne.type="checkbox",ne.checked=G);let ae;return typeof m=="string"?ae=m:Array.isArray(m)&&(ae=m[0]),b.isMacintosh&&(ae==="editor.action.clipboardCutAction"?ne.role="cut":ae==="editor.action.clipboardCopyAction"?ne.role="copy":ae==="editor.action.clipboardPasteAction"&&(ne.role="paste"),ae==="undo"?ne.click=this.makeContextAwareClickHandler(F,{inDevTools:K=>K.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):ae==="redo"?ne.click=this.makeContextAwareClickHandler(F,{inDevTools:K=>K.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):ae==="editor.action.selectAll"&&(ne.click=this.makeContextAwareClickHandler(F,{inDevTools:K=>K.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(ae,ne))}makeContextAwareClickHandler(l,m){return(S,D,R)=>{const F=p.BrowserWindow.getFocusedWindow();if(!F)return m.inNoWindow();if(F.webContents.isDevToolsFocused()&&F.webContents.devToolsWebContents)return m.inDevTools(F.webContents.devToolsWebContents);l(S,D||F,R)}}runActionInRenderer(l){let m=p.BrowserWindow.getFocusedWindow();if(!m){const D=this.windowsMainService.getLastActiveWindow();D?.isMinimized()&&(m=D.win)}const S=m?this.windowsMainService.getWindowById(m.id):void 0;if(S){if(this.logService.trace("menubar#runActionInRenderer",l),b.isMacintosh&&!this.environmentMainService.isBuilt&&!S.isReady&&(l.type==="commandId"&&l.commandId==="workbench.action.toggleDevTools"||l.type!=="commandId"&&l.userSettingsLabel==="alt+cmd+i"))return;if(l.type==="commandId"){const D={id:l.commandId,from:"menu"};S.sendWhenReady("vscode:runAction",k.CancellationToken.None,D)}else{const D={userSettingsLabel:l.userSettingsLabel};S.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",l)}withKeybinding(l,m){const S=typeof l=="string"?this.keybindings[l]:void 0;if(S?.label){if(S.isNative!==!1)m.accelerator=S.label,m.userSettingsLabel=S.userSettingsLabel;else if(typeof m.label=="string"){const D=m.label.indexOf("[");D>=0?m.label=`${m.label.substr(0,D)} [${S.label}]`:m.label=`${m.label} [${S.label}]`}}else m.accelerator=void 0;return m}likeAction(l,m,S=!m.accelerator){S&&(m=this.withKeybinding(l,m));const D=m.click;return m.click=(R,F,C)=>{this.reportMenuActionTelemetry(l),D&&D(R,F,C)},m}openUrl(l,m){this.nativeHostMainService.openExternal(void 0,l),this.reportMenuActionTelemetry(m)}reportMenuActionTelemetry(l){this.telemetryService.publicLog2("workbenchActionExecuted",{id:l,from:t})}mnemonicLabel(l){return(0,M.mnemonicMenuLabel)(l,!this.currentEnableMenuBarMnemonics)}};a.lastKnownMenubarStorageKey="lastKnownMenubarData",a=ue([te(0,u.IUpdateService),te(1,w.IConfigurationService),te(2,o.IWindowsMainService),te(3,i.IEnvironmentMainService),te(4,y.ITelemetryService),te(5,c.IWorkspacesHistoryMainService),te(6,I.IStateMainService),te(7,P.ILifecycleMainService),te(8,E.ILogService),te(9,d.INativeHostMainService),te(10,g.IProductService)],a),e.Menubar=a;function r(){return new p.MenuItem({type:"separator"})}}),define(Z[235],x([0,1,5,22,6,234]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let b=class{constructor(f,w,i){this.instantiationService=f,this.lifecycleMainService=w,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(f,w){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(w,f)}};b=ue([te(0,p.IInstantiationService),te(1,L.ILifecycleMainService),te(2,k.ILogService)],b),e.MenubarMainService=b}),define(Z[236],x([0,1,14,32,26,30,23,4,31,43,34,2,10,8,73,3,33,15,13,7,150,51,16,52,24,20,5,22,6,45,21,55,74,39,62,233,99,216,27,100,63,46]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I,y,u,h,o,c,t,a,r,s,l,m,S,D,R,F,C,G,ne,ae,K,ee,_,j,$,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function H(T){return(0,_.isWorkspaceIdentifier)(T?.workspace)}function O(T){return(0,_.isSingleFolderWorkspaceIdentifier)(T?.workspace)}let q=class Je extends P.Disposable{constructor(A,W,z,X,U,N,Q,J,re,le,ie,oe,ge,fe,de){super();this.machineId=A,this.initialUserEnv=W,this.logService=z,this.stateMainService=X,this.environmentMainService=U,this.lifecycleMainService=N,this.backupMainService=Q,this.configurationService=J,this.workspacesHistoryMainService=re,this.workspacesManagementMainService=le,this.instantiationService=ie,this.dialogMainService=oe,this.fileService=ge,this.productService=fe,this.protocolMainService=de,this._onDidOpenWindow=this._register(new n.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new n.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new n.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new n.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new ee.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const W=new P.DisposableStore;if(W.add(n.Event.any(A.onDidClose,A.onDidDestroy)(()=>W.dispose())),A.config.extensionDevelopmentPath)for(const z of A.config.extensionDevelopmentPath)W.add(this.protocolMainService.addValidFileRoot(h.URI.file(z)));A.config.extensionTestsPath&&W.add(this.protocolMainService.addValidFileRoot(h.URI.file(A.config.extensionTestsPath)))}}))}openEmptyWindow(A,W){let z=this.environmentMainService.args;const X=W?.remoteAuthority||void 0,U=!0,N=W?.forceReuseWindow,Q=!N;return this.open({...A,cli:z,forceEmpty:U,forceNewWindow:Q,forceReuseWindow:N,remoteAuthority:X})}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const W=[],z=[],X=[],U=[],N=[];let Q,J=0;const re=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",re);for(const fe of re)O(fe)?A.addMode?W.push(fe):z.push(fe):H(fe)?X.push(fe):fe.fileUri?(Q||(Q={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:fe.remoteAuthority}),Q.filesToOpenOrCreate.push(fe)):fe.backupPath?N.push({backupFolder:(0,v.basename)(fe.backupPath),remoteAuthority:fe.remoteAuthority}):J++;A.diffMode&&Q&&Q.filesToOpenOrCreate.length>=2&&(Q.filesToDiff=Q.filesToOpenOrCreate.slice(0,2),Q.filesToOpenOrCreate=[]),Q&&A.waitMarkerFileURI&&(Q.filesToWait={paths:[...Q.filesToDiff,...Q.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(U.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),X.push(...U),N.push(...this.backupMainService.getEmptyWindowBackupPaths())):N.length=0;const{windows:le,filesOpenedInWindow:ie}=this.doOpen(A,X,z,N,J,Q,W);if(this.logService.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${X.length}, foldersToOpen: ${z.length}, emptyToRestore: ${N.length}, emptyToOpen: ${J})`),le.length>1)if(ie)ie.focus();else{const fe=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let de=!0,Pe=!0;if(fe){const pe=le.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),de=!1,Pe=!1)}if(de)for(let pe=le.length-1;pe>=0;pe--){const me=le[pe];if(!(me.openedWorkspace&&U.some(be=>me.openedWorkspace&&be.workspace.id===me.openedWorkspace.id)||me.backupPath&&N.some(be=>me.backupPath&&be.backupFolder===(0,v.basename)(me.backupPath)))){me.focus(),Pe=!1;break}}Pe&&le[le.length-1].focus()}const oe=Q&&Q.filesToDiff.length>0;if(!le.some(fe=>fe.isExtensionDevelopmentHost)&&!oe&&!A.noRecentEntry){const fe=[];for(const de of re)H(de)&&!de.transient?fe.push({label:de.label,workspace:de.workspace,remoteAuthority:de.remoteAuthority}):O(de)?fe.push({label:de.label,folderUri:de.workspace.uri,remoteAuthority:de.remoteAuthority}):de.fileUri&&fe.push({label:de.label,fileUri:de.fileUri,remoteAuthority:de.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(fe)}const ge=A.waitMarkerFileURI;return A.context===0&&ge&&le.length===1&&le[0]&&(async()=>{await le[0].whenClosedOrLoaded;try{await this.fileService.del(ge)}catch(fe){}})(),le}doOpen(A,W,z,X,U,N,Q){const J=[];let re;function le(pe,me){J.push(pe),me&&(re=pe,N=void 0)}let{openFolderInNewWindow:ie,openFilesInNewWindow:oe}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&Q.length>0){const pe=Q[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(pe);me&&le(this.doAddFoldersToExistingWindow(me,Q.map(be=>be.workspace.uri)))}const ge=z.length+W.length+X.length;if(N&&ge===0){const pe=N.filesToOpenOrCreate[0]||N.filesToDiff[0],me=this.getWindows().filter(ke=>N&&ke.remoteAuthority===N.remoteAuthority);let be;pe?.fileUri&&!oe&&((A.context===4||A.context===0||A.context===1)&&(be=(0,K.findWindowOnFile)(me,pe.fileUri,ke=>ke.configPath.scheme===E.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ke.configPath):void 0)),be||(be=this.doGetLastActiveWindow(me))),be?(0,_.isWorkspaceIdentifier)(be.openedWorkspace)?W.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,_.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?z.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):le(this.doOpenFilesInExistingWindow(A,be,N),!0):le(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const fe=(0,M.distinct)(W,pe=>pe.workspace.id);if(fe.length>0){const pe=(0,M.coalesce)(fe.map(me=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.configPath)));if(pe.length>0){const me=pe[0],be=N?.remoteAuthority===me.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(A,me,be),!!be),ie=!0}fe.forEach(me=>{if(pe.some(Ae=>Ae.openedWorkspace&&Ae.openedWorkspace.id===me.workspace.id))return;const be=me.remoteAuthority,ke=N?.remoteAuthority===be?N:void 0;le(this.doOpenFolderOrWorkspace(A,me,ie,ke),!!ke),ie=!0})}const de=(0,M.distinct)(z,pe=>y.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(de.length>0){const pe=(0,M.coalesce)(de.map(me=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.uri)));if(pe.length>0){const me=pe[0],be=N?.remoteAuthority===me.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(A,me,be),!!be),ie=!0}de.forEach(me=>{if(pe.some(Ae=>(0,_.isSingleFolderWorkspaceIdentifier)(Ae.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(Ae.openedWorkspace.uri,me.workspace.uri)))return;const be=me.remoteAuthority,ke=N?.remoteAuthority===be?N:void 0;le(this.doOpenFolderOrWorkspace(A,me,ie,ke),!!ke),ie=!0})}const Pe=(0,M.distinct)(X,pe=>pe.backupFolder);if(Pe.length>0&&Pe.forEach(pe=>{const me=pe.remoteAuthority,be=N?.remoteAuthority===me?N:void 0;le(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:be,remoteAuthority:me,forceNewWindow:!0,forceNewTabbedWindow:A.forceNewTabbedWindow,emptyWindowBackupInfo:pe}),!!be),ie=!0}),J.length===0||N){N&&!U&&U++;const pe=N?N.remoteAuthority:A.remoteAuthority;for(let me=0;me<U;me++)le(this.doOpenEmpty(A,ie,pe,N),!!N),ie=!0}return{windows:(0,M.distinct)(J),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(A,W,z){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),W.focus();const X={filesToOpenOrCreate:z?.filesToOpenOrCreate,filesToDiff:z?.filesToDiff,filesToWait:z?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",b.CancellationToken.None,X),W}doAddFoldersToExistingWindow(A,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),A.focus();const z={foldersToAdd:W};return A.sendWhenReady("vscode:addFolders",b.CancellationToken.None,z),A}doOpenEmpty(A,W,z,X,U){return!W&&!U&&typeof A.contextWindowId=="number"&&(U=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:z,forceNewWindow:W,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:X,windowToUse:U})}doOpenFolderOrWorkspace(A,W,z,X,U){return!z&&!U&&typeof A.contextWindowId=="number"&&(U=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:z,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:X,windowToUse:U})}getPathsToOpen(A){let W,z=!1,X=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(W=this.doExtractPathsFromAPI(A),z=!0):A.forceEmpty?W=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(W=this.doExtractPathsFromCLI(A.cli),W.length===0&&W.push(Object.create(null)),z=!0):(W=this.doGetPathsFromLastSession(),W.length===0&&W.push(Object.create(null)),X=!0),!A.addMode&&z){const U=W.filter(N=>O(N));if(U.length>1){const N=U[0].remoteAuthority;if(U.every(Q=>Q.remoteAuthority===N)){const Q=this.workspacesManagementMainService.createUntitledWorkspaceSync(U.map(J=>({uri:J.workspace.uri})));W.push({workspace:Q,remoteAuthority:N}),W=W.filter(J=>!O(J))}}}return A.initialStartup&&!X&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&W.unshift(...this.doGetPathsFromLastSession().filter(U=>H(U)||O(U)||U.backupPath)),W}doExtractPathsFromAPI(A){const W=[],z={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const X of(0,M.coalesce)(A.urisToOpen||[])){const U=this.resolveOpenable(X,z);if(U)U.label=X.label,W.push(U);else{const N=this.resourceFromOpenable(X),Q={title:this.productService.nameLong,type:"info",buttons:[(0,i.mnemonicButtonLabel)((0,o.localize)(0,null))],defaultId:0,message:N.scheme===E.Schemas.file?(0,o.localize)(1,null):(0,o.localize)(2,null),detail:N.scheme===E.Schemas.file?(0,o.localize)(3,null,(0,i.getPathLabel)(N.fsPath,this.environmentMainService)):(0,o.localize)(4,null,N.toString()),noLink:!0};this.dialogMainService.showMessageBox(Q,(0,u.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return W}doExtractPathsFromCLI(A){const W=[],z={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},X=A["folder-uri"];if(X)for(const Q of X){const J=this.cliArgToUri(Q);if(J){const re=this.resolveOpenable({folderUri:J},z);re&&W.push(re)}}const U=A["file-uri"];if(U)for(const Q of U){const J=this.cliArgToUri(Q);if(J){const re=this.resolveOpenable((0,_.hasWorkspaceFileExtension)(Q)?{workspaceUri:J}:{fileUri:J},z);re&&W.push(re)}}const N=A._;for(const Q of N){const J=z.remoteAuthority?this.doResolvePathRemote(Q,z):this.doResolveFilePath(Q,z);J&&W.push(J)}return W}cliArgToUri(A){try{const W=h.URI.parse(A);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${A}, ${W.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":const W=[];A!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const z=[];for(const X of W)if(X.workspace){const U=this.resolveOpenable({workspaceUri:X.workspace.configPath},{remoteAuthority:X.remoteAuthority,rejectTransientWorkspaces:!0});H(U)&&z.push(U)}else if(X.folderUri){const U=this.resolveOpenable({folderUri:X.folderUri},{remoteAuthority:X.remoteAuthority});O(U)&&z.push(U)}else A!=="folders"&&X.backupPath&&z.push({backupPath:X.backupPath,remoteAuthority:X.remoteAuthority});return z}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,W=Object.create(null)){let z=this.resourceFromOpenable(A);return z.scheme===E.Schemas.file?((0,ne.isFileToOpen)(A)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(z.fsPath,W)):this.doResolveRemoteOpenable(A,W)}doResolveRemoteOpenable(A,W){let z=this.resourceFromOpenable(A);const X=(0,C.getRemoteAuthority)(z)||W.remoteAuthority;if(z=(0,y.removeTrailingPathSeparator)((0,y.normalizePath)(z)),(0,ne.isFileToOpen)(A)){if(W.gotoLineMode){const{path:U,line:N,column:Q}=(0,f.parseLineAndColumnAware)(z.path);return{fileUri:z.with({path:U}),selection:N?{startLineNumber:N,startColumn:Q||1}:void 0,remoteAuthority:X}}return{fileUri:z,remoteAuthority:X}}else if((0,ne.isWorkspaceToOpen)(A))return{workspace:(0,j.getWorkspaceIdentifier)(z),remoteAuthority:X};return{workspace:(0,j.getSingleFolderWorkspaceIdentifier)(z),remoteAuthority:X}}resourceFromOpenable(A){return(0,ne.isWorkspaceToOpen)(A)?A.workspaceUri:(0,ne.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,W){let z,X;W.gotoLineMode&&({path:A,line:z,column:X}=(0,f.parseLineAndColumnAware)(A)),A=(0,f.sanitizeFilePath)((0,v.normalize)(A),(0,I.cwd)());try{const U=(0,L.statSync)(A);if(U.isFile()){if(!W.forceOpenWorkspaceAsFile){const N=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(A));if(N)return N.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},remoteAuthority:N.remoteAuthority,exists:!0,transient:N.transient}}return{fileUri:h.URI.file(A),selection:z?{startLineNumber:z,startColumn:X||1}:void 0,exists:!0}}else if(U.isDirectory())return{workspace:(0,j.getSingleFolderWorkspaceIdentifier)(h.URI.file(A),U),exists:!0}}catch(U){const N=h.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([N]),W.ignoreFileNotFound)return{fileUri:N,exists:!1}}}doResolvePathRemote(A,W){const z=A.charCodeAt(0),X=W.remoteAuthority;let U,N;W.gotoLineMode&&({path:A,line:U,column:N}=(0,f.parseLineAndColumnAware)(A)),z!==47&&((0,f.isWindowsDriveLetter)(z)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,f.toSlashes)(A)),A=`/${A}`);const Q=h.URI.from({scheme:E.Schemas.vscodeRemote,authority:X,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,_.hasWorkspaceFileExtension)(A))return W.forceOpenWorkspaceAsFile?{fileUri:Q,selection:U?{startLineNumber:U,startColumn:N||1}:void 0,remoteAuthority:W.remoteAuthority}:{workspace:(0,j.getWorkspaceIdentifier)(Q),remoteAuthority:X};if(W.gotoLineMode||v.posix.basename(A).indexOf(".")!==-1)return{fileUri:Q,selection:U?{startLineNumber:U,startColumn:N||1}:void 0,remoteAuthority:X}}return{workspace:(0,j.getSingleFolderWorkspaceIdentifier)(Q),remoteAuthority:X}}shouldOpenNewWindow(A){const W=this.configurationService.getValue("window"),z=W?.openFoldersInNewWindow||"default",X=W?.openFilesInNewWindow||"off";let U=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(z==="on"||z==="off")&&(U=z==="on");let N=!1;return A.forceNewWindow||A.forceReuseWindow?N=!!A.forceNewWindow&&!A.forceReuseWindow:(g.isMacintosh?A.context===1&&(N=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!A.cli.extensionDevelopmentPath&&(X==="on"||X==="off")&&(N=X==="on")),{openFolderInNewWindow:!!U,openFilesInNewWindow:N}}openExtensionDevelopmentHostWindow(A,W){const z=(0,K.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(z)return this.lifecycleMainService.reload(z,W.cli),z.focus(),[z];let X=W.cli["folder-uri"]||[],U=W.cli["file-uri"]||[],N=W.cli._;if(!N.length&&!X.length&&!U.length&&!W.cli.extensionTestsPath){const le=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ie=le&&(le.workspace||le.folderUri);ie&&(h.URI.isUri(ie)?ie.scheme===E.Schemas.file?N=[ie.fsPath]:X=[ie.toString()]:ie.configPath.scheme===E.Schemas.file?N=[(0,y.originalFSPath)(ie.configPath)]:U=[ie.configPath.toString()])}let Q=W.remoteAuthority;for(const le of A)if(le.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ie=h.URI.parse(le),oe=(0,C.getRemoteAuthority)(ie);oe&&(Q?oe!==Q&&this.logService.error("more than one extension development path authority"):Q=oe)}N=N.filter(le=>{const ie=h.URI.file(le);return(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:(0,C.getRemoteAuthority)(ie)===Q}),X=X.filter(le=>{const ie=this.cliArgToUri(le);return ie&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,C.getRemoteAuthority)(ie)===Q:!1}),U=U.filter(le=>{const ie=this.cliArgToUri(le);return ie&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,C.getRemoteAuthority)(ie)===Q:!1}),W.cli._=N,W.cli["folder-uri"]=X,W.cli["file-uri"]=U;const J=!N.length&&!X.length&&!U.length,re={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:J,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:Q};return this.open(re)}openInBrowserWindow(A){const W=this.configurationService.getValue("window"),z={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,v.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:D.default,isInitialStartup:A.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof W?.zoomLevel=="number"?W.zoomLevel:void 0,enableLegacyRecursiveWatcher:this.configurationService.getValue("files.legacyWatcher"),autoDetectHighContrast:W?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let X;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(X=A.windowToUse||this.getLastActiveWindow(),X&&X.focus()),X){const U=X.config;!z.extensionDevelopmentPath&&U&&!!U.extensionDevelopmentPath&&(z.extensionDevelopmentPath=U.extensionDevelopmentPath,z.verbose=U.verbose,z["inspect-brk-extensions"]=U["inspect-brk-extensions"],z.debugId=U.debugId,z["inspect-extensions"]=U["inspect-extensions"],z["extensions-dir"]=U["extensions-dir"])}else{const U=this.windowsStateHandler.getNewWindowState(z);(0,d.mark)("code/willCreateCodeWindow");const N=X=this.instantiationService.createInstance(ae.CodeWindow,{state:U,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});if((0,d.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow){const J=this.getLastActiveWindow();J&&J.addTabbedWindow(N)}Je.WINDOWS.push(N),this._onDidOpenWindow.fire(N),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(N.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(N)),(0,w.once)(N.onDidClose)(()=>this.onWindowClosed(N)),(0,w.once)(N.onDidDestroy)(()=>this._onDidDestroyWindow.fire(N));const Q=(0,u.assertIsDefined)(N.win?.webContents);Q.removeAllListeners("devtools-reload-page"),Q.on("devtools-reload-page",()=>this.lifecycleMainService.reload(N)),this.lifecycleMainService.registerWindow(N)}return z.windowId=X.id,X.isReady?this.lifecycleMainService.unload(X,4).then(U=>{U||this.doOpenInBrowserWindow(X,z,A)}):this.doOpenInBrowserWindow(X,z,A),X}doOpenInBrowserWindow(A,W,z){if(!W.extensionDevelopmentPath)if((0,_.isWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:W.workspace,remoteAuthority:W.remoteAuthority});else if((0,_.isSingleFolderWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerFolderBackupSync(W.workspace.uri);else{const X=z.emptyWindowBackupInfo&&z.emptyWindowBackupInfo.backupFolder;W.backupPath=this.backupMainService.registerEmptyWindowBackupSync(X,W.remoteAuthority)}A.load(W)}onWindowClosed(A){const W=Je.WINDOWS.indexOf(A);Je.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=p.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(W=>W.remoteAuthority===A))}doGetLastActiveWindow(A){const W=Math.max.apply(Math,A.map(z=>z.lastFocusTime));return A.find(z=>z.lastFocusTime===W)}sendToFocused(A,...W){const z=this.getFocusedWindow()||this.getLastActiveWindow();z&&z.sendWhenReady(A,b.CancellationToken.None,...W)}sendToAll(A,W,z){for(const X of this.getWindows())z&&z.indexOf(X.id)>=0||X.sendWhenReady(A,b.CancellationToken.None,W)}getWindows(){return Je.WINDOWS}getWindowCount(){return Je.WINDOWS.length}getWindowById(A){const W=this.getWindows().filter(z=>z.id===A);return(0,M.firstOrDefault)(W)}getWindowByWebContents(A){const W=p.BrowserWindow.fromWebContents(A);if(!!W)return this.getWindowById(W.id)}};q.WINDOWS=[],q=ue([te(2,S.ILogService),te(3,G.IStateMainService),te(4,r.IEnvironmentMainService),te(5,m.ILifecycleMainService),te(6,c.IBackupMainService),te(7,t.IConfigurationService),te(8,$.IWorkspacesHistoryMainService),te(9,B.IWorkspacesManagementMainService),te(10,l.IInstantiationService),te(11,a.IDialogMainService),te(12,s.IFileService),te(13,R.IProductService),te(14,F.IProtocolMainService)],q),e.WindowsMainService=q}),define(Z[237],x([0,1,51,36,63,46]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let b=class{constructor(f,w,i,P){this.workspacesManagementMainService=f,this.windowsMainService=w,this.workspacesHistoryMainService=i,this.backupMainService=P,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,w){const i=this.windowsMainService.getWindowById(f);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(f,w,i){return this.workspacesManagementMainService.createUntitledWorkspace(w,i)}deleteUntitledWorkspace(f,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(f,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}async getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}async addRecentlyOpened(f,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}async removeRecentlyOpened(f,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}async clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};b=ue([te(0,M.IWorkspacesManagementMainService),te(1,L.IWindowsMainService),te(2,k.IWorkspacesHistoryMainService),te(3,p.IBackupMainService)],b),e.WorkspacesMainService=b}),define(Z[238],x([0,1,14,32,26,18,17,31,43,40,34,2,10,8,3,15,13,7,28,67,119,35,122,84,229,131,51,220,16,178,157,71,52,219,88,24,54,90,169,185,89,172,20,70,5,72,230,196,101,22,6,180,235,53,21,74,225,75,39,214,98,197,29,199,201,60,42,205,227,231,228,232,97,206,207,208,209,211,36,236,212,27,63,237,46]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I,y,u,h,o,c,t,a,r,s,l,m,S,D,R,F,C,G,ne,ae,K,ee,_,j,$,B,H,O,q,T,A,W,z,X,U,N,Q,J,re,le,ie,oe,ge,fe,de,Pe,pe,me,be,ke,Ae,Ue,Ce,Ge,Be,ot,Ze,at,Ye,ht,xe,Y,se,ce,we,ye,De,Fe,We){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ne=class extends P.Disposable{constructor(he,Se,Ee,ve,Ie,Le,Me,Re,Te,$e){super();this.mainProcessNodeIpcServer=he,this.userEnv=Se,this.mainInstantiationService=Ee,this.logService=ve,this.environmentMainService=Ie,this.lifecycleMainService=Le,this.configurationService=Me,this.stateMainService=Re,this.fileService=Te,this.productService=$e,this.configureSession(),this.registerListeners()}configureSession(){const he=ve=>ve?.startsWith(`${E.Schemas.vscodeWebview}://`),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((ve,Ie,Le,Me)=>he(Me.requestingUrl)?Le(Se.has(Ie)):Le(!1)),p.session.defaultSession.setPermissionCheckHandler((ve,Ie,Le,Me)=>he(Me.requestingUrl)?Se.has(Ie):!1);const Ee=p.session.defaultSession;typeof Ee.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ee.setCodeCachePath((0,v.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,b.setUnexpectedErrorHandler)(Ee=>this.onUnexpectedError(Ee)),process.on("uncaughtException",Ee=>(0,b.onUnexpectedError)(Ee)),process.on("unhandledRejection",Ee=>(0,b.onUnexpectedError)(Ee)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,o.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(Ee,ve)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ve)}),p.app.on("activate",(Ee,ve)=>{this.logService.trace("app#activate"),ve||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(Ee,ve)=>{ve.on("will-navigate",Ie=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),ve.setWindowOpenHandler(({url:Ie})=>(this.nativeHostMainService?.openExternal(void 0,Ie),{action:"deny"}))});let he=[],Se;p.app.on("open-file",(Ee,ve)=>{this.logService.trace("app#open-file: ",ve),Ee.preventDefault(),he.push(this.getWindowOpenableFromPathSync(ve)),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:he,gotoLineMode:!1,preferNewWindow:!0}),he=[],Se=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",Ee=>{const ve=this.windowsMainService?.getWindowByWebContents(Ee.sender);let Ie,Le;return ve?.config?(Ie=ve.config,Le={...process.env,...ve.config.userEnv}):(Ie=this.environmentMainService.args,Le=process.env),(0,ee.resolveShellEnv)(this.logService,Ie,Le)}),p.ipcMain.handle("vscode:writeNlsFile",(Ee,ve,Ie)=>{const Le=this.validateNlsPath([ve]);if(!Le||typeof Ie!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,M.VSBuffer.fromString(Ie))}),p.ipcMain.handle("vscode:readNlsFile",async(Ee,...ve)=>{const Ie=this.validateNlsPath(ve);if(!Ie)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ie)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",Ee=>Ee.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",Ee=>Ee.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",Ee=>Ee.sender.reload())}validateNlsPath(he){let Se;for(const Ee of he)typeof Ee=="string"&&(typeof Se!="string"?Se=Ee:Se=(0,v.join)(Se,Ee));if(!(typeof Se!="string"||!(0,v.isAbsolute)(Se)||!(0,n.isEqualOrParent)(Se,this.environmentMainService.cachedLanguagesPath,!d.isLinux)))return y.URI.file(Se)}onUnexpectedError(he){if(he){const Se={message:`[uncaught exception in main]: ${he.message}`,stack:he.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.logService.error(`[uncaught exception in main]: ${he}`),he.stack&&this.logService.error(he.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const he=this.productService.win32AppUserModelId;d.isWindows&&he&&p.app.setAppUserModelId(he);try{d.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.logService.error(Te)}const Se=new t.Server;this.logService.trace("Resolving machine identifier...");const Ee=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Ee}`);const{sharedProcess:ve,sharedProcessReady:Ie,sharedProcessClient:Le}=this.setupSharedProcess(Ee),Me=await this.initServices(Ee,ve,Ie);if(this.environmentMainService.driverHandle){const Te=await(0,G.serve)(Se,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Te)}this._register(Me.createInstance(r.ProxyAuthHandler)),Me.invokeFunction(Te=>this.initChannels(Te,Se,Le));const Re=Me.invokeFunction(Te=>this.openFirstWindow(Te,Se));Me.invokeFunction(Te=>this.afterWindowOpen(Te,ve)),this.environmentMainService.args.trace&&Me.invokeFunction(Te=>this.stopTracingEventually(Te,Re))}async resolveMachineId(){let he=this.stateMainService.getItem(pe.machineIdKey);return(!he||d.isMacintosh&&he==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(he=await(0,h.getMachineId)(),this.stateMainService.setItem(pe.machineIdKey,he)),he}setupSharedProcess(he){const Se=this._register(this.mainInstantiationService.createInstance(ie.SharedProcess,he,this.userEnv)),Ee=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ie=await Se.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new a.Client(Ie,"main")})(),ve=(async()=>(await Se.whenReady(),Ee))();return{sharedProcess:Se,sharedProcessReady:ve,sharedProcessClient:Ee}}async initServices(he,Se,Ee){const ve=new T.ServiceCollection;switch(process.platform){case"win32":ve.set(Ae.IUpdateService,new O.SyncDescriptor(ot.Win32UpdateService));break;case"linux":d.isLinuxSnap?ve.set(Ae.IUpdateService,new O.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(Ae.IUpdateService,new O.SyncDescriptor(Ge.LinuxUpdateService));break;case"darwin":ve.set(Ae.IUpdateService,new O.SyncDescriptor(Ce.DarwinUpdateService));break}ve.set(se.IWindowsMainService,new O.SyncDescriptor(ce.WindowsMainService,[he,this.userEnv])),ve.set(C.IDialogMainService,new O.SyncDescriptor(C.DialogMainService)),ve.set(z.ILaunchMainService,new O.SyncDescriptor(z.LaunchMainService)),ve.set(F.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(Ee.then(Le=>Le.getChannel("diagnostics"))))),ve.set(A.IIssueMainService,new O.SyncDescriptor(A.IssueMainService,[this.userEnv])),ve.set(ne.IEncryptionMainService,new O.SyncDescriptor(ne.EncryptionMainService,[he])),ve.set(W.IKeyboardLayoutMainService,new O.SyncDescriptor(W.KeyboardLayoutMainService)),ve.set(J.INativeHostMainService,new O.SyncDescriptor(J.NativeHostMainService,[Se])),ve.set(xe.IWebviewManagerService,new O.SyncDescriptor(Y.WebviewMainService)),ve.set(ye.IWorkspacesService,new O.SyncDescriptor(Fe.WorkspacesMainService)),ve.set(We.IWorkspacesManagementMainService,new O.SyncDescriptor(We.WorkspacesManagementMainService)),ve.set(De.IWorkspacesHistoryMainService,new O.SyncDescriptor(De.WorkspacesHistoryMainService)),ve.set(Q.IMenubarMainService,new O.SyncDescriptor(Q.MenubarMainService)),ve.set(_.IExtensionUrlTrustService,new O.SyncDescriptor(j.ExtensionUrlTrustService)),ve.set(de.IStorageMainService,new O.SyncDescriptor(de.StorageMainService)),d.isWindows?ve.set($.IExternalTerminalMainService,new O.SyncDescriptor(B.WindowsExternalTerminalService)):d.isMacintosh?ve.set($.IExternalTerminalMainService,new O.SyncDescriptor(B.MacExternalTerminalService)):d.isLinux&&ve.set($.IExternalTerminalMainService,new O.SyncDescriptor(B.LinuxExternalTerminalService));const Ie=new m.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ve.set(l.IBackupMainService,Ie),ve.set(Ze.IURLService,new O.SyncDescriptor(Ye.NativeURLService)),(0,ke.getTelemetryLevel)(this.productService,this.environmentMainService)>=2){const Le=(0,c.getDelayedChannel)(Ee.then(Ve=>Ve.getChannel("telemetryAppender"))),Me=new me.TelemetryAppenderClient(Le),Re=(0,Pe.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,he,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Te=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],$e={appender:Me,commonProperties:Re,piiPaths:Te,sendErrorTelemetry:!0};ve.set(pe.ITelemetryService,new O.SyncDescriptor(be.TelemetryService,[$e]))}else ve.set(pe.ITelemetryService,ke.NullTelemetryService);return await Ie.initialize(),this.mainInstantiationService.createChild(ve)}initChannels(he,Se,Ee){const ve=c.ProxyChannel.fromService(he.get(z.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ve),Se.registerChannel(D.UserConfigurationFileServiceId,c.ProxyChannel.fromService(new D.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Ie=new Ue.UpdateChannel(he.get(Ae.IUpdateService));Se.registerChannel("update",Ie);const Le=c.ProxyChannel.fromService(he.get(A.IIssueMainService));Se.registerChannel("issue",Le);const Me=c.ProxyChannel.fromService(he.get(ne.IEncryptionMainService));Se.registerChannel("encryption",Me);const Re=c.ProxyChannel.fromService(he.get(oe.ISignService));Se.registerChannel("sign",Re);const Te=c.ProxyChannel.fromService(he.get(W.IKeyboardLayoutMainService));Se.registerChannel("keyboardLayout",Te),this.nativeHostMainService=he.get(J.INativeHostMainService);const $e=c.ProxyChannel.fromService(this.nativeHostMainService);Se.registerChannel("nativeHost",$e),Ee.then(He=>He.registerChannel("nativeHost",$e));const Ve=c.ProxyChannel.fromService(he.get(ye.IWorkspacesService));Se.registerChannel("workspaces",Ve);const et=c.ProxyChannel.fromService(he.get(Q.IMenubarMainService));Se.registerChannel("menubar",et);const tt=c.ProxyChannel.fromService(he.get(Ze.IURLService));Se.registerChannel("url",tt);const it=c.ProxyChannel.fromService(he.get(_.IExtensionUrlTrustService));Se.registerChannel("extensionUrlTrust",it);const _e=c.ProxyChannel.fromService(he.get(xe.IWebviewManagerService));Se.registerChannel("webview",_e);const nt=this._register(new fe.StorageDatabaseChannel(this.logService,he.get(de.IStorageMainService)));Se.registerChannel("storage",nt),Ee.then(He=>He.registerChannel("storage",nt));const rt=c.ProxyChannel.fromService(he.get($.IExternalTerminalMainService));Se.registerChannel("externalTerminal",rt);const Xe=new N.LogLevelChannel(he.get(U.ILogService));Se.registerChannel("logLevel",Xe),Ee.then(He=>He.registerChannel("logLevel",Xe));const st=new N.LoggerChannel(he.get(U.ILoggerService));Se.registerChannel("logger",st),Ee.then(He=>He.registerChannel("logger",st));const lt=new R.ElectronExtensionHostDebugBroadcastChannel(he.get(se.IWindowsMainService));Se.registerChannel("extensionhostdebugservice",lt)}openFirstWindow(he,Se){const Ee=this.windowsMainService=he.get(se.IWindowsMainService),ve=he.get(Ze.IURLService),Ie=he.get(J.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:y.URI.parse(Oe),url:Oe}}catch{return}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(Oe.uri);return Qe?(Le.push(Qe),!1):!0}),Re=this,Te=this.environmentMainService,$e=this.productService;ve.registerHandler({async handleURL(Oe,Qe){if(Oe.scheme===$e.urlProtocol&&Oe.path==="workspace"&&(Oe=Oe.with({authority:"file",path:y.URI.parse(Oe.query).path,query:""})),Re.shouldBlockURI(Oe))return!0;const vt=Re.getWindowOpenableFromProtocolLink(Oe);if(vt){const[ft]=Ee.open({context:5,cli:{...Te.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(d.isMacintosh&&Ee.getWindowCount()===0){const[ft]=Ee.open({context:5,cli:{...Te.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,le.getRemoteAuthority)(Oe)});return await ft.ready(),ve.open(Oe,Qe)}return!1}});const Ve=this._register(new we.ActiveWindowManager({onDidOpenWindow:Ie.onDidOpenWindow,onDidFocusWindow:Ie.onDidFocusWindow,getActiveWindowId:()=>Ie.getActiveWindowId(-1)})),et=new c.StaticRouter(Oe=>Ve.getActiveClientId().then(Qe=>Oe===Qe)),tt=new at.URLHandlerRouter(et),it=Se.getChannel("urlHandler",tt);ve.registerHandler(new at.URLHandlerChannelClient(it)),this._register(new ht.ElectronURLListener(Me,ve,Ee,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,nt=global.macOpenFiles,rt=(0,K.isLaunchedFromCli)(process.env)?0:4,Xe=_e._.length,st=!!_e["folder-uri"],lt=!!_e["file-uri"],He=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?y.URI.file(_e.waitMarkerFilePath):void 0,pt=_e.remote||void 0;return Le.length>0?Ee.open({context:rt,cli:_e,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Xe&&!st&&!lt?Ee.open({context:rt,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):nt.length&&!Xe&&!st&&!lt?Ee.open({context:1,cli:_e,urisToOpen:nt.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:He,waitMarkerFileURI:dt,initialStartup:!0}):Ee.open({context:rt,cli:_e,forceNewWindow:_e["new-window"]||!Xe&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:He,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(he){return!!(he.authority===E.Schemas.file&&d.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,i.mnemonicButtonLabel)((0,s.localize)(0,null)),(0,i.mnemonicButtonLabel)((0,s.localize)(1,null))],defaultId:0,cancelId:1,message:(0,s.localize)(2,null,(0,i.getPathLabel)(he.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,s.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(he){if(!!he.path){if(he.authority===E.Schemas.file)return{fileUri:y.URI.file(he.fsPath)};if(he.authority===E.Schemas.vscodeRemote){const Se=he.path.indexOf(v.posix.sep,1);if(Se!==-1){const Ee=he.path.substring(1,Se),ve=he.path.substring(Se),Ie=y.URI.from({scheme:E.Schemas.vscodeRemote,authority:Ee,path:ve,query:he.query,fragment:he.fragment});return(0,ye.hasWorkspaceFileExtension)(ve)?{workspaceUri:Ie}:/:[\d]+$/.test(ve)?{fileUri:Ie}:{folderUri:Ie}}}}}getWindowOpenableFromPathSync(he){try{if((0,L.statSync)(he).isDirectory())return{folderUri:y.URI.file(he)};if((0,ye.hasWorkspaceFileExtension)(he))return{workspaceUri:y.URI.file(he)}}catch(Se){}return{fileUri:y.URI.file(he)}}async afterWindowOpen(he,Se){this.lifecycleMainService.phase=3;let Ee=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Ee=!0);const ve=he.get(pe.ITelemetryService);this._register(Se.onDidError(({type:Me,details:Re})=>{let Te;switch(Me){case 1:Te="SharedProcess: detected unresponsive window";break;case 2:Te=`SharedProcess: crashed (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break;case 3:Te=`SharedProcess: failed to load (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break}(0,b.onUnexpectedError)(new Error(Te)),ve.publicLog2("sharedprocesserror",{type:Me,reason:Re?.reason,code:Re?.exitCode,visible:Se.isVisible(),shuttingdown:Ee})}));const Ie=this.productService.win32MutexName;if(d.isWindows&&Ie)try{const Me=V.__$__nodeRequire("windows-mutex").Mutex,Re=new Me(Ie);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(Me){this.logService.error(Me)}p.protocol.registerHttpProtocol(E.Schemas.vscodeRemoteResource,(Me,Re)=>{Re({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const Le=he.get(Ae.IUpdateService);(Le instanceof ot.Win32UpdateService||Le instanceof Ge.LinuxUpdateService||Le instanceof Ce.DarwinUpdateService)&&Le.initialize(),(0,ee.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const Re=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,w.stripComments)(Re))["enable-crash-reporter"]===void 0){const $e=(0,ke.getTelemetryConfiguration)(this.configurationService),Ve=$e==="on"||$e==="error",et=typeof Ve=="boolean"?Ve:!0,tt=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${et},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,u.generateUuid)()}"`,"}"],it=Re.substring(0,Re.length-2).concat(`,
`,tt.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(it))}}catch(Me){this.logService.error(Me)}}stopTracingEventually(he,Se){this.logService.info("Tracing: waiting for windows to get ready...");const Ee=he.get(C.IDialogMainService);let ve=!1;const Ie=async Me=>{if(ve)return;ve=!0;const Re=await p.contentTracing.stopRecording((0,g.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Re}`):Ee.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,s.localize)(4,null),detail:(0,s.localize)(5,null,Re),buttons:[(0,i.mnemonicButtonLabel)((0,s.localize)(6,null))],defaultId:0,noLink:!0},(0,I.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},Le=setTimeout(()=>Ie(!0),3e4);Promise.all(Se.map(Me=>Me.ready())).then(()=>{clearTimeout(Le),Ie(!1)})}};Ne=ue([te(2,q.IInstantiationService),te(3,U.ILogService),te(4,ae.IEnvironmentMainService),te(5,X.ILifecycleMainService),te(6,S.IConfigurationService),te(7,ge.IStateMainService),te(8,H.IFileService),te(9,re.IProductService)],Ne),e.CodeApplication=Ne}),define(Z[242],x([0,1,14,32,30,9,68,17,31,43,34,10,8,73,3,33,25,19,35,56,238,11,16,189,198,24,54,161,20,183,184,70,174,72,22,92,6,181,93,45,21,55,186,95,222,50,224,75,195,39,226,60,61,204]),function(V,e,p,L,k,M,b,n,f,w,i,P,E,v,d,g,I,y,u,h,o,c,t,a,r,s,l,m,S,D,R,F,C,G,ne,ae,K,ee,_,j,$,B,H,O,q,T,A,W,z,X,U,N,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class J{main(){try{this.startup()}catch(ie){console.error(ie.message),p.app.exit(1)}}async startup(){(0,n.setUnexpectedErrorHandler)(me=>console.error(me));const[ie,oe,ge,fe,de,Pe,pe]=this.createServices();try{try{await this.initServices(ge,fe,de)}catch(me){throw this.handleStartupDataDirError(ge,pe.nameLong,me),me}await ie.invokeFunction(async me=>{const be=me.get(K.ILogService),ke=me.get(ne.ILifecycleMainService),Ae=me.get(S.IFileService),Ue=await this.claimInstance(be,ge,ke,ie,pe,!0);return y.Promises.writeFile(ge.mainLockfile,String(process.pid)).catch(Ce=>{be.warn(`Error writing main lockfile: ${Ce.stack}`)}),Pe.logger=new _.SpdLogLogger("main",(0,E.join)(ge.logsPath,"main.log"),!0,Pe.getLevel()),(0,w.once)(ke.onWillShutdown)(Ce=>{Ae.dispose(),fe.dispose(),Ce.join(y.Promises.unlink(ge.mainLockfile).catch(()=>{}))}),ie.createInstance(o.CodeApplication,Ue,oe).startup()})}catch(me){ie.invokeFunction(this.quit,me)}}createServices(){const ie=new G.ServiceCollection,oe={_serviceBrand:void 0,...j.default};ie.set($.IProductService,oe);const ge=new s.EnvironmentMainService(this.resolveArgs(),oe),fe=this.patchEnvironment(ge);ie.set(s.IEnvironmentMainService,ge);const de=new ae.BufferLogService,Pe=new K.MultiplexLogService([new K.ConsoleMainLogger((0,K.getLogLevel)(ge)),de]);process.once("exit",()=>Pe.dispose()),ie.set(K.ILogService,Pe);const pe=new D.FileService(Pe);ie.set(S.IFileService,pe);const me=new R.DiskFileSystemProvider(Pe);pe.registerProvider(P.Schemas.file,me),ie.set(K.ILoggerService,new ee.LoggerService(Pe,pe));const be=new a.ConfigurationService(ge.settingsResource,pe);ie.set(t.IConfigurationService,be),ie.set(ne.ILifecycleMainService,new F.SyncDescriptor(ne.LifecycleMainService));const ke=new U.StateMainService(ge,Pe,pe);return ie.set(X.IStateMainService,ke),ie.set(T.IRequestService,new F.SyncDescriptor(A.RequestMainService)),ie.set(Q.IThemeMainService,new F.SyncDescriptor(Q.ThemeMainService)),ie.set(W.ISignService,new F.SyncDescriptor(z.SignService)),ie.set(O.ITunnelService,new F.SyncDescriptor(q.TunnelService)),ie.set(B.IProtocolMainService,new F.SyncDescriptor(H.ProtocolMainService)),[new C.InstantiationService(ie,!0),fe,ge,be,ke,de,oe]}patchEnvironment(ie){const oe={VSCODE_IPC_HOOK:ie.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ge=>{const fe=process.env[ge];typeof fe=="string"&&(oe[ge]=fe)}),Object.assign(process.env,oe),oe}initServices(ie,oe,ge){return M.Promises.settled([Promise.all([ie.extensionsPath,ie.codeCachePath,ie.logsPath,ie.globalStorageHome.fsPath,ie.workspaceStorageHome.fsPath,ie.backupHome].map(fe=>fe?y.Promises.mkdir(fe,{recursive:!0}):void 0)),oe.initialize(),ge.init()])}async claimInstance(ie,oe,ge,fe,de,Pe){let pe;try{(0,v.mark)("code/willStartMainServer"),pe=await(0,h.serve)(oe.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),(0,w.once)(ge.onWillShutdown)(()=>pe.dispose())}catch(me){if(me.code!=="EADDRINUSE")throw this.handleStartupDataDirError(oe,de.nameLong,me),me;let be;try{be=await(0,h.connect)(oe.mainIPCHandle,"main")}catch(Ue){if(!Pe||d.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,de.nameShort),(0,c.localize)(1,null),de.nameLong),Ue;try{(0,L.unlinkSync)(oe.mainIPCHandle)}catch(Ce){throw ie.warn("Could not delete obsolete instance handle",Ce),Ce}return this.claimInstance(ie,oe,ge,fe,de,!1)}if(oe.extensionTestsLocationURI&&!oe.debugExtensionHost.break){const Ue="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ie.error(Ue),be.dispose(),new Error(Ue)}let ke;!oe.args.wait&&!oe.args.status&&(ke=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,de.nameShort),(0,c.localize)(3,null),de.nameLong)},1e4));const Ae=u.ProxyChannel.toService(be.getChannel("launch"),{disableMarshalling:!0});if(oe.args.status)return fe.invokeFunction(async()=>{const Ue=new r.DiagnosticsService(N.NullTelemetryService,de),Ce=await Ae.getMainProcessInfo(),Ge=await Ae.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ue.getDiagnostics(Ce,Ge);throw console.log(Be),new n.ExpectedError});throw d.isWindows&&await this.windowsAllowSetForegroundWindow(Ae,ie),ie.trace("Sending env to running instance..."),await Ae.start(oe.args,process.env),be.dispose(),ke&&clearTimeout(ke),new n.ExpectedError("Sent env to running instance. Terminating...")}if(oe.args.status)throw ie.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new n.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),pe}handleStartupDataDirError(ie,oe,ge){if(ge.code==="EACCES"||ge.code==="EPERM"){const fe=(0,k.coalesce)([ie.userDataPath,ie.extensionsPath,h.XDG_RUNTIME_DIR]).map(de=>(0,i.getPathLabel)(de,ie));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,b.toErrorMessage)(ge),fe.join(`
`)),oe)}}showStartupWarningDialog(ie,oe,ge){p.dialog.showMessageBoxSync({title:ge,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,c.localize)(6,null))],message:ie,detail:oe,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ie,oe){if(d.isWindows){const ge=await ie.getMainProcessId();oe.trace("Sending some foreground love to the running instance:",ge);try{(await new Promise((fe,de)=>{V(["windows-foreground-love"],fe,de)})).allowSetForegroundWindow(ge)}catch(fe){oe.error(fe)}}}quit(ie,oe){const ge=ie.get(K.ILogService),fe=ie.get(ne.ILifecycleMainService);let de=0;oe&&(oe.isExpected?oe.message&&ge.trace(oe.message):(de=1,oe.stack?ge.error(oe.stack):ge.error(`Startup error: ${oe.toString()}`))),fe.kill(de)}resolveArgs(){const ie=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(ie.wait&&!ie.waitMarkerFilePath){const oe=(0,m.createWaitMarkerFile)(ie.verbose);oe&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",oe),ie.waitMarkerFilePath=oe)}return ie}validatePaths(ie){if(ie["open-url"]&&(ie._urls=ie._,ie._=[]),!ie.remote){const oe=this.doValidatePaths(ie._,ie.goto);ie._=oe}return ie}doValidatePaths(ie,oe){const ge=(0,g.cwd)(),fe=ie.map(pe=>{let me=String(pe),be;oe&&(be=(0,f.parseLineAndColumnAware)(me),me=be.path),me&&(me=this.preparePath(ge,me));const ke=(0,f.sanitizeFilePath)(me,ge),Ae=(0,E.basename)(ke);return Ae&&!(0,f.isValidBasename)(Ae)?null:oe&&be?(be.path=ke,this.toPath(be)):ke}),de=d.isWindows||d.isMacintosh,Pe=(0,k.distinct)(fe,pe=>pe&&de?pe.toLowerCase():pe||"");return(0,k.coalesce)(Pe)}preparePath(ie,oe){return d.isWindows&&(oe=(0,I.rtrim)(oe,'"')),oe=(0,I.trim)((0,I.trim)(oe," "),"	"),d.isWindows&&(oe=(0,E.resolve)(ie,oe),oe=(0,I.rtrim)(oe,".")),oe}toPath(ie){const oe=[ie.path];return typeof ie.line=="number"&&oe.push(String(ie.line)),typeof ie.column=="number"&&oe.push(String(ie.column)),oe.join(":")}}new J().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5df296407363de70e9d7b455e1fcb004ceaa6b75/core/vs/code/electron-main/main.js.map
